*------------------------------------------------------------------------------
*- Version....: ACCPAC Pro Series 7.30.00
*- File Name..: $Workfile:   SOREPT.prg  $
*- VCS Level..: $Revision:   1.27  $
*- Last Update: $Date:   13 Dec 2005 18:16:34  $
*------------------------------------------------------------------------------
*- Copyright (C) 2004 ACCPAC International, Inc.  All Rights Reserved.
*------------------------------------------------------------------------------
*- App ID.....: SO
*- App Name...: Order Entry
*------------------------------------------------------------------------------
*- Description: Reports option grid and output control
*------------------------------------------------------------------------------
*- Synopsis...: Order Entry Report Processing.
*------------------------------------------------------------------------------
*- Called By..: SO
*------------------------------------------------------------------------------
*- Calls......: G_GETDLG(), G_DSPGD, G_DSPCH, L_GTGRD, G_GETCH(),
*-              L_VLGRD, L_SOREP1, L_SOREP2, L_SOREP3, SYCUSR,
*-              L_SOREP4, G_PRNRP
*------------------------------------------------------------------------------
*- Passed:
*- Variables..:
*-
*- Parameters.: lc_rept = single character report identifier
*-                 1  - Transactions
*-                 2  - Shipments
*-                 3  - Open Orders
*-                 4  - Orders by Salesperson
*-                 5  - Picking List
*-                 6  - Recurring Orders
*-                 7  - Commissions for Sales People/ Sales Groups
*-                 8  - Commissions  - Quotas vs. Actual sales
*-                 9  - Commissions for Items
*-                 A  - Inventory Master
*-                 BO - Blanket Orders
*-                 C  - Customer File
*-                 D  - Sales People / Sales Groups defined
*-                 I  - Sales Tax By Tax Code
*-                 M  - Operation Summary
*-                 P  - Customer PO Report
*-                 T  - Picking Tickets
*-                 R  - Comments
*-                 U  - Customer Payment Terms
*-                 V  - Customer Distribution by Value
*-                 P  - Customer PO report
*-                 S  - Drop Ship Status
*------------------------------------------------------------------------------
PARAMETERS lc_rept

#include global.h
#include events.h

*-- Local defines
#define Cn_WasOpen        1     && Database was already open
#define Cn_OpenHere       2     && Table was opened here
#define Cc_BrwCust        [custno :p=REPLICATE("X", 12) ] + ;
        [:h="Customer", ] + ;
        [Company :22, ] + ;
        [Contact :15, ] + ;
        [City    :10, ] + ;
        [Phone   :12 ]

#define Cc_BrwMast        [ponum  :h = "PO #", ] + ;
        [sono   :h = "Order #" :p = gc_docpic, ] + ;
        [sodate :h = "Order Date" :10, ] + ;
        IIF(gl_mc, [currid :H = "Curr",], []) + ;
        [Open  = IIF(ordamt = 0, "Shipped", ordamt) ] + ;
        [:P = g_ccypct("", currid) :20 ] + ;
        [WHEN r_algncol(] + IIF(gl_mc, [5], [4]) + [, 1) ] + ;
        [KEY lc_prefix]

*-- Defines for Sales Commission
#define Cc_PrdTierBasis   "P"
#define Cc_QtrTierBasis   "Q"
#define Cc_YrTierBasis    "Y"

*-- Sales commission status
#define Cc_SOEntered      "E"
#define Cc_SOShipped      "S"
#define Cc_InvoiceEntered "I"
#define Cc_CashReceipt    "R"
#define Cc_TrnfrStat      "T"
#define Cc_CommPaidStat   "P"
#define Cc_VoidStat       "V"
#define Cc_NegCashRec     "-"

#if 0
  PUBLIC go_SQL AS sbtmgrsql OF sbtsql.vcx
  LOCAL lo_Table AS sbtcmpsql OF sbtsql.vcx
#endif

*--Open the files as reports are now in a private data session
DO (gc_adrvprg + "soopnf") WITH .f.

*\ [2 lines] PTR 74256 03/22/04 SSHA National Account for Customer File Report
PRIVATE lc_NlacNo
lc_NlacNo = SPACE(6)

PRIVATE lc_UnInvShip, ;
        lc_ShipVia, ;
        lc_FOB, ;
        lc_CurrId, ;
        lc_GrpOrds, ;
        lc_Grouping, ;
        ll_UnInvRept
lc_UnInvShip = 'All Shipments'
lc_ShipVia   = SPACE(15)
lc_FOB       = SPACE(12)
lc_CurrId    = SPACE(3)
lc_GrpOrds   = "Yes"
lc_Grouping  = "ShipNo"
ll_UnInvRept = .f.

*\ [2 Lines] PTR# 73740 01/12/04 TISU Printing No matching data implementation.
*\                                    Declared variables
*\ [1 Line] PTR# 69388 03/23/04 TIGJ Add variable lc_amtpict
PRIVATE lc_valpic, ;
        ln_decnum, ;
        lc_popt, ;
        lc_scust, ;
        lc_range, ;
        lc_bdate, ;
        lc_edate, ;
        lc_include, ;
        lc_bpepl, ;
        lc_epepl, ;
        lc_bgrp, ;
        lc_egrp, ;
        lc_adjust, ;
        lc_plinid, ;
        lc_saletyp, ;
        lc_div, ;
        lc_terr, ;
        lc_dept, ;
        lc_cntry, ;
        lc_tiers, ;
        lc_markem, ;
        ln_bperiod, ;
        ln_eperiod, ;
        lc_item, ;
        lc_sumdet, ;
        lc_frx, ;
        ll_gened, ;
        lc_deleted, ;
        lc_century, ;
        ll_export, ;
        lc_pono, ;
        lc_include, ;
        lc_bcust, ;
        lc_ecust, ;
        lc_supp, ;
        lc_ship, ;
        ld_fedate, ;
        ld_fbdate, ;
        lc_optitle, ;
        ll_custfrx, ;
        ln_resp, ;
        ll_cont, ;
        ln_lastkey, ;
        ll_prnt, ;
        lc_prnsb1, ;
        lc_prnsb2, ;
        ln_balltot, ;
        ln_balltax, ;
        lc_grpitem, ;
        ld_begdt, ;
        ll_cursum, ;
        lc_cursum, ;
        lc_prvfrx, ;
        ll_report, ;
        lc_prvtitl, ;
        ll_norecs, ;
        ll_NoMatch, ;
        lc_OldAlias, ;
        lc_amtpict

*\ [2 Lines] PTR 76407 07/06/04 DAND Customer payment terms listing
PRIVATE lo_TermsAPI
lo_TermsApi = Null

*\ [2 Lines] PTR# 73740 01/12/04 TISU Printing No matching data implementation
*-- Set initial value as .f.. This variable will determine whether user wants
*-- to preview/print the report even though there are no data
ll_NoMatch  = .f.
lc_OldAlias = ""

*\ [1 Line] PTR# 69388 03/23/04 TIGJ Initialize variable lc_amtpict
lc_amtpict = REPLICATE("#", Cn_AmtStdWidth) + ".##"

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
PRIVATE ll_NoSelrpt

*-- Flag whether to prompt for selection of custom reports
ll_NoSelrpt = .f.
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

ld_begdt = Cd_mindate
ll_cursum = .f.
lc_cursum = "No "

DECLARE la_cursum[1], ;
        la_chead[1]

*-- Initialize string vars for stores and bins
lc_prnsb1 = Cc_NullStr
lc_prnsb2 = Cc_NullStr

lc_deleted = SET("DELETED")

*-- Save century setting
lc_century = SET("CENTURY")

SET CENTURY OFF

*-- Initially we have not generated
ll_gened  = .f.

*-- Default for all reports is exportable
ll_export = .t.

lc_include = "To Purchase"
*\ [1 Line] PTR None 01/22/04 TISM Set length of supplier dynamically
lc_supp = SPACE(LEN(gc_cvnopic))
lc_range   = IIF(gl_slsclc AND VAL(gc_slsqpd)=4,"Quarter","Month  ")

lc_bdate   = Cc_NullDate
lc_edate   = Cc_NullDate
lc_bpepl   = SPACE(4)
lc_epepl   = SPACE(4)
lc_bgrp    = SPACE(4)
lc_egrp    = SPACE(4)
lc_adjust  = "Due" + SPACE(3)
lc_plinid  = SPACE(6)
lc_saletyp = "All" + SPACE(13)
lc_div     = SPACE(10)
lc_terr    = SPACE(10)
lc_dept    = SPACE(10)
lc_tiers   = "Y"
lc_markem  = "N"
ln_bperiod = 0
ln_eperiod = 0
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
lc_item    = SPACE(LEN(gc_itempic))
lc_sumdet  = "Summary"
lc_pono    = SPACE(20)
ld_fbdate  = Cd_NullDate
ld_fedate  = Cd_NullDate
lc_grpitem = "Yes "

*-- Initially we have not generated
ll_gened  = .f.

*-- Use user defined number of price decimals for shipment report
lc_valpic = LEFT("##########.#####", 10 + gn_decprc + ;
            IIF(gn_decprc = 0, 0, 1))

ln_decnum = SET("DECIMALS")
lc_ship  = "All     "
lc_cntry = SPACE(15)

*-- Disables any opened MDI forms and its hotkeys
= g_setmdi(.t.)

*-- Define report window
DEFINE WINDOW lw_rept ;
              FROM 0, 0 ;
              TO 23, 79 ;
              NONE ;
              COLOR SCHEME 1

lc_title  = ""
lc_gpdesc = ""

*-- Set summary/detail option
IF lc_rept $ "1234CIP" OR lc_rept == "BO"

  IF NOT gl_detail
    lc_detail = "S"
    lc_title  = "Summary"
  ELSE
    lc_detail = "D"
    lc_title = "Detail"
  ENDIF

ENDIF

*-- Set report title, grid size, option grid defaults
lc_order   = "N"
lc_only    = "A"
lc_shipped = "All items      "
lc_type    = "All          "

DO CASE
  CASE lc_rept = "1"
    lc_title  = lc_title + " Transactions "
    ln_bot = IIF(gl_locts, 22, 20)
    lc_order  = "Order        "

  CASE lc_rept = "P"
    lc_title  = lc_title + " Customer POs "
    ln_bot = 14

  CASE lc_rept = "2"
    lc_title  = lc_title + " Shipments "

    IF lc_detail = "D"
      ln_bot = IIF(gl_locts, 22, 20)
    ELSE
      ln_bot = IIF(gl_locts, 20, 18)
    ENDIF

    lc_order    = IIF(lc_detail = "S", "Date Shipped", "Order       ")

  CASE lc_rept = "3"
    lc_title  = lc_title + " Open Orders "
    ln_bot = IIF(lc_detail = "S", 20, 24)
    lc_order    = "Order        "
    lc_only     = "All open orders     "
    lc_shipped  = "All items      "

  CASE lc_rept = "4"
    lc_title  = lc_title + " Orders by Salesperson "
    ln_bot = 20
    lc_order = "S"
    lc_only  = "All orders       "

  CASE lc_rept = "5"
    lc_title  = lc_title + " Picking List "
    ln_bot = 20
    lc_order = "Location      "

  CASE lc_rept = "6"
    lc_title  = lc_title + " Recurring Orders "
    ln_bot = 10

  CASE lc_rept = "7"
    lc_title  = lc_title + " Commissions for Salespeople / Sales Groups "
    ln_bot = IIF(gl_slsgps, 18, 14)
    lc_cond = ""
    ll_cont = .t.

    *-- Initialize variables used in option grid
    lc_include = "Salespeople "

    IF gc_slstrb = Cc_QtrTierBasis
      *-- Tier basis is quarter
      *-- Set range title
      lc_range   = "Quarter"

      *-- Changed current date into system date
      *-- Determine beginning and ending period
      IF MONTH(gd_sdate)/3 = INT(MONTH(gd_sdate)/3)
        *-- Current month is on quarter end
        ln_eperiod = MONTH(gd_sdate)/3
        ln_bperiod = MONTH(gd_sdate)/3
      ELSE
        *-- Changed current date into system date
        *-- Month is in begining of middle of period
        ln_eperiod = g_extnd(0,MONTH(gd_sdate)/3 + 0.5,1,0)
        ln_bperiod = g_extnd(0,MONTH(gd_sdate)/3 + 0.5,1,0)

      ENDIF

    ELSE
      *-- Tier basis is year or period
      *-- Set range title
      lc_range = "Month  "

      *-- Changed current date into system date
      ln_eperiod = MONTH(gd_sdate)
      ln_bperiod = MONTH(gd_sdate)
    ENDIF

    *--
  CASE lc_rept = "8"
    lc_title  = lc_title + " Commissions - Quota vs. Actual "
    ln_bot = 10
    lc_cond   = ""
    ll_cont   = .t.

    *-- Initialize variables used in option grid
    lc_include = "Salespeople "

    *--
  CASE lc_rept = "9"
    lc_title  = lc_title + " Commissions for Items "
    ln_bot = 16
    lc_cond   = ""
    ll_cont   = .t.

    IF gc_slstrb = Cc_QtrTierBasis
      *-- Tier basis is quarter
      *-- Set range title
      lc_range   = "Quarter"

      *-- Changed current date into system date
      *-- Determine beginning and ending period
      IF MONTH(gd_sdate)/3 = INT(MONTH(gd_sdate)/3)
        *-- Current month is on quarter end
        ln_eperiod = MONTH(gd_sdate)/3
        ln_bperiod = MONTH(gd_sdate)/3
      ELSE
        *-- Changed current date into system date
        *-- Month is in begining of middle of period
        ln_eperiod = g_extnd(0,MONTH(gd_sdate)/3 + 0.5,1,0)
        ln_bperiod = g_extnd(0,MONTH(gd_sdate)/3 + 0.5,1,0)
      ENDIF

    ELSE
      *-- Tier basis is year or period
      *-- Set range title
      lc_range = "Month  "

      *-- Changed current date into system date
      ln_eperiod = MONTH(gd_sdate)
      ln_bperiod = MONTH(gd_sdate)
    ENDIF

  CASE lc_rept = "A"
    lc_title  = lc_title + " Inventory Master "
    ln_bot = IIF(gl_locts, 22, 20)
    lc_order  = "Item       "
    lc_type   = "All      "

  CASE lc_rept == "BO"
    lc_title  = lc_title + " Blanket Orders "
    ln_bot = 14
    lc_order  = "Customer"

  CASE lc_rept = "C"
    lc_title  = lc_title + " Customer File "

*\ [1 line] PTR# 76649 07/19/04 TISY Changed ln_bot value to 17
    ln_bot = 17
    lc_order    = PADR("Number  ", 10)
*\ [2 Lines] PTR# 74081 03/18/04 TIRK Customer status option is included in option grid
*\ [1 lines] PTR 74256 03/22/04 SSHA National Account for Customer File Report

*\ [1 line] PTR# 76649 07/19/04 TISY Check whether 'AR' is installed
    IF gl_ar
      ln_bot = 19
      ln_rptcol = 80
    ENDIF 

  CASE lc_rept = "D"
    lc_title  = lc_title + " Salespeople / Sales Groups "
    ln_bot = 18

    *-- Initialize variables used in option grid
    lc_include = "Salespeople "

  CASE lc_rept = "F"
    lc_title  = " Customer Ship To Address File " + ;
                IIF(gl_detail, "Detail ", "Summary ")
    lc_detail = IIF(gl_detail, "D", "S")
    ln_bot = 20
    lc_order  = "Company"

  CASE lc_rept = "I"
    lc_title  = lc_title + " Sales Tax By Tax Code "
    ln_bot = IIF(lc_detail = "S", 8, 10)
    lc_order = "Item    "

  CASE lc_rept = "M"
    lc_title  = lc_title + " Operation Summary "
    ln_bot = 16
    lc_order    = "Date"

  CASE lc_rept = "T"

    PRIVATE lc_sotype, ;
            ll_outstk, ;
            lc_lots, ;
            lc_serial, ;
            lc_xscope, ;
            lc_bsono, ;
            lc_esono, ;
            lc_cond, ;
            lc_xcustno, ;
            ln_result, ;
            lc_msg, ;
            ln_line, ;
            ln_opnitm, ;
            lc_ndx, ;
            lc_loc, ;
            lc_lpage, ;
            lc_order, ;
            lc_changed, ;
            ll_insfstk, ;
            ln_icserl, ;
            ll_NoOnhand

    ln_bot  = IIF(gl_locts, 22, 16)

    *-- TIW hook to support exploded line items for picking tickets
    IF gl_tiw
      ln_bot     = ln_bot + 2
      lc_grpitem = "No "
    ENDIF

    *-- Initialize variables for file opening
    ln_icserl = 0

    *-- Initialize local switches
    ll_outstk  = .f.
    ll_insfstk = .f.
    ll_NoOnhand = .f.

    lc_sotype  = " "
    lc_ndx     = ""
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
    lc_item    = SPACE(LEN(gc_itempic))
    lc_bsono   = SPACE(LEN(gc_docpic))
    lc_esono   = SPACE(LEN(gc_docpic))
    lc_loc     = SPACE(6)
*\ [1 Line] PTR None 01/22/04 TISM Set length of custno dynamically
    lc_xcustno = SPACE(LEN(gc_cvnopic))
    lc_class   = SPACE(6)
    lc_code    = SPACE(6)

    lc_bdate   = Cc_NullDate
    lc_edate   = Cc_NullDate
    lc_lpage   = "No "

    lc_order   = PADR("Item", 16)
    lc_incld   = "All Items  "
    lc_changed = "New and Changed"
    lc_zero    = "No "

    lc_title = "Picking Tickets "

  CASE lc_rept = "R"
    lc_title  = lc_title + " Comments "
    ln_bot = 4

*\ [Begin] PTR 76407 07/06/04 DAND Customer payment terms listing
  CASE lc_rept = "U"
    lc_title     = "Customer Payment Terms"
    ln_bot       = 4
    lc_order     = "Terms ID   "
*\ [End] PTR 76407 07/06/04 DAND Customer payment terms listing

  CASE lc_rept = "V"
    lc_title  = " Customer Distribution by Value "
    ln_bot = 14

    *-- Set Distribution Type to "C" for Customers
    lc_dbvtype = "C"
    ln_minamt  = 1000

  CASE lc_rept = "S"
    lc_title  = " Drop Shipment Status "
    ln_bot = 22
    lc_order = "Order #         "

  CASE lc_rept = "Y"
    lc_title  = " Multiple VAT Detail SO "
    lc_order  = "Customer   "
    ln_bot = 14
    ln_rptcol = 132

ENDCASE

IF lc_rept $ "134P" AND gl_mc
  ln_bot = ln_bot + 2
ENDIF

*-- Initialize option variables
lc_file    = "Current"
lc_show    = "Value ordered"
lc_bdate   = Cc_NullDate
lc_edate   = Cc_NullDate
lc_tax     = "N"
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
lc_item    = SPACE(LEN(gc_itempic))
lc_pono    = SPACE(20)
*\ [2 Lines] PTR None 01/23/04 TISM Set length of item dynamically
lc_bitem   = SPACE(LEN(gc_itempic))
lc_eitem   = SPACE(LEN(gc_itempic))
lc_ctype   = SPACE(8)
lc_class   = SPACE(6)
lc_bclass  = SPACE(6)
lc_eclass  = SPACE(6)
lc_vpartno = SPACE(15)
lc_loctid  = SPACE(6)
lc_code    = SPACE(6)
lc_bccode  = SPACE(2)
lc_eccode  = SPACE(2)
lc_bmcode  = SPACE(6)
lc_emcode  = SPACE(6)
*\ [1 Line] PTR None 01/22/04 TISM Set length of custno dynamically
lc_custno  = SPACE(LEN(gc_cvnopic))
lc_bcommid = SPACE(6)
lc_ecommid = SPACE(6)
lc_indust  = SPACE(5)
lc_salesmn = SPACE(4)
lc_terr    = SPACE(2)
lc_taxcode = SPACE(1)
lc_bsono   = SPACE(10)
lc_esono   = SPACE(10)
lc_begbo   = SPACE(10)
lc_endbo   = SPACE(10)

*\ [1 Line] PTR 74817 04/21/04 TIMI Set lc_status based on lc_rept
*\ [1 Line] PTR# 74081 03/18/04 TIRK Customer status option is included in option grid
IF NOT INLIST(lc_rept,"C","F")
  lc_status  = "Open  "
ELSE
  lc_status  = "All     "
ENDIF

*\ [2 Lines] PTR None 01/22/04 TISM Set length of custno dynamically
lc_bcust = SPACE(LEN(gc_cvnopic))
lc_ecust = SPACE(LEN(gc_cvnopic))

lc_incitm = "I"
lc_uom    = "Transaction unit"

ln_alltot = 0.000
ln_alltax = 0.000

ln_balltot = 0.000
ln_balltax = 0.000

*-- Initialize heading lines
lc_head1 = ""
lc_head2 = ""
lc_head3 = ""

*-- Initialize report form variables
lc_frx = ""
lc_cond    = ""

lc_baccnt  = TRANSFORM(REPLICATE(" ", gn_acctlen), gc_acctpic)
lc_eaccnt  = TRANSFORM(REPLICATE(" ", gn_acctlen), gc_acctpic)

*-- Activate report window
ACTIVATE WINDOW lw_rept NOSHOW

lc_optitle = lc_title

*-- Display option grid
DO g_dspgd WITH "Option Grid - " + TRIM(lc_optitle) + " Report:", (ln_bot), ;
                .f., 0, .t.

*-- Setup arrays for pads and prompts
ln_lastkey = 0

*\[Begin] PTR# 73741 01/31/04 TIVN support for multiple custom reports
*-- Setup custom report button variables
PRIVATE ll_custfrx, ;
        ll_askfrx, ;
        lc_custom, ;
        lc_cusrept

ll_custfrx = .f.
ll_askfrx = .t.

lc_custom = ""

*-- If the standard report name is available at this juncture
*-- then display the same
IF TYPE("lc_frx") = "C" AND NOT EMPTY(lc_frx)
  lc_cusrept = UPPER(JUSTSTEM(lc_frx)) + "(Standard)"
ELSE
  lc_cusrept = ""
ENDIF

*-- Row source for report selection drop dowm
DIMENSION la_Custom[1]
la_Custom[1] = ""
*\[End] PTR# 73741 01/31/04 TIVN support for multiple custom reports

IF lc_rept = "T"
  *-- Print Picking Tickets
  *-- Set up arrays of menu choices and prompts
  DECLARE la_pad[3]
  DECLARE la_prmpt[3]
  la_pad[1] = "Print"
  la_pad[2] = "Edit"
  la_pad[3] = "Cancel"
  la_prmpt[1] = "Print Picking Tickets"
  la_prmpt[2] = "Edit Picking Ticket options"
  la_prmpt[3] = "Cancel Picking Ticket printing"
  ll_askfrx = .f.
ELSE

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*\                                 Facilitate the removal of "Modify" Pad

*!*	  DECLARE la_pad[6]
*!*	  DECLARE la_prmpt[6]
*!*	  DECLARE la_skip[6]

  DECLARE la_pad[5]
  DECLARE la_prmpt[5]
  DECLARE la_skip[5]
  la_skip = ".f."

  la_pad[1]   = "Generate"
  la_prmpt[1] = "Generate"
  *-- Skip if generated
  la_skip[1]  = "ll_gened OR ln_lastkey = gk_esc"

  la_pad[2]   = "Pre\<view"
  la_prmpt[2] = "Preview"
  *-- Skip if not yet generated
  la_skip[2]  = "NOT ll_gened"

  la_pad[3]   = "Print"
  la_prmpt[3] = "Print"
  *-- Skip if not yet generated
  la_skip[3]  = "NOT ll_gened"

  la_pad[4]   = "Reenter"
  la_prmpt[4] = "Reenter"
  *-- Always active
  la_skip[4]  = ".f."

*!*	  la_pad[5]   = "Modify"
*!*	  la_prmpt[5] = "Modify Report"
*!*	  *-- Skip if not yet generated or when running WIN, not a WIN fork
*!*	  la_skip[5]  = "NOT (ll_gened)"

*!*	  la_pad[6]   = "E\<xit"
*!*	  la_prmpt[6] = "Exit"
*!*	  *-- Always active
*!*	  la_skip[6]  = ".f."

  la_pad[5]   = "E\<xit"
  la_prmpt[5] = "Exit"
  *-- Always active
  la_skip[5]  = ".f."

  *-- Do not prompt for selection of custom/Standard report 
  *-- when the selection list is already available in the option
  *-- grid itself
  ll_NoSelrpt = .t.

*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*\                               Facilitate the removal of "Modify" Pad

ENDIF

*-- Set to ignore deleted records
SET DELETED ON

*-- Set to continue
ll_cont = .t.

DO WHILE .t.
  DO g_dspst WITH gc_task, .f., gn_msgline, gc_applid, gc_compid, gc_userid

  IF NOT ll_gened
    *-- Get grid options
    DO l_getop

    *-- Customer Purchase Order Report
    IF lc_rept = "P"
      *-- Validates the PO number.
      = l_valpo()
    ENDIF

    lc_prvfrx = IIF(EMPTY(lc_frx), " ", lc_frx)
    ll_report = gl_landscp
    lc_prvtitl = lc_title

    IF lc_cursum = "Yes"
      ll_cursum = .t.
    ENDIF

    ln_lastkey = LASTKEY()

    *-- Initialize filter condition
    lc_filt    = ""
    lc_segmnt1 = ""
    lc_segmnt2 = ""
    lc_segmnt3 = ""
    lc_segmnt4 = ""
    lc_current = ""

    DO CASE
      CASE lc_rept $ "1357VS" OR (lc_rept = "4" AND lc_detail = "D") OR ;
           lc_rept == "BO"

        *-- Set print width to 132 columns
        ln_rptcol = 132

      CASE lc_rept = "P"
        ln_rptcol = IIF(lc_detail = "D", 134, 73)

      CASE lc_rept = "M"
        *-- Set printer width for Operation Summary Report

        IF lc_order = "Item"
          *-- Item report
          ln_rptcol = 132
        ELSE
          ln_rptcol = 80
        ENDIF

      CASE lc_rept $ "269"
        *-- Shipments, Recurring Order Entries & Commission reports
        ln_rptcol = 96

      CASE lc_rept = "F"

        IF lc_detail = "D"
          ln_rptcol = 145
        ELSE
          ln_rptcol = 95
        ENDIF

      OTHERWISE
        ln_rptcol = 80
    ENDCASE

  ELSE
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

*\ [1 Line] PTR# 73740 01/12/04 TISU Printing No matching data implementation
    *-- There are no records to generate the report. Allow ll_gened to be set as
    *-- .f. only when the user has chosen not to print/preview the report
    IF go_SQL.so_CurrentAlias.m_IsEof() AND (NOT ll_NoMatch)
      ll_gened = .f.
    ENDIF

  ENDIF

  IF ln_bot > 0
    *-- Get report destination
*\[1 Line] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
    ln_resp = g_getch(IIF(LASTKEY() = gk_esc, 5, 1))
  ENDIF

  IF lc_rept = "T" AND ln_resp <> 1

    DO CASE
      CASE ln_resp = 2
        *-- Set to reenter
        ln_resp = 4
      OTHERWISE
        *-- Set to Exit
        ln_resp = 6
    ENDCASE

  ENDIF

  DO CASE
    CASE ln_resp = 1
      *--- Generate the report

      *-- Initialize filter condition
      lc_filt    = ""
      lc_segmnt1 = ""
      lc_segmnt2 = ""
      lc_segmnt3 = ""
      lc_segmnt4 = ""
      lc_current = ""

      *-- Set up report headings
      DO l_sethd

      IF go_SQL.m_IsUsed("a_tmpf1")
        go_SQL.cmpA_Tmpf1.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf2")
        go_SQL.cmpA_Tmpf2.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf3")
        go_SQL.cmpA_Tmpf3.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf4")
        go_SQL.cmpA_Tmpf4.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf5")
        go_SQL.cmpA_Tmpf5.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf6")
        go_SQL.cmpA_Tmpf6.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf7")
        go_SQL.cmpA_Tmpf7.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf8")
        go_SQL.cmpA_Tmpf8.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf9")
        go_SQL.cmpA_Tmpf9.m_CloseTable()
      ENDIF

      *-- Call report procedure
      DO CASE
        CASE lc_rept $ "1234VP"
          *-                 1  - Transactions
          *-                 2  - Shipments
          *-                 3  - Open Orders
          *-                 4  - Orders by Salesperson
          *-                 V  - Customer Distribution by Value
          *-                 P  - Customer PO report
          DO CASE
            CASE lc_rept = "2" AND ll_UnInvRept
               DO l_UnInvShip
            CASE go_SQL.sc_SQLTypeMain = "F"
               DO l_sorep1_vfp
            OTHERWISE
              DO l_sorep1_sql
          ENDCASE

*\ [1 Line] PTR 76407 07/06/04 DAND Customer payment terms listing
        CASE lc_rept $ "56ARU" OR lc_rept == "BO"
          *-                 5  - Picking List
          *-                 6  - Recurring Orders
          *-                 A  - Inventory Master
          *-                 R  - Comments
          *-                 U  - Customer Payment Terms Listing
          *-                 BO - Blanket Orders
          DO l_sorep2
        CASE lc_rept = "M"
          *-                 M  - Operation Summary
          DO l_sorep3
        CASE lc_rept = "C" OR lc_rept = "F"
          *-                 C  - Customer File
*\ [1 lines] PTR 74256 03/22/04 SSHA National Account for Customer File Report
          = d_setfl("ARNLAC", gc_compid, 3)
          *# DOCCODE DO sycusr
          DO (gc_idrvprg + "sycusr")
        CASE lc_rept $ 'I'
          *-                 I  - Sales Tax By Tax Code
          DO l_sorep4

        CASE lc_rept = "7"
          *-                 7  - Commissions for Sales People/ Sales Groups
          DO l_comrpt7

        CASE lc_rept = "8"
          *-                 8  - Commissions - Quotas vs. Actual sales
          DO l_comrpt8

        CASE lc_rept = "9"
          *-                 9  - Commissions for Items
          DO l_comrpt9

        CASE lc_rept = "D"
          *-                 D  - Sales People / Sales Groups defined
          DO l_comrpte

        CASE lc_rept = "S"
          *-                 S  - Drop Ship Status
          DO l_sorep6
        CASE lc_rept = "T"
          *-                 T  - Picking Tickets
          DO l_sorep7

          *-- Cancel, set continuation flag (Picking tickets only)
          ll_cont = .f.
          ll_custfrx = .f.
          EXIT

        CASE lc_rept = "Y"
          DO (gc_idrvprg + "symvat")

      ENDCASE

      *-- Mark as generated
      ll_gened = .t.

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

*\ [Begin] PTR# 73740 01/12/04 TISU Printing No matching data implementation
      IF go_SQL.so_CurrentAlias.m_IsEof()

        IF g_getdlg(Cc_NoDataMsg, 2, 2, "Yes ", ;
                    "No ", Cc_NullStr, Cc_NullStr) = 1
          *-- Chosen to preview/print the report even though there are no
          *-- records matching the given criteria
          ll_NoMatch = .t.
        ELSE
          LOOP
        ENDIF && g_getdlg(Cc_NoDataMsg, 2, 2, "Yes ",

      ENDIF
*\ [End] PTR# 73740 01/12/04 TISU Printing No matching data implementation

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*!*	      IF FILE(lc_frx + gc_compid + ".FRX") AND ;
*!*	         FILE(lc_frx + gc_compid + ".FRT")
*!*	        lc_frmfile = lc_frx + gc_compid
*!*	        ll_custfrx = .t.
*!*	        lc_custom = "Custom"
*!*	      ELSE
*!*	        lc_frmfile = lc_frx
*!*	        ll_custfrx = .f.
*!*	        lc_custom = "Standard"
*!*	      ENDIF

      *-- Check to see if there is a custom form , if so use it
      = g_getfrx(lc_frx, ;
                 "SYRFCUS", ;
                 @la_custom, ;
                 @lc_cusrept)

      ll_custfrx = .t.

      *-- Get the report name along with path info
      lc_frmfile = l_getfrx()
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

    CASE ln_resp = 2
      *-- Preview

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*!*	      IF ll_custfrx AND lc_custom = "Custom"
*!*	        lc_frmfile = lc_frx + gc_compid
*!*	      ELSE
*!*	        lc_frmfile = lc_frx
*!*	      ENDIF
      lc_frmfile = l_getfrx()
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

*\ [Begin] PTR# 73740 01/12/04 TISU Printing No matching data implementation
      IF ll_NoMatch
        lc_OldAlias = ALIAS()

        *-- Call g_prvfrx with the temporary frx to display report
        *-- with no data found information
        DO g_prvfrx WITH g_pnorec(.t., lc_frmfile)

        *-- Call without parameters to erase the created temporary files
        = g_pnorec()

        *-- Restore back the previous alias
        go_SQL.m_TableChangeCurrent(lc_OldAlias)
      ELSE
*\[1 Line] PTR# 73741 01/31/04 TIVN Passed the third parameter based on
*\                                  which report selection dialog will
*\                                  pop up
        DO g_prvfrx WITH lc_frmfile, .f., ll_NoSelrpt
      ENDIF
*\ [End]   PTR# 73740 01/12/04 TISU Printing No matching data implementation

      IF ln_bot <= 0
        EXIT
      ENDIF

    CASE ln_resp = 3
      *-- Print, set print destination flag
      ll_prnt  = .t.

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*!*	      IF ll_custfrx AND lc_custom = "Custom"
*!*	        lc_frmfile = lc_frx + gc_compid
*!*	      ELSE
*!*	        lc_frmfile = lc_frx
*!*	      ENDIF
      lc_frmfile = l_getfrx()
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

*\ [Begin] PTR# 73740 01/12/04 TISU Printing No matching data implementation
      IF ll_cont OR ll_NoMatch

        IF ll_NoMatch
          lc_OldAlias = ALIAS()

          *-- Capture the temporary frx name to be used for printing
          *-- no matching data found information
          lc_frmfile = g_pnorec(.t., lc_frmfile)
        ENDIF

*\[1 Line] PTR# 73741 01/31/04 TIVN Passed the fifth parameter based on
*\                                  which report selection dialog will
*\                                  pop up
        DO g_prnrp WITH .t., .f., ll_export, .f., ll_NoSelrpt

        IF ll_NoMatch
          *-- Erase the created temporary files
          = g_pnorec()

          *-- Restore back the alias
          go_SQL.m_TableChangeCurrent(lc_OldAlias)
        ENDIF

      ENDIF
*\ [End]   PTR# 73740 01/12/04 TISU Printing No matching data implementation

    CASE ln_resp = 4
      *-- Edit
      ll_gened = .f.
      ll_custfrx = .f.

      ll_cursum = .f.
      lc_frx = lc_prvfrx
      gl_landscp = ll_report
      lc_title = lc_prvtitl

*\ [1 Line] PTR# 73740 01/12/04 TISU Printing No matching data implementation
      *-- Criteria for the report might get changed,so reset the value
      ll_NoMatch = .f.

      *-- Reset workarea environment to release relations etc.
      = go_SQL.m_CloseTableAll()

      *# DOCCODE DO soopnf
      DO (gc_adrvprg + "soopnf") WITH .f.

      LOOP

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*!*	    CASE ln_resp = 5
*!*	      *-- Modify report

*!*	      *-- If a custom report exists but toggle is to standard
*!*	      IF ll_custfrx AND NOT lc_custom = "Custom"

*!*	        IF g_getdlg("Do you want to replace your custom report with " + ;
*!*	           "the original PRO report form?", 2, 1, "Yes", "No") = 1
*!*	          COPY FILE (lc_frx + ".frx") TO ;
*!*	               (lc_frx + gc_compid + ".frx")
*!*	          COPY FILE (lc_frx + ".frt") TO ;
*!*	               (lc_frx + gc_compid + ".frt")
*!*	        ENDIF

*!*	      ENDIF

*!*	      IF ll_custfrx
*!*	        lc_frmfile = lc_frx + gc_compid
*!*	      ELSE
*!*	        lc_frmfile = lc_frx
*!*	      ENDIF

*!*	      = g_modfrx(lc_frx, @lc_frmfile)

*!*	      ll_cont = .t.
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

    CASE ln_resp >= 5
      *-- Cancel, set continuation flag
      ll_custfrx = .f.
      ll_cont = .f.
      EXIT

  ENDCASE

  ERASE (gc_idrvtmp + gc_tmpf5 + ".frx")
  ERASE (gc_idrvtmp + gc_tmpf5 + ".frt")

  ll_cont = .t.

  *-- Initialize variables used to calculate cumulative tax
  IF lc_tax = "Y" AND lc_rept = "3"
    mcust   = ""
    msono   = ""
    tottax  = 0.00
    gtottax = 0.00
    ordsub  = 0.00
    ordamt  = 0.00
  ENDIF

  saletot  = 0.00
  salegtot = 0.00

ENDDO && WHILE .t.

*-- If Shipments Report, reset decimals
IF lc_rept = "2"
  SET DECIMALS TO ln_decnum
ENDIF

*-- Display sign of life
DO g_dspst WITH "Returning to Order Entry Main Menu...", ;

*-- Reset workarea environment
go_SQL.m_CloseTableAll()

*# DOCCODE DO soopnf
DO (gc_adrvprg + "soopnf") WITH .f.

*-- Erase temporary files
*-- Remove temp tables from Server
go_SQL.m_dropTable(go_SQL.m_getTempTableName(1))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(3))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(4))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(5))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(6))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(7))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(8))
go_SQL.m_dropTable(go_SQL.m_getTempTableName(9))

*\ [1 Line] PTR# 76810 08/06/04 TIVN Remove temporary table
go_SQL.m_dropTable(go_SQL.m_getTempTableName(18))

*-- Remove temp FoxPro tables from
go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(2, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(3, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(4, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(5, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(6, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(7, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(8, "F"), "", "F")
go_SQL.m_dropTable(go_SQL.m_getTempTableName(9, "F"), "", "F")

*-- Restore environment state
IF lc_deleted = "OFF"
  SET DELETED OFF
ELSE
  SET DELETED ON
ENDIF

*-- Reset century
IF lc_century = "ON"
  SET CENTURY ON
ELSE
  SET CENTURY OFF
ENDIF

*-- Release window
RELEASE WINDOWS lw_rept

*-- Reset any disabled MDI forms and its hotkeys
= g_setmdi(.f.)

RETURN
*------------------------------------------------------------------------------
*- End Main: SOREPT.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_GETOP
*------------------------------------------------------------------------------
*- Description: Get grid options
*------------------------------------------------------------------------------
*- Synopsis...: Display option grid and enter report options.
*------------------------------------------------------------------------------
*- Calls......: G_DSPCH, G_SAYOP, G_VALDTE()
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*-              lc_rept, report identifier
*-
*- Parameters.: None
*-
*- Objects....: Assumes window lw_rept defined
*------------------------------------------------------------------------------
PROCEDURE l_getop

  PRIVATE ln_line, ;
          ll_read

  ll_read = .t.

  *-- Activate report window
  IF WVISIBLE("lw_rept")
    ACTIVATE WINDOW lw_rept SAME

    *-- Clear old options
    DO g_dspgd WITH "Option Grid - " + lc_optitle + "Report:", (ln_bot), ;
                    .f., 0, .t.
  ELSE
    ACTIVATE WINDOW lw_rept NOSHOW
  ENDIF

  *-- Display menu options
  DO g_dspch

  *-- Set grid entry line
  ln_line = 4

  *-- Enter options
  DO CASE
    CASE lc_rept = "1"
      *-- Transactions
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(order date or blank for all)"

      IF lc_detail = "D"
        @ ln_line, 56.5 GET lc_order ;
                            PICTURE "@M Customer     , Date Required, " + ;
                            "Item         , Order        , Salesperson  "

        DO g_sayop WITH ln_line, "Order By", ;
                        "{Cust/Dt Reqd/Item/Order/Slsprsn}"
      ELSE
        @ ln_line, 56.5 GET lc_show ;
                            PICTURE "@M Qty ordered  , Value ordered"
        DO g_sayop WITH ln_line, "Show By", "{Qty ordered/Value ordered}"
      ENDIF

      @ ln_line, 56.5 GET lc_type ;
                          PICTURE "@M All         , Exclude bids, " + ;
                          "Orders      ,Drop Ship   , Returns     , " + ;
                          "Bids        "

      DO g_sayop WITH ln_line, "Include Type", ;
                      "{All/Exclude bids/Orders/DS/Return/Bid}"

      IF gl_locts
        @ ln_line, 56.5 GET lc_loctid ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(portion or blank for all)"
      ENDIF

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set picture of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_class PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

      IF lc_detail = "D"
        @ ln_line, 56.5 GET lc_uom ;
                            PICTURE "@M Transaction unit, Stock unit, Both"
        DO g_sayop WITH ln_line, "Quantity in", ;
                        "{Transaction unit/Stock unit/Both}"
      ENDIF

    CASE lc_rept = "2"
      *-- Shipments

      IF gl_DfrInv
        @ ln_line, 56.5 GET lc_UnInvShip ;
                            PICTURE "@M All Shipments,Uninvoiced   "
        DO g_sayop WITH ln_line, "Shipment status", "{All Shipments/Uninvoiced}"

        *-- Call special READ function
        ACTIVATE WINDOW lw_rept
        = g_read()
      ENDIF

      ll_UnInvRept = ALLTRIM(UPPER(lc_UnInvShip)) = "UNINVOICED"

      IF NOT ll_UnInvRept
        @ ln_line, 56.5 GET lc_file ;
                            PICTURE "@M Current, History, Both   "
        DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"
      ELSE
        lc_order = "Customer    "
      ENDIF

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(ship date or blank for all)"

      IF lc_detail = "D" AND NOT ll_UnInvRept
        @ ln_line, 56.5 GET lc_order ;
                            PICTURE "@M Customer    , Date Shipped, " + ;
                            "Item        , " + ;
                            "Order       , Salesperson "
        DO g_sayop WITH ln_line, "Order By", ;
                        "{Cust/Dt Ship/Item/Order/Slsprsn}"
      ENDIF

      IF ll_UnInvRept
        @ ln_line, 56.5 GET lc_order ;
                            PICTURE "@M Customer    , Ship Via    , " + ;
                                       "FOB         , Salesperson "
        DO g_sayop WITH ln_line, "Order By", ;
                        "{Cust/Ship Via/FOB/Slsprsn}"
      ENDIF

      IF gl_locts AND ;
         ( NOT ll_UnInvRept OR ll_UnInvRept AND gl_Detail)
        @ ln_line, 56.5 GET lc_loctid ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(portion or blank for all)"
      ENDIF

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

      IF NOT ll_UnInvRept
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
        = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
        DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

        @ ln_line, 56.5 GET lc_class ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

        @ ln_line, 56.5 GET lc_code ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"
      ELSE
        @ ln_line, 56.5 GET lc_ShipVia ;
                            PICTURE "!xxxxxxxxxxx"
        DO g_sayop WITH ln_line, "Ship Via", "(portion or blank for all)"

        @ ln_line, 56.5 GET lc_FOB;
                            PICTURE "!xxxxxxxxxxx"
        DO g_sayop WITH ln_line, "FOB", "(portion or blank for all)"

        @ ln_line, 56.5 GET lc_SalesMn ;
                            PICTURE "!!!!"
        DO g_sayop WITH ln_line, "Salesperson", "(portion or blank for all)"

        IF gl_mc
          @ ln_line, 56.5 GET lc_CurrId;
                            PICTURE "!!!"
          DO g_sayop WITH ln_line, "Currency ID", "(portion or blank for all)"
        ENDIF

        @ ln_line, 56.5 GET lc_GrpOrds PICTURE "@M Yes,No "
        DO g_sayop WITH ln_line, "Combine shipments", "(rollup partial shipments)"

      ENDIF

      IF lc_detail = "D" AND NOT ll_UnInvRept
        @ ln_line, 56.5 GET lc_uom ;
                            PICTURE "@M Transaction unit, Stock unit, Both"
        DO g_sayop WITH ln_line, "Quantity in", ;
                        "{Transaction unit/Stock unit/Both}"
      ENDIF

    CASE lc_rept = "3"
      *-- Open Orders
      ln_line = 4

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(order date or blank for all)"

      IF lc_detail = "D"

        IF gl_sbtmod
          @ ln_line, 56.5 GET lc_order ;
                              PICTURE "@M Customer     , Date Required, " + ;
                              "Item         , Order        , Territory    "

          DO g_sayop WITH ln_line, "Order By", ;
                          "{Cust/Dt Reqd/Item/Order/Terr}"
        ELSE
          @ ln_line, 56.5 GET lc_order ;
                              PICTURE "@M Customer     , Date Required, " + ;
                              "Item         , Order        , Salesperson  "

          DO g_sayop WITH ln_line, "Order By", ;
                          "{Cust/Dt Reqd/Item/Order/Slsprsn}"
        ENDIF

        *-- Get order and skip Tax prompt if ordered by Item
        ACTIVATE WINDOW lw_rept

        *-- Call special READ function
        = g_read()
      ELSE
        @ ln_line, 56.5 GET lc_show ;
                            PICTURE "@M Qty ordered  , Value ordered"
        DO g_sayop WITH ln_line, "Show By", "{Qty ordered/Value ordered}"
      ENDIF

      IF LASTKEY() <> gk_esc
        @ ln_line, 56.5 GET lc_type ;
                            PICTURE "@M All         , Exclude bids, " + ;
                            "Orders      ,Drop Ship  , Returns     , " + ;
                            "Bids        "

        DO g_sayop WITH ln_line, "Include Type", ;
                        "{All/Exclude bids/Orders/DS/Return/Bid}"

        IF lc_detail = "D" AND lc_order <> "I"
          @ ln_line, 56.5 GET lc_tax ;
                              PICTURE "@M Y, N"
          DO g_sayop WITH ln_line, "Include Tax", "{Y/N}"
        ELSE
          lc_tax = "N"
        ENDIF

        @ ln_line, 56.5 GET lc_only ;
                            PICTURE "@M All open orders     ," + ;
                            " Partial shipped only"

        DO g_sayop WITH ln_line, "Include Only", ;
                        "{All open orders/Part'l ship only}"

        IF lc_order = "Order"
          @ ln_line, 56.5 GET lc_shipped ;
                              PICTURE "@M All items, Unshipped items only"

          DO g_sayop WITH ln_line, "Include Items", ;
                          "{All items/Unshipped items only}"
        ENDIF

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
        = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
        DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

        IF gl_sbtmod

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
          = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
          @ ln_line, COL() + 1 GET lc_incitm ;
                                   PICTURE "@M I, E"
          DO g_sayop WITH ln_line, "Item (In/Exclude)", ;
                          "(<F2> to list, portion or blank for all)"
        ELSE

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
          = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
          DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"
        ENDIF

        @ ln_line, 56.5 GET lc_class ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

        @ ln_line, 56.5 GET lc_code ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

        IF lc_detail = "D"
          @ ln_line, 56.5 GET lc_uom ;
                              PICTURE "@M Transaction unit, Stock unit, Both"
          DO g_sayop WITH ln_line, "Quantity in", ;
                          "{Transaction unit/Stock unit/Both}"
        ENDIF

      ENDIF

    CASE lc_rept = "4"
      *-- Orders by Salesperson
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(order date or blank for all)"

      @ ln_line, 56.5 GET lc_show ;
                          PICTURE "@M Qty ordered  , Value ordered"
      DO g_sayop WITH ln_line, "Show By", "{Qty ordered/Value ordered}"

      @ ln_line, 56.5 GET lc_only ;
                          PICTURE "@M All orders, Open orders, " + ;
                          "Partially Shipped"

      DO g_sayop WITH ln_line, "Include Only", ;
                      "{All/Open orders/Partial Shipped}"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_class ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

      IF lc_detail = "D"
        @ ln_line, 56.5 GET lc_uom ;
                            PICTURE "@M Transaction unit, Stock unit, Both"
        DO g_sayop WITH ln_line, "Quantity in", ;
                        "{Transaction unit/Stock unit/Both}"
      ENDIF

    CASE lc_rept = "5"
      *-- Order Picking List
      @ ln_line, 56.5 GET lc_order ;
                          PICTURE "@M Location      , Order sequence"
      DO g_sayop WITH ln_line, "Order By", "{Location/Order sequence}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", ;
                      "(required date or blank for all)"

      @ ln_line, 56.5 GET lc_bsono ;
                          PICTURE "##########"
      DO g_sayop WITH ln_line, "Beginning Order #", "(leave blank for all)"

      @ ln_line, 56.5 GET lc_esono ;
                          PICTURE "##########"
      DO g_sayop WITH ln_line, "Ending Order #", "(leave blank for all)"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_class ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_uom ;
                          PICTURE "@M Transaction unit, Stock unit,Both"
      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction unit/Stock unit/Both}"

    CASE lc_rept = "6"
      *-- Recurring Orders

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_class ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

    CASE lc_rept = "7"
      *--  Commmissions for Salespeople / Sales Groups

      *-- Select current history or both files
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current,History,Both   " ;
                          VALID v_scope()

      DO g_sayop WITH ln_line, "Report Scope", "{Current/History/Both}"

      *-- Determine wether to display quarters or months
      IF gc_slstrb = Cc_QtrTierBasis
        *-- Display quarters

        *-- Select by period, th entire year or a date range
        @ ln_line, 56.5 GET lc_range ;
                            PICTURE "@M Quarter,Range  " ;
                            VALID v_range()
        DO g_sayop WITH ln_line, "Quarter/Range", "{Quarter/Range}"

      ELSE
        *-- Display months
        *-- Select by period, the entire year or a date range
        @ ln_line, 56.5 GET lc_range ;
                            PICTURE "@M Month,Range" ;
                            VALID v_range()
        DO g_sayop WITH ln_line, "Month/Range", "{Month/Range}"

      ENDIF

      *-- Call special READ function
      = g_read()

      DO CASE
        CASE lc_range = "Quarter"
          *-- If period selected, specify period(s) to report on
          @ ln_line, 56.5 GET ln_bperiod ;
                              PICTURE "@Z 99" ;
                              VALID v_trbrng()
          @ ln_line, COL() + 1 GET ln_eperiod ;
                                   PICTURE "@Z 99" ;
                                   VALID v_trbrng()
          DO g_sayop WITH ln_line, "Quarter(s)", "(specify quarter(s))"

        CASE LEFT(lc_range,1) = "R"

          *-- If date range selected , allow entry of date spread
          @ ln_line, 56.5 GET lc_bdate ;
                              PICTURE gc_datepi8 ;
                              VALID g_valdte()
          @ ln_line, COL() + 1 GET lc_edate ;
                                   PICTURE gc_datepi8 ;
                                   VALID g_chkdt(lc_bdate, lc_edate)
          DO g_sayop WITH ln_line, "Date Range", ;
                          "(date range or blank for all)"

        CASE lc_range = "Month"

          *-- If period selected, specify period(s) to report on
          @ ln_line, 56.5 GET ln_bperiod ;
                              PICTURE "@Z 99" ;
                              VALID v_trbrng()
          @ ln_line, COL() + 1 GET ln_eperiod ;
                                   PICTURE "@Z 99" ;
                                   VALID v_trbrng()
          DO g_sayop WITH ln_line, "Month(s)", "(specify month(s))"

      ENDCASE

      IF gl_slsgps
        *-- Sales groups used

        *-- Determine who to include in report, people , groups or both
        @ ln_line, 56.5 GET lc_include ;
                            PICTURE ;
                            "@M Salespeople ,Sales Groups,Both        " ;
                            VALID v_include("7")
        DO g_sayop WITH ln_line, "Include", "{Salespeople/Sales Groups/Both}"
      ELSE
        *-- Sales groups not used
        lc_include = "Salespeople "
      ENDIF

      *-- If salespeople included, offer range filter
      @ ln_line, 56.5 GET lc_bpepl ;
                          PICTURE "!!!!" ;
                          WHEN lc_include $ "Salespeople ~Both        " ;
                          VALID v_slspepl("lc_bpepl")
      @ ln_line, COL() + 1 GET lc_epepl ;
                               PICTURE "!!!!" ;
                               WHEN lc_include $ ;
                               "Salespeople ~Both        " AND ;
                               NOT EMPTY(lc_bpepl) ;
                               VALID v_slspepl("lc_epepl")
      DO g_sayop WITH ln_line, "Salespeople", ;
                      "(range or blank for all)"

      *-- If using sales groups, handle salegroup range
      IF gl_slsgps
        *-- If sales groups included, offer range filter
        @ ln_line, 56.5 GET lc_bgrp ;
                            PICTURE "!!!!" ;
                            WHEN lc_include $ "Sales Groups~Both        " ;
                            VALID v_slsgrp("lc_bgrp")
        @ ln_line, COL() + 1 GET lc_egrp ;
                                 PICTURE "!!!!" ;
                                 WHEN lc_include $ ;
                                 "Sales Groups~Both        " AND ;
                                 NOT EMPTY(lc_bgrp) ;
                                 VALID v_slsgrp("lc_egrp")
        DO g_sayop WITH ln_line, "Sales Group", ;
                        "(range or blank for all)"
      ENDIF

      *-- Display Commissions Due, Paid, adjustments or all 3
      IF TRIM(LEFT(lc_file,1)) $ "Current~Both   "
        @ ln_line, 56.5 GET lc_adjust ;
                            PICTURE ;
                            "@M Due   ,Paid  ,Adjust,All   "
        DO g_sayop WITH ln_line, "Include", ;
                        "{Due/Paid/Adjust/All}"
      ELSE
        @ ln_line, 56.5 GET lc_adjust ;
                            PICTURE ;
                            "@M Paid  ,Adjust,All   "
        DO g_sayop WITH ln_line, "Include", ;
                        "{Paid/Adjust/All}"
      ENDIF

      *-- Option to mark unpaid commissions as paid after running report
      @ ln_line, 56.5 GET lc_markem ;
                          PICTURE "@M Y,N"
      DO g_sayop WITH ln_line, "Mark as Paid","{Y/N}"

    CASE lc_rept = "8"
      *--  - Quota Vs. Actual Sales

      *-- If period selected, specify period(s) to report on
      @ ln_line, 56.5 GET ln_bperiod ;
                          PICTURE "@Z 99" ;
                          VALID v_period()
      @ ln_line, COL() + 1 GET ln_eperiod ;
                               PICTURE "@Z 99" ;
                               VALID v_period()

      *-- Determine wether to display quarters or months
      IF VAL(gc_slsqpd) = 4
        *-- Display quarters
        DO g_sayop WITH ln_line, "Quarter(s)", "(specify quarter(s))"
      ELSE
        *-- Display months
        DO g_sayop WITH ln_line, "Month(s)", "(specify month(s))"
      ENDIF

      *-- Detemine who to include, people groups or both
      @ ln_line, 56.5 GET lc_include ;
                          PICTURE ;
                          "@M Salespeople ,Sales Groups,Both        " ;
                          VALID v_include("8")
      DO g_sayop WITH ln_line, "Include", "{Salespeople/Sales Groups/Both}"

      *-- If people included offer range
      @ ln_line, 56.5 GET lc_bpepl ;
                          PICTURE "!!!!" ;
                          WHEN lc_include $ "Salespeople ~Both        " ;
                          VALID v_slspepl("lc_bpepl")
      @ ln_line, COL() + 1 GET lc_epepl ;
                               PICTURE "!!!!" ;
                               WHEN lc_include $ ;
                               "Salespeople ~Both        " AND ;
                               NOT EMPTY(lc_bpepl) ;
                               VALID v_slspepl("lc_epepl")
      DO g_sayop WITH ln_line, "Salespeople", ;
                      "(range or blank for all)"

      *-- If groups included offer range filter
      @ ln_line, 56.5 GET lc_bgrp ;
                          PICTURE "!!!!" ;
                          WHEN lc_include $ "Sales Groups~Both        " ;
                          VALID v_slsgrp("lc_bgrp")
      @ ln_line, COL() + 1 GET lc_egrp ;
                               PICTURE "!!!!" ;
                               WHEN lc_include $ ;
                               "Sales Groups~Both        " AND ;
                               NOT EMPTY(lc_bgrp) ;
                               VALID v_slsgrp("lc_egrp")
      DO g_sayop WITH ln_line, "Sales Group", ;
                      "(range or blank for all)"

    CASE lc_rept = "9"
      *-- Commmissions for Items
      @ ln_line, 56.5 GET lc_sumdet ;
                          PICTURE "@M Summary,Detail "
      DO g_sayop WITH ln_line, "Summary/Detail", "{Summary/Detail}"

      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current,History,Both   " ;
                          VALID v_scope()

      DO g_sayop WITH ln_line, "Report Scope", "{Current/History/Both}"

      *-- Determine wether to display quarters or months
      IF gc_slstrb = Cc_QtrTierBasis
        *-- Display quarters
        @ ln_line, 56.5 GET lc_range ;
                            PICTURE "@M Quarter,Range  " ;
                            WHEN LEFT(lc_file,1) = "C" ;
                            VALID v_range()
        DO g_sayop WITH ln_line, "Quarter/Range", "{Quarter/Range}"

        @ ln_line, 56.5 GET ln_bperiod ;
                            PICTURE "@Z 99" ;
                            WHEN LEFT(lc_range,1) = "Q" ;
                            VALID v_trbrng()

        @ ln_line, COL() + 1 GET ln_eperiod ;
                                 PICTURE "@Z 99" ;
                                 WHEN LEFT(lc_range,1) = "Q" ;
                                 VALID v_trbrng()
        DO g_sayop WITH ln_line, "Quarter Range", "(specify quarter(s))"
      ELSE
        *-- Display months
        @ ln_line, 56.5 GET lc_range ;
                            PICTURE "@M Month,Range" ;
                            WHEN LEFT(lc_file,1) = "C" ;
                            VALID v_range()
        DO g_sayop WITH ln_line, "Month/Range", "{Month/Range}"

        @ ln_line, 56.5 GET ln_bperiod ;
                            PICTURE "@Z 99" ;
                            WHEN LEFT(lc_range,1) = "M" ;
                            VALID v_trbrng()
        @ ln_line, COL() + 1 GET ln_eperiod ;
                                 PICTURE "@Z 99" ;
                                 WHEN LEFT(lc_range,1) = "M" ;
                                 VALID v_trbrng()
        DO g_sayop WITH ln_line, "Month Range", "(specify month(s))"
      ENDIF

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          WHEN LEFT(lc_range,1) = "R" ;
                          VALID g_valdte()
      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               WHEN LEFT(lc_range,1) = "R" ;
                               VALID g_chkdt(lc_bdate, lc_edate)
      DO g_sayop WITH ln_line, "Date Range", ;
                      "(date range or blank for all)"

      @ ln_line, 56.5 GET lc_plinid ;
                          PICTURE "!!!!!!" VALID v_plinid()
      DO g_sayop WITH ln_line, "Product Line", ;
                      "(specify or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", " v_item() ", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", ;
                      "(<F2> to list, specify or blank for all)"

    CASE lc_rept = "A"
      *-- Inventory Master
      @ ln_line, 56.5 GET lc_type ;
                          PICTURE "@M All,Asset,Expense,Inventory,Service"
      DO g_sayop WITH ln_line, "Item Type ", ;
                      "{All/Asset/Expense/Inventory/Svc}"

      IF gl_locts
        @ ln_line, 56.5 GET lc_loctid ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(portion or blank for all)"
      ENDIF

      @ ln_line, 56.5 GET lc_order ;
                          PICTURE "@M Description, Item"
      DO g_sayop WITH ln_line, "Order By", "{Description/Item}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      DO g_sayop WITH ln_line, "Last Sold", "(sold after or blank for all)"

*\ [Begin] PTR None 01/23/04 TISM Set length of item dynamically
*\ [Begin] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 56.5, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"
*\ [End] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
*\ [End] PTR None 01/23/04 TISM Set length of item dynamically

      @ ln_line, 56.5 GET lc_vpartno ;
                          PICTURE REPLICATE("!", 15)
      DO g_sayop WITH ln_line, "Part Number", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_bclass ;
                          PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass ;
                                        PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 56.5 GET lc_bccode ;
                          PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode ;
                                        PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 56.5 GET lc_bmcode ;
                          PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode ;
                                        PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

    CASE lc_rept == "BO"
      *-- Blanket Order Report

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_begbo ;
                          PICTURE "@!"
      @ ln_line, COL() + 1 GET lc_endbo ;
                               PICTURE "@!"
      DO g_sayop WITH ln_line, "BO # Range", "(blank for all)"

      @ ln_line, 56.5 GET lc_status ;
                          PICTURE "@M Open  ,Closed,Void  ,All   "
      DO g_sayop WITH ln_line, "BO Status", "{Open/Closed/Void/All}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(BO date or blank for all)"

      @ ln_line, 56.5 GET lc_order ;
                          PICTURE "@M Customer,BO #  "
      DO g_sayop WITH ln_line, "Order By", "{Customer/BO #}"

      IF lc_detail = "D"
        @ ln_line, 56.5 GET lc_uom ;
                            PICTURE "@M Transaction unit,Stock unit,Both"
        DO g_sayop WITH ln_line, "Quantity in", ;
                        "{Transaction Unit/Stock Unit/Both}"
      ENDIF

    CASE lc_rept = "C"
      *-- Customer File
      @ ln_line, 56.5 GET lc_order PICTURE "@M Company, Number, Sales " + ;
                          ALLTRIM(gc_currsym) + "s"
      DO g_sayop WITH ln_line, "Order By", ;
                      "{Company/Number/Sales " + ALLTRIM(gc_currsym) + "s}"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [2 lines] PTR 74256 03/22/04 SSHA National Account for Customer File Report
*\ [2 Lines] PTR# 75575 06/04/04 TIJH Used g_getop to provide pick list functionality
*\ [1 line] PTR# 76649 07/19/04 TISY Check whether 'AR' is installed
      IF gl_ar
*\ [1 line] PTR# 76847 07/27/04 TINP Modified the Coloumn Coordinate
        = g_getop(ln_line, 56.5, "lc_NlacNo", "!!!!!!", "", "", "", "", "N", "", .t., .t.)
        DO g_sayop WITH ln_line, "National Account", "(<F2> to list, portion or blank for all)"
      ENDIF 

      @ ln_line, 56.5 GET lc_ctype ;
                          PICTURE "!!!!!!!!"
      DO g_sayop WITH ln_line, "Cust Type", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_indust ;
                          PICTURE "!!!!!"
      DO g_sayop WITH ln_line, "Industry", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_salesmn ;
                          PICTURE "!!!!"
      DO g_sayop WITH ln_line, "Salesperson", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_terr ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Territory", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Cust Misc Code", "(portion or blank for all)"

*\ [1 line] PTR# 74081 03/18/04 TIRK Customer status option is included in option grid
	  @ ln_line, 56.5 GET lc_status PICTURE "@M All,Active,Inactive"
      DO g_sayop WITH ln_line, "Customer Status", "{All/Active/Inactive}"                      
      
      *--
    CASE lc_rept = "D"
      *-- Salespeople Sales Group File Listings
      @ ln_line, 56.5 GET lc_include ;
                          PICTURE ;
                          "@M Salespeople ,Sales Groups,Both        " ;
                          VALID v_include("D")
      DO g_sayop WITH ln_line, "Include", "{Salespeople/Sales Groups/Both}"

      @ ln_line, 56.5 GET lc_tiers ;
                          PICTURE "@M Y,N"
      DO g_sayop WITH ln_line, "Include Tiers", "{Y/N}"

      @ ln_line, 56.5 GET lc_bgrp ;
                          PICTURE "!!!!" ;
                          WHEN lc_include $ "Sales Groups~Both        " ;
                          VALID v_slsgrp("lc_bgrp")
      @ ln_line, COL() + 1 GET lc_egrp ;
                               PICTURE "!!!!" ;
                               WHEN lc_include $ ;
                               "Sales Groups~Both        " AND ;
                               NOT EMPTY(lc_bgrp) ;
                               VALID v_slsgrp("lc_egrp")
      DO g_sayop WITH ln_line, "Sales Group", ;
                      "(range or blank for all)"

      @ ln_line, 56.5 GET lc_saletyp ;
                          PICTURE ;
                          "@M Employee        ,Contractor      ," + ;
                          "Non-Commissioned   ,All             " ;
                          WHEN lc_include <> "Sales Groups" ;
                          VALID v_saletyp()
      DO g_sayop WITH ln_line, "Salespeople Types", ;
                      "{Employee/Contractor/Non-Comm./All}"

      @ ln_line, 56.5 GET lc_bpepl ;
                          PICTURE "!!!!" ;
                          WHEN lc_include $ "Salespeople ~Both        " ;
                          VALID v_slspepl("lc_bpepl", ;
                          LEFT(lc_saletyp,1))
      @ ln_line, COL() + 1 GET lc_epepl ;
                               PICTURE "!!!!" ;
                               WHEN lc_include $ ;
                               "Salespeople ~Both        " AND ;
                               NOT EMPTY(lc_bpepl) ;
                               VALID v_slspepl("lc_epepl", ;
                               LEFT(lc_saletyp,1))
      DO g_sayop WITH ln_line, "Salespeople", ;
                      "(range or blank for all)"

      @ ln_line, 56.5 GET lc_div ;
                          PICTURE "@A" ;
                          WHEN lc_include <> "Sales Groups"
      DO g_sayop WITH ln_line, "Division", "(specify or blank for all)"

      @ ln_line, 56.5 GET lc_terr ;
                          PICTURE "@!" ;
                          WHEN lc_include <> "Sales Groups"
      DO g_sayop WITH ln_line, "Territory", "(specify or blank for all)"

      @ ln_line, 56.5 GET lc_dept ;
                          PICTURE "@A" ;
                          WHEN lc_include <> "Sales Groups"
      DO g_sayop WITH ln_line, "Department", "(specify or blank for all)"

    CASE lc_rept = "F"
      *-- Ship-to Address File
      @ ln_line, 56.5 GET lc_order ;
                          PICTURE "@M Company , Number "
      DO g_sayop WITH ln_line, "Order By", "{Company/Number}"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_custno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_ctype ;
                          PICTURE "!!!!!!!!"
      DO g_sayop WITH ln_line, "Customer Type", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_indust ;
                          PICTURE "!!!!!"
      DO g_sayop WITH ln_line, "Industry", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_salesmn ;
                          PICTURE "!!!!"
      DO g_sayop WITH ln_line, "Salesperson", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_terr ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Territory", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Cust Misc Code", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_ship ;
                          PICTURE "@M All , Default"
      DO g_sayop WITH ln_line, "Ship To Address", "(All or Default)"

      @ ln_line, 56.5 GET lc_cntry ;
                          PICTURE "@!"
      DO g_sayop WITH ln_line, "Country", "(portion or blank for all)"

    CASE lc_rept = "I"
      *-- Sales Tax By Tax Code
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()
      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(ship date or blank for all)"

      IF lc_detail = "D"
        @ ln_line, 56.5 GET lc_order ;
                            PICTURE "@M Customer, Item    "
        DO g_sayop WITH ln_line, "Order By", "{Customer/Item}"
      ENDIF

      @ ln_line, 56.5 GET lc_taxcode ;
                          PICTURE "!"
      DO g_sayop WITH ln_line, "Tax Code", "(blank for all)"

    CASE lc_rept = "M"
      *-- Operation Summary
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(trans date or blank for all)"

      @ ln_line, 56.5 GET lc_order ;
                          PICTURE "@M Date, Item"
      DO g_sayop WITH ln_line, "Order By", "{Date/Item}"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 56.5 GET lc_class ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

      ACTIVATE WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      ll_read = .f.

      IF lc_order = "I" AND LASTKEY() <> gk_esc
        @ ln_line, 56.5 GET lc_uom ;
                            PICTURE "@M Transaction unit, Stock unit,Both"
        DO g_sayop WITH ln_line, "Quantity in", ;
                        "{Transaction unit/Stock unit/Both}"

        ll_read = .t.
      ENDIF

    CASE lc_rept = "P"
      *-- Customer Purchase Order Report
      @ ln_line, 56.5 GET lc_custno ;
                          PICTURE "@!" VALID l_valcust()
      DO g_sayop WITH ln_line, "Customer", ;
                      "(<F2>, portion, or blank for all)"

      *-- PO Number
      @ ln_line, 56.5 GET lc_pono ;
                          PICTURE "@!" VALID l_valpo()
      DO g_sayop WITH ln_line, "PO Number", ;
                      "(<F2>, portion, or blank for all)"

      *-- File to use
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Date range
      @ ln_line, 56.5 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", "(order date or blank for all)"

      *-- Include type
      @ ln_line, 56.5 GET lc_type ;
                          PICTURE "@M All         , Exclude bids, " + ;
                          "Orders      , Returns     , Bids        "

      DO g_sayop WITH ln_line, "Include Type", ;
                      "{All/Exclude bids/Orders/Return/Bid}"

      *-- Item
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 56.5, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2>, portion or blank for all)"

    CASE lc_rept = "R"
      *-- Comments
      @ ln_line, 56.5 GET lc_bcommid ;
                          PICTURE "!!!!!!"
      @ ln_line, COL() + 1 GET lc_ecommid ;
                               PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Code Range", "(portion or blank for all)"

    CASE lc_rept = "T"
      *-- Picking Tickets
      @ ln_line, 57 GET lc_changed PICTURE "@M New and Changed,All"
      DO g_sayop WITH ln_line, "Print Only", "{New and changed/All}"

      @ln_line, 57 GET lc_incld PICTURE "@M All Items, Stock Items"
      DO g_sayop WITH ln_line, "Item Type","{All Items/Stock Items}"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate ;
                               PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", ;
                      "(required date or blank for all)"

      IF gl_tiw
        @ ln_line, 57 GET lc_grpitem PICTURE "@M Yes,No "
        DO g_sayop WITH ln_line, "Group like items", "{Yes/No}"
      ENDIF

      @ ln_line, 57 GET lc_bsono PICTURE gc_docpic
      DO g_sayop WITH ln_line, "Beginning Order #", "(leave blank for all)"

      @ ln_line, 57 GET lc_esono PICTURE gc_docpic
      DO g_sayop WITH ln_line, "Ending Order #", "(leave blank for all)"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 57, "lc_xcustno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Customer", "(<F2> to list, portion or blank for all)"

*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
      = g_getop(ln_line, 57, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_loc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Location", "(portion or blank for all)"

        @ ln_line, 57 GET lc_order PICTURE "@M Item, Location, Order Sequence"
        DO g_sayop WITH ln_line, "Order By", "{Item/Location/Order Sequence}"

        @ ln_line, 57 GET lc_lpage PICTURE "@M Yes,No"
        DO g_sayop WITH ln_line, "Print", "(separate page per location)"
      ENDIF

*\ [Begin] PTR 76407 07/06/04 DAND Customer payment terms listing
   CASE lc_rept = "U"
      *-- Customer Payment Terms listing
      @ ln_line, 57 GET lc_order PICTURE "@M Terms ID , Description "
      DO g_sayop WITH ln_line, "Order By", "{Terms ID/Description}"
*\ [End] PTR 76407 07/06/04 DAND Customer payment terms listing

    CASE lc_rept = "V"
*\ [1 Line] PTR# 69388 03/23/04 TIGJ Increased to 11 digits in the integer part
      *-- Customer Distribution by Value
      @ ln_line, 56.5 GET ln_minamt ;
                          PICTURE lc_amtpict
      DO g_sayop WITH ln_line, "Minimum Value", ;
                      "(Include values >= this amount)"

      @ ln_line, 56.5 GET lc_ctype ;
                          PICTURE "!!!!!!!!"
      DO g_sayop WITH ln_line, "Cust Type", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_indust ;
                          PICTURE "!!!!!"
      DO g_sayop WITH ln_line, "Industry", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_salesmn ;
                          PICTURE "!!!!"
      DO g_sayop WITH ln_line, "Salesperson", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_terr ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Territory", "(portion or blank for all)"

      @ ln_line, 56.5 GET lc_code ;
                          PICTURE "!!"
      DO g_sayop WITH ln_line, "Cust Misc Code", "(portion or blank for all)"

    CASE lc_rept = "S"
      *-- Drop Ship Status Report
      @ ln_line, 56.5 GET lc_file ;
                          PICTURE "@M Current, History, Both   "
      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      SHOW WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      ACTIVATE WINDOW lw_rept

      IF LASTKEY() <> gk_esc

        IF lc_file = "C"
          @ ln_line, 56.5 GET lc_include ;
                              PICTURE "@M To Purchase, Unrecd, " + ;
                              "Partial, Complete, All"
          DO g_sayop WITH ln_line, "Include Only ", ;
                          "{To Purchase/Unrecd/Partial/Complete/All}"
        ELSE
          @ ln_line, 56.5 GET lc_include ;
                              PICTURE "@M Received   , All        "
          DO g_sayop WITH ln_line, "Include Only ", ;
                          "{Received/All}"
        ENDIF

        SHOW WINDOW lw_rept

        *-- Call special READ function
        = g_read()

        ACTIVATE WINDOW lw_rept
      ENDIF

      IF LASTKEY() <> gk_esc

        IF LEFT(lc_include,1) = "T"
          @ ln_line, 56.5 GET lc_order ;
                              PICTURE "@M Order #          , " + ;
                              "Customer #       , Reqd. Date          "

          DO g_sayop WITH ln_line, "Order By", ;
                          "{Order #/Cust #/Reqd. Date}"
        ELSE
          @ ln_line, 56.5 GET lc_order ;
                              PICTURE "@M Order #          , Purchase "+ ;
                              "Order # , Vendor #         , "+ ;
                              "Customer #       , Reqd. Date          "

          DO g_sayop WITH ln_line, "Order By", ;
                          "{Order #/PO #/Vend #/Cust #/Rq Date}"
        ENDIF

*\ [Begin] PTR None 01/22/04 TISM Set picture dynamically to the length of custno
*\ [Begin] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
        = g_getop(ln_line, 56.5, "lc_bcust", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
        DO g_sayop WITH ln_line, "Beginning Cust", "(<F2> to list, portion or blank for all)"

        = g_getop(ln_line, 56.5, "lc_ecust", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "C", "", .t., .t.)
        DO g_sayop WITH ln_line, "Ending Cust", "(<F2> to list, portion or blank for all)"
*\ [End] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
*\ [End] PTR None 01/22/04 TISM Set picture dynamically to the length of custno

        @ ln_line, 56.5 GET lc_bsono ;
                            PICTURE "##########"
        DO g_sayop WITH ln_line, "Beginning Order #", "(leave blank for all)"

        @ ln_line, 56.5 GET lc_esono ;
                            PICTURE "##########"
        DO g_sayop WITH ln_line, "Ending Order #", "(leave blank for all)"

        @ ln_line, 56.5 GET lc_bdate ;
                            PICTURE gc_datepi8 ;
                            VALID g_valdte()

        @ ln_line, COL() + 1 GET lc_edate ;
                                 PICTURE gc_datepi8 ;
                                 VALID g_chkdt(lc_bdate, lc_edate)
        DO g_sayop WITH ln_line, "Reqd. Date Range", ;
                        "(order date or blank for all)"

        IF lc_include <> "T"

*\ [1 Line] PTR None 01/22/04 TISM Set picture dynamically to the length of vendno
*\ [2 Lines] PTR# 75151 05/14/04 TISJ Used g_getop to provide pick list functionality
          = g_getop(ln_line, 56.5, "lc_supp", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                    "", "", "", "V", "", .t., .t.)
          DO g_sayop WITH ln_line, "Supplier", "(<F2> to list, leave blank for all)"
        ENDIF

        @ ln_line, 56.5 GET lc_class ;
                            PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"
      ENDIF

  CASE lc_rept = "Y"
      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both   "

      DO g_sayop WITH ln_line, "File to Use", ;
                      "{Current/History/Both}"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 VALID g_valdte()

      @ ln_line, COL() + 1 GET lc_edate PICTURE gc_datepi8 ;
                               VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Date Range", ;
                      "(transaction date or blank for all)"

      lc_acctpic = TRANSFORM(REPLICATE("#", gn_acctlen), gc_acctpic)

      IF gn_acctlen <= 21
        *-- Enough room in grid
        @ ln_line, 57 GET lc_baccnt PICTURE gc_acctpic
      ELSE
        *-- Activate a windowed get
        @ ln_line, 57 GET lc_baccnt PICTURE LEFT(gc_acctpic, 9) ;
                          WHEN g_winget(gc_acctpic, "Beginning Account")
      ENDIF

      DO g_sayop WITH ln_line, "Beginning Account ", ;
                      "(blank for all)"

      IF gn_acctlen <= 21
        *-- Enough room in grid
        @ ln_line, 57 GET lc_eaccnt PICTURE gc_acctpic
      ELSE
        *-- Activate a windowed get
        @ ln_line, 57 GET lc_eaccnt PICTURE LEFT(gc_acctpic, 9) ;
                          WHEN g_winget(gc_acctpic, "Ending Account")
      ENDIF

      DO g_sayop WITH ln_line, "Ending Account ", ;
                      "(blank for all)"

      @ ln_line, 57 GET lc_order PICTURE "@M Customer, Sales Order"

      DO g_sayop WITH ln_line, "Order By", ;
                      "{Customer/ Sales Order}"

      lc_taxcode = SPACE(6)
      @ ln_line, 57 GET lc_taxcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Tax Code", ;
                      "(blank for all)"


  ENDCASE

  IF lc_rept $ "134P" AND gl_mc
    @ ln_line, 56.5 GET lc_cursum PICTURE "@M Yes,No "
    DO g_sayop WITH ln_line, "Currency Summary", "{Yes/No}"
  ENDIF

  IF ll_read AND LASTKEY() <> gk_esc
    ACTIVATE WINDOW lw_rept

    *-- Call special READ function
    = g_read()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_getop
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SETHD
*------------------------------------------------------------------------------
*- Description: Set up report headings
*------------------------------------------------------------------------------
*- Synopsis...: Set up report headings according to entered options.
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*-              lc_rept, report identifier
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: lc_head1, heading line 1
*-              lc_head2, heading line 2
*------------------------------------------------------------------------------
PROCEDURE l_sethd

  PRIVATE lc_daterng, ;
          lc_rngstrt, ;
          lc_rngend, ;
          ln_dbperd, ;
          ln_deperd

  *-- Initialize headings
  lc_head1    = ""
  lc_head2    = ""
  lc_head3    = ""
  lc_daterng  = ""
  lc_rngstrt  = ""
  lc_rngend   = ""
  ln_dbperd   = 0
  ln_deperd   = 0

  *-- File to use
  IF lc_rept $ "12479IMPS"

    DO CASE
      CASE lc_rept = "2" AND ll_UnInvRept
        *-- Ingore file selection for uninvoiced So Shipments report
        IF lc_GrpOrds = "Yes"
          lc_head1 = "Grouped by Line Items and Unit of Measure "
        ENDIF

      CASE LEFT(lc_file,1) = "C"
        lc_head1 = "Current File "
      CASE LEFT(lc_file,1) = "H"
        lc_head1 = "History File "
      OTHERWISE
        lc_head1 = "Current and History Files "
    ENDCASE

  ENDIF

  *--
  *-- Date range
  IF lc_rept $ "123479MIP"

    DO CASE
      CASE NOT EMPTY(g_retdt(lc_bdate)) AND NOT EMPTY(g_retdt(lc_edate))
        lc_head1 = lc_head1 + lc_bdate + " to " + lc_edate + " "

      CASE NOT EMPTY(g_retdt(lc_bdate))
        lc_head1 = lc_head1 + "On or After " + lc_bdate + " "

      CASE NOT EMPTY(g_retdt(lc_edate))
        lc_head1 = lc_head1 + "Before " + lc_edate + " "
    ENDCASE

  ENDIF

  DO CASE
    CASE lc_rept $ "1P"

      *-- Transactions
      DO CASE
        CASE lc_type = "A"
          lc_head1 = lc_head1 + "All Order Types"
        CASE lc_type = "E"
          lc_head1 = lc_head1 + "Open & Return Order Types"
        CASE lc_type = "O"
          lc_head1 = lc_head1 + "Orders Only"
        CASE lc_type = "D"
          lc_head1 = lc_head1 + "Drop Ship Orders Only"
        CASE lc_type = "R"
          lc_head1 = lc_head1 + "Return Orders Only"
        CASE lc_type = "B"
          lc_head1 = lc_head1 + "Bids Only"
      ENDCASE

      IF NOT EMPTY(lc_loctid)
        lc_head2 = lc_head2 + "  Location = " + TRIM(lc_loctid)
      ENDIF

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + "  Cust = " + TRIM(lc_custno)
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

    CASE lc_rept = "2"
      *-- Shipments

      IF ll_UnInvRept
        lc_head1 = lc_head1 + " Tax Excluded"
      ELSE
        lc_head1 = lc_head1 + " Tax " + IIF(lc_tax = "Y", "Included", "Excluded")
      ENDIF

      IF NOT EMPTY(lc_loctid)
        lc_head2 = lc_head2 + " Location = " + TRIM(lc_loctid)
      ENDIF

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + " Cust = " + TRIM(lc_custno)
      ENDIF

      IF ll_UnInvRept

        IF NOT EMPTY(lc_ShipVia)
          lc_head2 = lc_head2 + " Ship Via = " + TRIM(lc_ShipVia)
        ENDIF

        IF NOT EMPTY(lc_FOB)
          lc_head2 = lc_head2 + " FOB = " + TRIM(lc_FOB)
        ENDIF

        IF NOT EMPTY(lc_SalesMn)
          lc_head2 = lc_head2 + " Salesperson = " + TRIM(lc_SalesMn)
        ENDIF

        IF gl_mc AND NOT EMPTY(lc_CurrId)
          lc_head2 = lc_head2 + " Currency = " + TRIM(lc_CurrId)
        ENDIF

      ELSE

        IF NOT EMPTY(lc_item)
          lc_head2 = lc_head2 + " Item = " + TRIM(lc_item)
        ENDIF

        IF NOT EMPTY(lc_class)
          lc_head2 = lc_head2 + " Class = " + TRIM(lc_class)
        ENDIF

        IF NOT EMPTY(lc_code)
          lc_head2 = lc_head2 + " Code = " + TRIM(lc_code)
        ENDIF

      ENDIF

    CASE lc_rept = "3"
      *-- Open Orders

      DO CASE
        CASE lc_type = "A"
          lc_head1 = lc_head1 + "All Order Types"
          lc_head3 = "Includes Bids"
        CASE lc_type = "E"
          lc_head1 = lc_head1 + "Open & Return Order Types"
          lc_head3 = "Excludes Bids"
        CASE lc_type = "O"
          lc_head1 = lc_head1 + "Orders Only"
          lc_head3 = "Excludes Bids and Returns"
        CASE lc_type = "R"
          lc_head1 = lc_head1 + "Return Orders Only"
          lc_head3 = "Excludes Orders and Bids"
        CASE lc_type = "B"
          lc_head1 = lc_head1 + "Bids Only"
          lc_head3 = "Excludes Orders and Returns"
        CASE lc_type = "D"
          lc_head1 = lc_head1 + "Drop Ship Only"
          lc_head3 = "Excludes Orders and Returns and Bids"
      ENDCASE

      DO CASE
        CASE lc_only = "A"
          lc_head1 = lc_head1 + ", All Open Orders"
        CASE lc_only = "P"
          lc_head1 = lc_head1 + ", Part'l Ship Only"
      ENDCASE

      IF lc_shipped <> "A"
        lc_head1 = lc_head1 + ", Unshipped Items Only"
      ENDIF

      IF lc_show = "V"
        lc_head1 = lc_head1 + ", Tax " + ;
                   IIF(lc_tax = "Y", "Included", "Excluded")

      ENDIF

      *-- Added if condition to show heading only
      *-- for summary option
      IF lc_detail = "S"

        IF LEFT(lc_show,1) = "Q"
          lc_head1 = lc_head1 + ", In Order of Qty Ordered"
        ELSE
          lc_head1 = lc_head1 + ", In Order of Value Ordered"
        ENDIF

      ENDIF

      IF NOT EMPTY(lc_loctid)
        lc_head2 = lc_head2 + "  Location = " + TRIM(lc_loctid)
      ENDIF

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + "  Cust = " + TRIM(lc_custno)
      ENDIF

      IF NOT EMPTY(lc_item)

        IF gl_sbtmod

          IF lc_incitm = "I"
            lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
          ELSE
            lc_head2 = lc_head2 + "  Item <> " + TRIM(lc_item)
          ENDIF

        ELSE
          lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
        ENDIF

      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

    CASE lc_rept = "4"
      *-- Orders by Salesperson

      DO CASE
        CASE lc_only = "A"
          lc_head1 = lc_head1 + "All Open Orders"
        CASE lc_only = "O"
          lc_head1 = lc_head1 + "Open Orders Only"
        CASE lc_only = "P"
          lc_head1 = lc_head1 + "Part'l Ship Only"
      ENDCASE

      IF LEFT(lc_show,1) = "Q"
        lc_head1 = lc_head1 + ", In Order of Qty Ordered"
      ELSE
        lc_head1 = lc_head1 + ", In Order of Value Ordered"
      ENDIF

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + "  Cust = " + TRIM(lc_custno)
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

    CASE lc_rept = "5"
      *-- Order Picking List

      lc_head1 = ""

      DO CASE
        CASE NOT EMPTY(g_retdt(lc_bdate)) AND NOT EMPTY(g_retdt(lc_edate))
          lc_head1 = lc_head1 + lc_bdate + " to " + lc_edate

        CASE NOT EMPTY(g_retdt(lc_bdate))
          lc_head1 = lc_head1 + "Dates After " + lc_bdate

        CASE NOT EMPTY(g_retdt(lc_edate))
          lc_head1 = lc_head1 + "Dates Before " + lc_edate
      ENDCASE

      IF NOT EMPTY(lc_bsono)
        lc_head1 = lc_head1 + "  Beginning Order # = " + lc_bsono
      ENDIF

      IF NOT EMPTY(lc_esono)
        lc_head1 = lc_head1 + "  Ending Order # = " + lc_esono
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head1 = lc_head1 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head1 = lc_head1 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head1 = lc_head1 + "  Code = " + TRIM(lc_code)
      ENDIF

      IF LEN(lc_head1) = 4
        lc_head1 = ""
      ENDIF

    CASE lc_rept = "6"
      *-- Recurring Orders

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + "  Cust = " + TRIM(lc_custno)
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

      *--
    CASE lc_rept = "7"
      *-- Commissions for groups / people

      *-- If Quarter/Month selected
      IF lc_range $ "Quarter~Month  "
        ln_dbperd = IIF(ln_bperiod = 0, 1, ln_bperiod)

        *-- Determine character string for date range
        IF gc_slstrb = Cc_QtrTierBasis
          *-- Quarter
          lc_daterng = " Quarter = "

          *-- Using quarters, last perid will be 4
          ln_deperd = IIF(ln_eperiod = 0, 4, ln_eperiod)

          lc_rngstrt = STR(ln_dbperd,2,0)
          lc_rngend  = STR(ln_deperd,2,0)
        ELSE
          *-- Month
          lc_daterng = " Month = "

          *-- Using months, last period will be 12
          ln_deperd = IIF(ln_eperiod = 0, 12, ln_eperiod)

          lc_rngstrt = LEFT(CMONTH(ld_begdt + ;
                       INT((365/12)*(ln_dbperd-1)+15)),3)
          lc_rngend  = LEFT(CMONTH(ld_begdt + ;
                       INT((365/12)*(ln_deperd-1)+15)),3)
        ENDIF

        *-- Check if begining and ending periods specified
        IF ln_bperiod <> 0 OR ln_eperiod <> 0
          lc_head2 = lc_head2 + lc_daterng + lc_rngstrt

          IF ln_bperiod <> ln_eperiod
            lc_head2 = lc_head2 + "  thru " + lc_rngend
          ENDIF

        ELSE
          *-- Begining or ending period is blank, default to all
          lc_head2 = lc_head2 + lc_daterng + "All"
        ENDIF

      ENDIF

      *-- If Period selected
      IF lc_range = "Year  "
        lc_head2 = lc_head2 + " Entire Year "
      ENDIF

      *-- Heading for type ...salesperson, sales groups or both
      DO CASE
        CASE NOT gl_slsgps
          *-- Do not put up type if sales group not setup
        CASE lc_include <> "Both"
          lc_head2 = lc_head2 + "  for " + TRIM(lc_include)
        OTHERWISE
          lc_head2 = lc_head2 + " for Both Salespeople and Sales group "
      ENDCASE

      *-- Beginning range for salesperson
      IF NOT EMPTY(lc_bpepl)
        lc_head3 = lc_head3 + "  Salesperson = " + lc_bpepl
      ENDIF

      *-- Ending range for salesperson
      IF NOT EMPTY(lc_epepl) AND lc_bpepl <> lc_epepl
        lc_head3 = lc_head3 + " thru " + lc_epepl
      ENDIF

      *-- Beginning range for groups
      IF NOT EMPTY(lc_bgrp)
        lc_head3 = lc_head3 + "  Sales group = " + lc_bgrp
      ENDIF

      *-- Ending range for groups
      IF NOT EMPTY(lc_egrp) AND lc_bgrp <> lc_egrp
        lc_head3 = lc_head3 + " thru " + lc_egrp
      ENDIF

      *-- Adjustment types
      DO CASE
        CASE TRIM(lc_adjust) = "All"
          lc_head3 = lc_head3 + ;
                     "  Include = Due, Paid and Adjustments"

        OTHERWISE
          lc_head3 = lc_head3 + "  Include = " + TRIM(lc_adjust)
      ENDCASE

    CASE lc_rept = "8"
      *-- Quotas vs. Actual

      ln_dbperd = IIF(ln_bperiod = 0, 1, ln_bperiod)

      *-- Determine character string for date range
      IF VAL(gc_slsqpd) = 4
        *-- Quarter
        lc_daterng = " Quarter = "

        *-- Using quarters, last perid will be 4
        ln_deperd = IIF(ln_eperiod = 0, 4, ln_eperiod)

        lc_rngstrt = STR(ln_dbperd,2,0)
        lc_rngend  = STR(ln_deperd,2,0)
      ELSE
        *-- Month
        lc_daterng = " Month = "

        *-- Using months, last period will be 12
        ln_deperd = IIF(ln_eperiod = 0, 12, ln_eperiod)

        lc_rngstrt = LEFT(CMONTH(ld_begdt + ;
                     INT((365/12)*(ln_dbperd-1)+15)),3)

        lc_rngend  = LEFT(CMONTH(ld_begdt + ;
                     INT((365/12)*(ln_deperd-1)+15)),3)
      ENDIF

      *-- If Period selected
      IF lc_range $ "Quarter~Month  "

        *-- Check if begining and ending periods specified
        IF ln_bperiod <> 0 OR ln_eperiod <> 0
          lc_head2 = lc_head2 + lc_daterng + lc_rngstrt

          IF ln_bperiod <> ln_eperiod
            lc_head2 = lc_head2 + "  thru " + lc_rngend

          ENDIF

        ELSE
          *-- Begining or ending period is blank, default to all
          lc_head2 = lc_head2 + lc_daterng + "All"
        ENDIF

      ENDIF

      *-- Heading for type ...salesperson, sales groups or both
      IF lc_include <> "Both"
        lc_head2 = lc_head2 + "  for " + TRIM(lc_include)
      ELSE
        lc_head2 = lc_head2 + " for Both Salespeople and Sales group "
      ENDIF

      *-- Beginning range for salesperson
      IF NOT EMPTY(lc_bpepl)
        lc_head3 = lc_head3 + "  Salesperson = " + lc_bpepl
      ENDIF

      *-- Ending range for salesperson
      IF NOT EMPTY(lc_epepl) AND lc_bpepl <> lc_epepl
        lc_head3 = lc_head3 + " thru " + lc_epepl
      ENDIF

      *-- Beginning range for groups
      IF NOT EMPTY(lc_bgrp)
        lc_head3 = lc_head3 + "  Sales group = " + lc_bgrp
      ENDIF

      *-- Ending range for groups
      IF NOT EMPTY(lc_egrp) AND lc_bgrp <> lc_egrp
        lc_head3 = lc_head3 + " thru " + lc_egrp
      ENDIF

      *--
    CASE lc_rept = "9"
      *-- Commissions on Items

      lc_head2 = lc_head2 + TRIM(lc_sumdet)

      ln_dbperd = IIF(ln_bperiod = 0, 1, ln_bperiod)

      *-- Determine character string for date range
      IF VAL(gc_slsqpd) = 4
        *-- Quarter
        lc_daterng = " Quarter = "

        *-- Using quarters, last perid will be 4
        ln_deperd = IIF(ln_eperiod = 0, 4, ln_eperiod)

        lc_rngstrt = STR(ln_dbperd,2,0)
        lc_rngend  = STR(ln_deperd,2,0)
      ELSE
        *-- Month
        lc_daterng = " Month = "

        *-- Using months, last period will be 12
        ln_deperd = IIF(ln_eperiod = 0, 12, ln_eperiod)

        lc_rngstrt = LEFT(CMONTH(ld_begdt + ;
                     INT((365/12)*(ln_dbperd-1)+15)),3)
        lc_rngend  = LEFT(CMONTH(ld_begdt + ;
                     INT((365/12)*(ln_deperd-1)+15)),3)
      ENDIF

      *-- If Period selected
      IF lc_range $ "Quarter~Month  "

        *-- Check if begining and ending periods specified
        IF ln_bperiod <> 0 OR ln_eperiod <> 0
          lc_head2 = lc_head2 + lc_daterng + lc_rngstrt

          IF ln_bperiod <> ln_eperiod
            lc_head2 = lc_head2 + "  thru " + lc_rngend

          ENDIF

        ELSE
          *-- Begining or ending period is blank, default to all
          lc_head2 = lc_head2 + lc_daterng + "All"
        ENDIF

      ENDIF

      IF NOT EMPTY(lc_plinid)
        lc_head3 = lc_head3 + " Product Line = " + TRIM(lc_plinid)
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head3 = lc_head3 + " Item = " + TRIM(lc_item)
      ENDIF

    CASE lc_rept = "A"
      *-- Inventory Master

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      IF NOT " " $ lc_bdate
        lc_head1 = lc_head1 + " Sold on or after " + lc_bdate
      ENDIF

      IF gl_locts AND NOT EMPTY(lc_loctid)
        lc_head1 = PROPER(gc_loct) + " " + TRIM(lc_loctid) + ;
                   IIF(EMPTY(lc_head1), "", ", " + lc_head1)
      ENDIF

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + ""
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head2 = lc_head2 + "Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      IF NOT EMPTY(lc_vpartno)
        lc_head2 = lc_head2 + " Vendor Part " + TRIM(lc_vpartno)
      ENDIF

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head3 = lc_head3 + ""
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head3 = lc_head3 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head3 = lc_head3 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head3 = lc_head3 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head3 = lc_head3 + ""
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head3 = lc_head3 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)

        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head3 = lc_head3 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head3 = lc_head3 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head3 = lc_head3 + ""
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head3 = lc_head3 + "  Misc. Code " + TRIM(lc_bmcode) + ;
                     " to " + TRIM(lc_emcode)
      ENDCASE

    CASE lc_rept == "BO"
      *-- Blanket Order file listings

      IF NOT EMPTY(lc_custno)
        lc_head1 = "Customer " + TRIM(lc_custno)
      ENDIF

      DO CASE
        CASE NOT EMPTY(lc_begbo) AND NOT EMPTY(lc_endbo)
          lc_head2 = "Blanket Order " + TRIM(lc_begbo) + " to " + ;
                     TRIM(lc_endbo)

        CASE NOT EMPTY(lc_begbo)
          lc_head2 = "Beginning BO = " + TRIM(lc_begbo)
        CASE NOT EMPTY(lc_endbo)
          lc_head2 = "Ending BO = " + TRIM(lc_endbo)
      ENDCASE

      DO CASE
        CASE NOT EMPTY(g_retdt(lc_bdate)) AND NOT EMPTY(g_retdt(lc_edate))
          lc_head2 = lc_head2 + "BO Date " + TRIM(lc_bdate) + " to " + ;
                     TRIM(lc_edate)

        CASE NOT EMPTY(g_retdt(lc_bdate))
          lc_head2 = lc_head2 + "Beginning BO Date = " + TRIM(lc_bdate)
        CASE NOT EMPTY(g_retdt(lc_edate))
          lc_head2 = lc_head2 + "Ending BO Date = " + TRIM(lc_edate)
      ENDCASE

      DO CASE
        CASE lc_status = "Open"
          lc_head3 = "Open BO's"
        CASE lc_status = "Closed"
          lc_head3 = "Closed BO's"
        CASE lc_status = "Void"
          lc_head3 = "Voided BO's"
        OTHERWISE
          lc_head3 = "All BO's"
      ENDCASE

    CASE lc_rept = "C"
      *-- Customer File

      *-- Customer file report
      DO CASE
        CASE lc_order = "N"
          lc_head1 = "Ordered By Customer Number"
        CASE lc_order = "C"
          lc_head1 = "Ordered By Company Name"
        CASE lc_order = "S"
          lc_head1 = "Ordered By Sales Volume"
      ENDCASE

      IF NOT EMPTY(lc_custno)
        lc_head2 = lc_head2 + "  Number = " + RTRIM(lc_custno)
      ENDIF

*\ [3 lines] PTR 74256 03/22/04 SSHA National Account for Customer File Report
      IF NOT EMPTY(lc_NlacNo)
        lc_head2 = lc_head2 + "  Nat'l A/c = " + RTRIM(lc_NlacNo)
      ENDIF

      IF NOT EMPTY(lc_ctype)
        lc_head2 = lc_head2 + "  Type = " + RTRIM(lc_ctype)
      ENDIF

      IF NOT EMPTY(lc_indust)
        lc_head2 = lc_head2 + "  Indust = " + RTRIM(lc_indust)
      ENDIF

      IF NOT EMPTY(lc_salesmn)
        lc_head2 = lc_head2 + "  Sls Per = " + RTRIM(lc_salesmn)
      ENDIF

      IF NOT EMPTY(lc_terr)
        lc_head2 = lc_head2 + "  Terr = " + RTRIM(lc_terr)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + RTRIM(lc_code)
      ENDIF

*\ [1 Line] PTR# 74081 03/18/04 TIRK Customer status option is included in option grid
      DO CASE
        CASE lc_status = "All"
         *-- No heading required.
        CASE lc_status = "Active"
      	  lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
        CASE lc_status = "Inactive"
          lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
      ENDCASE  
      
      lc_head2 = ALLTRIM(lc_head2)

      IF NOT EMPTY(lc_head2)
        lc_head2 = "Matching: " + lc_head2
      ENDIF

    CASE lc_rept = "I"
      *-- Sales Tax By Tax Code

      IF lc_detail = "D"

        IF lc_order = "C"
          lc_head2 = lc_head2 + " Ordered by Customer within Tax Code"
        ELSE
          lc_head2 = lc_head2 + " Ordered by Item within Tax Code"
        ENDIF

      ENDIF

      IF NOT EMPTY(lc_taxcode)
        lc_head2 = lc_head2 + "  Tax Code = " + TRIM(lc_taxcode)
      ENDIF

    CASE lc_rept = "D"
      *-- Sales Person Sales Group File Listing

      *-- Heading for type ...salesperson, sales groups or both
      IF lc_include <> "Both"
        lc_head1 = lc_head1 + "  Include = " + TRIM(lc_include)
      ELSE
        lc_head1 = lc_head1 + "  Include = Salespeople/Sales Groups"
      ENDIF

      *-- Specify if tiers being listed
      IF lc_tiers = "Y"
        lc_head1 = lc_head1 + " Include tiers "
      ENDIF

      *-- Beginning range for salesperson
      IF NOT EMPTY(lc_bpepl)
        lc_head2 = lc_head2 + "  Salesperson = " + lc_bpepl
      ENDIF

      *-- Ending range for salesperson
      IF NOT EMPTY(lc_epepl) AND lc_bpepl <> lc_epepl
        lc_head2 = lc_head2 + " thru " + lc_epepl
      ENDIF

      *-- Beginning range for groups
      IF NOT EMPTY(lc_bgrp)
        lc_head2 = lc_head2 + " Sales group = " + lc_bgrp
      ENDIF

      *-- Ending range for groups
      IF NOT EMPTY(lc_egrp) AND lc_bgrp <> lc_egrp
        lc_head2 = lc_head2 + " thru " + lc_egrp
      ENDIF

      *-- Determine Salesperson Type
      IF NOT LEFT(lc_saletyp,1) = "A"
        lc_head3 = lc_head3 + " SalesPerson Type = " + lc_saletyp
      ENDIF

      IF NOT EMPTY(lc_div)
        lc_head3 = lc_head3 + " Division = " + TRIM(lc_div)
      ENDIF

      IF NOT EMPTY(lc_terr)
        lc_head3 = lc_head3 + " Territory = " + TRIM(lc_terr)
      ENDIF

      IF NOT EMPTY(lc_dept)
        lc_head3 = lc_head3 + " Dept = " + TRIM(lc_dept)
      ENDIF

    CASE lc_rept = "M"
      *-- Operation Summary

      IF NOT EMPTY(lc_item)
        lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

    CASE lc_rept = "R"
      *-- Comments

      DO CASE
        CASE NOT EMPTY(lc_bcommid) AND NOT EMPTY(lc_ecommid)
          lc_head1 = "Codes " + TRIM(lc_bcommid) + " to " + TRIM(lc_ecommid)
        CASE NOT EMPTY(lc_bcommid)
          lc_head1 = "Beginning Code = " + TRIM(lc_bcommid)
        CASE NOT EMPTY(lc_ecommid)
          lc_head1 = "Ending Code = " + TRIM(lc_ecommid)
      ENDCASE

    CASE lc_rept = "S"
      *-- Drop shipment status report

      lc_head1 = lc_head1 + ", Ordered By "

      DO CASE
        CASE lc_order = "O"
          lc_head1 = lc_head1 + "Order #"
        CASE lc_order = "P"
          lc_head1 = lc_head1 + "PO #"
        CASE lc_order = "V"
          lc_head1 = lc_head1 + "Vendor #"
        CASE lc_order = "C"
          lc_head1 = lc_head1 + "Customer #"
        CASE lc_order = "R"
          lc_head1 = lc_head1 + "Reqd. Date"
        CASE lc_order = "C"
          lc_head1 = lc_head1 + "Cust #"
      ENDCASE

      DO CASE
        CASE lc_include = "T"
          lc_head1 = lc_head1 + ", Included Only: To Purchase"
        CASE lc_include = "U"
          lc_head1 = lc_head1 + ", Included Only: Unreceived"
        CASE lc_include = "P"
          lc_head1 = lc_head1 + ", Included Only: Partially Received"
        CASE lc_include = "C"
          lc_head1 = lc_head1 + ", Included Only: Fully Received"
      ENDCASE

      DO CASE
        CASE NOT EMPTY(lc_bcust) AND NOT EMPTY(lc_ecust)

          IF ALLTRIM(lc_bcust) = ALLTRIM(lc_ecust)
            lc_head2 = "Cust # = " + ALLTRIM(lc_bcust)
          ELSE
            lc_head2 = "Cust # " + ALLTRIM(lc_bcust) + ;
                       " to " + ALLTRIM(lc_ecust)
          ENDIF

        CASE NOT EMPTY(lc_bcust)
          lc_head2 = "Cust # After " + ALLTRIM(lc_bcust)
        CASE NOT EMPTY(lc_ecust)
          lc_head2 = "Cust # Before " + ALLTRIM(lc_ecust)
      ENDCASE

      DO CASE
        CASE NOT EMPTY(g_retdt(lc_bdate)) AND NOT EMPTY(g_retdt(lc_edate))

          IF g_retdt(lc_bdate) = g_retdt(lc_edate)
            lc_head2 = lc_head2 + "  Reqd. Date " + lc_bdate
          ELSE
            lc_head2 = lc_head2 + "  Reqd. Date " + lc_bdate + ;
                       " to " + lc_edate
          ENDIF

        CASE NOT EMPTY(g_retdt(lc_bdate))
          lc_head2 = lc_head2 + "  Reqd. Date On or After " + lc_bdate

        CASE NOT EMPTY(g_retdt(lc_edate))
          lc_head2 = lc_head2 + "  Reqd. Date On or Before " + lc_edate
      ENDCASE

      DO CASE
        CASE NOT EMPTY(lc_bsono) AND NOT EMPTY(lc_esono)

          IF ALLTRIM(lc_bsono) = ALLTRIM(lc_esono)
            lc_head2 = lc_head2 + "  Order # = " + ALLTRIM(lc_bsono)
          ELSE
            lc_head2 = lc_head2 + "  Order # " + ALLTRIM(lc_bsono) + ;
                       " to " + ALLTRIM(lc_esono)
          ENDIF

        CASE NOT EMPTY(lc_bsono)
          lc_head2 = lc_head2 + "  Order # After " + ALLTRIM(lc_bsono)
        CASE NOT EMPTY(lc_esono)
          lc_head2 = lc_head2 + "  Order # Before " + ALLTRIM(lc_esono)
      ENDCASE

      IF NOT EMPTY(lc_supp)
        lc_head3 = "Supplier = " + ALLTRIM(lc_supp)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head3 = lc_head3 + "  Item Class = " + ALLTRIM(lc_class)
      ENDIF

*\ [Begin] PTR 76407 07/06/04 DAND Customer payment terms listing
   CASE lc_rept = "U"
      *-- Customer payment terms listing

      IF LEFT(lc_order,1) = "T"
        lc_head1 = "Ordered by Terms ID"
      ELSE
        lc_head1 = "Ordered by Description"
      ENDIF
*\ [End] PTR 76407 07/06/04 DAND Customer payment terms listing

    CASE lc_rept = "V"
      *-- Customer Distribution by Value

      lc_head1 = "Customers Ranked by Most Recent 12 Months Sales"

      IF NOT EMPTY(lc_ctype)
        lc_head2 = lc_head2 + "  Customer Type = " + TRIM(lc_ctype)
      ENDIF

      IF NOT EMPTY(lc_indust)
        lc_head2 = lc_head2 + "  Industry = " + TRIM(lc_indust)
      ENDIF

      IF NOT EMPTY(lc_salesmn)
        lc_head2 = lc_head2 + "  Salesperson = " + TRIM(lc_salesmn)
      ENDIF

      IF NOT EMPTY(lc_terr)
        lc_head2 = lc_head2 + "  Territory = " + TRIM(lc_terr)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Misc Code = " + TRIM(lc_code)
      ENDIF

      IF ln_minamt <> 0
*\ [1 Line] PTR# 69388 03/23/04 TIGJ Increased to 11 digits in the integer part            
        lc_head2 = lc_head2 + "  Minimum Value Reported = " + ;
                   TRANSFORM(ln_minamt, "@B ##,###,###,###.##")
      ENDIF

  ENDCASE

  lc_head1 = ALLTRIM(lc_head1)
  lc_head2 = ALLTRIM(lc_head2)
  lc_head3 = ALLTRIM(lc_head3)
RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sethd
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP1_SQL
*------------------------------------------------------------------------------
*- Description: Reports - Procedure 1 of 4
*------------------------------------------------------------------------------
*- Synopsis...: Reports 1 - Transaction Reports
*-                      2 - Shipments
*-                      3 - Open Orders
*-                      4 - Orders by Salesperson
*-                      V - Distribution by Value
*-                      P - Customer PO report
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_DSPALT, G_EXTND(), G_CLRTX, G_FRMCLC, SYVALR,
*-              G_OPNFL
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_rept   = single character report identifier
*-              LEFT(lc_file,1)     = file to get records from:
*-                          "C" for current period file
*-                          "H" for history file
*-                          "B" for both files
*-              lc_detail   = level of detail:
*-                          "S" for summary report
*-                          "D" for detail report
*-              lc_type     = type of report:
*-                          "A" for all orders
*-                          "E" for open and returns only
*-                          "S" for open orders only
*-                          "R" for returns only
*-                          "B" for bids only
*-              lc_tax      = include tax Yes or No
*-              lc_show     = view by qty or $ (1,3,4):
*-                          "Q" for qty ordered
*-                          "V" for value ($) ordered
*-              lc_only     = type of order (3 or 4 only):
*-                          "A" for all open orders (3)
*-                          "A" for all orders (4)
*-                          "O" for open orders only (4 only)
*-                          "P" for partially shipped only
*-              lc_bdate    = beginning date
*-              lc_edate    = ending date
*-              lc_order    = "C" to order report by customer number
*-                          "D" to order report by date (req or ship)
*-                          "I" to order report by item number
*-                          "O" to order report by order number
*-                          "S" to order report by salesperson
*-              lc_custno   = customer number or portion to match
*-              lc_item     = item number or portion to match
*-              lc_class    = inventory class or portion to match
*-              lc_code     = inventory code or portion to match
*-              lc_dbvtype, "C" = Customer, "I" = Inventory, "V" = Vendor
*-              ln_minamt, activity below this amount is excluded
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep1_sql

  PRIVATE lc_sofilt, ;
          ln_icserlf

  lc_sofilt  = ""
  ln_icserlf = 1

  PRIVATE lc_SQLMast, ;
          lc_SQLFilt, ;
          lc_IndDef, ;
          ll_norecs

  lc_SQLMast = ""
  lc_SQLFilt= ""
  lc_IndDef = ""

  *-- Convert variables to dates
  ld_bdate   = g_retdt(lc_bdate)
  ld_edate   = g_retdt(lc_edate)

  *-- Set up variable to match to sostat field
  IF lc_rept $ "13P"
    *-- 1 - Transactions
    *-- 3 - Open Orders
    *-- P - PO report

    *-- Open ICSERL file
    ln_icserlf = g_opnfl(gf_icserlf, "a_icserl", .f., .f., "sono1")

    DO CASE
      CASE lc_type = "A"
        ms = " ORBD"
      CASE lc_type = "E"
        ms = " ORD"
      CASE lc_type = "O"
        ms = " O"
      CASE lc_type = "R"
        ms = "R"
      CASE lc_type = "B"
        ms = "B"
      CASE lc_type = "D"
        ms = "D"
    ENDCASE

  ELSE
    ms = " ORD"
  ENDIF

  *-- Set to continue
  ll_cont = .t.

  DO WHILE ll_cont
    DO g_dspst WITH "Locating Selected Transactions...", .t., ;
                    gn_msgline, "", "", ""

    DO CASE
      CASE lc_rept = "3"
        *-- Open Orders

        *-- Open Customer file
        = g_opnfl(gf_arcustf, "a_arcust", .f., .f., "")
        go_SQL.cmpA_Arcust.m_SetOrder(0)

        *-- Open Inventory Master file
        = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")
        go_SQL.cmpA_Icitem.m_SetOrder(0)

        *-- Open current Master file
        = g_opnfl(gf_somastf, "a_somast", .f., .f., "")
        go_SQL.cmpA_Somast.m_SetOrder(0)

        *-- Open current Detail file
        = g_opnfl(gf_sotranf, "a_sotran", .f., .f., "")
        go_SQL.cmpA_Sotran.m_SetOrder(0)

        *-- Setup WHERE condition
        lc_filt = lc_filt + [ a->sostat = '] + SPACE(LEN(sostat)) + [' AND ]

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + [a->loctid %=% TRIM(??lc_loctid) + '%/%' AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + [a->custno %=% TRIM(??lc_custno) + '%/%' AND ]
        ENDIF

        IF NOT EMPTY(lc_item)

          IF gl_sbtmod

            IF lc_incitm = "I"
              *-- Set item number condition
              lc_filt = lc_filt + [a->item %=% TRIM(??lc_item) + '%/%' AND ]
            ELSE
              *-- Set item number condition to exclude
              lc_filt = lc_filt + [a->item NOT %=% TRIM(??lc_item) + '%/%' AND ]
            ENDIF

          ELSE
            *-- Set item number condition
            lc_filt = lc_filt + [a->item %=% TRIM(??lc_item) + '%/%' AND ]
          ENDIF

        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [c->itmclss %=% TRIM(??lc_class) + '%/%' AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [c->code %=% TRIM(??lc_code) + '%/%' AND ]
        ENDIF

        *-- Set date conditions
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + [DTOS(a->ordate)] + ;
                    [ >= '] + DTOS(ld_bdate) + [' AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + [DTOS(a->ordate)] + ;
                    [ <= '] + DTOS(ld_edate) + [' AND ]
        ENDIF

        *-- Partially shipped Open Orders
        IF lc_only <> "A"
          lc_filt = lc_filt + [b->shpamt <> 0 AND ]
        ENDIF

        *-- Unshipped Items Only
        IF lc_shipped <> "A"
          lc_filt = lc_filt + [a->qtyord <> 0 AND ]
        ENDIF

        *-- Setup filter based on type
        lc_filt1 = ""

        DO CASE
          CASE lc_type = "A"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O' OR ] + ;
                       [a->sotype = 'R' OR a->sotype = 'B' OR ] + ;
                       [a->sotype = 'D' ]

          CASE lc_type = "E"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O' OR ] + ;
                       [a->sotype = 'R' OR a->sotype = 'D' ]

          CASE lc_type = "O"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O']

          CASE lc_type = "R"
            lc_filt1 = [a->sotype = 'R']

          CASE lc_type = "B"
            lc_filt1 = [a->sotype = 'B']

          CASE lc_type = "D"
            lc_filt1 = [a->sotype = 'D']
        ENDCASE

        IF lc_type $ "AEO"
          lc_filt1 = lc_filt1 + [ OR (a->sotype = "O" AND ] + ;
                     [a->qtyshp = 0.000)]
        ENDIF

        IF NOT EMPTY(lc_filt1)
          lc_filt1 = [(] + lc_filt1 + [) AND ]
        ENDIF

        *-- Setup table list
        IF NOT EMPTY(lc_class) OR NOT EMPTY(lc_code)
          *-- Include item master file
          lc_from = gf_sotranf + " AS a, " + ;
                    gf_somastf + " AS b, " + ;
                    gf_icitemf + " AS c "

          lc_filt = lc_filt + [a->item = c->item AND ]
        ELSE
          *-- SO transaction detail and header files only
          lc_from = gf_sotranf + " AS a, " + ;
                    gf_somastf + " AS b, " + ;
                    gf_icitemf + " AS c "
          lc_filt = lc_filt + [a->item = c->item AND ]
        ENDIF

        *-- If Summary
        IF lc_detail = "S"
          *-- Include customer file
          lc_from = lc_from + ", " + gf_arcustf + " AS d "
          lc_filt = lc_filt + [a->custno = d->custno AND ]
        ENDIF

        *-- Add join to master file
        lc_filt = lc_filt + [a->sono = b->sono AND ]

        *-- Setup fields list
        IF lc_detail = "S"
          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Added tcost,tbcost
          *-- Summary

*- NOTE: Exchange rate is replaced after the SQL statement is executed with a Bulk Replace
          lc_fields = [a->sono, a->custno, a->item, d->company AS descrip, ] + ;
                      [a->disc, a->taxrate, a->cost, a->tcost, a->price, a->tprice, a->tbprice, ] + ;
                      [a->qtyord, a->tqtyord, a->qtyshp, a->tqtyshp, a->extprice, a->ordate, ] + ;
                      [a->rqdate, a->shipdate, a->shipqty, a->tshpqty, a->terr, a->salesmn, a->isoclss, ] + ;
                      [a->seq, a->stkcode, a->taxable, a->currhist, a->sostat, a->sotype, a->taxcode, a->loctid, ] + ;
                      [a->tranlineno, b->shpamt, b->currid, ] + REPLICATE("0",14) + [.0000] + [ AS bshipqty, b->bshpamt, ] + ;
                      [a->exchrat, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->price, 1, 0) AS bprice, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->cost, 1, 0) AS bcost, ] + ;
                      [a->tbcost, ] + ;
                      [g_extnd(] + + ALLTRIM(STR(gn_basedec)) + [, a->extprice, 1, 0) AS bextpri, ] + ;
                      [.f. AS exchfrz ]

        ELSE
          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Added tcost,tbcost
          *-- Detail

*- NOTE: Exchange rate is replaced after the SQL statement is executed with a Bulk Replace
          lc_fields = [a->sono, a->custno, a->item, a->descrip, a->disc, a->taxrate, ] + ;
                      [a->cost, a->tcost, a->price, a->tprice, a->tbprice, a->qtyord, a->tqtyord, ] + ;
                      [a->qtyshp, a->tqtyshp, a->extprice, a->ordate, a->rqdate, a->shipdate, a->shipqty, ] + ;
                      [a->tshpqty, a->terr, a->salesmn, a->isoclss, a->seq, a->stkcode, a->taxable, ] + ;
                      [a->currhist, a->sostat, a->sotype, a->taxcode, a->loctid, a->tranlineno, b->shpamt, ] + ;
                      [a->rqdate AS tdate, c->stkumid, a->umeasur, a->umfact, b->currid, ] + REPLICATE("0",14) + [.0000] + [ AS bshipqty, ] + ;
                      [b->bshpamt, ] + ;
                      [a->exchrat, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->price, 1, 0) AS bprice, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->cost, 1, 0) AS bcost, ] + ;
                      [a->tbcost, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->extprice, 1, 0) AS bextpri, ] + ;
                      [.f. AS exchfrz ]

        ENDIF && lc_detail = "S"

        *-- Setup ORDER BY list
        DO CASE
          CASE lc_detail = "S"
            *-- If summary report
            lc_orderby = ""

          CASE lc_detail = "D" AND lc_order = "S"
            *-- loctid + salesmn + custno + sono
            *-- Changed order from 26, 17, 2, 1, 27 to 32, 23, 2, 1, 33
            lc_orderby = "ORDER BY 32, 23, 2, 1, 33"

          CASE lc_detail = "D" AND lc_order = "T"
            *-- gl_sbtmod by territory
            *-- loctid + terr + custno + sono
            *-- Changed order from 26, 16, 2, 1 to 32, 23, 2, 1
            lc_orderby = "ORDER BY 32, 22, 2, 1"

          CASE lc_detail = "D" AND lc_order = "C"
            *-- loctid + custno + sono
            *-- Changed order from 26, 2, 1, 27 to 32, 2, 1, 33
            lc_orderby = "ORDER BY 32, 2, 1, 33"

          CASE lc_detail = "D" AND lc_order = "D"
            *-- loctid + STR(CTOD(rqdate) - {01/01/01}, 8, 0)
            *-- Changed order from 26, 29, 1, 3 to 32, 35, 1, 3
            lc_orderby = "ORDER BY 32, 35, 1, 3"

          CASE lc_detail = "D" AND lc_order = "I"
            *-- loctid + item + STR(CTOD(rqdate) - {01/01/01},8,0)
            *-- Changed order from 26, 3, 29 to 32, 3, 35
            lc_orderby = "ORDER BY 32, 3, 35"

          CASE lc_detail = "D" AND lc_order = "O"
            *-- loctid + sono + custno
            *-- Changed order from 26, 1, 2, 27 to 32, 1, 2, 33
            *-- Changed order from 26, 1, 2, 23 to 32, 1, 2, 33
            lc_orderby = "ORDER BY 32, 1, 2, 33"

        ENDCASE

        *-- Get subset of records
        go_SQL.m_SQLSelect(lc_fields + ;
                           " FROM " + lc_from + ;
                           " WHERE " + lc_filt + " " + lc_filt1 + ;
                           " a->sostat <> 'V' AND a->sostat <> 'C' AND a->sostat <> 'X' " + ;
                           lc_orderby, "SQL TABLE", go_SQL.m_getTempTableName(1))
        *-- Open Temporary report file
        = go_SQL.so_CurrentAlias.m_CloseTable()
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE gl_locts AND lc_detail = "S"
            *# DOCCODE REPORT FORM sosonl
            lc_frx = gc_adrvprg + "sosonl"
          CASE NOT gl_locts AND lc_detail = "S"
            *# DOCCODE REPORT FORM soson2
            lc_frx = gc_adrvprg + "soson2"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM sooctl
            lc_frx = gc_adrvprg + "sooctl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodtl
            lc_frx = gc_adrvprg + "soodtl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM soootl
            lc_frx = gc_adrvprg + "soootl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soostl
            lc_frx = gc_adrvprg + "soostl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM soottl
            lc_frx = gc_adrvprg + "soottl"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM sooct2
            lc_frx = gc_adrvprg + "sooct2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodt2
            lc_frx = gc_adrvprg + "soodt2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooot2
            lc_frx = gc_adrvprg + "sooot2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soost2
            lc_frx = gc_adrvprg + "soost2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM soottl
            lc_frx = gc_adrvprg + "soottl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM soocnl
            lc_frx = gc_adrvprg + "soocnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodnl
            lc_frx = gc_adrvprg + "soodnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooonl
            lc_frx = gc_adrvprg + "sooonl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soosnl
            lc_frx = gc_adrvprg + "soosnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "I"
            *# DOCCODE REPORT FORM sooinl
            lc_frx = gc_adrvprg + "sooinl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM sootnl
            lc_frx = gc_adrvprg + "sootnl"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM soocn2
            lc_frx = gc_adrvprg + "soocn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodn2
            lc_frx = gc_adrvprg + "soodn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooon2
            lc_frx = gc_adrvprg + "sooon2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soosn2
            lc_frx = gc_adrvprg + "soosn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "I"
            *# DOCCODE REPORT FORM sooin2
            lc_frx = gc_adrvprg + "sooin2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM sootnl
            lc_frx = gc_adrvprg + "sootnl"
        ENDCASE

*\ [Deleted 15 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                              routine g_cursum for currency summary.  
 
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        *-- Check for records in result set
        IF go_SQL.cmpA_Tmpf1.m_Reccount() = 0
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        *- NOTE: As we could not pass exchange reate function through SQL we did a Bulk Replace
        IF ll_cont AND gl_mc

*\ [Begin] PTR# 76810 08/06/04 TIVN Fix for performance improvement
          LOCAL lc_Tmpf18, ;
                lc_PrevAlias, ;
                lc_Eratedef, ;
                lc_Erate

          lc_Tmpf18 = go_SQL.m_GetTempTableName(18)

          lc_PrevAlias = ALIAS()

          *-- The approach here is to bring all the 'currencies used for ORDERS',
          *-- their exchange rates into a separate table
          go_SQL.m_SQLSelect([DISTINCT currid AS currency, ] + ;
                             [exchrat AS erate ] + ;
                             [FROM ] + ;
                             go_SQL.m_getTempTableName(1), ;
                             "SQL TABLE", ;
                             lc_Tmpf18)

          *-- Close the opened table
          go_SQL.so_CurrentAlias.m_CloseTable()

          *-- Open the temp table
          =g_opnfl(lc_Tmpf18, "a_tmp18", .f., .f.)

          *-- Create index on the temporary table
          go_SQL.cmpA_tmp18.m_CreateIndex("currid", "currency", "", .t., .f.)

          *-- Replace exchange rate
          go_SQL.cmpA_tmp18.m_ReplaceBulk("erate WITH l_retcxra(currency)", ;
                                          "A")

          *-- Restore previously selected work area
          IF NOT EMPTY(lc_PrevAlias)
            go_SQL.m_TableChangeCurrent(lc_PrevAlias)
          ENDIF

          *-- Set relation to temp. table
          go_SQL.cmpA_Tmpf1.m_SetRelation("currid", "A_tmp18", .t.)

          *--SSHA  Need to pupulate exchfrz field also

          *--Recalculate all currency fields with latest exchange rates
          go_SQL.cmpA_Tmpf1.m_ReplaceBulk("exchrat WITH a_tmp18->erate,  " + ;
                                          "bprice WITH g_extnd(2, a_tmpf1->price, 1/a_tmp18->erate, 0), " + ;
                                          "bcost WITH g_extnd(2, a_tmpf1->cost, 1/a_tmp18->erate, 0), " + ;
                                          "bextpri WITH g_extnd(2, a_tmpf1->extprice, 1/a_tmp18->erate, 0) ", ;
                                          "A", ;
                                          "", ;
                                          .t.)

          *-- Turn OFF relation
          go_SQL.cmpA_Tmpf1.m_SetRelation("OFF", "A_tmp18")
*\ [End] PTR# 76810 08/06/04 TIVN Fix for performance improvement
        ENDIF && ll_cont AND gl_mc

        IF lc_detail = "D"
          ll_norecs = .f.

          IF go_SQL.sc_SQLType = "SD"
            *-- Have the count of records matching the condition and update the records only
            *-- if there is atleast one record matching the condition. This has been done to
            *-- to avoid fatal when the backend is DB2, as DB2 will throw error if there are
            *-- no records to update matching the condition
            ll_norecs = NOT (go_SQL.cmpA_Tmpf1.m_Count("FOR umfact = 0") > 0)
          ENDIF

          IF NOT ll_norecs
            go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                             " SET umfact = 1 WHERE umfact = 0", "")
          ENDIF

          go_SQL.cmpA_Tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

        *-- Display processing message
        DO g_dspst WITH "Retrieving shipments...", .t., gn_msgline, "", "", ""

        *-- Get shipments for ICTRAN
        DO l_getshp

        *-- Summary report
        IF lc_detail = "S"
          *-- Display processing message
          DO g_dspst WITH "Summarizing transactions...", .t., ;
                          gn_msgline, "", "", ""

          *-- Setup ORDER BY
          IF LEFT(lc_show,1) = "Q"
            *-- qtyord
            lc_orderby = "ORDER BY 8"
          ELSE
            *-- openval extprice
            lc_orderby = "ORDER BY 13"
          ENDIF

          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Create summarized cursor for report
          go_SQL.m_SQLSelect(" sono, loctid, custno, ordate, rqdate,  " + ;
                             " SUM(ROUND(tprice * (tqtyord +0+ tqtyshp) * (100 - disc) / 100.000, 3)) AS extprice,   " + ;
                             " SUM(qtyshp) AS qtyshp, SUM(qtyord) AS qtyord,   " + ;
                             " SUM(shipqty) AS shipqty, SUM(tshpqty) AS tshpqty,   " + ;
                             " salesmn, descrip,   " + ;
                             " SUM(ROUND(tprice * tqtyord * (100 - disc) / 100.000, 3)) AS openval,   " + ;
                             " tbprice,   " + ;
                             " SUM(ROUND(tbprice * (tqtyord +0+ tqtyshp) * (100 - disc) / 100.000, 3)) AS bextpri,   " + ;
                             " SUM(bshipqty) AS bshipqty,   " + ;
                             " SUM(ROUND(bprice * qtyord * (100 - disc) / 100.000, 3)) AS bopenval,   " + ;
                             " currid, .f. AS exchfrz, exchrat   " + ;
                             " FROM " + go_SQL.m_getTempTableName(1) + ;
                             " GROUP BY sono, loctid, custno, ordate " + ;
                             lc_orderby, ;
                             "SQL TABLE", go_SQL.m_getTempTableName(6))

          *-- Close the temporary table
          go_SQL.so_CurrentAlias.m_CloseTable()

          *-- Close and erase Temporary file
          go_SQL.cmpA_Tmpf1.m_CloseTable()
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(1), "", "")

          = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

          IF ll_cont AND gl_mc
            *--SSHA  Need to pupulate exchfrz field also
          ENDIF

        ENDIF && lc_detail = "S"

        *-- Move to top of temporary cursor or file
        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

        *-- If including sales tax
        IF lc_tax = "Y"
          DO g_dspst WITH "Calculating sales tax...", .t., gn_msgline, ;
                          "", "", ""

          *-- Initialize variables for report totals
          ln_alltot = 0.000
          ln_alltax = 0.000

          ln_balltot = 0.000
          ln_balltax = 0.000

*\ [1 Line] PTR #74741 05/07/04 TISJ Fix for expansion of customer, vendor, item and state
*\                                   in reports
          *-- Create temporary tax file
          go_SQL.m_createTable(go_SQL.m_getTempTableName(4), ;
                               " FREE (sono C(10), custno C(" + TRIM(STR(LEN(gc_CVNoPic))) + "), "+ ;
                               " taxamt Y, totamt Y, btaxamt Y, btotamt Y, exchfrz L)", "", "")
          go_SQL.so_CurrentAlias.m_CloseTable()
          *-- Open Temporary Tax file
          = g_opnfl(go_SQL.m_getTempTableName(4), "a_tmpf4", .t., .f.)

          *-- Save alias name for temporary report file
          lc_alias = IIF(lc_detail = "D", "a_tmpf1", "a_tmpf2")

          *-- Select temporary report file
          go_SQL.m_TableChangeCurrent(lc_alias)

          *-- Create index for tax calculation
          go_SQL.so_CurrentAlias.m_CreateIndex("Loctid", "loctid + custno + sono", "", .t., .f.)

          go_SQL.so_CurrentAlias.m_MoveRecord(cn_TopRec)

          *-- Calculate line item tax and save total tax for each order
          DO WHILE NOT go_SQL.so_CurrentAlias.m_IsEof()
            mcust = custno
            msono = sono
            ln_linamt = 0.000
            ln_taxamt = 0.000
            ln_totamt = 0.000
            ln_totopn = lc_alias+"->extprice"
            ln_btaxamt = 0.00
            ln_btotamt = 0.00

            DO g_clrtx  WITH taxrate
            DO g_frmclc WITH "custno = mcust AND sono = msono", ;
                             ln_linamt, ln_taxamt, ln_totamt, ln_totopn

            ln_btaxamt = g_extnd(gn_basedec, ln_taxamt, ;
                         1/&lc_alias.->exchrat, 0)
            ln_btotamt = g_extnd(gn_basedec, ln_totamt, ;
                         1/&lc_alias.->exchrat, 0)

            go_SQL.so_CurrentAlias.m_ScanBegin("W", ".t. = .t.")
            DO WHILE go_SQL.so_CurrentAlias.m_Scan() AND custno = mcust AND sono = msono

              *-- Advance to next order
            ENDDO
            go_SQL.so_CurrentAlias.m_ScanEnd()

            *-- Add order totals to report totals
            ln_alltot = ln_alltot + (ln_totamt - ln_taxamt)
            ln_alltax = ln_alltax + ln_taxamt
            ln_balltot = ln_balltot + (ln_btotamt - ln_btaxamt)
            ln_balltax = ln_balltax + ln_btaxamt

            *-- Save total amount and tax for each order
            go_SQL.m_TableChangeCurrent("a_tmpf4")
            go_SQL.cmpA_Tmpf4.m_SQLInsert("sono, custno, taxamt, totamt, btaxamt, btotamt", ;
                                          "msono, mcust, ln_taxamt, ln_totamt, ln_btaxamt, ln_btotamt", "")

            go_SQL.m_TableChangeCurrent(lc_alias)
          ENDDO

          *-- Create index for temporary tax file
          go_SQL.m_TableChangeCurrent("a_tmpf4")
          go_SQL.so_CurrentAlias.m_CreateIndex("Sono", "sono", "", .t., .f.)

          *-- Set relation into temporary tax file
          go_SQL.m_TableChangeCurrent(lc_alias)
          go_SQL.so_CurrentAlias.m_SetOrder(0)
          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
          go_SQL.so_CurrentAlias.m_SetRelation("sono", "a_tmpf4", .f.)
        ENDIF && lc_tax = "Y"

        *-- Set report title
        lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                   " Open Orders Report"

        DO CASE
          CASE lc_detail = "S"
            *-- Summary report
          CASE lc_order = "C"
            lc_title = lc_title + " by Customer"
          CASE lc_order = "D"
            lc_title = lc_title + " by Date Required"
          CASE lc_order = "I"
            lc_title = lc_title + " by Item"
          CASE lc_order = "O"
            lc_title = lc_title + " by Order Number"
          CASE lc_order = "S"
            lc_title = lc_title + " by Salesperson"
        ENDCASE

        *-- Set relation into master file
        *- NOTE: Check to see if the alias is changing
        go_SQL.cmpA_Somast.m_SetOrder("custno1")
        go_SQL.so_CurrentAlias.m_SetRelation("custno + sono", "a_somast", .f.)

        *-- If Include Tax
        IF lc_tax = "Y"
          *-- Relate to table containing tax summarizations
          go_SQL.so_CurrentAlias.m_SetRelation("sono", "a_tmpf4", .f.)
        ENDIF

        IF ll_cursum

          IF lc_detail = "D"
            DO g_cursum WITH "currid", ;
                             "extprice~shipqty", ;
                             "Open Value~Shipped Value"
          ELSE
            DO g_cursum WITH "currid", ;
                             "openval~shipqty", ;
                             "Open Value~Shipped Value"
          ENDIF

          gl_landscp = .f.
          *# DOCCODE REPORT FORM sycsum
          lc_frx = gc_idrvprg + "sycsum"
          lc_title = ALLTRIM(lc_title) + " - Currency Summary"
        ENDIF

      CASE lc_rept $ "14P"
        *-- 1 - Transactions
        *-- 4 - Orders by Salesperson
        *-- P - Customer PO

        IF go_SQL.m_IsUsed("a_tmpf1")
          go_SQL.cmpa_Tmpf1.m_CloseTable()
        ENDIF

        *-- Drop the table, just in case is already exists
        go_SQL.m_DropTable(go_SQL.m_GetTempTableName(1))

        *-- Open IC Serial number table
        ln_icserlf = g_opnfl(gf_icserlf, ;
                     "a_icserl", .f., .f., "sono1")

        *-- Select SO serial number detail file
        go_SQL.m_TableChangeCurrent("a_icserl")
        go_SQL.cmpA_Icserl.m_SetOrder("sono1")

        *-- Select records from transaction files
        IF LEFT(lc_file,1) = "C" OR ;
           (lc_rept $ "P" AND lc_only = "O")

          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")
          go_SQL.cmpA_Sotran.m_SetOrder("sono1")

          go_SQL.cmpA_Icitem.m_SetOrder("item")
          go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

          *-- Select Order Entry Master file
          go_SQL.m_TableChangeCurrent("a_somast")
          go_SQL.cmpA_Somast.m_SetOrder("sono")
          go_SQL.m_TableChangeCurrent("a_sotran")
          go_SQL.cmpA_Sotran.m_SetRelation("sono", "a_somast", .t.)
          lc_SQLFilt = go_SQL.cmpA_Sotran.m_GetFilter()
          lc_SQLFilt = lc_SQLFilt + ;
                       IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                       " NOT go_SQL.cmpA_SoMast.m_IsEof()"
          go_SQL.cmpA_Sotran.m_SetFilter(lc_SQLFilt)
          go_SQL.m_TableChangeCurrent("a_somast")

          lc_alias = "a_sotran->"
          lc_SQLMast = "a_somast->"
        ELSE
          *-- Open YTD Order Entry Transaction file
          ln_opndhst = g_opnfl(gf_soytrnf, "a_soytrn", .f., .f.)
          go_SQL.cmpA_Soytrn.m_SetOrder("sono1")
          go_SQL.cmpA_Soytrn.m_SetRelation("item", "a_icitem", .f.)

          *-- Select Order Entry Master file
          IF NOT go_SQL.m_IsUsed("a_soymst")
            ln_opnmhst = g_opnfl(gf_soymstf, "a_soymst", .f., .f.)
          ELSE
            go_SQL.m_TableChangeCurrent("a_soymst")
          ENDIF
          go_SQL.cmpA_SoyMst.m_SetOrder("sono")
          go_SQL.m_TableChangeCurrent("a_soytrn")
          go_SQL.cmpA_Soytrn.m_SetRelation("sono", "a_soymst", .t.)
          lc_SQLFilt = go_SQL.cmpA_SoyTrn.m_GetFilter()
          lc_SQLFilt = lc_SQLFilt + ;
                       IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                       " a_soymst.sono <> '" + SPACE(LEN(a_soymst.sono)) + "'"
          go_SQL.cmpA_SoyTrn.m_SetFilter(lc_SQLFilt)
          go_SQL.m_TableChangeCurrent("a_soymst")
          lc_alias = "a_soytrn->"
          lc_SQLMast = "a_soymst->"
        ENDIF

        *-- Set current period condition
        IF LEFT(lc_file,1) = "C"
          lc_current = [currhist <> 'X' AND ]
        ELSE
          lc_current = ""
        ENDIF

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + lc_alias + [loctid %=% TRIM(??lc_loctid) + '%/%' AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + lc_alias + [custno %=% TRIM(??lc_custno) + '%/%' AND ]
        ENDIF

        IF NOT EMPTY(lc_item)

          IF gl_sbtmod

            IF lc_incitm = "I"
              *-- Set item number condition
              lc_filt = lc_filt + lc_alias + [item %=% TRIM(??lc_item) + '%/%' AND ]
            ELSE
              *-- Set item number condition to exclude
              lc_filt = lc_filt + lc_alias + [item NOT %=% TRIM(??lc_item) + '%/%' AND ]
            ENDIF

          ELSE
            *-- Set item number condition
            lc_filt = lc_filt + lc_alias + [item %=% TRIM(??lc_item) + '%/%' AND ]
          ENDIF

        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [a_icitem->itmclss %=% TRIM(??lc_class) + '%/%' AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [a_icitem->code %=% TRIM(??lc_code) + '%/%' AND ]
        ENDIF

        *-- Set date condition
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + lc_alias + [ordate >= ??ld_bdate AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + lc_alias + [ordate <= ??ld_edate AND ]
        ENDIF

        IF NOT EMPTY(lc_filt)
          lc_filt = LEFT(lc_filt, RAT(" AND ", lc_filt) - 1)
        ELSE
          lc_filt = '1=1'
        ENDIF

        *-- Added tprice,tqtyord,tqtyshp,tbprice
        *-- Added tcost,tbcost,tshpqty
        lc_fields = lc_alias + "sono, " + ;
                    lc_alias + "custno, " + ;
                    lc_alias + "item, " + ;
                    lc_alias + "descrip, " + ;
                    lc_alias + "disc, " + ;
                    lc_alias + "taxrate, " + ;
                    lc_alias + "cost, " + ;
                    lc_alias + "tcost, " + ;
                    lc_alias + "price, " + ;
                    lc_alias + "qtyord, " + ;
                    "a_icitem->stkumid, " + ;
                    lc_alias + "qtyshp, " + ;
                    lc_alias + "extprice, " + ;
                    lc_alias + "ordate, " + ;
                    lc_alias + "rqdate, " + ;
                    lc_alias + "shipdate, " + ;
                    lc_alias + "shipqty, " + ;
                    lc_alias + "tshpqty, " + ;
                    lc_alias + "umeasur, " + ;
                    lc_alias + "umfact, " + ;
                    lc_alias + "terr, " + ;
                    lc_alias + "salesmn, " + ;
                    lc_alias + "isoclss, " + ;
                    lc_alias + "seq, " + ;
                    lc_alias + "stkcode, " + ;
                    lc_alias + "taxable, " + ;
                    lc_alias + "currhist, " + ;
                    lc_alias + "sostat, " + ;
                    lc_alias + "sotype, " + ;
                    lc_alias + "taxcode, " + ;
                    lc_alias + "loctid, " + ;
                    lc_alias + "tranlineno, " + ;
                  lc_SQLMast + "shpamt, " + ;
                  lc_SQLMast + "ponum, " + ;
                  lc_SQLMast + "sodate, " + ;
                    lc_alias + "currid, " + ;
                    lc_alias + "bcost,  " + ;
                    lc_alias + "tbcost,  " + ;
                    lc_alias + "bextpri,  " + ;
                    lc_alias + "bprice,  " + ;
                    lc_alias + "exchrat, " + ;
                    lc_alias + "tqtyord,  " + ;
                    lc_alias + "tprice,  " + ;
                    lc_alias + "tqtyshp,  " + ;
                    lc_alias + "tbprice "

        IF LEFT(lc_file,1) = "C" OR ;
           (lc_rept $ "P" AND lc_only = "O")
          go_SQL.m_TableChangeCurrent("a_sotran")
          lc_SQLFilt = go_SQL.cmpA_SoMast.m_GetFilter()
        ELSE
          go_SQL.m_TableChangeCurrent("a_soytrn")
          lc_SQLFilt = go_SQL.cmpA_SoyMst.m_GetFilter()
        ENDIF

        *--Add filter of the related table
        lc_SQLFilt = IIF(EMPTY(lc_SQLFilt), "", ' AND ' + lc_SQLFilt)

        DO CASE
          CASE lc_rept $ "1P"
            *-- Build criteria for creating file for transactions
            lc_tmpFilt = " AND " + lc_alias + "sotype $ ??ms AND " + ;
                         "NOT (" + lc_alias + "sostat = 'V' OR " + ;
                         lc_alias + "sostat = 'X')"

          CASE lc_rept = "4"
            *-- Orders by Salesperson
            mshiplen = LEN(TRIM(gc_shiptyp))

            DO CASE
              CASE lc_only = "O"
                *-- Build criteria for creating file for open orders
                lc_TmpFilt = " AND " + lc_alias + "sotype $ ??ms AND " + ;
                             "NOT (" + lc_alias + "sostat = 'V' OR " + ;
                             lc_alias + "sostat = 'X') AND " + ;
                             IIF(EMPTY(gc_shiptyp), "1 = 1", lc_alias + ;
                             "item <> TRIM(??gc_shiptyp) ")

              CASE lc_only = "P"
                *-- Build criteria for creating file for partially shipped
                lc_TmpFilt = " AND " + lc_alias + "sotype $ ??ms AND " + ;
                             "NOT (" + lc_alias + "sostat = 'V' OR " + ;
                             lc_alias + "sostat = 'X') AND " + ;
                             lc_SQLMast + "shpamt > 0 AND " + ;
                             IIF(EMPTY(gc_shiptyp), "1 = 1", lc_alias + ;
                             "item <> TRIM(??gc_shiptyp) ")

              CASE lc_only = "A"
                *-- Build criteria for creating file for all orders
                lc_TmpFilt = " AND " + lc_alias + "sotype $ ??ms AND " + ;
                             "NOT (" + lc_alias + "sostat = 'V' OR " + ;
                             lc_alias + "sostat = 'X') AND " + ;
                             IIF(EMPTY(gc_shiptyp), "1=1", lc_alias + ;
                             "item <> TRIM(??gc_shiptyp) ")

            ENDCASE

        ENDCASE

        IF go_SQL.sc_SQLType = "SS"
          lc_Key = go_SQL.so_CurrentAlias.m_Key()

          *-- Creating table using SELECT..INTO creates a table with user as the
          *-- owner (e.g. AIADMN) instead of "dbo"
          lc_TmpFile = go_SQL.sc_TempDbName + ".dbo.t" + gc_Tmpf1

          *-- Building SQL statement
          lc_SQLString = "SELECT " + lc_Fields + ", 0000000000.0000 AS bshipqty " + ;
                         " INTO " + lc_Tmpfile + ;
                         " FROM " + ;
                         go_SQL.so_CurrentAlias.sc_TableNameFull + ;
                         SPACE(1) + go_SQL.so_CurrentAlias.sc_TableAlias + ;
                         SPACE(1) + ;
                         "WHERE " + lc_Current + ;
                         " " + lc_filt + lc_SQLFilt + lc_Tmpfilt

          lc_SQLString = go_SQL.i_ParseRelatedFilter(lc_SQLString, go_SQL.so_CurrentAlias)

          *-- Avoided m_SQLSelect as SELECT query is executed twice. First for fetching
          *-- the top most row in order to determine the structure of destination table.
          *-- Next is inserting the rows matching the criteria into the newly created
          *-- destination table.
          go_SQL.m_Execute(lc_SQLString, "")

          *-- ID_COL is needed for subsequent operations
          go_SQL.i_SqlExec("ALTER TABLE " + lc_TmpFile + ;
                       " ADD id_col int identity (1, 1)", ;
                       " ", , "SQL - SELECT")

          = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

          *-- Alter the columns to currency data type as these columns were passed as
          *-- parameters to g_curpic in reports to display the decimal places specific
          *-- to currency
          go_SQL.m_AlterTable(go_SQL.so_CurrentAlias.sc_TableNameFull, ;
                              " ALTER COLUMN extprice Y(8) " + ;
                              "ALTER COLUMN shipqty Y(8) " + ;
                              "ALTER COLUMN bextpri Y(8) " + ;
                              "ALTER COLUMN bshipqty Y(8) " + ;
                              "ALTER COLUMN tshpqty Y(8) ")

          *-- Close and reopen the table to reflect the altered data type
          go_SQL.so_CurrentAlias.m_CloseTable()
        ELSE
          go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), "FIELDS " + lc_Fields + ;
                                          " FOR " + lc_Current + ;
                                          " " + lc_filt + lc_SQLFilt + lc_Tmpfilt)

          = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

          *-- Alter the table to add bshipqty field to temporary table
          go_SQL.m_AlterTable(go_SQL.so_CurrentAlias.sc_TableNameFull, ;
                              " ADD COLUMN bshipqty Y(8) ")

          *-- Close and reopen the table to reflect the added column
          go_SQL.so_CurrentAlias.m_CloseTable()
        ENDIF

        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.sc_SQLType = "SS"
          *-- Set the order here, instead of using it in the ORDER BY clause.
          *-- It appears that using of STR() in the ORDER BY is slowing down the query
          go_SQL.so_CurrentAlias.m_CreateIndex("sono1", lc_key, , .t., .t.)

          *-- Reset index order
          go_SQL.cmpA_Sotran.m_SetOrder("sono1")
        ENDIF

        IF LEFT(lc_file,1) = "B" AND NOT (lc_rept = "4" AND lc_type = "O")
          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")

          *-- Set filter to current file
          lc_filt = STRTRAN(lc_filt, "a_soytrn", "a_sotran")
          lc_filt = STRTRAN(lc_filt, "a_somast", "a_soymst")

          *-- Set code condition
          IF NOT EMPTY(lc_code)
            go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
          ENDIF

          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")
          go_SQL.cmpA_Sotran.m_SetOrder("sono1")
          go_SQL.cmpA_Icitem.m_SetOrder("item")
          go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

          *-- Select Order Entry Master file
          go_SQL.m_TableChangeCurrent("a_somast")
          go_SQL.cmpA_Somast.m_SetOrder("sono")
          go_SQL.m_TableChangeCurrent("a_sotran")
          go_SQL.cmpA_Sotran.m_SetRelation("sono", "a_somast", .t.)
          lc_SQLFilt= go_SQL.cmpA_Sotran.m_GetFilter()
          lc_SQLFilt = lc_SQLFilt + ;
                       IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                       " NOT go_SQL.cmpA_Somast.m_IsEof() "

          go_SQL.cmpA_Sotran.m_SetFilter(lc_SQLFilt)
          go_SQL.m_TableChangeCurrent("a_somast")
          lc_fields = STRTRAN(lc_fields, lc_alias, "a_sotran->")
          lc_fields = STRTRAN(lc_fields, "a_soymst->", "a_somast->")
          lc_alias = "a_sotran->"

          *-- Relate back to master file for PO number if Cust PO rpt
          *-- Work around for set skip to
           go_SQL.m_TableChangeCurrent("a_sotran")
          DO CASE
            CASE NOT EMPTY(lc_pono)
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), "FIELDS " + lc_fields + " FOR " + lc_filt + " AND UPPER(a_somast->ponum) %=% UPPER(ALLTRIM(??lc_pono)) + '%/%' ")

            CASE NOT EMPTY(ld_bdate) AND NOT EMPTY(ld_edate)
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                            " FIELDS " + lc_fields + " FOR ordate <= ??ld_edate AND " + lc_filt)

            CASE NOT EMPTY(ld_bdate)
*\ [Begin] PTR# 75564 06/10/04 TIVK Printing for only begin date and no end date
*!*                  go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
*!*                                                " FIELDS " + lc_fields + " REST FOR " + lc_filt)
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                            " FIELDS " + lc_fields + " FOR ordate >= ??ld_bdate AND " + lc_filt)
*\ [End] PTR# 75564 06/10/04 TIVK Printing for only begin date and no end date

            CASE NOT EMPTY(ld_edate)
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                            " FIELDS " + lc_fields + " FOR ordate <= ??ld_edate AND " + lc_filt)
            CASE lc_rept = "4"
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                              "FIELDS " + lc_fields + " FOR " + lc_filt + " AND NOT (sostat $ 'VCX' )")

            OTHERWISE
              go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                              "FIELDS " + lc_fields + " FOR " + lc_filt)

          ENDCASE

          *-- Reset index order

          *-- Select first temporary file
          go_SQL.m_TableChangeCurrent("a_tmpf1")

          DO CASE
            CASE lc_rept $ "1P"
              *-- Transactions
              go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "FOR currhist = ' ' AND sotype $ '" + ms + "' AND NOT sostat $ 'VX'")

            CASE lc_rept = "4"
              *-- Orders by Salesperson
              mshiplen = LEN(TRIM(gc_shiptyp))

              go_SQL.cmpA_tmpf1.m_SQLAppendFrom( go_SQL.m_getTempTableName(2), ;
                                            " FOR currhist = ' ' AND sotype $ '" + ms + "' AND NOT sostat $ 'VX' AND " + ;
                                            IIF(EMPTY(gc_shiptyp), "1=1", "item <> TRIM(??gc_shiptyp)"))
          ENDCASE

          *-- Erase second temporary file
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(2), "", "")
        ENDIF && LEFT(lc_file,1) = "B" AND etc.

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE lc_rept = "1"

            DO CASE
              CASE lc_detail = "D"

                IF gl_locts

                  DO CASE
                    CASE lc_order = "C"
                      *# DOCCODE REPORT FORM sotdcl
                      lc_frx = gc_adrvprg + "sotdcl"
                    CASE lc_order = "D"
                      *# DOCCODE REPORT FORM sotddl
                      lc_frx = gc_adrvprg + "sotddl"
                    CASE lc_order = "I"
                      *# DOCCODE REPORT FORM sotdil
                      lc_frx = gc_adrvprg + "sotdil"
                    CASE lc_order = "O"
                      *# DOCCODE REPORT FORM sotdol
                      lc_frx = gc_adrvprg + "sotdol"
                    CASE lc_order = "S"
                      *# DOCCODE REPORT FORM sotdsl
                      lc_frx = gc_adrvprg + "sotdsl"
                  ENDCASE

                ELSE

                  DO CASE
                    CASE lc_order = "C"
                      *# DOCCODE REPORT FORM sotdcx
                      lc_frx = gc_adrvprg + "sotdcx"
                    CASE lc_order = "D"
                      *# DOCCODE REPORT FORM sotddx
                      lc_frx = gc_adrvprg + "sotddx"
                    CASE lc_order = "I"
                      *# DOCCODE REPORT FORM sotdix
                      lc_frx = gc_adrvprg + "sotdix"
                    CASE lc_order = "O"
                      *# DOCCODE REPORT FORM sotdox
                      lc_frx = gc_adrvprg + "sotdox"
                    CASE lc_order = "S"
                      *# DOCCODE REPORT FORM sotdsx
                      lc_frx = gc_adrvprg + "sotdsx"
                  ENDCASE

                ENDIF

              CASE lc_detail = "S"

                IF gl_locts
                  *# DOCCODE REPORT FORM sotrsl
                  lc_frx = gc_adrvprg + "sotrsl"
                ELSE
                  *# DOCCODE REPORT FORM sotrsx
                  lc_frx = gc_adrvprg + "sotrsx"
                ENDIF

            ENDCASE

*\ [Deleted 15 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                             routine g_cursum for currency summary.

          CASE lc_rept = "P"
            *# DOCCODE REPORT FORM sopotr
            *# DOCCODE REPORT FORM sopots
            lc_frx = gc_adrvprg + IIF(lc_detail = "D", "sopotr", "sopots")
            
*\ [Deleted 9 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                            routine g_cursum for currency summary.            

          CASE lc_rept = "4"

            DO CASE
              CASE lc_detail = "D"

                IF gl_locts
                  *# DOCCODE REPORT FORM sotndl
                  lc_frx = gc_adrvprg + "sotndl"
                ELSE
                  *# DOCCODE REPORT FORM sotndx
                  lc_frx = gc_adrvprg + "sotndx"
                ENDIF

              CASE lc_detail = "S"

                *# DOCCODE REPORT FORM sosyal
                lc_frx = gc_adrvprg + "sosyal"
            ENDCASE

*\ [Deleted 9 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                            routine g_cursum for currency summary.            

        ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        IF go_SQL.so_CurrentAlias.m_IsEof()
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        ll_norecs = .f.
        
        IF go_SQL.sc_SQLType = "SD"
          *-- Have the count of records matching the condition and update the records only
          *-- if there is atleast one record matching the condition. This has been done to
          *-- to avoid fatal when the backend is DB2, as DB2 will throw error if there are
          *-- no records to update matching the condition
          ll_norecs = NOT (go_SQL.cmpA_Tmpf1.m_Count("FOR umfact = 0") > 0)
        ENDIF

        IF NOT ll_norecs
          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_tmpf1.sc_TableNameFull + ;
                           " SET umfact = 1 WHERE umfact = 0", "")
        ENDIF

        DO g_dspst WITH "Sorting transactions...", .t., gn_msgline, "", "", ""

        IF lc_detail = "D"
          *-- Detail report

          *-- Calculate discounted price and quantity

          *-- Conditionally update columns checking if item is not closed and is a ship type item or
          *-- Closed item or ship type item that has shipped
          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                           " SET " + ;
                           "qtyord = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "qtyord +0+ qtyshp ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "qtyshp ELSE qtyord END END, " + ;
                           "tqtyord = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "tqtyord +0+ tqtyshp ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "tqtyshp ELSE tqtyord END END " + ;
                           IIF(lc_rept = "4", ", taxrate = 0", ""), "")

          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                           " SET " + ;
                           "extprice = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyord, tprice, disc) ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyshp, tprice, disc) ELSE extprice END END, " + ;
                           "bextpri = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "g_extnd(" + ALLTRIM(STR(gn_basedec)) + ", tqtyord, tbprice, disc) ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "g_extnd(" + ALLTRIM(STR(gn_basedec)) + ", tqtyshp, tbprice, disc) ELSE bextpri END END ", ;
                           "")

          *-- Get shipments for ICTRAN
          DO l_getshp

          go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        ELSE
          *-- Summary report
          go_SQL.m_TableChangeCurrent("a_tmpf1")
          go_SQL.Cmpa_tmpf1.m_SetRelation("custno", "a_arcust", .f.)

          *-- Conditionally update columns checking if item is not closed and is a ship type item or
          *-- Closed item or ship type item that has shipped
          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                           " SET " + ;
                           "qtyord = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "qtyord +0+ qtyshp ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "qtyshp ELSE qtyord END END, " + ;
                           "tqtyord = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "tqtyord +0+ tqtyshp ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "tqtyshp ELSE tqtyord END END " + ;
                           IIF(lc_rept = "4", ", taxrate = 0", ""), "")

          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                           " SET " + ;
                           "extprice = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyord, tprice, disc) ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyshp, tprice, disc) ELSE extprice END END, " + ;
                           "bextpri = CASE WHEN sostat <> 'C' AND LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") <> ??gc_ShipTyp THEN " + ;
                           "g_extnd(" + ALLTRIM(STR(gn_basedec)) + ", tqtyord, tbprice, disc) ELSE " + ;
                           "CASE WHEN sostat = 'C' OR (LEFT(item, " + ALLTRIM(STR(LEN(gc_shiptyp))) + ") = ??gc_shiptyp AND qtyord = 0) THEN " + ;
                           "g_extnd(" + ALLTRIM(STR(gn_basedec)) + ", tqtyord, tbprice, disc) ELSE bextpri END END ", ;
                           "")

          go_SQL.so_CurrentAlias.m_ReplaceBulk("descrip WITH a_arcust->company", "A", "", .t.)

          *-- Get shipments for ICTRAN
          DO l_getshp

          go_SQL.m_TableChangeCurrent("a_tmpf1")

          go_SQL.cmpA_Tmpf1.m_CreateIndex("OrDate", "DTOS(ordate) + sono + loctid + custno", "", .t., .f.)

          *-- Fetch the records from a_tmpf1 table into a_tmpf2 table by grouping on key values
          go_SQL.m_SQLSelect("sono, " + ;
                             "custno, " + ;
                             "item, " + ;
                             "descrip, " + ;
                             "disc, " + ;
                             "taxrate, " + ;
                             "SUM(cost) AS cost, " + ;
                             "SUM(tcost) AS tcost, " + ;
                             "SUM(price) AS price, " + ;
                             "SUM(qtyord) AS qtyord, " + ;
                             "stkumid, " + ;
                             "SUM(qtyshp) AS qtyshp, " + ;
                             "SUM(extprice) AS extprice, " + ;
                             "ordate, " + ;
                             "rqdate, " + ;
                             "shipdate, " + ;
                             "SUM(shipqty) AS shipqty, " + ;
                             "SUM(tshpqty) AS tshpqty, " + ;
                             "umeasur, " + ;
                             "umfact, " + ;
                             "terr, " + ;
                             "salesmn, " + ;
                             "isoclss, " + ;
                             "seq, " + ;
                             "stkcode, " + ;
                             "taxable, " + ;
                             "currhist, " + ;
                             "sostat, " + ;
                             "sotype, " + ;
                             "taxcode, " + ;
                             "loctid, " + ;
                             "tranlineno, " + ;
                             "SUM(shpamt) AS shpamt, " + ;
                             "ponum, " + ;
                             "sodate, " + ;
                             "currid, " + ;
                             "SUM(bcost) AS bcost,  " + ;
                             "SUM(tbcost) AS tbcost,  " + ;
                             "SUM(bextpri) AS bextpri,  " + ;
                             "SUM(bprice) AS bprice,  " + ;
                             "exchrat, " + ;
                             "SUM(tqtyord) AS tqtyord,  " + ;
                             "SUM(tprice) AS tprice,  " + ;
                             "SUM(tqtyshp) AS tqtyshp,  " + ;
                             "SUM(tbprice) AS tbprice, " + ;
                             "000000.00 AS bshipqty " + ;
                             "FROM " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + " " + ;
                             "GROUP BY loctid, sono, ordate, custno " + ;
                             "ORDER BY loctid, sono, ordate, custno", ;
                             "SQL TABLE", ;
                             go_SQL.m_GetTempTableName(2))

          go_SQL.so_CurrentAlias.m_CloseTable()

          g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)

          go_SQL.so_CurrentAlias.m_CreateIndex("OrdDate", "DTOS(ordate) + sono + loctid + custno", "", .t., .f.)

          go_SQL.m_TableChangeCurrent("a_tmpf2")

          *-- Close and erase Temporary file
          go_SQL.cmpA_Tmpf1.m_CloseTable()
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(1), "", "")

          go_SQL.m_TableChangeCurrent("a_tmpf2")
          go_SQL.cmpA_tmpf2.m_SetOrder(0)

          DO CASE
            CASE lc_rept $ "1P"

              IF gl_locts
                go_SQL.so_CurrentAlias.m_CreateIndex("LoctId", "loctid + DTOS(ordate)", "", .t., .f.)
              ELSE
                go_SQL.so_CurrentAlias.m_CreateIndex("ordate", "ordate", "", .t., .f.)
              ENDIF

            OTHERWISE
              go_SQL.so_CurrentAlias.m_CreateIndex("salesmn", "salesmn + DTOS(ordate)", "", .t., .f.)
          ENDCASE

        ENDIF && lc_detail = "D"

        *-- Create temporary index
        DO g_dspst WITH "Indexing file...", .t., gn_msgline, "", "", ""

        DO CASE
          CASE lc_detail = "S" AND lc_rept = "1"

            DO CASE
              CASE LEFT(lc_show,1) = "Q"
                go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY loctid, qtyord", ;
                                   "SQL TABLE", go_SQL.m_getTempTableName(3))

              CASE LEFT(lc_show,1) = "V"
                go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY loctid, extprice", ;
                                   "SQL TABLE", go_SQL.m_getTempTableName(3))
            ENDCASE

            *-- Close the temporary table
            go_SQL.so_CurrentAlias.m_CloseTable()

            *-- Open sorted temporary file
            = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)

          CASE lc_rept = "P"
            go_SQL.so_CurrentAlias.m_CreateIndex("custno", "custno + ponum + sono", "", .t., .f.)

          CASE lc_detail = "D" AND lc_rept = "1"

            DO CASE
              CASE lc_order = "S"

                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + salesmn + custno + sono", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("salesmn", "salesmn + custno + sono", "", .t., .f.)
                ENDIF

              CASE lc_order = "T"

                *-- gl_sbtmod by territory
                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + terr + custno + sono", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("terr", "terr + custno + sono", "", .t., .f.)
                ENDIF

              CASE lc_order = "C"

                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + custno + sono", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("custno", "custno + sono", "", .t., .f.)
                ENDIF

              CASE lc_order = "D"

                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + DTOS(rqdate)", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("rqdate", "rqdate", "", .t., .f.)
                ENDIF

              CASE lc_order = "I"

                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + item + DTOS(rqdate)", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("item", "item + DTOS(rqdate)", "", .t., .f.)
                ENDIF

              CASE lc_order = "O"

                IF gl_locts
                  go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + sono + custno", "", .t., .f.)
                ELSE
                  go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + custno", "", .t., .f.)
                ENDIF

                go_SQL.cmpA_Somast.m_SetOrder("custno1")
                go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)
                go_SQL.so_CurrentAlias.m_SetRelation("custno + sono", "a_somast", .t.)
            ENDCASE

          CASE lc_rept = "4"

            IF LEFT(lc_show,1) = "Q"
              go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY qtyord DESC", ;
                                 "SQL TABLE", go_SQL.m_getTempTableName(3))
            ELSE
              go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY extprice DESC", ;
                                 "SQL TABLE", go_SQL.m_getTempTableName(3))
            ENDIF

            = go_SQL.so_CurrentAlias.m_CloseTable()

            IF go_SQL.m_IsUsed("a_tmpf2")
              go_SQL.cmpA_Tmpf2.m_CloseTable()
            ENDIF

            = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf2", .t., .f.)

            DO CASE
              CASE gl_locts AND LEFT(lc_show,1) = "Q"
                go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + salesmn", "", .t., .f.)

              CASE gl_locts AND LEFT(lc_show,1) = "V"
                go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + salesmn", "", .t., .f.)

              CASE LEFT(lc_show,1) = "Q"
                go_SQL.so_CurrentAlias.m_CreateIndex("salesmn", "salesmn", "", .t., .f.)

              CASE LEFT(lc_show,1) = "V"
                go_SQL.so_CurrentAlias.m_CreateIndex("salesmn", "salesmn", "", .t., .f.)

            ENDCASE

        ENDCASE

        *-- Set report title
        DO CASE
          CASE lc_rept $ "1"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Transaction Report by "

            DO CASE
              CASE lc_detail = "S" AND LEFT(lc_show,1) = "Q"
                lc_title = lc_title + "Qty ordered"
              CASE lc_detail = "S" AND LEFT(lc_show,1) = "V"
                lc_title = lc_title + "Value ordered"
              CASE lc_order = "C"
                lc_title = lc_title + "Customer"
              CASE lc_order = "D"
                lc_title = lc_title + "Date Required"
              CASE lc_order = "I"
                lc_title = lc_title + "Item"
              CASE lc_order = "S"
                lc_title = lc_title + "Salesperson"
              CASE lc_order = "O"
                lc_title = lc_title + "Order Number"
            ENDCASE

          CASE lc_rept = "4" AND lc_only = "A"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Orders by Salesperson"

          CASE lc_rept = "4" AND lc_only = "O"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Open Orders by Salesperson"

          CASE lc_rept = "4" AND lc_only = "P"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Partially Shipped Orders by Salesperson"

        ENDCASE

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE lc_rept = "1"

            IF ll_cursum

              IF lc_detail = "S" AND gl_locts
                DO g_cursum WITH "currid", ;
                                 "extprice~shipqty", ;
                                 "Order Value~Ship Value"
              ELSE
                DO g_cursum WITH "currid", ;
                                 "extprice~shipqty", ;
                                 "Order Value~Shipped Value"
              ENDIF

              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

          CASE lc_rept = "P"
            *# DOCCODE REPORT FORM sopotr
            *# DOCCODE REPORT FORM sopots
            lc_frx = gc_adrvprg + IIF(lc_detail = "D", "sopotr", "sopots")

            IF ll_cursum
              DO g_cursum WITH "currid", ;
                               "extprice~shipqty", ;
                               "Order Value~Shipped Value"
              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

          CASE lc_rept = "4"

            IF ll_cursum
              DO g_cursum WITH "currid", ;
                               "extprice~shipqty", ;
                               "Order Value~Shipped Value"
              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

        ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

      CASE lc_rept = "2"
        *-- Shipments

        *-- Open Inventory Master file
        = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")
        go_SQL.cmpA_Icitem.m_SetOrder(0)

        IF LEFT(lc_file,1) $ "BC"
          *-- Open current Master file
          = g_opnfl(gf_somastf, "a_somast", .f., .f., "")
          go_SQL.cmpA_Somast.m_SetOrder(0)

          *-- Open current Inventory transfers
          = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "")
          go_SQL.cmpA_Ictran.m_SetOrder(0)
        ENDIF

        IF LEFT(lc_file,1) $ "BH"
          *-- Open YTD Transaction file
          = g_opnfl(gf_soymstf, "a_soymst", .f., .f., "")
          go_SQL.cmpA_Soymst.m_SetOrder(0)

          *-- Open YTD Inventory Transaction Detail file
          = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "")
          go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ENDIF

        *-- Set transaction type condition, exclude explosion records
        lc_filt = [LEFT(a->trantyp,1) <> 'E' AND ]

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + [a->loctid+a->item %=% TRIM(??lc_loctid) + '%/%' AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + [a->orgno+a->docno %=% TRIM(??lc_custno) + '%/%' AND ]
        ENDIF

        *-- Set item number condition
        IF NOT EMPTY(lc_item)
          lc_filt = lc_filt + [a->item %=% TRIM(??lc_item) + '%/%' AND ]
        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [c->itmclss %=% TRIM(??lc_class) + '%/%' AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [c->code %=% TRIM(??lc_code) + '%/%' AND ]
        ENDIF

        *-- Set date range conditions
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + [DTOS(a->tdate) >= '] + DTOS(ld_bdate) + [' AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + [DTOS(a->tdate) <= '] + DTOS(ld_edate) + [' AND ]
        ENDIF

        *-- Add join and shipment conditions
        lc_filt = [a->applid = 'SO' AND ] + lc_filt + [a->sqty <> 0 ]

        *-- Setup FROM (table) lists

        *-- Included join condition clause avoiding comparison of join condition
        *-- columns in the WHERE clause
        lc_hfrom = gf_icytrnf + " AS a INNER JOIN " + gf_soymstf + " AS b "
        lc_cfrom = gf_ictranf + " AS a INNER JOIN " + gf_somastf + " AS b "

        lc_hfrom = lc_hfrom + "ON a->docno = b->sono "
        lc_cfrom = lc_cfrom + "ON a->docno = b->sono "

        *-- Include item master file

        lc_cfrom = lc_cfrom + " INNER JOIN " + gf_icitemf + " AS c "
        lc_hfrom = lc_hfrom + " INNER JOIN " + gf_icitemf + " AS c "

        lc_cfrom = lc_cfrom + "ON a->item = c->item "
        lc_hfrom = lc_hfrom + "ON a->item = c->item "

        *-- Setup fields list list
        IF lc_detail = "S"
          *-- Added tqty,trprice,tfprice
          *-- Added tftcost
          *-- Summary
          lc_fields = [a->loctid, ] + ;
                      [a->tdate, ] + ;
                      [a->docno, ] + ;
                      [MAX(a->orgno) AS orgno, ] + ;
                      [MAX(1) AS sqty, ] + ;
                      [MAX(1) AS tqty, ] + ;
                      [SUM(ROUND(-a->sqty * a->price * ] + ;
                      [(100 - a->disc)/100.000, 2)) AS price, ] + ;
                      [SUM(ROUND(-a->tqty * a->trprice * ] + ;
                      [(100 - a->disc)/100.000, 2)) AS trprice, ] + ;
                      [MAX(a->disc) AS disc, ] + ;
                      [MAX(a->taxrate) AS taxrate, ] + ;
                      [MAX(b->salesmn) AS salesmn, ] + ;
                      [MAX(c->stkumid) AS stkumid, ] + ;
                      [MAX(a->umeasur) AS umeasur, ] + ;
                      [MAX(a->umfact) AS umfact, ]  + ;
                      [MAX(a->currid) AS currid, ]  + ;
                      [SUM(ROUND(-a->sqty * a->fprice * ] + ;
                      [(100 - a->disc)/100.000, 2)) AS fprice, ] + ;
                      [SUM(ROUND(-a->tqty * a->tfprice * ] + ;
                      [(100 - a->disc)/100.000, 2)) AS tfprice, ] + ;
                      [MAX(a->tftcost) AS tftcost, ] + ;
                      [MAX(a->ftcost) AS ftcost   ]

        ELSE
          *-- Added tqty,trprice,tfprice
          *-- Added tftcost
          *-- Detail
          lc_fields = [a->loctid, ] + ;
                      [a->item, ] + ;
                      [a->trantyp, ] + ;
                      [a->tdate, ] + ;
                      [-a->sqty AS sqty, ] + ;
                      [-a->tqty AS tqty, ] + ;
                      [a->tcost, ] + ;
                      [a->applid, ] + ;
                      [a->orgno, ] + ;
                      [a->docno, ] + ;
                      [a->tstore, ] + ;
                      [a->tbin, ] + ;
                      [a->price, ] + ;
                      [a->trprice, ] + ;
                      [a->disc, ] + ;
                      [a->taxrate, ] + ;
                      [b->salesmn, ] + ;
                      [c->stkumid, ] + ;
                      [a->umeasur, ] + ;
                      [a->umfact, ]  + ;
                      [a->currid, ]  + ;
                      [a->fprice, ] + ;
                      [a->tfprice, ] + ;
                      [a->tftcost, ] + ;
                      [a->ftcost   ]

        ENDIF && lc_detail = "S"

        *-- Setup ORDER BY list
        DO CASE
          CASE lc_detail = "S"
            *-- Summary, create temporary total file
            lc_orderby = "ORDER BY 1, 2, 3"

          CASE lc_order = "S"
            *-- loctid + salesmn + orgno + docno + item
            lc_orderby = "ORDER BY 1, 15, 9, 10, 2"
            lc_IndDef = "loctid + salesmn + orgno + docno + item"

          CASE lc_order = "C"
            *-- loctid + orgno + docno + item
            lc_orderby = "ORDER BY 1, 9, 10, 2"
            lc_IndDef = "loctid + orgno + docno + item"

          CASE lc_order = "D"
            *-- loctid + tdate + docno + item
            lc_orderby = "ORDER BY 1, 4, 10, 2"
            lc_IndDef = "loctid + tdate + docno + item"

          CASE lc_order = "I"
            *-- loctid + item + tdate
            lc_orderby = "ORDER BY 1, 2, 4"
            lc_IndDef = "loctid + item + tdate"

          CASE lc_order = "O"
            *-- loctid + docno + orgno + item
            lc_orderby = "ORDER BY 1, 10, 9, 2"
            lc_IndDef = "loctid + docno + orgno + item"
        ENDCASE

        *-- Setup GROUP BY list
        IF lc_detail = "S"
          *-- Summary, create temporary total file
          lc_groupby = "GROUP BY a->loctid, a->tdate, a->docno"
        ELSE
          *-- Detail
          lc_groupby = ""
        ENDIF

        *-- Retrieve records
        DO CASE
          CASE LEFT(lc_file,1) = "C"
            *-- From current file
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_cfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))

          CASE LEFT(lc_file,1) = "H"
            *-- From history file
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_hfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))

          CASE LEFT(lc_file,1) = "B"
            *-- From current and history file

            *-- Combine the data from current and history file into a single file
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_cfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + ;
                               " UNION ALL " + ;
                               "(SELECT " + lc_fields + ;
                               " FROM " + lc_hfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + ")" + ;
                               " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))
        ENDCASE

        *-- Open Temporary report file
        go_SQL.so_CurrentAlias.m_CloseTable()
        = g_opnfl(go_SQL.m_getTempTableName(5), "a_tmpf5", .t., .f.)

        IF lc_detail = "D"
*\ [1 Line] PTR 74075 04/12/04 SSHA Fixed the conversion problem
          go_SQL.so_CurrentAlias.m_CreateIndex("Loctid", lc_IndDef, "", .t., .f.)
        ELSE
          go_SQL.so_CurrentAlias.m_CreateIndex("Loctid", "loctid + docno + orgno", ;
                                               "", .t., .f.)
        ENDIF

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        DO CASE
          CASE lc_detail = "D" AND gl_locts
            *# DOCCODE REPORT FORM soshpl
            lc_frx = gc_adrvprg + "soshpl"
          CASE lc_detail = "D" AND NOT gl_locts
            *# DOCCODE REPORT FORM soshpx
            lc_frx = gc_adrvprg + "soshpx"
          CASE lc_detail = "S" AND gl_locts
            *# DOCCODE REPORT FORM soshsl
            lc_frx = gc_adrvprg + "soshsl"
          CASE lc_detail = "S" AND NOT gl_locts
            *# DOCCODE REPORT FORM soshsx
            lc_frx = gc_adrvprg + "soshsx"
        ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        *-- Check for records in result set
        IF go_SQL.cmpA_Tmpf5.m_Reccount() = 0
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        ll_norecs = .f.
        
        IF go_SQL.sc_SQLType = "SD"
          *-- Have the count of records matching the condition and update the records only
          *-- if there is atleast one record matching the condition. This has been done to
          *-- to avoid fatal when the backend is DB2, as DB2 will throw error if there are
          *-- no records to update matching the condition
          ll_norecs = NOT (go_SQL.cmpA_Tmpf5.m_Count("FOR umfact = 0") > 0)
        ENDIF
        
        IF NOT ll_norecs
          go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf5.sc_TableNameFull + ;
                           " SET umfact = 1 WHERE umfact = 0", "")
        ENDIF

        go_SQL.cmpA_Tmpf5.m_MoveRecord(Cn_TopRec)

        *-- Set report title
        DO CASE
          CASE lc_order = "C"
            lc_title = "Shipments by Customer"
            lc_gpdesc = "** Customer => "
          CASE lc_order = "D"
            lc_title = "Shipments by Ship Date"
            lc_gpdesc = "** Ship Date => "
          CASE lc_order = "I"
            lc_title = "Shipments by Item"
            lc_gpdesc = "** Item => "
          CASE lc_order = "O"
            lc_title = "Shipments by Order Number"
            lc_gpdesc = "** Order => "
          CASE lc_order = "S"
            lc_title = "Shipments by Salesperson"
            lc_gpdesc = "** Salesman => "
        ENDCASE

        IF lc_detail = "D"
          lc_title = "Detail " + lc_title
        ELSE
          lc_title = "Summary " + lc_title
        ENDIF

        *-- Set decimals to the user defined value of price decimals
        ln_decnum = SET("DECIMALS")
        SET DECIMALS TO gn_decprc

      CASE lc_rept = "V"
        *-- Distribution by Value Report

        *-- Create and build Distribution by Value Report file
        *# DOCCODE DO syvalr
        DO (gc_idrvprg + "syvalr")

        *-- Set report title
        lc_title = "Customer Distribution by Value Report"

        *-- Set report form name
        *# DOCCODE REPORT FORM syvalc
        lc_frx = gc_idrvprg + "syvalc"
    ENDCASE

    *-- Exit control loop
    EXIT
  ENDDO && WHILE ll_cont

  *-- close data tables opened here
  IF go_SQL.m_IsUsed("a_icserl") AND ln_icserlf = Cn_OpenHere
    go_SQL.cmpA_Icserl.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep1_sql
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP2
*------------------------------------------------------------------------------
*- Description: Reports - Procedure 2 of 4
*------------------------------------------------------------------------------
*- Synopsis...: Reports "5" = Order Picking List
*-                      "6" = Recurring Orders
*-                      "A" = Inventory Master
*-                      "R" = Comments
*-                      "U" = Customer Payment Terms
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_DSPALT
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_rept   = single character report identifier
*-              LEFT(lc_file,1)     = file to get records from:
*-                          "C" for current period file
*-                          "H" for history file
*-                          "B" for both files
*-              lc_type     = type of report (6 only):
*-                          "A" for all items
*-                          "S" for stock items only
*-                          "N" for nonstock items only
*-              lc_bdate    = beginning date
*-              lc_edate    = ending date
*-              lc_order    = "L" to order report by location (5,A,F)
*-                          "O" to order report by order seq (5,A,F)
*-                          "1" to show 1st price (B)
*-                          "2" to show 2nd price (B)
*-                          "3" to show 3rd price (B)
*-              lc_custno   = customer number or portion to match
*-              lc_item     = item number or portion to match
*-              lc_class    = inventory class or portion to match
*-              lc_code     = inventory code or portion to match
*-              lc_vpartno  = vendor part number
*-              lc_loctid  = inventory item location
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep2

  PRIVATE ln_bsono, ;
          ln_esono

  PRIVATE lc_SqlFrom, ;
          lc_SQLFilt, ;
          lc_qstore, ;
          lc_qbin

*\ [4 Lines] PTR# 80791 12/13/05 TIKV Variables Declared
  LOCAL lc_filtmore, ;
        lc_hblkord, ;
        lc_LeftCols, ;
        lc_RightCols, ;
        ln_Col, ;
        lc_Flds

  lc_SqlFrom = ""
  lc_SQLFilt = ""

  DECLARE la_array(1)
  la_array(1) = ""

  *-- Convert variables to dates
  ld_bdate   = g_retdt(lc_bdate)
  ld_edate   = g_retdt(lc_edate)

  *-- Open ICSERL file
  ln_icserlf = g_opnfl(gf_icserlf, "a_icserl", .f., .f., "sono1")

  *-- Display processing message
  DO g_dspst WITH "Locating Selected Transactions...", .t., gn_msgline, ;
                  "", "", ""

  DO CASE
    CASE lc_rept = "5"
      *-- Order Picking List
      ln_bsono = VAL(lc_bsono)

      IF LEN(TRIM(lc_esono)) = 0
        ln_esono = 9999999999
      ELSE
        ln_esono = VAL(lc_esono)
      ENDIF

      *-- Set Order # condition
      lc_filt = "VAL(a_tmpf6->sono) >= " + TRIM(STR(ln_bsono)) + " AND " + ;
                "VAL(a_tmpf6->sono) <= " + TRIM(STR(ln_esono)) + " AND "

      *-- Set customer number condition
      IF NOT EMPTY(lc_custno)
        lc_filt = lc_filt + "a_tmpf6->custno %=% TRIM(??lc_custno) + '%/%'AND "
      ENDIF

      *-- Set item number condition
      IF NOT EMPTY(TRIM(lc_item))
        lc_filt = lc_filt + "a_tmpf6->item %=% TRIM(??lc_item) + '%/%' AND "
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_class)
        lc_filt = lc_filt + "a_icitem->itmclss %=% TRIM(??lc_class) + '%/%' AND "
      ENDIF

      *-- Set code condition
      IF NOT EMPTY(lc_code)
        lc_filt = lc_filt + "a_icitem->code %=% TRIM(??lc_code) + '%/%' AND "
      ENDIF

      *-- Set required date condition
      IF NOT EMPTY(ld_bdate)
        lc_filt = lc_filt + "a_tmpf6->rqdate >= ??ld_bdate AND "
      ENDIF

      IF NOT EMPTY(ld_edate)
        lc_filt = lc_filt + [a_tmpf6->rqdate <= ??ld_edate AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + " NOT a_tmpf6->sotype $ 'BR' AND " + ;
                " NOT a_somast->sostat $ 'V' AND " + ;
                " a_tmpf6->qtyord <> 0 AND " + ;
                " NOT a_tmpf6->sostat $ 'VX'"

      *-- Open Inventory Quantities file, order by item
      ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f.)
      go_SQL.cmpA_Iciqty.m_SetOrder("item1")

      *-- Select Order Entry Transaction file
      go_SQL.m_TableChangeCurrent("a_sotran")
      go_SQL.cmpA_Sotran.m_SetOrder("sono1")

*\ [Begin] PTR# 80791 12/10/05 TIKV Code optimized for performance
      DECLARE la_Flds[1]
      lc_Flds = ""

      AFIELDS(la_Flds)

      FOR ln_Col = 1 TO ALEN(la_Flds,1)
        lc_Flds = lc_Flds + "a_sotran." + la_Flds[ln_Col,1] + "," 
      NEXT 
       
      lc_LeftCols = lc_Flds + "'" + SPACE(LEN(a_icserl->qserial)) + "' AS qserial, '" + ;
                     SPACE(LEN(a_icserl->status)) + "' AS status"

      lc_RightCols = lc_Flds + "a_icserl->qserial AS qserial, " + ;
                     "a_icserl->status AS status"

      *-- Get sotran data to temp table
      go_SQL.m_SQLSelect(lc_LeftCols + " FROM " + go_SQL.CmpA_sotran.sc_TableNameFull + ;
                         " a_sotran WHERE a_sotran.detail = ??gx_false UNION ALL SELECT " + ;
                         lc_RightCols + " FROM " + go_SQL.CmpA_sotran.sc_TableNameFull + ;
                         " a_sotran INNER JOIN " + go_SQL.CmpA_icserl.sc_TableNameFull + " a_icserl ON " + ;
                         "a_sotran->sono + STR(a_sotran->tranlineno, 4) = a_icserl.soline AND " + ;
                         "a_sotran.item = a_icserl.item WHERE a_sotran.detail = ??gx_True AND " + ;
                         "a_icserl.status <> 'X'", ;
                         "SQL TABLE", ;
                         go_SQL.m_getTempTableName(6))

      *-- Update the serial item quantity detail
      go_SQL.so_CurrentAlias.m_ReplaceBulk("serial  WITH qserial, "+ ;
                                           "qtyshp  WITH IIF(status = 'S', 1, 0), "+ ;
                                           "tqtyshp WITH IIF(status = 'S', 1, 0), "+ ;
                                           "qtyord  WITH 1, "+ ;
                                           "tqtyord WITH 1, "+ ;
                                           "sostat  WITH status", ;
                                           "F", ;
                                           "detail = ??gx_true", ;
                                           .t.)

      go_SQL.so_CurrentAlias.m_CloseTable()

      = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

      go_SQL.m_TableChangeCurrent("a_tmpf6")
      go_SQL.cmpA_Tmpf6.m_CreateIndex("Sono", "sono", "", .t., .f.)
      go_SQL.cmpA_Tmpf6.m_CreateIndex("Sono1", "sono+STR(tranlineno,4)", "", .t., .f.)
      go_SQL.cmpA_Tmpf6.m_SetOrder("sono1")

      go_SQL.cmpA_Tmpf6.m_SetRelation("item + loctid", "a_iciqty", .f.)
      go_SQL.cmpA_Tmpf6.m_SetRelation("item", "a_icitem", .t.)

      *-- Select Order Entry Master file
      go_SQL.m_TableChangeCurrent("a_somast")
      go_SQL.cmpA_Somast.m_SetOrder("sono")
      go_SQL.m_TableChangeCurrent("a_tmpf6")
      go_SQL.cmpA_Tmpf6.m_SetRelation("sono", "a_somast", .t.)
      lc_SQLFilt = go_SQL.cmpA_Tmpf6.m_GetFilter()
      lc_SQLFilt = lc_SQLFilt + ;
                   IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                   " NOT go_SQL.cmpA_SoMast.m_IsEof()"

      go_SQL.cmpA_Tmpf6.m_SetFilter(lc_SQLFilt)

      go_SQL.m_TableChangeCurrent("a_somast")

      DO l_setflt

      *-- Added tqtyord
      *-- Copy selected records to temporary file
      *--Work around for Set Skip to
      lc_SQLFilt = go_SQL.cmpA_SoMast.m_GetFilter()
      lc_SQLFilt = IIF(EMPTY(lc_SQLFilt), '1=1', lc_SQLFilt)
      go_SQL.m_TableChangeCurrent("a_tmpf6")

      go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"), ,"F")

      go_SQL.cmpA_Tmpf6.m_CopyTo(go_SQL.m_getTempTableName(1, "F"), ;
               "FIELDS a_tmpf6->seq, a_tmpf6->sono, a_tmpf6->custno, a_tmpf6->item, a_tmpf6->descrip, "+ ;
               "a_tmpf6->isoclss, a_tmpf6->rqdate,  a_tmpf6->lotno,   a_tmpf6->serial, a_tmpf6->qtyord, "+;
               "a_tmpf6->tqtyord, a_tmpf6->loctid,  a_icitem->stkumid, a_icitem->useserl, "+;
               "a_icitem->uselots, a_tmpf6->umeasur, a_tmpf6->umfact FOR " + lc_SQLFilt, "F")

      lc_qstore = ALLTRIM(STR(LEN(a_iciqty->qstore)))
      lc_qbin   = ALLTRIM(STR(LEN(a_iciqty->qbin)))

      go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1, "F"), "ADD COLUMN qstore C(" + lc_qstore + ")", "F")
      go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1, "F"), "ADD COLUMN qbin C(" + lc_qbin + ")", "F")

      go_SQL.so_CurrentAlias.m_Closetable()

      go_SQL.m_TableChangeCurrent("a_sotran")
      go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

      *-- Open temporary file
      = g_opnfl(go_SQL.m_getTempTableName(1, "F"), "a_tmpf1", .t., .f.,,,"F")

      *-- Move the record ponter to top
      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      IF go_SQL.sc_SqlTypeMain = "F"

        *-- Retrieve store/bin information from the quantity file
        DO WHILE NOT go_SQL.cmpA_Tmpf1.m_IsEof()

          go_SQL.m_TableChangeCurrent("a_iciqty")

          DO CASE
            CASE a_tmpf1->useserl = "N" AND a_tmpf1->uselots = "N"
              *-- Item does not use serial numbers or lots, nothing is tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

            CASE a_tmpf1->useserl <> "N" AND EMPTY(a_tmpf1->serial)
              *-- Item uses serial numbers but nothing is tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

            OTHERWISE
              *-- Item uses serial numbers or lots and qty records are tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item3")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->serial, "")

          ENDCASE

          lc_store = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qstore, "")
          lc_bin   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qbin, "")
          lc_lot   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->lotno, "")

          go_SQL.m_TableChangeCurrent("a_tmpf1")

          IF NOT EMPTY(lc_store)
            go_SQL.so_CurrentAlias.m_Replace("qstore", lc_store)
          ENDIF

          IF NOT EMPTY(lc_bin)
            go_SQL.so_CurrentAlias.m_Replace("qbin", lc_bin)
          ENDIF

          IF NOT EMPTY(a_tmpf1->serial) AND NOT a_tmpf1->useserl $ "OS"
            go_SQL.so_CurrentAlias.m_Replace("serial", SPACE(20))
          ENDIF

          IF NOT EMPTY(lc_lot)
            go_SQL.so_CurrentAlias.m_Replace("lotno", lc_lot)
          ENDIF

          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)
        ENDDO

        *-- Clear filter and relation
        go_SQL.m_TableChangeCurrent("a_iciqty")
        go_SQL.so_CurrentAlias.m_SetFilter("")
        go_SQL.m_TableChangeCurrent("a_tmpf1")
        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)      
      ELSE 

        *-- Get the ICIQTY data to local cursor due to permform
        go_SQL.cmpA_Iciqty.m_ScanBegin("F", ".t. = .t.")
        DO WHILE go_SQL.cmpA_Iciqty.m_ScanBulk()
          *-- Exit the loop 
          EXIT 
        ENDDO
        go_SQL.cmpA_Iciqty.m_ScanEnd()

        *-- Set index to local cursor
        INDEX ON item+loctid TO (gc_idrvtmp + "Item1.IDX") ADDITIVE 
        INDEX ON item+qserial TO (gc_idrvtmp + "Item3.IDX") ADDITIVE 

        *-- Retrieve store/bin information from the quantity file
        SELECT a_Tmpf1

        SCAN 
          SELECT a_iciqty

          DO CASE
            CASE (a_tmpf1->useserl = "N" AND a_tmpf1->uselots = "N")
              *-- Item does not use serial numbers or lots, nothing is tagged
              ll_IsFound = SEEK( a_tmpf1->item + a_tmpf1->loctid, "a_iciqty", "Item1")
            CASE a_tmpf1->useserl <> "N" AND EMPTY(a_tmpf1->serial)
              *-- Item uses serial numbers but nothing is tagged
              ll_IsFound = SEEK( a_tmpf1->item + a_tmpf1->loctid, "a_iciqty", "Item1")
            OTHERWISE
              *-- Item uses serial numbers or lots and qty records are tagged
              ll_IsFound = SEEK(a_tmpf1->item + a_tmpf1->serial, "a_iciqty", "Item3")
          ENDCASE

          lc_store = IIF(ll_IsFound, a_iciqty->qstore, "")
          lc_bin   = IIF(ll_IsFound, a_iciqty->qbin, "")
          lc_lot   = IIF(ll_IsFound, a_iciqty->lotno, "")

          SELECT a_Tmpf1

          IF NOT EMPTY(lc_store)
            REPLACE qstore WITH lc_store
          ENDIF

          IF NOT EMPTY(lc_bin)
            REPLACE qbin WITH lc_bin
          ENDIF

          IF NOT EMPTY(a_tmpf1->serial) AND NOT a_tmpf1->useserl $ "OS"
            REPLACE serial WITH SPACE(20)
          ENDIF

          IF NOT EMPTY(lc_lot)
            REPLACE lotno with  lc_lot
          ENDIF

        ENDSCAN 

        *-- Clear Filters and Indexs
        go_SQL.m_TableChangeCurrent("a_iciqty")
        go_SQL.so_CurrentAlias.m_SetFilter("")

        SET INDEX TO 

        *-- Remove single indexs
        ERASE (gc_idrvtmp + "Item1.idx")
        ERASE (gc_idrvtmp + "Item3.idx")

        *-- Clear filter and relation
        go_SQL.m_TableChangeCurrent("a_tmpf1")
        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

      ENDIF

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      IF NOT go_SQL.so_CurrentAlias.m_IsEof()
        go_SQL.so_CurrentAlias.m_ReplaceBulk("umfact WITH 1", "F", "umfact = 0", .t.)
        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
      ENDIF

      *-- If matching records found, create temporary index
      IF NOT go_SQL.so_CurrentAlias.m_IsEof()
        DO g_dspst WITH "Sorting transactions...", .t., gn_msgline, ;
                        "", "", ""

        IF lc_order = "L"
          go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + sono + seq", "", .t., .f.)
        ELSE
          go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + seq", "", .t., .f.)
        ENDIF

      ENDIF
*\ [END] PTR# 80791 12/10/05 TIKV Code optimized for performance

*\ [Deleted Begin] PTR# 80791 12/10/05 TIKV Code modified 
*!*        *-- Create temp file to hold all serial number bearing records from
*!*        *-- a_icserl apart from other records in a_sotran
*!*        go_SQL.so_CurrentAlias.m_CopyStructure(go_SQL.m_getTempTableName(6), "", "", .t.)

*!*        = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

*!*        go_SQL.m_TableChangeCurrent("a_sotran")

*!*        go_SQL.CmpA_sotran.m_ScanBegin("F", "")
*!*        DO WHILE go_SQL.CmpA_sotran.m_ScanBulk()
*!*          go_SQL.CmpA_sotran.m_Scatter("TO la_array(1) MEMO")

*!*          IF detail = gx_True
*!*            go_SQL.m_TableChangeCurrent("a_icserl")

*!*            go_SQL.CmpA_icserl.m_ScanBegin("F", ;
*!*                                  " soline = '" + a_sotran->sono + STR(a_sotran->tranlineno, 4) + "'" + ;
*!*                                  " AND item = '" + a_sotran->item + "' AND status <> 'X'")
*!*            DO WHILE go_SQL.CmpA_icserl.m_ScanBulk()

*!*              go_SQL.m_TableChangeCurrent("a_tmpf6")
*!*              go_SQL.so_CurrentAlias.m_Add()
*!*              go_SQL.so_CurrentAlias.m_Gather("FROM la_array(1) MEMO")

*!*              *-- Added tqtyord,tqtyshp
*!*              go_SQL.so_CurrentAlias.m_ReplaceBulk("serial  WITH a_icserl->qserial, "+ ;
*!*                                                   "qtyshp  WITH IIF(a_icserl->status = 'S', 1, 0), "+ ;
*!*                                                   "tqtyshp WITH IIF(a_icserl->status = 'S', 1, 0), "+ ;
*!*                                                   "qtyord  WITH 1, "+ ;
*!*                                                   "tqtyord WITH 1, "+ ;
*!*                                                   "sostat  WITH a_icserl->status")
*!*              go_SQL.m_TableChangeCurrent("a_icserl")
*!*            ENDDO
*!*            go_SQL.so_CurrentAlias.m_ScanEnd()

*!*          ELSE
*!*            go_SQL.cmpa_tmpf6.m_SQLInsert("", "", "ARRAY la_array(1)")
*!*          ENDIF

*!*        ENDDO
*!*        go_SQL.so_CurrentAlias.m_ScanEnd()

*!*        *-- Go to file top
*!*        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

*!*        go_SQL.m_TableChangeCurrent("a_tmpf6")
*!*        go_SQL.cmpA_Tmpf6.m_CreateIndex("Sono", "sono", "", .t., .f.)
*!*        go_SQL.cmpA_Tmpf6.m_CreateIndex("Sono1", "sono+STR(tranlineno,4)", "", .t., .f.)
*!*        go_SQL.cmpA_Tmpf6.m_SetOrder("sono1")

*!*        go_SQL.cmpA_Tmpf6.m_SetRelation("item + loctid", "a_iciqty", .f.)
*!*        go_SQL.cmpA_Tmpf6.m_SetRelation("item", "a_icitem", .t.)

*!*        *-- Select Order Entry Master file
*!*        go_SQL.m_TableChangeCurrent("a_somast")
*!*        go_SQL.cmpA_Somast.m_SetOrder("sono")
*!*        go_SQL.m_TableChangeCurrent("a_tmpf6")
*!*        go_SQL.cmpA_Tmpf6.m_SetRelation("sono", "a_somast", .t.)
*!*        lc_SQLFilt = go_SQL.cmpA_Tmpf6.m_GetFilter()
*!*        lc_SQLFilt = lc_SQLFilt + ;
*!*                     IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
*!*                     " NOT go_SQL.cmpA_SoMast.m_IsEof()"
*!*        go_SQL.cmpA_Tmpf6.m_SetFilter(lc_SQLFilt)

*!*        go_SQL.m_TableChangeCurrent("a_somast")

*!*        DO l_setflt
*!*        *-- Added tqtyord
*!*        *-- Copy selected records to temporary file
*!*        *--Work around for Set Skip to
*!*        lc_SQLFilt = go_SQL.cmpA_SoMast.m_GetFilter()
*!*        lc_SQLFilt = IIF(EMPTY(lc_SQLFilt), '1=1', lc_SQLFilt)
*!*        go_SQL.m_TableChangeCurrent("a_tmpf6")
*!*        go_SQL.m_dropTable(go_SQL.m_getTempTableName(1))
*!*        go_SQL.cmpA_Tmpf6.m_CopyTo(go_SQL.m_getTempTableName(1), ;
*!*                 "FIELDS a_tmpf6->seq, a_tmpf6->sono, a_tmpf6->custno, a_tmpf6->item, a_tmpf6->descrip, "+ ;
*!*                 "a_tmpf6->isoclss, a_tmpf6->rqdate,  a_tmpf6->lotno,   a_tmpf6->serial, a_tmpf6->qtyord,  "+;
*!*                 "a_tmpf6->tqtyord, a_tmpf6->loctid,  a_icitem->stkumid, "+;
*!*                 "a_tmpf6->umeasur, a_tmpf6->umfact FOR " + lc_SQLFilt)

*!*        lc_qstore = ALLTRIM(STR(LEN(a_iciqty->qstore)))
*!*        lc_qbin   = ALLTRIM(STR(LEN(a_iciqty->qbin)))


*!*        go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1), "ADD COLUMN qstore C(" + lc_qstore + ")")
*!*        go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1), "ADD COLUMN qbin C(" + lc_qbin + ")")

*!*        go_SQL.so_CurrentAlias.m_Closetable()

*!*        go_SQL.m_TableChangeCurrent("a_sotran")
*!*        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

*!*        *-- Set filter on quantity file
*!*        go_SQL.m_TableChangeCurrent("a_iciqty")
*!*        go_SQL.so_CurrentAlias.m_SetFilter("a_iciqty->qonhand > 0")

*!*        *-- Open temporary file
*!*        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

*!*        *-- Set and activate relation
*!*        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

*!*        IF go_SQL.so_CurrentAlias.m_Reccount() = 0
*!*          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
*!*        ELSE
*!*          go_SQL.so_CurrentAlias.m_MoveToRecno(go_SQL.so_CurrentAlias.m_GetRecno())
*!*        ENDIF

*!*        *-- Retrieve store/bin information from the quantity file
*!*        DO WHILE NOT go_SQL.cmpA_Tmpf1.m_IsEof()

*!*          go_SQL.m_TableChangeCurrent("a_iciqty")

*!*          DO CASE
*!*            CASE a_icitem->useserl = "N" AND a_icitem->uselots = "N"
*!*              *-- Item does not use serial numbers or lots, nothing is tagged
*!*              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
*!*              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

*!*            CASE a_icitem->useserl <> "N" AND EMPTY(a_tmpf1->serial)
*!*              *-- Item uses serial numbers but nothing is tagged
*!*              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
*!*              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

*!*            OTHERWISE
*!*              *-- Item uses serial numbers or lots and qty records are tagged
*!*              go_SQL.cmpA_Iciqty.m_SetOrder("item3")
*!*              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->serial, "")

*!*          ENDCASE

*!*          lc_store = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qstore, "")
*!*          lc_bin   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qbin, "")
*!*          lc_lot   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->lotno, "")

*!*          go_SQL.m_TableChangeCurrent("a_tmpf1")

*!*          IF NOT EMPTY(lc_store)
*!*            go_SQL.so_CurrentAlias.m_Replace("qstore", lc_store)
*!*          ENDIF

*!*          IF NOT EMPTY(lc_bin)
*!*            go_SQL.so_CurrentAlias.m_Replace("qbin", lc_bin)
*!*          ENDIF

*!*          IF NOT EMPTY(a_tmpf1->serial) AND NOT a_icitem->useserl $ "OS"
*!*            go_SQL.so_CurrentAlias.m_Replace("serial", SPACE(20))
*!*          ENDIF

*!*          IF NOT EMPTY(lc_lot)
*!*            go_SQL.so_CurrentAlias.m_Replace("lotno", lc_lot)
*!*          ENDIF

*!*          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)
*!*        ENDDO

*!*        *-- Clear filter and relation
*!*        go_SQL.m_TableChangeCurrent("a_iciqty")
*!*        go_SQL.so_CurrentAlias.m_SetFilter("")
*!*        go_SQL.m_TableChangeCurrent("a_tmpf1")
*!*        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

*!*        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

*!*        IF NOT go_SQL.so_CurrentAlias.m_IsEof()
*!*          go_SQL.so_CurrentAlias.m_ReplaceBulk("umfact WITH 1", "F", "umfact = 0", .t.)
*!*          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
*!*        ENDIF

*!*        *-- If matching records found, create temporary index
*!*        IF NOT go_SQL.so_CurrentAlias.m_IsEof()
*!*          DO g_dspst WITH "Sorting transactions...", .t., gn_msgline, ;
*!*                          "", "", ""

*!*          IF lc_order = "L"
*!*            go_SQL.so_CurrentAlias.m_CreateIndex("loctid", "loctid + sono + seq", "", .t., .f.)
*!*          ELSE
*!*            go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + seq", "", .t., .f.)
*!*          ENDIF

*!*        ENDIF
*\ [Deleted End] PTR# 80791 12/10/05 TIKV Code modified 

      *-- Set report title and report form name
      IF lc_order = "L"
        lc_title = "Order Picking List by Location"
        *# DOCCODE REPORT FORM sosels
        lc_frx = gc_adrvprg + "sosels"
      ELSE
        lc_title = "Order Picking List by Order Number"
        *# DOCCODE REPORT FORM sosols
        lc_frx = gc_adrvprg + "sosols"
      ENDIF

    CASE lc_rept = "6"
      *-- Recurring Orders

      *-- Open Recurring Order file
      IF NOT go_SQL.m_IsUsed("a_sorecr")
        ln_opnrecr = g_opnfl(gf_sorecrf,"a_sorecr", .f., .f.)
      ELSE
        go_SQL.m_TableChangeCurrent("a_sorecr")
      ENDIF

      *-- Set tag order
      go_SQL.cmpA_Sorecr.m_SetOrder("custno1")

      *-- Set customer number condition
      IF NOT EMPTY(lc_custno)
        lc_filt = lc_filt + [custno %=% TRIM(??lc_custno) + '%/%' AND ]
      ELSE
        lc_filt = ""
      ENDIF

      *-- Set item number condition
      IF NOT EMPTY(TRIM(lc_item))
		      lc_filt = lc_filt + [a_sorecr->item %=% TRIM(??lc_item) + '%/%'  AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_class)
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        lc_filt = lc_filt + [a_icitem->itmclss %=% TRIM(??lc_class) + '%/%'  AND ]
      ENDIF

      *-- Set code condition
      IF NOT EMPTY(lc_code)
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        lc_filt = lc_filt + [a_icitem->code %=% TRIM(??lc_code) + '%/%' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ NOT DELETED()]

      *-- Set filter
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)

      *-- Find first matching record
      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      *-- Set report title
      lc_title = "Recurring Orders Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM sorecr
      lc_frx = gc_adrvprg + "sorecr"

    CASE lc_rept = "A"
      *-- Inventory Master

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = "type = '" + LEFT(lc_type,1) + "' AND "
      ELSE
        lc_filt = [1=1 AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + "item >= '" + TRIM(lc_bitem) + "' AND "
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + "item <= '" + TRIM(lc_eitem) + CHR(255) + "' AND "
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + "itmclss >= TRIM(??lc_bclass) AND "
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_itmclss = TRIM(lc_eclass) + CHR(255)
        lc_filt = lc_filt + "itmclss <= ??lc_itmclss AND "
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + "comcode >= TRIM(??lc_bccode) AND "
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_comcode = TRIM(lc_eccode) + CHR(255)
        lc_filt = lc_filt + "comcode <= ??lc_comcode AND "
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + "code >= TRIM(??lc_bmcode) AND "
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_code = TRIM(lc_emcode) + CHR(255)
        lc_filt = lc_filt + "code <= ??lc_code AND "
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ NOT DELETED()]

      *-- Open Inventory Master file
      = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Remove relationships in Inventory Master file
      go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

      *-- Initialize variable for extra filter
      lc_filtmore = ""

      *-- Set location and date of last sale conditions
      IF NOT EMPTY(lc_loctid) OR NOT EMPTY(ld_bdate)
        *-- Open Inventory by Location file
        = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item")

        *-- Set filter conditions in Inventory by Location file
        DO CASE
          CASE NOT EMPTY(lc_loctid) AND NOT EMPTY(ld_bdate)
            lc_filtmore = " AND a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' AND " + ;
                          "a_iciloc->lsale >= ??ld_bdate"
            go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' AND " + ;
                                               "a_iciloc->lsale >= ??ld_bdate")

          CASE NOT EMPTY(lc_loctid)
            lc_filtmore = " AND a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%'"
            go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%'")

          CASE NOT EMPTY(ld_bdate)
            lc_filtmore = " AND a_iciloc->lsale >= ??ld_bdate"
            go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->lsale >= ??ld_bdate")

        ENDCASE

        *-- Select Inventory Master file
        go_SQL.m_TableChangeCurrent("a_icitem")
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_iciloc", .t.)

        *-- Set location and date of last sale conditions
        lc_filt = lc_filt + [ AND NOT go_SQL.cmpA_Iciloc.m_IsEof()] + lc_filtmore
      ENDIF && .NOT EMPTY(lc_loctid) OR NOT EMPTY(ld_bdate)

      *-- Set part number condition
      IF NOT EMPTY(lc_vpartno)
        *-- Open Inventory by Supplier file
        = g_opnfl(gf_icsuplf, "a_icsupl", .f., .f., "item")

        *-- Set filter conditions in Inventory by Supplier file
        lc_filtmore = " AND a_icsupl->vpartno %=% TRIM(??lc_vpartno) + '%/%'"

        go_SQL.so_CurrentAlias.m_SetFilter("a_icsupl->vpartno %=% TRIM(??lc_vpartno) + '%/%'")

        *-- Select Inventory Master file
        go_SQL.m_TableChangeCurrent("a_icitem")
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icsupl", .t.)

        *-- Set part number condition
        lc_filt = lc_filt + " AND NOT go_SQL.cmpA_Icsupl.m_IsEof()" + lc_filtmore
      ENDIF

      *-- Reset variable for extra filter
      lc_filtmore = ""

      *-- Set Filter
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)
      go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), "", "")


      *-- Open temporary file
      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

      IF lc_order = "I"
        go_SQL.so_CurrentAlias.m_CreateIndex("item", "item", "", .t., .f.)
      ELSE
        go_SQL.so_CurrentAlias.m_CreateIndex("itmdesc", "itmdesc", "", .t., .f.)
      ENDIF

      *-- Set report title
      lc_title = "Inventory Master Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM syinvt
      lc_frx = gc_idrvprg + "syinvt"

    CASE lc_rept == "BO"
      *-- Blanket Order file listing

      *-- Open blanket order tables
      ln_opnhblk = g_opnfl(gf_sohblkf, "a_sohblk", .f., .f., "")
      ln_opndblk = g_opnfl(gf_sodblkf, "a_sodblk", .f., .f., "")

      *-- Set end BO # condition
      IF EMPTY(lc_endbo)
        lc_endbo = REPLICATE(CHR(255), LEN(lc_endbo))
      ELSE
        lc_endbo = lc_endbo + CHR(255)
      ENDIF

      *-- Set date conditions
      IF EMPTY(ld_edate)
        ld_edate = Cd_maxdate
      ENDIF

      *-- Set status condition
      DO CASE
        CASE lc_status = "Open"
          lc_statflt = " "
        CASE lc_status = "Closed"
          lc_statflt = "C"
        CASE lc_status = "Void"
          lc_statflt = "V"
        OTHERWISE
          lc_statflt = ""
      ENDCASE

      *-- Setup SQL ORDER BY clause
      lc_ordby = IIF(LEFT(lc_order,1) = "C", ;
                 "a_sohblk->custno, a_sohblk->bono", "a_sohblk->bono")

      *-- Setup fields list
      IF lc_detail = "S"
        *-- Summary
        go_SQL.m_SQLSelect(" a_sohblk->bono, a_sohblk->bodate, a_sohblk->custno, "+ ;
                           " a_arcust->company, a_sohblk->ponum, a_sohblk->boamt,  "+ ;
                           " a_sohblk->rlsamt, a_sohblk->boamt - a_sohblk->rlsamt AS opnval,  "+ ;
                           " a_sohblk->bostat, a_sohblk->currid,  "+ ;
                           " a_sohblk->exchrat,  "+ ;
                           " a_sohblk->exchfrz " + ;
                           " FROM " + ;
                           gf_sohblkf + " AS a_sohblk, " + ;
                           gf_arcustf + " AS a_arcust " + ;
                           "WHERE a_sohblk->custno = a_arcust->custno AND " + ;
                           "a_sohblk->custno + a_sohblk->bono %=% RTRIM(??lc_custno) + '%/%' AND " + ;
                           "a_sohblk->bono   >= ??lc_begbo AND " + ;
                           "a_sohblk->bono   <= ??lc_endbo AND " + ;
                           "a_sohblk->bodate >= ??ld_bdate AND " + ;
                           "a_sohblk->bodate <= ??ld_edate AND " + ;
                           "a_sohblk->bostat %=% ??lc_statflt + '%/%' " + ;
                           "ORDER BY " + lc_ordby, ;
                           "SQL TABLE", go_SQL.m_getTempTableName(6))

        go_SQL.so_CurrentAlias.m_CLoseTable()
        = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

        *- NOTE: As we could not pass exchange reate function through SQL we did a Bulk Replace
        IF go_SQL.so_CurrentAlias.m_Reccount() > 0 AND gl_mc

          lc_hblkord = go_SQL.cmpA_sohblk.m_GetOrder()
          go_SQL.cmpA_sohblk.m_SetOrder("custno1")
          *-- Set relation to SOHBLK for replacebulk
          go_SQL.cmpA_tmpf6.m_SetRelation("custno + bono", "a_sohblk")

          go_SQL.so_CurrentAlias.m_ReplaceBulk("exchrat WITH l_retcxra(a_sohblk->currid)", ;
                                               "F", "a_sohblk->exchfrz = .f.")

          go_SQL.cmpA_sohblk.m_SetOrder(lc_hblkord)
          go_SQL.cmpA_tmpf6.m_SetRelation()
        ENDIF

        *# DOCCODE REPORT FORM soblns
        lc_frx = gc_adrvprg + "soblns"
      ELSE

        *-- Added tprice,tqtybo,tqtyrls,topnqty
        go_SQL.m_SQLSelect("a_sohblk->bono, a_sohblk->custno, a_sohblk->bodate,  "+ ;
                           "a_sodblk->rqdate, a_sodblk->item, a_sodblk->descrip,  "+ ;
                           "a_sodblk->umeasur, a_sodblk->umfact, a_icitem->stkumid,  "+ ;
                           "a_sodblk->qtybo, a_sodblk->tqtybo, a_sodblk->qtyrls,  "+ ;
                           "a_sodblk->tqtyrls, a_sodblk->qtybo - a_sodblk->qtyrls AS opnqty,  "+ ;
                           "a_sodblk->tqtybo - a_sodblk->tqtyrls AS topnqty, a_sodblk->price,  "+ ;
                           "a_sodblk->tprice, a_sodblk->disc, a_sohblk->bostat, a_sohblk->currid,  "+ ;
                           "a_sohblk->exchrat, "+ ;
                           "a_sohblk->exchfrz " + ;
                           " FROM " + ;
                           gf_sohblkf + " AS a_sohblk, " + ;
                           gf_sodblkf + " AS a_sodblk, " + ;
                           gf_icitemf + " AS a_icitem "   + ;
                           "WHERE " + ;
                           "a_sohblk->custno + a_sohblk->bono = a_sodblk->custno + a_sodblk->bono AND " + ;
                           "a_sodblk->item = a_icitem->item AND " + ;
                           "a_sohblk->custno + a_sohblk->bono %=% RTRIM(??lc_custno) + '%/%' AND " + ;
                           "a_sohblk->bono   >= ??lc_begbo AND " + ;
                           "a_sohblk->bono   <= ??lc_endbo AND " + ;
                           "a_sohblk->bodate >= ??ld_bdate AND " + ;
                           "a_sohblk->bodate <= ??ld_edate AND " + ;
                           "a_sohblk->bostat %=% ??lc_statflt + '%/%' AND " + ;
                           "a_sodblk->bostat <> 'X' " + ;
                           "ORDER BY " + lc_ordby, ;
                           "SQL TABLE", go_SQL.m_getTempTableName(6))

        go_SQL.so_CurrentAlias.m_CLoseTable()
        = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

        *- NOTE: As we could not pass exchange reate function through SQL we did a Bulk Replace
        IF go_SQL.so_CurrentAlias.m_Reccount() > 0 AND gl_mc

          lc_hblkord = go_SQL.cmpA_sohblk.m_GetOrder()
          go_SQL.cmpA_sohblk.m_SetOrder("custno1")
          go_SQL.cmpA_tmpf6.m_SetRelation("custno + bono", "a_sohblk")

          go_SQL.so_CurrentAlias.m_ReplaceBulk("exchrat WITH l_retcxra(a_sohblk->currid)", ;
                                               "F", "a_sohblk->exchfrz = .f.")

          go_SQL.cmpA_sohblk.m_SetOrder(lc_hblkord)
          go_SQL.cmpA_tmpf6.m_SetRelation()
        ENDIF

        *# DOCCODE REPORT FORM soblnd
        lc_frx = gc_adrvprg + "soblnd"
      ENDIF

      *-- close blanket order tables if opened here
      IF go_SQL.m_IsUsed("a_sohblk") AND ln_opnhblk = Cn_OpenHere
        go_SQL.cmpA_Sohblk.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_sodblk") AND ln_opndblk = Cn_OpenHere
        go_SQL.cmpA_Sodblk.m_CloseTable()
      ENDIF

      IF lc_endbo = REPLICATE(CHR(255), LEN(lc_endbo))
        lc_endbo = SPACE(LEN(lc_endbo))
      ENDIF

    CASE lc_rept = "R"
      *-- Comments List

      *-- Open Comment file
      IF NOT go_SQL.m_IsUsed("a_soscom")
        ln_opncomm = g_opnfl(gf_soscomf, "a_soscom", .f., .f.)
      ELSE
        go_SQL.m_TableChangeCurrent("a_soscom")
      ENDIF

      *-- Set tag order
      go_SQL.cmpA_Soscom.m_SetOrder("commid")

      lc_filt = ""

      *-- Set report condition
      IF NOT EMPTY(lc_ecommid)
        lc_filt = lc_filt + ;
                  [(LEFT(commid,LEN(TRIM(??lc_ecommid))) < TRIM(??lc_ecommid) OR ] + ;
                  [ LEFT(commid,LEN(TRIM(??lc_ecommid))) %=% TRIM(??lc_ecommid) + '%/%') AND ]
      ENDIF

      IF NOT EMPTY(lc_bcommid)
        lc_filt = lc_filt + ;
                  [(LEFT(commid,LEN(TRIM(??lc_bcommid))) > TRIM(??lc_bcommid) OR ] + ;
                  [ LEFT(commid,LEN(TRIM(??lc_bcommid))) %=% TRIM(??lc_bcommid) + '%/%') AND ]
      ENDIF

      lc_filt = lc_filt + [ NOT DELETED() ]

      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)

      *-- Set report title
      lc_title   = "SO Comments List"

      *-- Set report form name
      *# DOCCODE REPORT FORM sycomm
      lc_frx = gc_idrvprg + "sycomm"

*\ [Begin] PTR 76407 07/06/04 DAND Customer payment terms listing
    CASE lc_rept = "U"
      *-- Customer payment terms listing

      *-- Display processing message
      DO g_dspst WITH "Locating Records in File...", .t., ;
                      gn_msgline, "", "", ""

      *-- Open terms file
      = d_setfl("ARPTRM", gc_compid, 1)
      = g_opnfl(gf_arptrmf, "a_arptrm", .f., .t., "termsid1")

      *-- Open again for lookup
      = g_opnfl(gf_arptrmf, "a_arptrmLookup", .f., .t., "termsid1")

      go_SQL.cmpA_arptrm.m_SetFilter("")

      lc_filt = ""

      *-- If matching record found
      IF NOT go_SQL.cmpA_arptrm.m_IsEof()

        *-- Set index
        IF LEFT(lc_order,1) = "T"
          go_SQL.cmpA_arptrm.m_SetOrder("termsid1")
        ELSE
          go_SQL.cmpA_arptrm.m_SetOrder("ptdesc")
        ENDIF

      ENDIF && NOT EOF()

      *-- Set report scope
      lc_cond = []

      *-- Set report title
      lc_title = "Customer Payment Terms"

      *-- Instantiate a Terms API object
      lo_TermsAPI = NEWOBJECT("sbtCmpApiTerms", "sbtapi")
      lo_TermsAPI.sc_TermsTblAlias = "a_arptrmLookup"
      lo_TermsAPI.sc_TermsTblName  = "arptrm"
      lo_TermsAPI.sc_TermsType     = "C"

      *-- Select terms file
      go_SQL.m_TableChangeCurrent("a_arptrm")

      *-- Set report form name
      *# DOCCODE REPORT FORM ****
      lc_frx = gc_idrvprg + "syptrm"

      *-- Set report scope
      lc_cond = []
*\ [End] PTR 76407 07/06/04 DAND Customer payment terms listing

  ENDCASE

  *-- close data tables opened here
  IF go_SQL.m_IsUsed("a_icserl") AND ln_icserlf = Cn_OpenHere
    go_SQL.cmpA_Icserl.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep2
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP3
*------------------------------------------------------------------------------
*- Description: Report - Procedure 3 of 4
*------------------------------------------------------------------------------
*- Synopsis...: Reports "M" = Operations Report
*------------------------------------------------------------------------------
*- Calls......: G_DSPST
*------------------------------------------------------------------------------
*- Passed:
*- Variables..:      lc_rept   = single character report identifier
*-                   LEFT(lc_file,1)     = file to get records from:
*-                               "C" for current period file
*-                               "H" for history file
*-                               "B" for both files
*-                   lc_bdate    = beginning date
*-                   lc_edate    = ending date
*-                   lc_order    = "D" to order report by item number
*-                               "I" to order report by date
*-                   TRIM(lc_item)     = item number or portion to match
*-                   lc_class    = inventory class or portion to match
*-                   lc_code     = customer/inventory code or portion
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep3

  LOCAL lc_SQLalias, ;
        ln_times
  lc_SQLalias = ""
  ln_times = 0

  *-- Convert variables to dates
  ld_bdate  = g_retdt(lc_bdate)
  ld_edate  = g_retdt(lc_edate)

  *-- Display processing message
  DO g_dspst WITH "Locating Selected Transactions...", .t., gn_msgline, ;
                  "", "", ""

  IF LEFT(lc_file,1) <> "H"
    *-- Open current period transaction files
    *-- SO transaction file
    = g_opnfl(gf_sotranf, "a_sotran", .f., .f.)
    *-- IC transaction file
    = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)
  ENDIF

  IF LEFT(lc_file,1) <> "C"
    *-- Open history transaction files
    *-- SO transaction file
    = g_opnfl(gf_soytrnf, "a_soytrn", .f., .f.)
    *-- IC transaction file
    = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)
  ENDIF

  *-- Initialize filters for SO and IC files
  lc_sofilt = ""
  lc_icfilt = ""

  *-- Setup master selection field
  lc_sosel = IIF(lc_order = "I", "item", "ordate")
  lc_icsel = IIF(lc_order = "I", "item", "tdate")

  *-- Setup Name for key field and order by clause
  lc_keynam = IIF(lc_order = "I", "keyitm", "keydate")

  IF NOT EMPTY(lc_class+lc_code)
    *-- Set join filter
    lc_sofilt = "a_sotran->item = a_icitem->item AND "
    lc_icfilt = "a_ictran->item = a_icitem->item AND "
  ENDIF

  *-- Set date range conditions
  IF NOT EMPTY(ld_bdate)
    lc_sofilt = lc_sofilt + "ordate >= ??ld_bdate AND "
    lc_icfilt = lc_icfilt + "tdate >= ??ld_bdate AND "
  ENDIF

  IF NOT EMPTY(ld_edate)
    lc_sofilt = lc_sofilt + "ordate <= ??ld_edate AND "
    lc_icfilt = lc_icfilt + "tdate <= ??ld_edate AND "
  ENDIF

  *-- Set item condition
  IF NOT EMPTY(lc_item)
    lc_sofilt = lc_sofilt + "a_icitem->item %=% TRIM(??lc_item) + '%/%' AND "
    lc_icfilt = lc_icfilt + "a_icitem->item %=% TRIM(??lc_item) + '%/%' AND "
  ENDIF

  *-- Set class condition
  IF NOT EMPTY(lc_class)
    lc_sofilt = lc_sofilt + "a_icitem->itmclss %=% TRIM(??lc_class) + '%/%' AND "
    lc_icfilt = lc_icfilt + "a_icitem->itmclss %=% TRIM(??lc_class) + '%/%' AND "
  ENDIF

  *-- Set miscellaneous code condition
  IF NOT EMPTY(lc_code)
    lc_sofilt = lc_sofilt + "a_icitem->code %=% TRIM(??lc_code) + '%/%' AND "
    lc_icfilt = lc_icfilt + "a_icitem->code %=% TRIM(??lc_code) + '%/%' AND "
  ENDIF

  *-- Exclude deleted records
  lc_sofilt = lc_sofilt + " NOT (sostat $ 'VX') "
  lc_icfilt = lc_icfilt + " NOT 1=0 "

  *-- If selecting for current and history
  lc_curfilt = IIF(LEFT(lc_file,1) <> "H", " AND currhist <> 'X'", "")

  IF LEFT(lc_file,1) <> "H"
    *-- Gather data for current files

    *-- Added tqtyord,tqtyshp,tbprice
    *-- Added tprice
    *-- Added tcost
    *-- Gather data for SO transaction file, group by select criteria
    *-- Don't calculate price for shipping charges that have been shipped
    *-- Price for shipping charges that have been shipped is gathered below
    *-- from ICTRAN
    go_SQL.m_SQLSelect(" a_sotran->" + lc_sosel + " AS " + lc_keynam + ;
                       ", a_sotran->item,   " + ;
                       " SUM(.01 * INT((tqtyord+0+tqtyshp) * " + ;
                            " IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_sotran->item = '" + gc_shiptyp + "' AND a_sotran->tqtyshp <> 0, 0, a_sotran->tbprice)* " + ;
                            " (100-disc) +0+ IIF(tqtyord+0+tqtyshp * IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_sotran->item = '" + gc_shiptyp + "'AND a_sotran->tqtyshp <> 0, 0, a_sotran->tbprice) < 0, -.5, .5))) AS price, " + ;
                       " SUM(.01 * INT((tqtyord+0+tqtyshp) * IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_sotran->item = '" + gc_shiptyp + "' AND a_sotran->tqtyshp <> 0, 0, a_sotran->tbprice) * " + ;
                            " (100-disc) +0+ IIF(tqtyord+0+tqtyshp * IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_sotran->item = '" + gc_shiptyp + "' AND a_sotran->tqtyshp <> 0, 0, a_sotran->tbprice) < 0, -.5, .5))) AS tprice, " + ;
                       " SUM(qtyord+0+qtyshp) AS qtyord, " + ;
                       " SUM(tqtyord+0+tqtyshp) AS tqtyord, " + ;
                       " ABS(qtyshp)-ABS(qtyshp) AS qtyshp, " + ;
                       " ABS(tqtyshp)-ABS(tqtyshp) AS tqtyshp, " + ;
                       " ABS(a_sotran->tbprice)-ABS(a_sotran->tbprice) AS cost, " + ;
                       " ABS(a_sotran->tbprice)-ABS(a_sotran->tbprice) AS tcost, " + ;
                       " a_icitem->stkumid, a_sotran->umeasur, a_sotran->umfact " + ;
                       " FROM " + ;
                       gf_sotranf + " AS a_sotran, "+ ;
                       gf_icitemf + " AS a_icitem " + ;
                       " WHERE a_sotran->item = a_icitem->item AND a_sotran->sotype <> 'B' AND " + ;
                               lc_sofilt + lc_curfilt + ;
                       " GROUP BY a_sotran->" + lc_sosel, ;
                       "SQL TABLE", go_SQL.m_getTempTableName(1))

    *-- Close file and reopen with alias
    go_SQL.so_CurrentAlias.m_CloseTable()
    = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

    IF NOT EMPTY(gc_shiptyp)
      *-- Added trprice,tqtyord,tqtyshp
      *-- Added tcost
      *-- Gather shipping charge data
      go_SQL.m_SQLSelect("a_ictran->" + ;
                         lc_icsel + " AS " + lc_keynam + ;
                         ", a_ictran->item, "+ ;
                         " SUM(.01 * INT((-sqty) * a_ictran->price * (100-disc) +0+ IIF(-sqty * a_ictran->price < 0, -.5, .5))) AS price, " + ;
                         " SUM(.01 * INT((-tqty) * a_ictran->trprice * (100-disc) +0+ IIF(-tqty * a_ictran->trprice < 0, -.5, .5))) AS tprice, " + ;
                         " ABS(sqty)-ABS(sqty) AS qtyord, " + ;
                         " ABS(tqty)-ABS(tqty) AS tqtyord, " + ;
                         " SUM(-sqty) AS qtyshp, " + ;
                         " SUM(-tqty) AS tqtyshp, " + ;
                         " ABS(a_ictran->price)-ABS(a_ictran->price) AS cost, " + ;
                         " ABS(a_ictran->trprice)-ABS(a_ictran->trprice) AS tcost, " + ;
                         " a_ictran->umeasur, a_icitem->stkumid, a_ictran->umfact " + ;
                         " FROM " + ;
                         gf_ictranf + " AS a_ictran, " + ;
                         gf_icitemf + " AS a_icitem " + ;
                         " WHERE a_ictran->item = a_icitem->item AND " + ;
                                 " a_ictran->applid = 'SO' AND LEFT(a_ictran->trantyp, 1) <> 'E' AND " + ;
                                 lc_icfilt + " AND a_ictran->item = '" + gc_shiptyp + "' GROUP BY a_ictran->" + ;
                                 lc_icsel, ;
                         "SQL TABLE", go_SQL.m_getTempTableName(2))

      *-- Close file so that it can be appended
      go_SQL.so_CurrentAlias.m_CloseTable()

      *-- Combine the selected records
      go_SQL.m_TableChangeCurrent("a_tmpf1")
      go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
      go_SQL.m_DropTable(go_SQL.m_getTempTableName(2), "", "")
    ENDIF && NOT EMPTY(gc_shiptyp)

    *-- Added tqtyshp
    *-- Added tcost
    *-- Gather data for IC transaction file, group by select criteria
    go_SQL.m_SQLSelect(" a_ictran->" + lc_icsel + " AS " + lc_keynam + ;
                       ", a_ictran->item, SUM(-sqty) AS qtyshp, " + ;
                       " SUM(-tqty) AS tqtyshp, " + ;
                       " SUM(.01 * INT((-sqty) * a_ictran->price * (100-disc) +0+ IIF(-sqty * a_ictran->price < 0, -.5, .5))) AS cost, " + ;
                       " SUM(.01 * INT((-tqty) * a_ictran->trprice * (100-disc) +0+ IIF(-tqty * a_ictran->trprice < 0, -.5, .5))) AS tcost, " + ;
                       " a_icitem->stkumid, a_ictran->umeasur, a_ictran->umfact " + ;
                       " FROM " + ;
                       gf_ictranf + " AS a_ictran, " + ;
                       gf_icitemf + " AS a_icitem " + ;
                       " WHERE a_ictran->item = a_icitem->item AND " + ;
                             " a_ictran->applid = 'SO' AND  " + ;
                             " LEFT(a_ictran->trantyp, 1) <> 'E'  " + ;
                             " AND " + lc_icfilt + ;
                       " GROUP BY a_ictran->" + lc_icsel, ;
                       "SQL TABLE", go_SQL.m_getTempTableName(2))

    *-- Close file so that it can be appended
    go_SQL.so_CurrentAlias.m_CloseTable()

    *-- Combine the selected records
    go_SQL.m_TableChangeCurrent("a_tmpf1")
    go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")

    *-- Setup master report file alias
    lc_alias = "a_tmpf1"
  ENDIF

  IF LEFT(lc_file,1) <> "C"
    *-- Gather data from history files

    *-- Replace reference to current files in filter string
    lc_sofilt = STRTRAN(lc_sofilt, "a_sotran", "a_soytrn")
    lc_icfilt = STRTRAN(lc_icfilt, "a_ictran", "a_icytrn")

    *-- Added tqtyord,tqtyshp,tbprice
    *-- Added tcost,tprice
    *-- Gather data for SO history transaction file, group by select criteria
    *-- Don't calculate price for shipping charges that have been shipped
    *-- Price for shipping charges that have been shipped is gathered below
    *-- from ICYTRN
    go_SQL.m_SQLSelect(" a_soytrn->" + lc_sosel + " AS " + lc_keynam + ;
                       ", a_soytrn->item, "+ ;
                       " SUM(.01 * INT((tqtyord+0+tqtyshp) *  "+ ;
                            " IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_soytrn->item = '" + gc_shiptyp + "' AND a_soytrn->tqtyshp <> 0, 0, a_soytrn->tbprice) *  "+ ;
                            " (100-disc) +0+ IIF(tqtyord+0+tqtyshp * IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_soytrn->item = '" + gc_shiptyp + "' AND a_soytrn->tqtyshp <> 0, 0, a_soytrn->tbprice) < 0, -.5, .5))) AS price,  "+ ;
                       " SUM(.01 * INT((tqtyord+0+tqtyshp) *  "+ ;
                            " IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_soytrn->item = '" + gc_shiptyp + "' AND a_soytrn->tqtyshp <> 0, 0, a_soytrn->tbprice) * (100-disc) +0+  "+ ;
                            " IIF(tqtyord+0+tqtyshp * IIF(" + IIF(NOT EMPTY(gc_shiptyp), ".t. = .t.", ".t. = .f.") + " AND a_soytrn->item = '" + gc_shiptyp + "' AND a_soytrn->tqtyshp <> 0, 0, a_soytrn->tbprice) < 0, -.5, .5))) AS tprice,  "+ ;
                       " SUM(qtyord+0+qtyshp) AS qtyord,  "+ ;
                       " SUM(tqtyord+0+tqtyshp) AS tqtyord,  "+ ;
                       " ABS(qtyshp)-ABS(qtyshp) AS qtyshp,  "+ ;
                       " ABS(tqtyshp)-ABS(tqtyshp) AS tqtyshp,  "+ ;
                       " ABS(a_soytrn->tbprice)-ABS(a_soytrn->tbprice) AS cost,  "+ ;
                       " ABS(a_soytrn->tbprice)-ABS(a_soytrn->tbprice) AS tcost,  "+ ;
                       " a_icitem->stkumid,a_soytrn->umeasur,a_soytrn->umfact  "+ ;
                       " FROM " + ;
                       gf_soytrnf + " AS a_soytrn, " + ;
                       gf_icitemf + " AS a_icitem " + ;
                       " WHERE a_soytrn->item = a_icitem->item AND  "+ ;
                            " a_soytrn->sotype <> 'B' AND " + ;
                            lc_sofilt + lc_curfilt + ;
                       " GROUP BY a_soytrn->" + lc_sosel, ;
                       "SQL TABLE", go_SQL.m_getTempTableName(3))

    *-- Close file so that it can be appended or reopened with alias
    go_SQL.so_CurrentAlias.m_CloseTable()

    IF LEFT(lc_file,1) = "H"
      *-- Report from history only, so tmpf3 become the master file
        = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)
    ENDIF

    IF NOT EMPTY(gc_shiptyp)

      *-- Added tprice
      *-- Added tcost,tqtyord,tqtyshp
      *-- Gather shipping charge data
      go_SQL.m_SQLSelect(" a_icytrn->" + lc_icsel + " AS " + lc_keynam + ;
                         ", a_icytrn->item,  " + ;
                         " SUM(.01 * INT((-sqty) * a_icytrn->price * (100-disc) +0+   " + ;
                              " IIF(-sqty * a_icytrn->price < 0, -.5, .5))) AS price, SUM(.01 * INT((-tqty) * a_icytrn->trprice * (100-disc) +0+   " + ;
                              " IIF(-tqty * a_icytrn->trprice < 0, -.5, .5))) AS tprice, ABS(sqty)-ABS(sqty) AS qtyord, ABS(tqty)-ABS(tqty) AS tqtyord,   " + ;
                         " SUM(-sqty) AS qtyshp,   " + ;
                         " SUM(-tqty) AS tqtyshp,   " + ;
                         " ABS(a_icytrn->price)-ABS(a_icytrn->price) AS cost,   " + ;
                         " ABS(a_icytrn->trprice)-ABS(a_icytrn->trprice) AS tcost,   " + ;
                         " a_icitem->stkumid,a_icytrn->umeasur,a_icytrn->umfact   " + ;
                         " FROM " + ;
                         gf_icytrnf + " AS a_icytrn, " + ;
                         gf_icitemf + " AS a_icitem " + ;
                         " WHERE a_icytrn->item = a_icitem->item AND   " + ;
                               " a_icytrn->applid = 'SO' AND LEFT(a_icytrn->trantyp, 1) <> 'E' AND " + ;
                                 lc_icfilt + " AND a_icytrn->item = '" + gc_shiptyp + "' " +  ;
                         " GROUP BY a_icytrn->" + lc_icsel, ;
                         "SQL TABLE", go_SQL.m_getTempTableName(4))

      *-- Close file so that it can be appended
      go_SQL.so_CurrentAlias.m_CloseTable()

      *-- Combine the selected records
      IF LEFT(lc_file,1) = "B"
        go_SQL.m_TableChangeCurrent("a_tmpf1")
        go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(4), "")
      ELSE
        go_SQL.m_TableChangeCurrent("a_tmpf3")
        go_SQL.cmpA_tmpf3.m_SQLAppendFrom(go_SQL.m_getTempTableName(4), "")
      ENDIF

    ENDIF && NOT EMPTY(gc_shiptyp)

    *-- Added tcost,tqtyshp
    *-- Gather data for IC history transaction file, group by select criteria
    go_SQL.m_SQLSelect("a_icytrn->" + lc_icsel + " AS " + lc_keynam + ;
                       ", a_icytrn->item, SUM(-sqty) AS qtyshp, SUM(-tqty) AS tqtyshp,   " + ;
                       " SUM(.01 * INT(-sqty * a_icytrn->price * (100-disc) +0+   " + ;
                           " IIF(-sqty * a_icytrn->price < 0, -.5, .5))) AS cost, SUM(.01 * INT(-tqty * a_icytrn->trprice * (100-disc) +0+   " + ;
                           " IIF(-tqty * a_icytrn->trprice < 0, -.5, .5))) AS tcost,   " + ;
                       " a_icitem->stkumid,a_icytrn->umeasur,a_icytrn->umfact   " + ;
                       " FROM " + ;
                       gf_icytrnf + " AS a_icytrn, " + ;
                       gf_icitemf + " AS a_icitem " + ;
                       " WHERE a_icytrn->item = a_icitem->item AND   " + ;
                             " a_icytrn->applid = 'SO' AND LEFT(a_icytrn->trantyp, 1) <> 'E' AND " + ;
                               lc_icfilt + ;
                       " GROUP BY a_icytrn->" + lc_icsel, ;
                       "SQL TABLE", go_SQL.m_getTempTableName(4))

    *-- Close file so that it can be appended
    go_SQL.so_CurrentAlias.m_CloseTable()

    IF LEFT(lc_file,1) = "B"
      go_SQL.m_TableChangeCurrent("a_tmpf1")
      go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(3), "")
      go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(4), "")
    ELSE
      go_SQL.m_TableChangeCurrent("a_tmpf3")
      go_SQL.cmpA_tmpf3.m_SQLAppendFrom(go_SQL.m_getTempTableName(4), "")

      *-- Setup master report file alias
      lc_alias = "a_tmpf3"
    ENDIF

  ENDIF


  *-- Added tqtyord,tqtyshp
  *-- Added tcost,tprice
  *-- Group all selected records into one cursor workarea

  FOR ln_times = 1 TO GETWORDCOUNT(lc_alias, ",")
    lc_SQLalias = "go_SQL.cmp" + GETWORDNUM(lc_alias, ln_times, ",") + ".sc_TableNameFull"
  NEXT

  go_SQL.m_SQLSelect(lc_keynam + ", item, " + ;
                   " SUM(cost) AS cost, " + ;
                   " SUM(tcost) AS tcost, " + ;
                   " SUM(qtyord) AS qtyord, " + ;
                   " SUM(tqtyord) AS tqtyord, " + ;
                   " SUM(price)   AS price, " + ;
                   " SUM(tprice)  AS tprice, " + ;
                   " SUM(qtyshp)  AS qtyshp, " + ;
                   " SUM(tqtyshp) AS tqtyshp, " + ;
                   " stkumid, umeasur, umfact " + ;
                   " FROM " + ;
                   &lc_SQLalias. + ;
                   " GROUP BY " + lc_keynam, ;
                   "SQL TABLE", go_SQL.m_getTempTableName(5))

  *-- Open Temporary report file
  go_SQL.so_CurrentAlias.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(5), "a_tmpf5", .t., .f.)

  *-- Find first matching record
  go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

  IF go_SQL.so_CurrentAlias.m_IsEof()
    *-- Set continuation flag
    ll_cont = .f.
  ELSE
    go_SQL.so_CurrentAlias.m_ReplaceBulk("umfact WITH 1", "F", "umfact = 0", .t.)
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

    *-- Set relation into inventory file
    go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
  ENDIF

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
  *-- Set report title and report form name
  IF lc_order = "D"
    lc_title = "Daily and Cumulative Operations by Date"
    *# DOCCODE REPORT FORM soopsd
    lc_frx = gc_adrvprg + "soopsd"
  ELSE
    lc_title = "Daily and Cumulative Operations by Item"
    *# DOCCODE REPORT FORM soopsi
    lc_frx = gc_adrvprg + "soopsi"
  ENDIF
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep3
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP4
*------------------------------------------------------------------------------
*- Description: Reports - Procedure 4 of 4
*------------------------------------------------------------------------------
*- Synopsis...: Reports "I" = Sales Tax By Tax Code (VAT)
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_CLRTX, G_LINCLC
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: LEFT(lc_file,1)     = file to get records from:
*-                          "C" for current period file
*-                          "H" for history file
*-                          "B" for both files
*-              lc_bdate    = beginning date
*-              lc_edate    = ending date
*-              lc_order    = "C" to order report by customer
*-                          "I" to order report by item
*-              lc_detail   = level of detail
*-                          "S" for summary report
*-                          "D" for detail report
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep4

  *-- Convert variables to dates
  ld_bdate  = g_retdt(lc_bdate)
  ld_edate  = g_retdt(lc_edate)

  PRIVATE lc_tax

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

  *-- Initialize table of taxcodes and summaries in arrays
  DO g_clrtx WITH 0

  *-- Open VAT file
  ln_opnvat = g_opnfl(gc_idrvdbf + "sycvatt", "a_sycvat", .f., .f.)

  *-- Set tag order
  go_SQL.cmpA_Sycvat.m_SetOrder("compid")

  *-- Set filter
  go_SQL.so_CurrentAlias.m_SetFilter("NOT EMPTY(compid)")

  *-- Find record for company
  go_SQL.so_CurrentAlias.m_Seek(gc_compid, "")

  *-- Open Order Entry Transaction File
  = g_opnfl(gf_sotranf, "a_sotran", .f., .f., "sono1")

  *-- Set date range conditions
  IF NOT EMPTY(ld_bdate)
    lc_filt = [ordate >= ??ld_bdate AND ]
  ENDIF

  IF NOT EMPTY(ld_edate)
    lc_filt = lc_filt + [ordate <= ??ld_edate AND ]
  ENDIF

  *-- Set other conditions
  IF NOT EMPTY(lc_taxcode)
    lc_filt = lc_filt + "taxcode %=% TRIM(??lc_taxcode) + '%/%'  AND "
  ENDIF

  *-- Set shipment condition
  lc_filt = lc_filt + [qtyshp <> 0 AND ]

  *-- Set to ignore deleted records
  lc_filt = lc_filt + [ NOT DELETED() ]

  *-- Setup current filter
  lc_curfilt = IIF(LEFT(lc_file,1) = "B", " AND a_sotran->currhist <> 'X'", "")

  IF LEFT(lc_file,1) <> "H"
    *-- Added tprice,tqtyshp
    go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), ;
                     " FIELDS a_sotran->taxcode, a_sotran->taxrate, a_sotran->qtyshp, a_sotran->tqtyshp, "+ ;
                     " a_sotran->item, a_sotran->custno, a_sotran->price, a_sotran->tprice, a_sotran->disc " + ;
                     " FOR " + lc_filt + " " + lc_curfilt)
  ENDIF

  IF LEFT(lc_file,1) $ "BH"
    *-- Open YTD Transaction file
    = g_opnfl(gf_soytrnf, "a_soytrn", .f., .f., "sono1")

    IF LEFT(lc_file,1) = "B"
      *-- Added tprice,tqtyshp
      go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(3), ;
                                     " FIELDS a_soytrn->taxcode, a_soytrn->taxrate, a_soytrn->qtyshp, a_soytrn->tqtyshp, " + ;
                                     " a_soytrn->item, a_soytrn->custno, a_soytrn->price, a_soytrn->tprice, a_soytrn->disc " + ;
                                     " FOR " + lc_filt)

      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

      go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(3), "")

      go_SQL.m_DropTable(go_SQL.m_getTempTableName(3) + gc_extdbf, "", "")
    ELSE
      *-- Added tprice,tqtyshp
      go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), ;
                                    " FIELDS a_soytrn->taxcode, a_soytrn->taxrate, a_soytrn->qtyshp, a_soytrn->tqtyshp, " +  ;
                                    " a_soytrn->item, a_soytrn->custno, a_soytrn->price, a_soytrn->tprice, a_soytrn->disc " + ;
                                    " FOR " + lc_filt)
    ENDIF

  ENDIF

*\ [1 Line] PTR #74741 05/07/04 TISJ Fix for expansion of customer, vendor, item and state
*\                                   in reports
*marker
  *-- Added tprice
  *-- Create Temporary Report file
  go_SQL.m_createTable(go_SQL.m_getTempTableName(2), ;
                     " FREE (taxcode C(6), taxrate N(5,2), taxdesc C(10), item C(" + TRIM(STR(LEN(gc_ItemPic))) + "), "+ ;
                     " custno C(" + TRIM(STR(LEN(gc_CVNoPic))) + "), price N(12,2), tprice N(12,2), taxamt N(12,2))")

  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- Open Temporary Report file
  = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)

  *-- Create temporary index
  DO CASE
    CASE lc_detail = "S"
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode", "", .t., .f.)

    CASE lc_order = "C"
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode + custno", "", .t., .f.)

    OTHERWISE
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode + item + custno", "", .t., .f.)
  ENDCASE

  *-- Open Temporary transaction file
  = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

  *-- Create temporary index
  DO CASE
    CASE lc_detail = "S"
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode", "", .t., .f.)

    CASE lc_order = "C"
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode + custno", "", .t., .f.)

    OTHERWISE
      go_SQL.so_CurrentAlias.m_CreateIndex("taxcode", "taxcode + item + custno", "", .t., .f.)
  ENDCASE

  SET EXACT ON

  go_SQL.CmpA_tmpf1.m_ScanBegin("F", "")
  DO WHILE go_SQL.CmpA_tmpf1.m_ScanBulk()
    go_SQL.m_TableChangeCurrent("a_tmpf2")

    DO CASE
      CASE lc_detail = "S"
        go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->taxcode, "")

      CASE lc_order = "C"
        go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->taxcode + a_tmpf1->custno, "")

      OTHERWISE
        go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->taxcode + a_tmpf1->item + a_tmpf1->custno, "")
    ENDCASE

    IF NOT go_SQL.so_CurrentAlias.m_IsFound()
      lc_txcode = a_tmpf1->taxcode
      go_SQL.cmpA_Tmpf2.m_SQLInsert(" taxcode, custno, item, taxrate, taxdesc", + ;
                                    " a_tmpf1->taxcode, a_tmpf1->custno, a_tmpf1->item, " + ;
                                    " IIF(EMPTY(a_tmpf1->taxcode), 0.000, ga_taxrate[ASC(a_tmpf1->taxcode) - 64]), " + ;
                                    " IIF(EMPTY(lc_txcode), '', a_sycvat->descr&lc_txcode.)", "")
    ENDIF

    *-- Calculate extprice using tprice,tqtyshp
    iextprice = g_extnd(2, a_tmpf1->tqtyshp, a_tmpf1->tprice, a_tmpf1->disc)
    go_SQL.so_CurrentAlias.m_Replace("price", price + iextprice)
    *-- Added tprice
    go_SQL.so_CurrentAlias.m_Replace("tprice", tprice + iextprice)
  ENDDO
  go_SQL.so_CurrentAlias.m_ScanEnd()

  SET EXACT OFF

  *-- Close Temporary transaction file
  go_SQL.cmpA_Tmpf1.m_CloseTable()

  *-- Select Temporary Report file
  go_SQL.m_TableChangeCurrent("a_tmpf2")

  *-- Find first matching record
  go_SQL.CmpA_tmpf2.m_MoveRecord(Cn_TopRec)

  IF NOT go_SQL.CmpA_tmpf2.m_IsEof()

    go_SQL.CmpA_tmpf2.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_tmpf2.m_ScanBulk()
      lc_tax    = 0
      minvamt = 0
      *-- Calculate tax using tprice
      DO g_linclc WITH "A", 0, lc_tax, minvamt, a_tmpf2->tprice, ;
                       a_tmpf2->taxcode
      go_SQL.so_CurrentAlias.m_Replace("taxamt", lc_tax)
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
  ENDIF

  *-- Set report form name
  DO CASE
    CASE lc_detail = "S"
      *# DOCCODE REPORT FORM syvat1
      lc_frx = gc_idrvprg + "syvat1"

    CASE lc_order = "C"
      *# DOCCODE REPORT FORM syvat2
      lc_frx = gc_idrvprg + "syvat2"

    OTHERWISE
      *# DOCCODE REPORT FORM syvat3
      lc_frx = gc_idrvprg + "syvat3"
  ENDCASE

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep4
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP6
*------------------------------------------------------------------------------
*- Description: Reports - Procedure 6 of 6
*------------------------------------------------------------------------------
*- Synopsis...: Reports "S" = Drop Ship Report
*------------------------------------------------------------------------------
*- Calls......: G_DSPST
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: LEFT(lc_file,1)     = file to get records from:
*-                            "C" for current period file
*-                            "H" for history file
*-                            "B" for both files
*-              lc_bdate    = beginning date
*-              lc_edate    = ending date
*-              lc_order    = "S" to order report by Order #
*-                            "P" to order report by Order #
*-                            "V" to order report by Vendor #
*-                            "C" to order report by Cust #
*-                            "R" to order report by Req date
*-                            "P" to order
*-              lc_detail   = level of detail
*-                            "S" for summary report
*-                            "D" for detail report
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep6

  PRIVATE ll_eofpo, ;
          ll_from, ;
          ln_qtyint, ;
          ln_qtydec, ;
          lc_qtypct

  lc_filt = ""

  ln_qtydec = VAL(d_retfd("POTRAN  ", "QTYREC", 7))
  ln_qtyint = VAL(d_retfd("POTRAN  ", "QTYREC", 6)) - ln_qtydec - 1

  *-- Picture clause for the field qtyrec to be used with field list and in the
  *-- SQL select
  lc_qtypct = REPLICATE("0", ln_qtyint) + "." + REPLICATE("0", ln_qtydec)

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

  *-- Open SODROP file
  = g_opnfl(gf_sodropf, "a_sodrop", .f., .f., "sono1")

  go_SQL.so_CurrentAlias.m_SetFilter("status <> 'V'")

  *-- Open Purchase Order Transaction File
  = g_opnfl(gf_potranf, "a_potran", .f., .f., "")

  go_SQL.so_CurrentAlias.m_SetFilter("postat <> 'V'")

  *-- Initialize logical variable which indicates if POTRAN file is empty
  ll_eofpo = go_SQL.cmpA_Potran.m_Reccount() <= 0

  *-- Open Inventory Master File
  = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")

  *-- Open Order Entry Transaction File
  = g_opnfl(gf_sotranf, "a_sotran", .f., .f., "sono1")

  go_SQL.so_CurrentAlias.m_SetFilter("sostat <> 'V'")

  *--Set Customer Range Condition
  IF NOT EMPTY(lc_bcust)
    lc_filt = lc_filt + " ALLTRIM(custno) >= ALLTRIM(??lc_bcust) "
  ENDIF

  IF NOT EMPTY(lc_ecust)
    lc_filt = lc_filt + " AND ALLTRIM(custno) <= ??(ALLTRIM(lc_ecust) + CHR(255)) "
  ENDIF

  ld_fbdate = g_retdt(lc_bdate)
  ld_fedate = g_retdt(lc_edate)

  *-- Set date range conditions
  IF NOT EMPTY(ld_fbdate)
    lc_filt = lc_filt + [ AND rqdate >= ??ld_fbdate ]
  ENDIF

  IF NOT EMPTY(ld_fedate)
    lc_filt = lc_filt + [ AND rqdate <= ??ld_fedate ]
  ENDIF

  IF NOT EMPTY(lc_bsono)
    lc_filt = lc_filt + " AND ALLTRIM(sono) >= '" + ALLTRIM(lc_bsono) + "' "
  ENDIF

  IF NOT EMPTY(lc_esono)
    lc_filt = lc_filt + " AND ALLTRIM(sono) <= '" + ALLTRIM(lc_esono) + CHR(255) + "' "
  ENDIF

  IF NOT EMPTY(lc_supp)
    lc_filt = lc_filt + " AND ALLTRIM(vendno) %=% TRIM(??lc_supp) + '%/%' "
  ENDIF

  IF NOT EMPTY(lc_class)
    lc_filt = lc_filt + " AND ALLTRIM(itmclss) %=% TRIM(??lc_class) + '%/%' "
  ENDIF

  lc_title = "Drop Shipment Status"
  *# DOCCODE REPORT FORM sodrop
  lc_frx = gc_adrvprg + "sodrop"

  IF LEFT(lc_file,1) $ "BH"
    *-- Open YTD Transaction file
    *-- Open SODROP file
    = g_opnfl(gf_soydrpf , "a_soydrp", .f., .f.)

    *-- Open SOYTRN file
    = g_opnfl(gf_soytrnf, "a_soytrn", .f., .f.)

    *-- Open POYTRN file
    = g_opnfl(gf_poytrnf, "a_poytrn", .f., .f.)
  ENDIF

  IF LEFT(lc_include,1) = "T" OR (ll_eofpo AND LEFT(lc_include,1) = "A")
    lc_var = " a->sostat <> 'V' AND ;
             c->status <> 'V' AND "

      lc_from = gf_sotranf + " AS a, " + ;
                gf_sodropf + " AS c, " + ;
                gf_icitemf + " AS d "

    *-- Added tqtyord,tqtyshp
    *-- Build field list, note purno, vendno, and qtyrec are phantom
    *-- fiels for the report form
    lc_fldlst = " a->sono, a->tranlineno, a->custno, d->itmclss, " + ;
                " a->qtyord, a->rqdate, a->ordate, " + ;
                " a->tqtyord, a->tqtyshp, " + ;
                " a->qtyshp, a->item, c->status, " + ;
                "'" + SPACE(LEN(a_potran.purno)) + "' AS purno, '" + SPACE(LEN(a_potran.vendno)) + "' AS vendno, "  + lc_qtypct + " AS qtyrec"
  ELSE
    lc_var = " a->sostat <> 'V' AND ;
             b->postat <> 'V' AND c->status <> 'V' AND "

    lc_from = gf_sotranf + " AS a, " + ;
              gf_potranf + " AS b, " + ;
              gf_sodropf + " AS c, " + ;
              gf_icitemf + " AS d "

    *-- Added tqtyord,tqtyshp
    lc_fldlst = " a->sono, a->tranlineno, a->custno, d->itmclss, " + ;
                " a->qtyord, a->rqdate, a->ordate, " + ;
                " a->tqtyord, a->tqtyshp, " + ;
                " a->qtyshp, a->item, " + ;
                " IIF(b->purno ='" + SPACE(LEN(a_potran.purno)) + "' , '" + SPACE(LEN(a_potran.purno)) + "', b->purno) AS purno, " + ;
                " IIF(b->purno ='" + SPACE(LEN(a_potran.purno)) + "' , '"  + SPACE(LEN(a_potran.vendno)) + "', b->vendno) AS vendno, " + ;
                " IIF(b->purno ='" + SPACE(LEN(a_potran.purno)) + "' ,  " + lc_qtypct + ", b->qtyrec) AS qtyrec, " + ;
                " c->status"
  ENDIF

  DO CASE
    CASE LEFT(lc_include,1) = "T"
      lc_var = lc_var + " EMPTY(c->purno) AND EMPTY(c->status)"

    CASE LEFT(lc_include,1) = "U"
      lc_var = lc_var + " NOT EMPTY(c->purno) AND EMPTY(c->status)"

    CASE LEFT(lc_include,1) = "P"
      lc_var = lc_var + " c->status = 'O'"

    CASE LEFT(lc_include,1) = "R"
      lc_var = lc_var + " NOT EMPTY(c->status)"

    CASE LEFT(lc_include,1) = "C"
      lc_var = lc_var + " c->status = 'S'"

    OTHERWISE
      lc_var = lc_var + " 1=1 "
  ENDCASE

  *-- Setup ORDER BY list
  DO CASE
    CASE lc_order = "O"
      *-- Set order clause for Select
      lc_ordby = [ORDER BY 1]

    CASE lc_order = "P"
      *-- Set order clause for Select
      lc_ordby = [ORDER BY 12]

    CASE lc_order = "V"
      *-- Set order clause for Select
      lc_ordby = [ORDER BY 13]

    CASE lc_order = "C"
      *-- Set order clause for Select
      lc_ordby = [ORDER BY 3]

    CASE lc_order = "R"
      *-- Set order clause for Select
      lc_ordby = [ORDER BY 6]
  ENDCASE

  IF LEFT(lc_file,1) $ "CB"

    DO CASE
      CASE LEFT(lc_include,1) = "T" OR (ll_eofpo AND LEFT(lc_include,1) = "A")
        go_SQL.m_SQLSelect(" DISTINCT " + lc_fldlst + ;
                           " FROM " + lc_from + ;
                           " WHERE " + lc_var + " AND a->item = d->item " + ;
                                     " AND (ALLTRIM(a->sono) + ALLTRIM(STR(a->tranlineno)) == ALLTRIM(c->sono) + ALLTRIM(STR(c->soline))) " + ;
                           lc_ordby, ;
                           "TABLE", go_SQL.m_getTempTableName(2, "F"))

      OTHERWISE
        *-- Added tqtyord,tqtyshp
        *-- Changed UNION into the where clause because they are being picked from same file
        *-- Important Note: meaning of UNION is not equal to those of logic 'AND' or 'OR' in SQL.
        *-- UNION is like 'plus', 'OR' is like 'multiply', while 'AND' is like 'substract'
        IF go_Sql.sc_SqlTypeMain = "F" 
          go_SQL.m_SQLSelect(lc_fldlst + " FROM " + lc_from + " WHERE " + lc_var + " AND " + ;
                "b->purno+STR(b->tranlineno,4) = c->purno+STR(c->poline,4) AND " + ;
                "a->item = d->item AND a->sono+STR(a->tranlineno,4) = c->sono+STR(c->soline,4) " + ;
                " UNION SELECT " + ;
                "a->sono, a->tranlineno, a->custno, d->itmclss, a->qtyord, a->rqdate, a->ordate, " + ;
                "a->tqtyord, a->tqtyshp, a->qtyshp, a->item, '" +  SPACE(LEN(a_potran.purno)) + "' AS purno, " + ;
                "'" + SPACE(LEN(a_potran.vendno)) + "' AS vendno, " + lc_qtypct + ", c->status " + ;
                " FROM " + gf_sotranf + " AS a, " + gf_potranf + " AS b, " + ;
                gf_sodropf + " AS c, " + gf_icitemf + " AS d WHERE " + lc_var + "AND " + ;
                "EMPTY(c->purno) AND a->item = d->item AND a->sono+STR(a->tranlineno,4) = c->sono+STR(c->soline,4) " + ;
                lc_ordby, "TABLE", go_SQL.m_getTempTableName(2, "F"))
        ELSE
          *-- For SQL backend avoid concat in the expression for better performance.
          *-- For VFP is required for rushmore optimization
          go_SQL.m_SQLSelect(lc_fldlst + " FROM " + lc_from + " WHERE " + lc_var + " AND " + ;
              "b->purno = c->purno AND b->tranlineno = c->poline AND " + ;
              "a->item = d->item AND a->sono = c->sono AND a->tranlineno = c->soline " + ;
              " UNION SELECT " + ;
              "a->sono, a->tranlineno, a->custno, d->itmclss, a->qtyord, a->rqdate, a->ordate, " + ;
              "a->tqtyord, a->tqtyshp, a->qtyshp, a->item, '" +  SPACE(LEN(a_potran.purno)) + "' AS purno, " + ;
              "'" + SPACE(LEN(a_potran.vendno)) + "' AS vendno, " + lc_qtypct + " AS qtyrec, c->status " + ;
              " FROM " + gf_sotranf + " AS a, " + gf_potranf + " AS b, " + ;
              gf_sodropf + " AS c, " + gf_icitemf + " AS d WHERE " + lc_var + "AND " + ;
              "c->purno = '" + SPACE(LEN(a_potran->purno)) + "' AND a->item = d->item AND " + ;
              " a->sono = c->sono AND a->tranlineno = c->soline " + ;
              lc_ordby, "TABLE", go_SQL.m_getTempTableName(2, "F"))
        ENDIF

    ENDCASE

    go_SQL.so_CurrentAlias.m_CloseTable()

    = g_opnfl(go_SQL.m_getTempTableName(2, "F"), "a_tmpf2", .t., .f., "", .f., "F")
    
  ENDIF

  IF LEFT(lc_file,1) $ "HB"
    go_SQL.m_SQLSelect(" DISTINCT " + lc_fldlst + ;
                       " FROM " + ;
                       gf_soytrnf + " AS a, " + ;
                       gf_poytrnf + " AS b, " + ;
                       gf_soydrpf + " AS c, " + ;
                       gf_icitemf + " AS d " + ;
                       " WHERE " + lc_var +  " AND a->item = d->item " + ;
                                 " AND (b->purno + STR(b->tranlineno, 4) = c->purno + STR(c->poline, 4)) " + ;
                                 " AND (a->sono + STR(a->tranlineno, 4) = c->sono + STR(c->soline, 4)) " + ;
                       lc_ordby, "TABLE", go_SQL.m_getTempTableName(3, "F"))

    go_SQL.so_CurrentAlias.m_CloseTable()
    = g_opnfl(go_SQL.m_getTempTableName(3, "F"), "a_tmpf3", .t., .f., "", .f., "F")
  ENDIF

  IF LEFT(lc_file,1) = "B"
    go_SQL.m_TableChangeCurrent("a_tmpf2")
    go_SQL.cmpA_tmpf2.m_AppendFrom(go_SQL.m_getTempTableName(3, "F"), "")
  ELSE

    IF  LEFT(lc_file,1) = "H"
      go_SQL.cmpA_Tmpf3.m_CloseTable()

      *-- Close and delete tmpf2
      IF go_SQL.m_IsUsed("a_tmpf2")
        go_SQL.cmpA_Tmpf2.m_CloseTable()
      ENDIF

*\ [1 Line] PTR 73469 04/08/04 SGOU Passed right pram to m_droptable
      go_SQL.m_DropTable(go_SQL.m_getTempTableName(2, "F"), "", "F")

      go_SQL.m_SQLSelect(" * FROM " + go_SQL.m_getTempTableName(3, "F"), ;
                         "TABLE", ;
                         go_SQL.m_getTempTableName(2, "F"), "F")
                         
      go_SQL.so_CurrentAlias.m_CloseTable()

      go_SQL.m_DropTable(go_SQL.m_getTempTableName(3, "F"), "", "F")

        = g_opnfl(go_SQL.m_getTempTableName(2, "F"), "a_tmpf2", .t., .f., "", .f., "F")
    ENDIF

  ENDIF

  go_SQL.cmpA_tmpf2.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(2, "F"), "a_tmpf1", .t., .f., "", .f., "F")

  lc_filt = ALLTRIM(lc_filt)

  IF NOT EMPTY(lc_filt)

    IF LEFT(lc_filt, 4) = "AND "
      lc_filt = RIGHT(lc_filt, LEN(lc_filt) - 4)
    ENDIF

    go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep6
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP7
*------------------------------------------------------------------------------
*- Description: Report Picking Tickets
*------------------------------------------------------------------------------
PROCEDURE l_sorep7

  PRIVATE lc_prcomp, ;
          lc_sono, ;
          ll_eog, ;
          lc_cust, ;
          lc_sodate, ;
          lc_ordate, ;
          lc_shipvia, ;
          lc_fob, ;
          lc_pterms, ;
          lc_ponum, ;
          lc_salesmn, ;
          lc_ornum, ;
          lc_xsono, ;
          la_prnsn, ;
          lc_qstore, ;
          lc_qbin, ;
          lc_OldFilter

  go_SQL.m_TableChangeCurrent("a_sysdat")
  go_SQL.so_CurrentAlias.m_Locate("FOR UPPER(sysid) = '" + gc_applid + gc_compid + "'")
  DECLARE la_caddr[5]
  la_caddr[1] = gc_company
  la_caddr[2] = LEFT(a_sysdat->address,35)
  la_caddr[3] = SUBSTR(a_sysdat->address,36,35)
  la_caddr[4] = SUBSTR(a_sysdat->address,71,35)
  la_caddr[5] = ""

  *-- Eliminate blank lines from Company address
  IF EMPTY(la_caddr[1])
    la_caddr[1] = la_caddr[2]
    la_caddr[2] = la_caddr[3]
    la_caddr[3] = la_caddr[4]
    la_caddr[4] = la_caddr[5]
  ENDIF

  IF EMPTY(la_caddr[2])
    la_caddr[2] = la_caddr[3]
    la_caddr[3] = la_caddr[4]
    la_caddr[4] = la_caddr[5]
  ENDIF

  IF EMPTY(la_caddr[3])
    la_caddr[3] = la_caddr[4]
    la_caddr[4] = la_caddr[5]
  ENDIF

  *-- Initialize array of lot/serial number strings
  DECLARE la_prnsn[4]
  la_prnsn = Cc_NullStr

  lc_prcomp  = SUBSTR(a_sysdat->printer, 10, 1)

  ld_bdate   = g_retdt(lc_bdate)
  ld_edate   = g_retdt(lc_edate)

  *-- Set form type
  lc_frmfile = l_setfrm()

  *-- Use/reset windows printer setup dialog or cancel
  *-- Pass the 4th parameter as .t. to disable print range button
  ll_cont = g_setprn(.f., .f., .f., .t.)

  IF ll_cont
    *-- Open all files neccessary for Picking Ticket printing

    *-- Inventory item file
    = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

    *-- Open Inventory by Location file
    ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item1")

    *-- Inventory Quantities file
    ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f.,"item1")

    *-- Customer master file
    = g_opnfl(gf_arcustf, "a_arcust", .f., .f., "custno")

    *-- Ship-to address file
    = g_opnfl(gf_soaddrf, "a_soaddr", .f., .f., "sono")

    *-- Order Entry master file
    = g_opnfl(gf_somastf, "a_somast", .f., .f., "sono")

    go_SQL.so_CurrentAlias.m_SetFilter("")

    *-- Order Entry serial number file
    ln_icserl = g_opnfl(gf_icserlf, "a_icserl", .f., .f., "sono1")
    go_SQL.so_CurrentAlias.m_SetFilter("")

    *-- Order Entry line-item file
    = g_opnfl(gf_sotranf, "a_sotran", .f., .f., "custno1")

    *-- Set relation from tran file to other files

    go_SQL.cmpA_Sotran.m_SetRelation("item", "a_icitem", .f.)
    go_SQL.cmpA_Sotran.m_SetRelation("item+loctid", "a_iciqty", .t.)

    *-- Select Order Entry master file
    go_SQL.m_TableChangeCurrent("a_somast")
    go_SQL.cmpA_Somast.m_SetORder("custno1")

    go_SQL.m_TableChangeCurrent("a_somast")

    *-- Set up array for Bill-To address
    DECLARE la_baddr[5]

    *-- Set up array for Ship_to address
    DECLARE la_saddr[5]

    IF ll_cont
      DO g_dspst WITH "Preparing to print Picking Tickets", .t., gn_msgline, ;
                      "", "", ""

      *-- TRIM() filter variables
      lc_xcustno = TRIM(lc_xcustno)
      lc_item    = TRIM(lc_item)
      lc_loc     = TRIM(lc_loc)

      lc_filt = ""

      *-- Initialize beginning order number
      IF NOT EMPTY(lc_bsono)
        lc_bsono = PADL(TRIM(lc_bsono), LEN(lc_bsono), " ")
        lc_filt = "a_sotran->sono+STR(a_sotran->tranlineno,4) >= '" + lc_bsono + "' AND "
      ENDIF

      *-- Initialize ending order number
      IF NOT EMPTY(lc_esono)
        lc_esono = PADL(TRIM(lc_esono), LEN(lc_esono), " ")
        lc_filt = lc_filt + "a_sotran->sono+STR(a_sotran->tranlineno,4) <= '" + lc_esono + CHR(255) + "' AND "
      ENDIF

      *-- Set stock item condition
      IF LEFT(lc_incld,3) <> "All"
        lc_filt = lc_filt + [a_sotran->stkcode = "Y" AND ]
      ENDIF

      *-- Set new & changed condition
      IF LEFT(lc_changed,1) = "N"

        *-- Check from a_sotran instead of a_somast
        lc_filt = lc_filt + [ EMPTY(a_sotran->prnpktk) AND ]
      ENDIF

      *-- Set customer number condition
      IF NOT EMPTY(lc_xcustno)
        lc_filt = lc_filt + "a_sotran->custno %=% ??lc_xcustno + '%/%' AND "
      ENDIF

      *-- Set item number condition
      IF NOT EMPTY(lc_item)
        lc_filt = lc_filt + "a_sotran->item %=% ??lc_item + '%/%' AND "
      ENDIF

      *-- Set required date condition
      IF NOT EMPTY(ld_bdate)
        lc_filt = lc_filt + [a_sotran->rqdate >= ??ld_bdate AND ]
      ENDIF

      IF NOT EMPTY(ld_edate)
        lc_filt = lc_filt + [a_sotran->rqdate <= ??ld_edate AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_loc)
        lc_filt = lc_filt + "a_sotran->loctid %=% ??lc_loc + '%/%' AND "
      ENDIF

      *-- Set qty condition
      lc_filt = lc_filt + [a_sotran->qtyord <> 0 AND ]

      *-- Set other conditions
      lc_filt = lc_filt + " NOT a_sotran->sostat $ 'VX' AND " + ;
                " NOT a_sotran->sotype $ 'BR' AND " + ;
                " NOT LEFT(a_sotran->item, " + ;
                ALLTRIM(STR(LEN(gc_shiptyp))) + ;
                ") = '" + gc_shiptyp + "'"


      lc_segmnt1 = ""
      lc_segmnt2 = ""
      lc_segmnt3 = ""
      lc_segmnt4 = ""

      DO g_brkstr WITH lc_filt, lc_segmnt1, lc_segmnt2, lc_segmnt3, lc_segmnt4
    ENDIF && ll_cont

    go_SQL.so_CurrentAlias.m_SetRelation("OFF", "a_sotran", .f.)
    go_SQL.so_CurrentAlias.m_SetFilter("")

    IF ll_cont
      *-- Copy selected records to temporary file
      go_SQL.m_TableChangeCurrent("a_sotran")

      *-- Set relation from tran file to master file
      go_SQL.CmpA_sotran.m_SetRelation("sono", "a_somast", .t.)
      go_SQL.CmpA_sotran.m_SetFilter(lc_segmnt1 + lc_segmnt2 + lc_segmnt3 + lc_segmnt4)
      go_SQL.CmpA_sotran.m_MoveRecord(Cn_TopRec)

      *-- Added tprice,tqtyord,tqtyshp
      *-- Added tcost
      go_SQL.CmpA_sotran.m_CopyTo(go_SQL.m_getTempTableName(1), ;
                                " FIELDS a_sotran->seq, a_sotran->sono, a_sotran->custno, a_sotran->item, a_sotran->descrip, " + ;
                                " a_sotran->isoclss, a_sotran->rqdate, a_sotran->lotno, a_sotran->serial, a_sotran->qtyord, " + ;
                                " a_sotran->qtyshp, a_sotran->tqtyord, a_sotran->tqtyshp, a_sotran->umfact, a_sotran->umeasur, " + ;
                                " a_sotran->loctid, a_sotran->tranlineno, a_sotran->intmemo, a_sotran->cost, a_sotran->tcost, " + ;
                                " a_sotran->disc, a_sotran->taxrate, a_sotran->price, a_sotran->tprice, a_sotran->extprice, " + ;
                                " a_sotran->stkcode, a_sotran->detail, a_sotran->transeq ")

      lc_qstore = ALLTRIM(STR(LEN(a_iciqty->qstore)))
      lc_qbin   = ALLTRIM(STR(LEN(a_iciqty->qbin)))

      *-- Open temporary file
      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

      go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1), "ADD COLUMN qstore C(" + lc_qstore + ")")
      go_Sql.m_AlterTable(go_SQL.m_getTempTableName(1), "ADD COLUMN qbin C(" + lc_qbin + ")")
      go_Sql.so_CurrentAlias.m_CloseTable()

      *-- Open temporary file
      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

      go_SQL.so_CurrentAlias.m_SetRelation("item + loctid", "a_iciqty", .f.)
      go_SQL.so_CurrentAlias.m_ReplaceBulk("qstore WITH a_iciqty.qstore, " + ;
                                           "qbin WITH a_iciqty.qbin", "A", "", .t.)
      go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      IF go_SQL.so_CurrentAlias.m_Reccount() = 0
        DO g_dspalt WITH "No matching records found." + gc_oseol + ;
                         "Print forms cancelled.", 3

        ll_cont = .f.
      ENDIF

      IF ll_cont
        *-- Set filters and relations
        go_SQL.m_TableChangeCurrent("a_iciqty")
        go_SQL.so_CurrentAlias.m_SetFilter("qonhand > 0")

        go_SQL.m_TableChangeCurrent("a_sotran")
        go_SQL.so_CurrentAlias.m_SetRelation("OFF", "a_icitem", .f.)

        go_SQL.m_TableChangeCurrent("a_tmpf1")
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        go_SQL.so_CurrentAlias.m_MoveToRecno(go_SQL.so_CurrentAlias.m_GetRecno())

        *-- Retrieve store/bin information from the quantity file
        DO WHILE NOT go_SQL.cmpA_Tmpf1.m_IsEof()
          go_SQL.m_TableChangeCurrent("a_iciqty")

          DO CASE
            CASE a_icitem->useserl = "N" AND a_icitem->uselots = "N"
              *-- Item does not use serial numbers or lots, nothing is tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

            CASE a_icitem->useserl <> "N" AND EMPTY(a_tmpf1->serial)
              *-- Item uses serial numbers but nothing is tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item1")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->loctid, "")

            OTHERWISE
              *-- Item uses serial numbers or lots and qty records are tagged
              go_SQL.cmpA_Iciqty.m_SetOrder("item3")
              go_SQL.so_CurrentAlias.m_Seek(a_tmpf1->item + a_tmpf1->serial, "")
          ENDCASE

          lc_store = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qstore, "")
          lc_bin   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->qbin, "")
          lc_lot   = IIF(go_SQL.so_CurrentAlias.m_IsFound(), a_iciqty->lotno, "")

          go_SQL.m_TableChangeCurrent("a_tmpf1")

          go_SQL.so_CurrentAlias.m_ReplaceBulk("qstore WITH lc_store, qbin WITH lc_bin, lotno WITH lc_lot")
          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)
        ENDDO

        *-- Clear filters and reset relations
        go_SQL.m_TableChangeCurrent("a_iciqty")
        go_SQL.so_CurrentAlias.m_SetFilter("")

        go_SQL.m_TableChangeCurrent("a_tmpf1")
        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

        go_SQL.m_TableChangeCurrent("a_sotran")
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .t.)
        go_SQL.m_TableChangeCurrent("a_tmpf1")
      ENDIF && ll_cont

      IF ll_cont
*\ [1 Line] PTR# 74805 06/26/04 TISP Create temp index
        go_SQL.so_CurrentAlias.m_CreateIndex("sonotrln", "sono + STR(tranlineno)", "", .t., .f.)

        go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + loctid + qstore + qbin", "", .t., .f.)

        *-- Tran file summarization
        DO g_dspst WITH "Summarizing order items", .t., gn_msgline, "", "", ""

        *-- Summarize sotran file for entire batch
        DO l_sumtrn

        *-- Initialize "print-while' condition
        lc_cond = "1=1 AND "

        PRIVATE lc_xprint
        lc_xprint = SET("PRINTER",1)
      ENDIF

      *-- Select Inventory Quantities file
      go_SQL.cmpA_Iciqty.m_SetOrder("item5")

      *-- Main picking ticket printing loop
      DO WHILE ll_cont
        *-- Select order entry master file
        go_SQL.m_TableChangeCurrent("a_somast")

        IF NOT go_SQL.CmpA_somast.m_Seek(a_tmpf3->custno+ a_tmpf3->sono, "")
          EXIT
        ENDIF

        *-- Display status line message to user
        lc_title = "Picking Ticket for Order " + ALLTRIM(a_somast->sono)

        *-- Set "end of group" counter to true to start a new picking ticket
        *-- NOTE: ll_eog is referenced within the FRX files
        ll_eog = .f.

        *-- Initialize order entry header variables
        lc_sono     = a_somast->sono
        lc_cust     = a_somast->custno
        lc_sodate   = a_somast->sodate
        lc_ordate   = a_somast->ordate
        lc_shipvia  = a_somast->shipvia
        lc_fob      = a_somast->fob
        lc_pterms   = a_somast->pterms
        lc_ponum    = a_somast->ponum
        lc_salesmn  = a_somast->salesmn
        lc_ornum    = a_somast->ornum

        *-- Initialize order number to print on form
        lc_xsono = LTRIM(lc_sono)

        *-- Select customer file and seek current customer record
        go_SQL.m_TableChangeCurrent("a_arcust")
        go_SQL.so_CurrentAlias.m_Seek(lc_cust, "")

        IF NOT go_SQL.cmpA_Arcust.m_IsEof()
          *-- Initialize array variables for bill-to address
          la_baddr[1] = a_arcust->company
          la_baddr[2] = a_arcust->address1
          la_baddr[3] = a_arcust->address2
          la_baddr[4] = TRIM(a_arcust->city) + "," + ALLTRIM(a_arcust->addrstate) + " " + TRIM(a_arcust->zip)

          la_baddr[5] = a_arcust->country

          *-- Initialize array variables for ship-to address
          la_saddr[1] = a_arcust->company
          la_saddr[2] = a_arcust->address1
          la_saddr[3] = a_arcust->address2
          la_saddr[4] = TRIM(a_arcust->city) + "," + ALLTRIM(a_arcust->addrstate) + " " + TRIM(a_arcust->zip)

          la_saddr[5] = a_arcust->country

          IF a_somast->tosw <> " " OR lc_cust = "CASH  "
            *-- If using an alternate ship-to or a cash customer

            *-- Select ship-to address file and seek address for this order
            go_SQL.m_TableChangeCurrent("a_soaddr")
            go_SQL.so_CurrentAlias.m_Seek(lc_sono, "")

            *-- Build ship-to address
            la_saddr[1] = a_soaddr->company
            la_saddr[2] = a_soaddr->address1
            la_saddr[3] = a_soaddr->address2
            la_saddr[4] = ALLTRIM(a_soaddr->city) + ", " + ALLTRIM(a_soaddr->addrstate) + " " + ALLTRIM(a_soaddr->zip)
            la_saddr[5] = a_soaddr->country
          ENDIF

        ELSE
          *-- If customer file at EOF()

          *-- Initialize array variables for bill-to address
          la_baddr[1] = "***** INVALID CUSTOMER NUMBER ****"
          la_baddr[2] = "***** INVALID CUSTOMER NUMBER ****"
          la_baddr[3] = "***** INVALID CUSTOMER NUMBER ****"
          la_baddr[4] = "***** INVALID CUSTOMER NUMBER ****"
          la_baddr[5] = ""

          *-- Initialize array variables for ship-to address
          la_saddr[1] = "***** INVALID CUSTOMER NUMBER ****"
          la_saddr[2] = "***** INVALID CUSTOMER NUMBER ****"
          la_saddr[3] = "***** INVALID CUSTOMER NUMBER ****"
          la_saddr[4] = "***** INVALID CUSTOMER NUMBER ****"
          la_saddr[5] = ""
        ENDIF && NOT EOF(a_arcust)

        *-- Eliminate blank lines from billing address
        IF EMPTY(la_baddr[4])
          la_baddr[4] = la_baddr[5]
          la_baddr[5] = " "
        ENDIF

        IF EMPTY(la_baddr[3])
          la_baddr[3] = la_baddr[4]
          la_baddr[4] = la_baddr[5]
          la_baddr[5] = " "
        ENDIF

        IF EMPTY(la_baddr[2])
          la_baddr[2] = la_baddr[3]
          la_baddr[3] = la_baddr[4]
          la_baddr[4] = la_baddr[5]
          la_baddr[5] = " "
        ENDIF

        IF EMPTY(la_baddr[1])
          la_baddr[1] = la_baddr[2]
          la_baddr[2] = la_baddr[3]
          la_baddr[3] = la_baddr[4]
          la_baddr[4] = la_baddr[5]
          la_baddr[5] = " "
        ENDIF

        *-- Eliminate blank lines from shipping address
        IF EMPTY(la_saddr[4])
          la_saddr[4] = la_saddr[5]
          la_saddr[5] = " "
        ENDIF

        IF EMPTY(la_saddr[3])
          la_saddr[3] = la_saddr[4]
          la_saddr[4] = la_saddr[5]
          la_saddr[5] = " "
        ENDIF

        IF EMPTY(la_saddr[2])
          la_saddr[2] = la_saddr[3]
          la_saddr[3] = la_saddr[4]
          la_saddr[4] = la_saddr[5]
          la_saddr[5] = " "
        ENDIF

        IF EMPTY(la_saddr[1])
          la_saddr[1] = la_saddr[2]
          la_saddr[2] = la_saddr[3]
          la_saddr[3] = la_saddr[4]
          la_saddr[4] = la_saddr[5]
          la_saddr[5] = " "
        ENDIF

        go_SQL.m_TableChangeCurrent("a_tmpf3")

        ln_decnum = SET("DECIMALS")
        SET DECIMALS TO 3
        ll_prnt  = .t.

        lc_OldFilter = go_SQL.so_CurrentAlias.m_GetFilter()
        go_SQL.so_Currentalias.m_SetFilter("custno + sono = ??lc_cust + ??lc_sono")

        *-- Move to the first record in the current filter
        go_SQL.so_Currentalias.m_MoveRecord(Cn_TopRec)

        DO WHILE sono = a_somast->sono AND ll_cont
          *-- Print picking ticket
*\[1 Line] PTR# 73741 01/31/04 TIVN Passed the fifth parameter as .t.
*\                                  which will prevent the report selection
*\                                  dialog to pop up
          DO g_prnrp WITH .f., .f., .f., .f., .t.
        ENDDO

        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_BottRec)
        go_SQL.so_CurrentAlias.m_SetFilter(lc_OldFilter)
        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)

        SET DECIMALS TO ln_decnum

        *-- Deleted 15 lines because the field 'prnpktk' is no more
        *-- used in a_somast
        go_SQL.m_TableChangeCurrent("a_tmpf3")

        IF NOT ll_cont OR go_SQL.so_CurrentAlias.m_IsEof()
          EXIT
        ENDIF

      ENDDO &&while ll_cont (Main print loop)

    ENDIF && ll_cont

  ENDIF && ll_cont

  *-- Update a_sotran->prnpktk once pickting ticket is printed
  IF ll_cont
    go_SQL.m_TableChangeCurrent("a_tmpf1")
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

    go_SQL.cmpA_Sotran.m_SetOrder("sono1")
    go_SQL.so_CurrentAlias.m_SetRelation("sono + STR(tranlineno,4)", "a_sotran", .f.)

    go_SQL.so_CurrentAlias.m_ScanBegin("F", ".t. = .t.")

    DO WHILE go_SQL.so_CurrentAlias.m_ScanBulk()
      go_SQL.m_TableChangeCurrent("a_sotran")

*\ [1 Line] PTR# 73731 02/18/04 TISN Checked whether a record is found
      IF NOT go_SQL.so_CurrentAlias.m_IsEof()

        IF gl_multi AND NOT go_SQL.so_CurrentAlias.m_LockRow(1, .f.)
          ll_result = go_SQL.cmpA_Sotran.m_LockRow(-1, .f.)
        ENDIF

        *-- Mark order as printed
        go_SQL.so_CurrentAlias.m_Replace("prnpktk", 'P')
      ENDIF

      go_SQL.m_TableChangeCurrent("a_tmpf1")
    ENDDO

    go_SQL.so_CurrentAlias.m_ScanEnd()

    go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)

    go_SQL.cmpA_Sotran.m_Unlock()
  ENDIF && ll_cont

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep6
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_COMRPT7
*------------------------------------------------------------------------------
*- Description: Reports - Creates cursor and defines report for report "7"
*------------------------------------------------------------------------------
*- Synopsis...: Commissions for Sales People/ Sales Groups
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_comrpt7

  PRIVATE ln_opnscmt, ;
          ln_opnscyt, ;
          lc_cfilt, ;
          ln_pctoinv, ;
          lc_invno, ;
          lc_sono, ;
          ln_opnmast, ;
          ln_opmymst

  *-- Initialize locals
  ln_opnscmt = 0
  ln_opnscyt = 0
  lc_cfilt   = ""
  lc_pctoinv = 0
  lc_invno   = Cc_NullStr
  lc_sono    = Cc_NullStr
  ln_opnmast = 0
  ln_opnymst = 0

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

  go_SQL.m_createTable(go_SQL.m_getTempTableName(7), ;
                        " FREE (type C(1), salesmn C(4), sono C(13), invno C(13), tdate D(8), invamt N(15,2), scmamt N(15,2), " + ;
                        " comm N(15,2), comtype C(1), pctoinv N(5,2), doctype C(1), trantype C(10), finvamt Y, exchrat B(9), currid C(3))", ;
                        "", "")

  go_SQL.so_CurrentAlias.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(7), "a_tmpf7", .t., .f.)

  IF TRIM(LEFT(lc_file,1)) $ "Current~Both   "
    ln_opnscmt = g_opnfl(gf_soscmtf, "a_soscmt", .f., .f., "sonsls")
  ENDIF

  IF TRIM(LEFT(lc_file,1)) $ "History~Both   "
    ln_opnscyt = g_opnfl(gf_soscytf, "a_soscyt", .f., .f., "")
  ENDIF

  *-- open AR files when AR module is installed
  IF gl_ar
  
*\ [Begin] PTR# 75262 06/24/04 TINN Used somast,soymst instead of armast,arymst
*\                                  and used sono index instead of invno index

    IF TRIM(LEFT(lc_file,1)) $ "Current~Both   "
      ln_opnmast = g_opnfl(gf_somastf, "a_somast", .f., .f., "sono")
    ENDIF

    IF TRIM(LEFT(lc_file,1)) $ "History~Both   "
      ln_opnymst = g_opnfl(gf_soymstf, "a_soymst", .f., .f., "sono")
    ENDIF

    *-- If file opened, set relation to them
    IF ln_opnmast > 0
      go_SQL.m_TableChangeCurrent("a_soscmt")
      go_SQL.so_CurrentAlias.m_SetRelation("sono", "a_somast", .t.)
    ENDIF

    IF ln_opnymst > 0
      go_SQL.m_TableChangeCurrent("a_soscyt")
      go_SQL.so_CurrentAlias.m_SetRelation("sono", "a_soymst", .t.)
    ENDIF

  ENDIF

*\ [End] PTR# 75262 06/24/04 TINN Used somast,soymst instead of armast,arymst
*\                                and used sono index instead of invno index

  *-- If either file opened, determine filter
  IF ln_opnscmt > 0 OR ln_opnscyt > 0

    *-- Initialize filter condition
    DO CASE
      CASE ALLTRIM(lc_adjust) = "Adjust"
        *-- Adjustment only
        lc_cfilt   = "(doctype = 'M')"

      OTHERWISE
        *-- Show order entries, invoices, and adjustments
        *-- Returns, Credit memos, Voided Invoices, Voided Credit Memos
        *-- and Negative Cash Receipts
        lc_cfilt   = "(doctype = 'S' OR doctype = 'I' OR doctype = 'M' " + ;
                     "OR doctype = 'R' OR doctype = 'C' OR " + ;
                     "doctype = 'V' OR doctype = 'D' OR doctype = '-')"
    ENDCASE

    *-- If periods defined, connvert them to dates for date filtering
    IF lc_range $ "Quarter~Month  "
      lc_bdate = l_pertodte(1,ln_bperiod)
      lc_edate = l_pertodte(2,ln_eperiod)
    ENDIF

    ld_fbdate = g_retdt(lc_bdate)
    ld_fedate = g_retdt(lc_edate)

    *-- If beginning date provided, set filter
    IF NOT EMPTY(STRTRAN(lc_bdate, SET("MARK")))
      lc_cfilt = lc_cfilt + " AND tdate >= ??ld_fbdate"
    ENDIF

    *-- If ending date provided, set filter
    IF NOT EMPTY(STRTRAN(lc_edate, SET("MARK")))
      lc_cfilt = lc_cfilt + " AND tdate <= ??ld_fedate"
    ENDIF

    *-- If Salespeople selected
    IF lc_include = "Salespeople "

      IF NOT EMPTY(lc_bpepl)
        lc_cfilt = lc_cfilt + " AND salesmn >= ??lc_bpepl"
      ENDIF

      IF NOT EMPTY(lc_epepl)
        lc_cfilt = lc_cfilt + " AND salesmn <= ??lc_epepl "
      ENDIF

    ENDIF

    *-- If sales Groups selected
    IF lc_include = "Sales Groups"

      IF NOT EMPTY(lc_bgrp)
        lc_cfilt = lc_cfilt + " AND salegrp >= ??lc_bgrp"
      ENDIF

      IF NOT EMPTY(lc_egrp)
        lc_cfilt = lc_cfilt + " AND salegrp <= ??lc_bgrp"
      ENDIF

    ENDIF

    *-- Apply filter on type if necessary
    DO CASE
      CASE ALLTRIM(lc_adjust) = "Due"
        lc_cfilt = lc_cfilt + " AND status $ 'S~R~M~I'"

      CASE ALLTRIM(lc_adjust) = "Paid"
        lc_cfilt = lc_cfilt + " AND status = 'P'"
    ENDCASE

  ENDIF

*\ [1 Line] PTR# 73507 06/29/04 TIRR Excluded the entries that has status 'T'
  *-- Exclude unreportable entries (i.e. Commission Pending)
  *-- Exclude Non-Reportable entries
  lc_cfilt = lc_cfilt + " AND status <> 'T' AND NOT EMPTY(tdate)"

  *-- If current file opened
  IF ln_opnscmt > 0
    go_SQL.m_TableChangeCurrent("a_soscmt")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_cfilt)

    go_SQL.CmpA_soscmt.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_soscmt.m_ScanBulk()
      go_SQL.m_TableChangeCurrent("a_tmpf7")

      *-- Determine invoice/order number to display
      lc_invno = ALLTRIM(a_soscmt->invno)
      lc_sono  = ALLTRIM(a_soscmt->sono)

      IF a_soscmt->doctype $ "C~R~D"
        *-- Credit Memo, Return or Voided Credit Memo

        IF NOT EMPTY(lc_sono)
          lc_sono = "R" + lc_sono
        ENDIF

        IF NOT EMPTY(lc_invno)
          lc_invno = "C" + lc_invno
        ENDIF

      ENDIF

      IF a_soscmt->doctype $ "V~D" AND NOT EMPTY(lc_invno)
        *-- Voided Invoice or Voided Credit Memo
        lc_invno = "V " + lc_invno
      ENDIF

      IF ALLTRIM(lc_include) $ "Salespeople ~Both        "
        *-- Add record for salespeople
        go_SQL.so_CurrentAlias.m_Add()

        *-- Determine commission to invoice percentage
        IF a_soscmt->invamt <> 0 AND a_soscmt->doctype <> "M"
          *-- Calculate percentage
          ln_pctoinv = (a_soscmt->comm / a_soscmt->invamt) * 100
        ELSE
          *-- Zero invoice amount, set percentage to zero
          ln_pctoinv = 0
        ENDIF

        go_SQL.so_CurrentAlias.m_ReplaceBulk(" type WITH 'S', " + ;
                                         " salesmn  WITH a_soscmt->salesmn, " + ;
                                         " sono     WITH lc_sono,  " + ;
                                         " invno    WITH lc_invno,  " + ;
                                         " tdate    WITH a_soscmt->tdate,  " + ;
                                         " invamt   WITH a_soscmt->invamt,  " + ;
                                         " scmamt   WITH IIF(a_soscmt->doctype = 'M', a_soscmt->scmsal, a_soscmt->scmamt),  " + ;
                                         " comm     WITH a_soscmt->comm,  " + ;
                                         " comtype  WITH a_soscmt->comtype,  " + ;
                                         " pctoinv  WITH ln_pctoinv,  " + ;
                                         " doctype  WITH a_soscmt->doctype,  " + ;
                                         " trantype WITH l_scttype(a_soscmt->doctype)")

        IF gl_mc AND gl_ar

*\ [1 Line] PTR# 75262 06/24/04 TINN Used somast instead of armast
          go_SQL.so_CurrentAlias.m_ReplaceBulk("finvamt WITH g_extnd(g_retcur(a_somast->currid, 'DECNUM'), a_soscmt->invamt,a_somast->exchrat,0),  " + ;
                                              " exchrat WITH a_somast->exchrat,  " + ;
                                              " currid  WITH a_somast->currid")
        ENDIF

      ENDIF

      IF ALLTRIM(lc_include) $ "Sales Groups~Both        "
        *-- Add record for sales groups
        go_SQL.so_CurrentAlias.m_Add()

        *-- Determine commission to invoice percentage
        IF a_soscmt->invamt <> 0 AND a_soscmt->doctype <> "M"
          *-- Calculate percentage
          ln_pctoinv = (a_soscmt->comm / a_soscmt->invamt) * 100
        ELSE
          *-- Zero invoice amount, set percentage to zero
          ln_pctoinv = 0
        ENDIF

        go_SQL.so_CurrentAlias.m_ReplaceBulk(" type     WITH 'G',  " + ;
                                             " salesmn  WITH a_soscmt->salegrp, " + ;
                                             " sono     WITH lc_sono,  " + ;
                                             " invno    WITH lc_invno,  " + ;
                                             " tdate    WITH a_soscmt->tdate,  " + ;
                                             " invamt   WITH a_soscmt->invamt,  " + ;
                                             " scmamt   WITH IIF(a_soscmt->doctype = 'M', a_soscmt->scmsal, a_soscmt->scmamt),  " + ;
                                             " comm     WITH a_soscmt->comm,  " + ;
                                             " comtype  WITH a_soscmt->comtype,  " + ;
                                             " pctoinv  WITH ln_pctoinv,  " + ;
                                             " doctype  WITH a_soscmt->doctype,  " + ;
                                             " trantype WITH l_scttype(a_soscmt->doctype)")

        IF gl_mc AND gl_ar

*\ [1 Line] PTR# 75262 06/24/04 TINN Used somast instead of armast
          go_SQL.so_CurrentAlias.m_ReplaceBulk( "finvamt WITH g_extnd(g_retcur(a_somast->currid, 'DECNUM'), a_soscmt->invamt,a_somast->exchrat,0),  " + ;
                                               " exchrat WITH a_somast->exchrat,  " + ;
                                               " currid  WITH a_somast->currid")
        ENDIF

      ENDIF

      go_SQL.m_TableChangeCurrent("a_soscmt")

      *-- If instructed to mark as paid, do so
      IF ((gc_slspay = "S" AND a_soscmt->status $ "S~R~I") OR ;
         (gc_slspay = "R" AND a_soscmt->status = "R") OR ;
         a_soscmt->status = "M") AND lc_markem = "Y"

        go_SQL.so_CurrentAlias.m_Replace("status", 'P')
      ENDIF

    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  *-- If history file opened
  IF ln_opnscyt > 0
    go_SQL.m_TableChangeCurrent("a_soscyt")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_cfilt)

    go_SQL.CmpA_soscyt.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_soscyt.m_ScanBulk()
      go_SQL.m_TableChangeCurrent("a_tmpf7")

      *-- Determine invoice/order number to display
      lc_invno = ALLTRIM(a_soscyt->invno)
      lc_sono  = ALLTRIM(a_soscyt->sono)

      IF a_soscyt->doctype $ "C~R~D"
        *-- Credit Memo, Return or Voided Credit Memo

        IF NOT EMPTY(lc_sono)
          lc_sono = "R" + lc_sono
        ENDIF

        IF NOT EMPTY(lc_invno)
          lc_invno = "C" + lc_invno
        ENDIF

      ENDIF

      IF a_soscyt->doctype $ "V~D" AND NOT EMPTY(lc_invno)
        *-- Voided Invoice or Voided Credit Memo
        lc_invno = "V " + lc_invno
      ENDIF

      IF ALLTRIM(lc_include) $ "Salespeople ~Both        "
        *-- Add record for salespeople
        go_SQL.so_CurrentAlias.m_Add()

        *-- Determine commission to invoice percentage
        IF a_soscyt->invamt <> 0 AND a_soscyt->doctype <> "M"
          *-- Calculate percentage
          ln_pctoinv = (a_soscyt->comm / a_soscyt->invamt) * 100
        ELSE
          *-- Zero invoice amount, set percentage to zero
          ln_pctoinv = 0
        ENDIF

        go_SQL.so_CurrentAlias.m_ReplaceBulk(" type     WITH 'S',  " + ;
                                             " salesmn  WITH a_soscyt->salesmn,  " + ;
                                             " sono     WITH lc_sono,  " + ;
                                             " invno    WITH lc_invno,  " + ;
                                             " tdate    WITH a_soscyt->tdate,  " + ;
                                             " invamt   WITH a_soscyt->invamt,  " + ;
                                             " scmamt   WITH IIF(a_soscyt->doctype = 'M', a_soscyt->scmsal, a_soscyt->scmamt),  " + ;
                                             " comm     WITH a_soscyt->comm,  " + ;
                                             " comtype  WITH a_soscyt->comtype,  " + ;
                                             " pctoinv  WITH ln_pctoinv,  " + ;
                                             " doctype  WITH a_soscyt->doctype,  " + ;
                                             " trantype WITH l_scttype(a_soscyt->doctype)")

        IF gl_mc AND gl_ar

*\ [1 Line] PTR# 75262 06/24/04 TINN Used soymst instead of arymst
          go_SQL.so_CurrentAlias.m_ReplaceBulk(" finvamt WITH g_extnd(g_retcur(a_soymst->currid, 'DECNUM'), a_soscyt->invamt,a_soymst->exchrat,0),  " + ;
                                               " exchrat WITH a_soymst->exchrat,  " + ;
                                               " currid  WITH a_soymst->currid")
        ENDIF

      ENDIF

      IF ALLTRIM(lc_include) $ "Sales Groups~Both        "
        *-- Add record for sales groups
        go_SQL.so_CurrentAlias.m_Add()

        *-- Determine commission to invoice percentage
        IF a_soscyt->invamt <> 0 AND a_soscyt->doctype <> "M"
          *-- Calculate percentage
          ln_pctoinv = (a_soscyt->comm / a_soscyt->invamt) * 100
        ELSE
          *-- Zero invoice amount, set percentage to zero
          ln_pctoinv = 0
        ENDIF

        go_SQL.so_CurrentAlias.m_ReplaceBulk(" type     WITH 'G',  " + ;
                                             " salesmn  WITH a_soscyt->salegrp,  " + ;
                                             " sono     WITH lc_sono,  " + ;
                                             " invno    WITH lc_invno,  " + ;
                                             " tdate    WITH a_soscyt->tdate,  " + ;
                                             " invamt   WITH a_soscyt->invamt,  " + ;
                                             " scmamt   WITH IIF(a_soscyt->doctype = 'M', a_soscyt->scmsal, a_soscyt->scmamt),  " + ;
                                             " comm     WITH a_soscyt->comm,  " + ;
                                             " comtype  WITH a_soscyt->comtype,  " + ;
                                             " pctoinv  WITH ln_pctoinv,  " + ;
                                             " doctype  WITH a_soscyt->doctype,  " + ;
                                             " trantype WITH l_scttype(a_soscyt->doctype)")

        IF gl_mc AND gl_ar

*\ [1 Line] PTR# 75262 06/24/04 TINN Used soymst instead of arymst
          go_SQL.so_CurrentAlias.m_ReplaceBulk(" finvamt WITH g_extnd(g_retcur(a_soymst->currid, 'DECNUM'), a_soscyt->invamt, a_soymst->exchrat,0),  " + ;
                                               " exchrat WITH a_soymst->exchrat,  " + ;
                                               " currid  WITH a_soymst->currid")
        ENDIF

      ENDIF

      go_SQL.m_TableChangeCurrent("a_soscyt")
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  go_SQL.m_TableChangeCurrent("a_tmpf7")
  go_SQL.so_CurrentAlias.m_CreateIndex("tstsi", "type + salesmn + DTOC(tdate) + sono + invno", "", .t., .f.)

  *# DOCCODE REPORT FORM sosccm
  lc_frx = gc_adrvprg + "sosccm"

  IF ln_opnscmt = 2
    go_SQL.cmpA_Soscmt.m_CloseTable()
  ENDIF

  IF ln_opnscyt = 2
    go_SQL.cmpA_Soscyt.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_comrpt7
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_COMRPT8
*------------------------------------------------------------------------------
*- Description: Reports - Creates cursor and defines report for report "8"
*------------------------------------------------------------------------------
*- Synopsis...: Commissions - Quotas vs. Actual sales
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_comrpt8

  PRIVATE ln_opnslpq, ;
          ln_opnslgq, ;
          lc_pfilt, ;
          lc_gfilt, ;
          ln_start, ;
          ln_end, ;
          ln_loop, ;
          lc_monthst

  *-- Initialize locals
  ln_opnslpq  = 0
  ln_opnslgq  = 0
  ln_start    = 0
  ln_end      = 0
  ln_loop     = 0
  lc_pfilt    = "1=1 "
  lc_gfilt    = "1=1 "
  lc_monthst = ""

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

  *-- Create temporary cursor for report set
  go_SQL.m_createTable(go_SQL.m_getTempTableName(7), ;
                        " FREE (id C(4), period C(3), actual N(12,2), quota N(12,2), poolpct N(12,2), type C(1), mnthprd C(2))", ;
                        "", "")

  go_SQL.so_CurrentAlias.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(7), "a_tmpf7", .t., .f.)

  *-- Open Salespeople quota file if neccessary
  IF lc_include $ "Salespeople ~Both        "
    ln_opnslpq = g_opnfl(gf_soslpqf, "a_soslpq", .f., .f., "")
  ENDIF

  *-- Open Sales Groups Quota file if necessary
  IF lc_include $ "Sales Groups~Both        "
    ln_opnslgq = g_opnfl(gf_soslgqf, "a_soslgq", .f., .f., "")
  ENDIF

  *-- If salespeople file opened propely, apply necessary filter
  IF ln_opnslpq > 0

    IF NOT EMPTY(lc_bpepl)
      lc_pfilt = lc_pfilt + " AND a_soslpq->salesmn >= ??lc_bpepl"
    ENDIF

    IF NOT EMPTY(lc_epepl)
      lc_pfilt = lc_pfilt + " AND a_soslpq->salesmn <= ??lc_epepl"
    ENDIF

    *-- Apply filter to a_soslpq file
    go_SQL.m_TableChangeCurrent("a_soslpq")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_pfilt)

    *--
    IF NOT EMPTY(ln_bperiod)
      ln_start = ln_bperiod
    ELSE
      ln_start = 1
    ENDIF

    IF NOT EMPTY(ln_eperiod)
      ln_end = ln_eperiod
    ELSE
      ln_end = VAL(gc_slsqpd)
    ENDIF

    *-- Scan entire salespeople file
    go_SQL.CmpA_soslpq.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_soslpq.m_ScanBulk()

      FOR ln_loop = ln_start TO ln_end

        *-- Check if quotas are by month or quarter
        IF VAL(gc_slsqpd) = 4
          *-- By Quarter
          lc_period = "Q" + ALLTRIM(STR(ln_loop))
        ELSE
          *-- By month, determine character month
          lc_period = LEFT(CMONTH(ld_begdt + ;
                      INT((365/12)*(ln_loop-1)+15)),3)
        ENDIF

        lc_actual = "a_soslpq->aper" + PADL(ALLTRIM(STR(ln_loop)),2,"0")
        lc_quota  = "a_soslpq->qper" + PADL(ALLTRIM(STR(ln_loop)),2,"0")

        go_SQL.m_TableChangeCurrent("a_tmpf7")
        go_SQL.cmpa_tmpf7.m_SQLInsert("id, period, actual, quota, poolpct, type, mnthprd", ;
                                         "a_soslpq->salesmn, lc_period, &lc_actual, &lc_quota, IIF(&lc_quota <> 0,(&lc_actual / &lc_quota) * 100,0), 'P', STR(ln_loop,2,0)", "")
      NEXT

      go_SQL.m_TableChangeCurrent("a_soslpq")
    ENDDO
    go_SQL.CmpA_soslpq.m_ScanEnd()

  ENDIF

  *-- If salespeople file opened propely, apply necessary filter
  IF ln_opnslgq > 0

    IF NOT EMPTY(lc_bgrp)
      lc_gfilt = lc_gfilt + " AND (a_soslgq->salegrp > RTRIM(??lc_bgrp) OR" + ;
                 " a_soslgq->salegrp %=% RTRIM(??lc_bgrp) + '%/%')"
    ENDIF

    IF NOT EMPTY(lc_egrp)
      lc_gfilt = lc_gfilt + " AND (a_soslgq->salegrp < RTRIM(??lc_egrp) OR" + ;
                 " a_soslgq->salegrp %=% RTRIM(??lc_egrp) + '%/%')"
    ENDIF

    *-- Apply filter to a_soslpq file
    go_SQL.m_TableChangeCurrent("a_soslgq")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_gfilt)

    *--
    IF NOT EMPTY(ln_bperiod)
      ln_start = ln_bperiod
    ELSE
      ln_start = 1
    ENDIF

    IF NOT EMPTY(ln_eperiod)
      ln_end = ln_eperiod
    ELSE
      ln_end = VAL(gc_slsqpd)
    ENDIF

    *-- Scan entire sales group table
    go_SQL.CmpA_soslgq.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_soslgq.m_ScanBulk()

      FOR ln_loop = ln_start TO ln_end

        IF VAL(gc_slsqpd) = 4
          *-- By Quarter
          lc_period = "Q" + ALLTRIM(STR(ln_loop))
        ELSE
          *-- By month, determine character month
          lc_period = LEFT(CMONTH(ld_begdt + ;
                      INT((365/12)*(ln_loop-1)+15)),3)
        ENDIF

        lc_actual = "a_soslgq->aper" + PADL(ALLTRIM(STR(ln_loop)),2,"0")
        lc_quota  = "a_soslgq->qper" + PADL(ALLTRIM(STR(ln_loop)),2,"0")

        go_SQL.m_TableChangeCurrent("a_tmpf7")
        go_SQL.cmpa_tmpf7.m_SQLInsert("id, period, actual, quota, poolpct, type, mnthprd", ;
                                      "a_soslgq->salegrp, " + ;
                                      "'" + lc_period + "', " + ;
                                      lc_actual + ", " + ;
                                      lc_quota + ", " + ;
                                      IIF(&lc_quota <> 0, ;
                                      STR((&lc_actual / &lc_quota) * 100, 3), ;
                                      "0") + ", " + ;
                                      "'G', " + ;
                                      "'" + STR(ln_loop,2,0) + "'")
      NEXT

      go_SQL.m_TableChangeCurrent("a_soslgq")
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  go_SQL.m_TableChangeCurrent("a_tmpf7")
  go_SQL.so_CurrentAlias.m_CreateIndex("tip", "type + id + mnthprd", "", .t., .f.)

  *# DOCCODE REPORT FORM soscqt
  lc_frx = gc_adrvprg + "soscqt"

  *-- Close files if opened here
  IF ln_opnslpq = 2
    go_SQL.cmpA_Soslpq.m_CloseTable()
  ENDIF

  IF ln_opnslgq = 2
    go_SQL.cmpA_Soslgq.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_comrpt8
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_COMRPT9
*------------------------------------------------------------------------------
*- Description: Reports - Creates cursor and defines report for report "9"
*------------------------------------------------------------------------------
*- Synopsis...: Commissions for Items
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_comrpt9

  PRIVATE ln_opnscmd, ;
          ln_opnscmt, ;
          ln_opnscyd, ;
          ln_opnscyt, ;
          ln_opnitem, ;
          lc_cfilt, ;
          lc_hfilt, ;
          lc_ifilt, ;
          ln_rate, ;
          ln_comm

  *-- Initialize locals
  ln_opnscmd = 0
  ln_opnscmt = 0
  ln_opnscyd = 0
  ln_opnscyt = 0
  ln_opnitem = 0
  ln_rate    = 0
  ln_comm    = 0
  lc_cfilt   = "1=1 "
  lc_hfilt   = "1=1 "
  lc_ifilt   = "1=1 "

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

*\ [1 Line] PTR #74741 05/07/04 TISJ Fix for expansion of customer, vendor, item and state
*\                                   in reports
  *-- Create temporary cursor for report set
  go_SQL.m_createTable(go_SQL.m_getTempTableName(7), ;
                       " FREE (plinid C(10), item C(" + TRIM(STR(LEN(gc_ItemPic))) + "), "+ ;
                       " rate N(12,2), comm N(12,2), salesmn C(4), cmethod C(1), sono C(10), " + ;
                       "  type C(1), tdate D, detail L(1)) ", "", "")

  go_SQL.so_CurrentAlias.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(7), "a_tmpf7", .t., .f.)

  *-- Ensure the icitem file can be opened
  ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")

  *-- If item file opened propely
  IF ln_opnitem > 0

    IF NOT EMPTY(lc_plinid)
      lc_ifilt = lc_ifilt + " AND a_icitem->plinid = ??lc_plinid "
    ENDIF

    IF NOT EMPTY(lc_item)
      lc_ifilt = lc_ifilt +  " AND a_icitem->item %=% TRIM(??lc_item) + '%/%' "
    ENDIF

    *-- Apply filter to icitem file
    go_SQL.so_CurrentAlias.m_SetFilter(lc_ifilt)
  ENDIF

  *-- Open Current File if necessary
  IF LEFT(lc_file,1) $ "Current~Both   " AND ln_opnitem > 0
    ln_opnscmd = g_opnfl(gf_soscmdf, "a_soscmd", .f., .f., "")
    ln_opnscmt = g_opnfl(gf_soscmtf, "a_soscmt", .f., .f., "sonsls")
  ENDIF

  *-- Open History File if necessary
  IF LEFT(lc_file,1) $ "History~Both   " AND ln_opnitem > 0
    ln_opnscyd = g_opnfl(gf_soscydf, "a_soscyd", .f., .f., "")
    ln_opnscyt = g_opnfl(gf_soscytf, "a_soscyt", .f., .f., "sonsls")
  ENDIF

  *-- If current file opened, apply filters and process request
  IF ln_opnscmd > 0

    IF lc_range $ "Quarter~Month  " AND NOT EMPTY(ln_bperiod) AND NOT ;
       EMPTY(ln_eperiod)

      *-- If periods defined, convert them to date ranges for filter
      lc_bdate = l_pertodte(1,ln_bperiod)
      lc_edate = l_pertodte(2,ln_eperiod)
    ENDIF

    *-- If beginning date specified, add to filter
    IF NOT EMPTY(STRTRAN(lc_bdate, SET("MARK")))
      ld_fbdate = g_retdt(lc_bdate)
      lc_cfilt = lc_cfilt + " AND tdate >= ??ld_fbdate"
    ENDIF

    *-- If ending date specified, add to filter
    IF NOT EMPTY(STRTRAN(lc_edate, SET("MARK")))
      ld_fedate = g_retdt(lc_edate)
      lc_cfilt = lc_cfilt + " AND tdate <= ??ld_fedate"
    ENDIF

    *-- Exclude unreportable entries (Commissions Pending)
    lc_cfilt = lc_cfilt + " AND NOT EMPTY(tdate) AND status <> 'V'"

    *-- Apply filter to commission detail file
    go_SQL.m_TableChangeCurrent("a_soscmd")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_cfilt)

    *-- Scan trough filtered item file
    go_SQL.m_TableChangeCurrent("a_icitem")

    go_SQL.CmpA_icitem.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_icitem.m_ScanBulk()
      *-- Reset accumulators
      ln_rate = 0
      ln_comm = 0

      *-- If summary type report, accumulate all entries for current
      *-- item and create a single accumulated record
      IF lc_sumdet = "Summary"
        go_SQL.m_TableChangeCurrent("a_soscmd")

        go_SQL.CmpA_soscmd.m_ScanBegin("F", "a_soscmd->item = '" + a_icitem->item + "'")
        DO WHILE go_SQL.CmpA_soscmd.m_ScanBulk()
          ln_rate = a_soscmd->crate
          ln_comm = ln_comm + a_soscmd->comm
        ENDDO
        go_SQL.so_CurrentAlias.m_ScanEnd()

        *-- If commission found for item
        IF ln_comm <> 0
          go_SQL.m_TableChangeCurrent("a_tmpf7")
          go_SQL.cmpa_tmpf7.m_SQLInsert("plinid, item, comm, type, detail", ;
                                           "a_icitem->plinid, a_icitem->item, ln_comm, 'C', gx_False", "")
        ENDIF

      ELSE
        *-- If detail selected, we want to append a record for each
        *-- occurance of a matching item. Note. Detail reports extract
        *-- additional fields that the summary report doesn't
        go_SQL.m_TableChangeCurrent("a_soscmd")

        go_SQL.CmpA_soscmd.m_ScanBegin("F", "a_soscmd->item = '" + a_icitem->item + "'")
        DO WHILE go_SQL.CmpA_soscmd.m_ScanBulk()

          IF a_soscmd->comm <> 0
            go_SQL.m_TableChangeCurrent("a_tmpf7")
            go_SQL.cmpa_tmpf7.m_SQLInsert("plinid, item, rate, comm, salesmn, cmethod, sono, tdate, type, detail", ;
                                             "a_icitem->plinid, a_icitem->item, a_soscmd->crate, a_soscmd->comm, a_soscmd->salesmn, a_soscmd->cmethod, l_gettype('a_soscmt', a_soscmd->sono, a_soscmd->salesmn), a_soscmd->tdate, 'C', gx_True", "")
          ENDIF

          go_SQL.m_TableChangeCurrent("a_soscmd")
        ENDDO
        go_SQL.so_CurrentAlias.m_ScanEnd()

      ENDIF

      go_SQL.m_TableChangeCurrent("a_icitem")
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  *-- If History file opened, do the same thing as above
  IF ln_opnscyd > 0

    *-- If begginning date specified, add to filter
    IF NOT EMPTY(STRTRAN(lc_bdate, SET("MARK")))
      ld_fbdate = g_retdt(lc_bdate)
      lc_cfilt = lc_cfilt + " AND tdate >= ??ld_fbdate"
    ENDIF

    *-- If ending date specified, add to filter
    IF NOT EMPTY(STRTRAN(lc_edate, SET("MARK")))
      ld_fedate = g_retdt(lc_edate)
      lc_cfilt = lc_cfilt + " AND tdate <= ??ld_fedate"
    ENDIF

    *-- Exclude unreportable entries (Commissions Pending)
    lc_cfilt = lc_cfilt + " AND NOT EMPTY(tdate) AND status <> 'V'"

    *-- Apply filter to commission detail file
    go_SQL.m_TableChangeCurrent("a_soscyd")
    go_SQL.so_CurrentAlias.m_SetFilter(lc_cfilt)

    *-- Scan trough filtered item file
    go_SQL.m_TableChangeCurrent("a_icitem")

    go_SQL.CmpA_icitem.m_ScanBegin("F", "")
    DO WHILE go_SQL.CmpA_icitem.m_ScanBulk()
      *-- Reset accumulators
      ln_rate = 0
      ln_comm = 0

      *-- If summary type report, accumulate all entries for current
      *-- item and create a single accumulated record
      IF lc_sumdet = "Summary"
        go_SQL.m_TableChangeCurrent("a_soscyd")

        go_SQL.CmpA_soscyd.m_ScanBegin("F", "a_soscyd->item = ??a_icitem->item")
        DO WHILE go_SQL.CmpA_soscyd.m_ScanBulk()
          ln_rate = a_soscyd->crate
          ln_comm = ln_comm + a_soscyd->comm
        ENDDO
        go_SQL.so_CurrentAlias.m_ScanEnd()

        *-- If commission found for item
        IF ln_comm <> 0
          go_SQL.m_TableChangeCurrent("a_tmpf7")
          go_SQL.cmpa_tmpf7.m_SQLInsert("plinid, item, comm, type, detail", ;
                                           "a_icitem->plinid, a_icitem->item, ln_comm, 'H', gx_False", "")
        ENDIF

      ELSE
        *-- If detail selected, we want to append a record for each
        *-- occurance of a matching item. Note. Detail reports extract
        *-- additional fields that the summary report doesn't
        go_SQL.m_TableChangeCurrent("a_soscyd")

        go_SQL.CmpA_soscyd.m_ScanBegin("F", "a_soscyd->item = ??a_icitem->item")
        DO WHILE go_SQL.CmpA_soscyd.m_ScanBulk()

          IF a_soscyd->comm <> 0
            go_SQL.m_TableChangeCurrent("a_tmpf7")
            go_SQL.cmpa_tmpf7.m_SQLInsert("plinid, item, rate, comm, salesmn, cmethod, sono, tdate, type, detail", ;
                                             "a_icitem->plinid, a_icitem->item, a_soscyd->crate, a_soscyd->comm, a_soscyd->salesmn, a_soscyd->cmethod, l_gettype('a_soscyt', a_soscyd->sono, a_soscyd->salesmn), a_soscyd->tdate, 'H', gx_True", "")
          ENDIF

          go_SQL.m_TableChangeCurrent("a_soscyd")
        ENDDO
        go_SQL.so_CurrentAlias.m_ScanEnd()

      ENDIF

      go_SQL.m_TableChangeCurrent("a_icitem")
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  *-- Browse resulting extract dataset - REMOVE
  go_SQL.m_TableChangeCurrent("a_tmpf7")
  go_SQL.so_CurrentAlias.m_CreateIndex("plitm", "plinid + item", "", .t., .f.)

  IF lc_sumdet = "Summary"
    *# DOCCODE REPORT FORM sosits
    go_SQL.cmpA_Icitem.m_SetOrder("item")
    go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
    lc_frx = gc_adrvprg + "sosits"
  ELSE
    *# DOCCODE REPORT FORM sositd
    lc_frx = gc_adrvprg + "sositd"
  ENDIF

  *-- Close files if opened here
  IF go_SQL.m_IsUsed("a_soscmd") AND ln_opnscmd = Cn_OpenHere
    go_SQL.cmpA_Soscmd.m_CloseTable()
  ENDIF

  IF go_SQL.m_IsUsed("a_soscyd") AND ln_opnscyd = Cn_OpenHere
    go_SQL.cmpA_Soscyd.m_CloseTable()
  ENDIF

  IF go_SQL.m_IsUsed("a_soscmt") AND ln_opnscmt = Cn_OpenHere
    go_SQL.cmpA_Soscmt.m_CloseTable()
  ENDIF

  IF go_SQL.m_IsUsed("a_soscyt") AND ln_opnscyt = Cn_OpenHere
    go_SQL.cmpA_Soscyt.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_comrpt9
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_COMRPTE
*------------------------------------------------------------------------------
*- Description: Reports - Creates cursor and defines report for sales
*-                       people/sales group file listing report "D"
*------------------------------------------------------------------------------
*- Synopsis...: Sales People / Sales Groups defined
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_CLRTX, G_LINCLC
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_bpepl     = Report id
*-              lc_epepl
*-              lc_bgrp
*-              lc_egrp
*-              lc_saletyp
*-              lc_div
*-              lc_terr
*-              lc_dept
*-
*-
*- Parameters.: None
*-
*- Files Open.: SOSLSM - Salesperson file
*-              SOSLMR - Salesperson rate tier
*-              SOSGRP - Sales groups file
*-              SOSLGR - Sales groups rate tier
*------------------------------------------------------------------------------
PROCEDURE l_comrpte

  PRIVATE ln_opnslsm, ;
          ln_opnsgrp, ;
          ln_opnslmr, ;
          ln_opnslgr, ;
          lc_sfilt, ;
          lc_gfilt

  *-- Initialize locals
  ln_opnslsm = 0
  ln_opnsgrp = 0
  ln_opnslmr = 0
  ln_opnslgr = 0
  lc_sfilt   = "1=1 "
  lc_gfilt   = "1=1 "

  LOCAL lc_SQLFilt, ;
        lc_SQLAlias
  lc_SQLFilt= ""
  lc_SQLAlias=""

  *-- Display processing message
  DO g_dspst WITH "Preparing Report...", .t., gn_msgline, "", "", ""

  go_SQL.m_createTable(go_SQL.m_getTempTableName(7), ;
                     " FREE (type C(1), salesmn C(10), saletyp C(1), salegrp C(10), " + ;
                     " fname C(10), lname C(30), tier C(2), " + ;
                     " lrange N(12,2), hrange N(12,2), rate N(9,3)) ", ;
                     "", "")
  go_SQL.so_CurrentAlias.m_CloseTable()

  = g_opnfl(go_SQL.m_getTempTableName(7), "a_tmpf7", .t., .f.)

  *-- Open Salespeople files if necessary
  IF TRIM(lc_include) $ "Salespeople~Both"
    ln_opnslmr = g_opnfl(gf_soslmrf, "a_soslmr", .f., .f., "salesmn")
    ln_opnslsm = g_opnfl(gf_soslsmf, "a_soslsm", .f., .f., "salesmn")
  ENDIF

  *-- If file opened successfully
  IF ln_opnslsm > 0 AND ln_opnslmr > 0

    IF NOT EMPTY(lc_bpepl)
      lc_sfilt = lc_sfilt + " AND a_soslsm->salesmn >= ??lc_bpepl "
    ENDIF

    IF NOT EMPTY(lc_epepl)
      lc_sfilt = lc_sfilt + " AND a_soslsm->salesmn <= ??lc_epepl "
    ENDIF

    IF NOT TRIM(lc_saletyp) = "All"
      lc_sfilt =  lc_sfilt + ;
                 " AND a_soslsm->saletyp = LEFT(??lc_saletyp,1) "
    ENDIF

    IF NOT EMPTY(lc_div)
      lc_sfilt = lc_sfilt + " AND UPPER(a_soslsm->div) = UPPER(??lc_div) "
    ENDIF

    IF NOT EMPTY(lc_terr)
      lc_sfilt = lc_sfilt + " AND UPPER(a_soslsm->terr) %=% UPPER(TRIM(??lc_terr)) + '%/%' "
    ENDIF

    IF NOT EMPTY(lc_dept)
      lc_sfilt = lc_sfilt + " AND UPPER(a_soslsm->dept) = UPPER(??lc_dept) "
    ENDIF

    IF NOT EMPTY(lc_bgrp)
      lc_sfilt = lc_sfilt + " AND a_soslsm->salegrp >= ??lc_bgrp "
    ENDIF

    IF NOT EMPTY(lc_egrp)
      lc_sfilt = lc_sfilt + " AND a_soslsm->salegrp <= ??lc_egrp "
    ENDIF

    *-- Setup relation into rate table
    go_SQL.m_TableChangeCurrent("a_soslsm")
    go_SQL.cmpA_soslsm.m_SetOrder("salesmn")
    go_SQL.cmpA_soslsm.m_SetFilter(lc_sfilt)

    *-- Include rate tiers
    IF lc_tiers = "Y"
      *-- Set skip to include salesperson rate tiers
      go_SQL.m_TableChangeCurrent("a_soslmr")
      go_SQL.cmpA_soslmr.m_SetOrder("salesmn")
      go_SQL.cmpA_soslmr.m_SetRelation("salesmn", "a_soslsm", .f.)
      lc_SQLFilt = go_SQL.cmpA_soslmr.m_GetFilter()
      lc_SQLFilt = lc_SQLFilt + ;
                   IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                   " NOT go_SQL.cmpA_soslsm.m_IsEof()"
      go_SQL.cmpA_soslmr.m_SetFilter(lc_SQLFilt)
    ELSE
      go_SQL.cmpA_soslsm.m_SetRelation("salesmn", "a_soslmr", .f.)
    ENDIF

    *-- Scan salesperson table, append records to cursor if tier records
    lc_SQLAlias = ALIAS()
    go_SQL.so_CurrentAlias.m_ScanBegin("F", "")

    DO WHILE go_SQL.so_CurrentAlias.m_ScanBulk()

      IF NOT go_SQL.cmpA_soslsm.m_IsEof()
        go_SQL.m_TableChangeCurrent("a_tmpf7")
        go_SQL.cmpA_tmpf7.m_SQLInsert("type, salesmn, saletyp, salegrp, fname, lname", ;
                                      "'P', a_soslsm->salesmn, a_soslsm->saletyp, a_soslsm->salegrp, a_soslsm->fname, a_soslsm->lname", "")

        *-- Include rate tier information
        IF lc_tiers = "Y"
          *-- Include tier rates
          go_SQL.cmpA_tmpf7.m_ReplaceBulk(" tier    WITH a_soslmr->tier, " + ;
                                          " lrange  WITH a_soslmr->lrange,  " + ;
                                          " hrange  WITH a_soslmr->hrange,  " + ;
                                          " rate    WITH a_soslmr->rate")
        ELSE
          *-- No tier information included
          go_SQL.cmpA_tmpf7.m_ReplaceBulk(" tier    WITH SPACE(2),  " + ;
                                          " lrange  WITH 0,  " + ;
                                          " hrange  WITH 0,  " + ;
                                          " rate    WITH 0")
        ENDIF

        go_SQL.m_TableChangeCurrent(lc_SQLAlias)

      ENDIF

    ENDDO

    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  *-- Open Sales Group Files if necessary
  IF TRIM(lc_include) $ "Sales Groups~Both"
    ln_opnslgr = g_opnfl(gf_soslgrf, "a_soslgr", .f., .f., "salegrp")
    ln_opnsgrp = g_opnfl(gf_sosgrpf, "a_sosgrp", .f., .f., "salegrp")
  ENDIF

  *-- If files opened successfully
  IF ln_opnsgrp > 0 AND ln_opnslgr > 0

    IF NOT EMPTY(lc_bgrp)
      lc_gfilt = lc_gfilt + " AND a_sosgrp->salegrp >= ??lc_bgrp "
    ENDIF

    IF NOT EMPTY(lc_egrp)
      lc_gfilt = lc_gfilt + " AND a_sosgrp->salegrp <= ??lc_egrp "
    ENDIF

    *-- Setup relation into rate table
    go_SQL.m_TableChangeCurrent("a_sosgrp")
    go_SQL.cmpa_sosgrp.m_SetOrder("salegrp")
    go_SQL.cmpa_sosgrp.m_SetFilter(lc_gfilt)

    *-- Include rate tiers
    IF lc_tiers = "Y"
      *-- Set skip to include salesperson rate tiers
      go_SQL.m_TableChangeCurrent("a_soslgr")
      go_SQL.cmpA_soslgr.m_SetOrder("salegrp")
      go_SQL.cmpA_soslgr.m_SetRelation("salegrp", "a_sosgrp", .f.)
      lc_SQLFilt = go_SQL.cmpA_soslgr.m_GetFilter()
      lc_SQLFilt = lc_SQLFilt + ;
                   IIF(EMPTY(lc_SQLFilt), "", " AND ") + ;
                   " NOT go_SQL.cmpa_sosgrp.m_IsEof()"
      go_SQL.cmpA_soslgr.m_SetFilter(lc_SQLFilt)
    ELSE
      go_SQL.cmpa_sosgrp.m_SetRelation("salegrp", "a_soslgr", .f.)
    ENDIF

    *-- Scan sales groups table, append records to cursor
    lc_SQLAlias = ALIAS()
    go_SQL.so_CurrentAlias.m_ScanBegin("F", "")

    DO WHILE go_SQL.so_CurrentAlias.m_ScanBulk()
      IF NOT(lc_tiers = "Y" AND go_SQL.cmpa_sosgrp.m_IsEof())

        go_SQL.m_TableChangeCurrent("a_tmpf7")
        go_SQL.cmpa_tmpf7.m_SQLInsert("type, salegrp, saletyp, salesmn, fname, lname", ;
                                         "'G', a_sosgrp->salegrp, SPACE(0), SPACE(0), SPACE(0), a_sosgrp->grpname", "")

        *-- Include rate tier information
        IF lc_tiers = "Y"
        *-- Include tier rates
          go_SQL.cmpa_tmpf7.m_ReplaceBulk(" tier    WITH a_soslgr->tier,  " + ;
                                          " lrange  WITH a_soslgr->lrange,  " + ;
                                          " hrange  WITH a_soslgr->hrange,  " + ;
                                          " rate    WITH a_soslgr->rate")
        ELSE
        *-- No tier information included
          go_SQL.cmpa_tmpf7.m_ReplaceBulk(" tier    WITH SPACE(2),  " + ;
                                          " lrange  WITH 0,  " + ;
                                          " hrange  WITH 0, rate    WITH 0")
        ENDIF

      ENDIF
      go_SQL.m_TableChangeCurrent(lc_SQLAlias)
    ENDDO
    go_SQL.so_CurrentAlias.m_ScanEnd()

  ENDIF

  go_SQL.m_TableChangeCurrent("a_tmpf7")
  go_SQL.so_CurrentAlias.m_CreateIndex("tst", "type + salesmn + tier", "", .t., .f.)
  go_SQL.so_CurrentAlias.m_SetOrder("tst")

  *# DOCCODE REPORT FORM soslst
  lc_frx = gc_adrvprg + "soslst"

  *-- Close files if opened here
  IF ln_opnslsm = 2
    go_SQL.cmpA_Soslsm.m_CloseTable()
  ENDIF

  IF ln_opnsgrp = 2
    go_SQL.cmpA_Sosgrp.m_CloseTable()
  ENDIF

  IF ln_opnslmr = 2
    go_SQL.cmpA_Soslmr.m_CloseTable()
  ENDIF

  IF ln_opnslgr = 2
    go_SQL.cmpA_Soslgr.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_comrpte
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SETFLT
*------------------------------------------------------------------------------
*- Description: Checks string length against macro maximum & sets filter
*------------------------------------------------------------------------------
PROCEDURE l_setflt

  *-- Check string length against macro limit & set filter
  DO CASE
    CASE LEN(lc_filt) > 510
      lc_filt1 = LEFT(lc_filt,255)
      lc_filt2 = SUBSTR(lc_filt,256,255)
      lc_filt3 = SUBSTR(lc_filt,512,LEN(lc_filt))
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt1 + lc_filt2 + lc_filt3)

    CASE LEN(lc_filt) > 255
      lc_filt1 = LEFT(lc_filt,255)
      lc_filt2 = SUBSTR(lc_filt,256,LEN(lc_filt))
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt1 + lc_filt2)

    OTHERWISE
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)
  ENDCASE

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_setflt
*------------------------------------------------------------------------------


*------------------------------------------------------------------------------
*- Procedure..: L_GETSHP
*------------------------------------------------------------------------------
*- Description: Calls shipment calculation routines l_VFPgetshp /l_SQLgetshp
*-              l_VFPgetshp - During VFP mode
*-              l_SQLgetshp - During SQL mode
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_getshp

  *--This routine has been specially optimised by some hard coding
  IF go_Sql.sc_SqlTypeMain = "F"
    DO l_VFPgetshp
  ELSE
    DO l_SQLgetshp
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_getshp
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_SLSPEPL
*------------------------------------------------------------------------------
*- Description: Select and validate salespeople
*------------------------------------------------------------------------------
*- Synopsis...: Enter Salesperson number or select from list ,
*-              lc_rept = "7"
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pc_var - name of variable to validate
*------------------------------------------------------------------------------
*- Returns: .t.
*------------------------------------------------------------------------------
FUNCTION v_slspepl

PARAMETERS pc_var, ;
           pc_type

  PRIVATE lc_person, ;
          ln_trykey, ;
          lc_brwlst, ;
          ln_opnsls, ;
          lc_var2

  *-- Initialize locals
  lc_person = SPACE(0)
  ln_trykey = 0
  lc_brwlst = SPACE(0)
  ln_opnsls = 0
  lc_var2   = SPACE(0)

  *-- Determine value to validate
  lc_person = &pc_var
  lc_brwlst = [salesmn  :H = "Salesperson",]   + ;
              [saletyp  :H = "Classification",] + ;
              [fname    :H = "First Name",]     + ;
              [lname    :H = "Last Name" ]

  IF TYPE('pc_type') = "C" AND pc_type $ "ECN"
    lc_brwlst = lc_brwlst + [FOR saletyp == pc_type]
  ENDIF

  *-- Attempt to open ARCUST file
  ln_opnsls = g_opnfl(gf_soslsmf, "a_soslsm", .f., .f.)

  *-- If Unable to open arcust, blank out field
  IF ln_opnsls = 0
    lc_person = SPACE(4)
  ENDIF

  *-- Empty value for all customers OK
  IF NOT EMPTY(lc_person)
    *-- Attempt to validate the customer entered

    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_SALESPERSON"

      .sc_Key               = lc_person

      .sl_List              = .t.

      .sc_Alias             = "a_soslsm"
      .sc_Order             = "salesmn"
      .sc_KeyDescription    = "Salesperson"
      .sc_ValueToReturn     = "SalesMn"

      ln_trykey = .m_Run()
      *--Return value
      lc_person = .rx_ReturnValue
    ENDWITH

  ELSE
    ln_trykey = 1
  ENDIF

  *-- Case trykey result
  DO CASE
    CASE ln_trykey > 0
      STORE lc_person TO (pc_var)

      IF pc_var = "lc_bpepl"
        lc_var2 = "lc_epepl"
        STORE lc_person TO (lc_var2)
        SHOW GET &lc_var2
      ENDIF

      SHOW GET &pc_var

    OTHERWISE
      STORE SPACE(10) TO &pc_var
      SHOW GET &pc_var
      _CUROBJ = _CUROBJ
  ENDCASE

  *-- If ARCUST opened here, close it
  IF ln_opnsls = 2
    go_SQL.cmpA_Soslsm.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_slspepl()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_VSLSGRP
*------------------------------------------------------------------------------
*- Description: Select and validate sales groups
*------------------------------------------------------------------------------
*- Synopsis...: Enter SalesGroup number or select from list ,
*-              lc_rept = "7"
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pc_var - name of variable to validate
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION v_slsgrp

PARAMETERS pc_var

  PRIVATE lc_group, ;
          ln_trykey, ;
          lc_brwlst, ;
          ln_opngrp, ;
          lc_var2

  *-- Initialize locals
  lc_group = SPACE(0)
  ln_trykey = 0
  lc_brwlst = SPACE(0)
  ln_opngrp = 0
  lc_var2   = SPACE(0)

  *-- Determine value to validate
  lc_group = &pc_var
  lc_brwlst = [salegrp  :H = "Sales Group",]   + ;
              [grpname  :H = "Group Name"]

  *-- Attempt to open ARCUST file
  ln_opngrp = g_opnfl(gf_sosgrpf, "a_sosgrp", .f., .f.)

  *-- If Unable to open arcust, blank out field
  IF ln_opngrp = 0
    lc_group = SPACE(4)
  ENDIF

  *-- Empty value for all customers OK
  IF NOT EMPTY(lc_group)
    *-- Attempt to validate the customer entered
    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_SALESGROUP"

      .sc_Key               = lc_group
      .sl_List              = .t.

      .sc_Alias             = "a_sosgrp"
      .sc_Order             = "salegrp"
      .sc_KeyDescription    = "Sales group"
      .sc_ValueToReturn     = "salegrp"

      ln_trykey = .m_Run()
      lc_group = .rx_ReturnValue

    ENDWITH
  ELSE
    ln_trykey = 1
  ENDIF

  *-- Case trykey result
  DO CASE
    CASE ln_trykey > 0
      STORE lc_group TO (pc_var)

      IF pc_var = "lc_bgrp"
        lc_var2 = "lc_egrp"
        STORE lc_group TO (lc_var2)
        SHOW GET &lc_var2
      ENDIF

      SHOW GET &pc_var

    OTHERWISE
      STORE SPACE(4) TO &pc_var
      SHOW GET &pc_var
      _CUROBJ = _CUROBJ
  ENDCASE

  *-- If ARCUST opened here, close it
  IF ln_opngrp = 2
    go_SQL.cmpA_Sosgrp.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_slsgrp()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_INCLUDE
*------------------------------------------------------------------------------
*- Description: Validates select field for rept = "7'
*------------------------------------------------------------------------------
*- Synopsis...: Clears lc_bpepl, lc_epepl, lc_bgrp, lc_egrp
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION v_include

PARAMETERS pc_rpt

  DO CASE
    CASE pc_rpt $ "78D"

      IF lc_include = "Sales Groups"
        lc_bpepl = SPACE(4)
        lc_epepl = SPACE(4)
        SHOW GET lc_bpepl
        SHOW GET lc_epepl

        IF pc_rpt = "D"
          lc_saletyp = "All" + SPACE(13)
          lc_div     = SPACE(10)
          lc_terr    = SPACE(10)
          lc_dept    = SPACE(10)
          SHOW GET lc_saletyp
          SHOW GET lc_div
          SHOW GET lc_terr
          SHOW GET lc_dept
        ENDIF

      ENDIF

      IF lc_include = "Salespeople"
        lc_bgrp = SPACE(4)
        lc_egrp = SPACE(4)
        SHOW GET lc_bgrp
        SHOW GET lc_egrp
      ENDIF

  ENDCASE

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_include()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_PLINID
*------------------------------------------------------------------------------
*- Description: Validates product line for rept = "9"
*------------------------------------------------------------------------------
*- Synopsis...: Validates product line specified in option grid
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION v_plinid

  PRIVATE ln_trykey, ;
          ln_opnpln, ;
          lc_brwlst

  *-- Initialize locals
  ln_trykey = 0
  ln_opnpln = 0
  lc_brwlst = SPACE(0)

  *-- Determine value to validate
  lc_brwlst = [plinid   :H = "Product Line",]   + ;
              [plndesc  :H = "Product Line Description"]

  *-- Attempt to open ARCUST file
  ln_opnpln = g_opnfl(gf_icplinf, "a_icplin", .f., .f.)

  *-- If Unable to open arcust, blank out field
  IF ln_opnpln = 0
    lc_plinid  = SPACE(4)
  ENDIF

  *-- Empty value for all customers OK
  IF NOT EMPTY(lc_plinid)
    *-- Attempt to validate the customer entered
    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_ICPLIN"

      .sc_Key               = lc_plinid
      .sl_List              = .t.

      .sc_Alias             = "a_icplin"
      .sc_Order             = "plinid"
      .sc_KeyDescription    = "Product Line"
      .sc_ValueToReturn     = "plinid"

      .so_sql               = go_sql
      ln_trykey = .m_Run()
      lc_plinid = .rx_ReturnValue

    ENDWITH
  ELSE
    ln_trykey = 1
  ENDIF

  *-- Case trykey result
  DO CASE
    CASE ln_trykey > 0
      SHOW GET lc_plinid

    OTHERWISE
      STORE SPACE(10) TO lc_plinid
      _CUROBJ = _CUROBJ
  ENDCASE

  *-- If ARCUST opened here, close it
  IF ln_opnpln = 2
    go_SQL.cmpA_Icplin.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_plinid()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_SALETYP
*------------------------------------------------------------------------------
*- Description: Clears customer range when saletyp modified for rept = "D"
*------------------------------------------------------------------------------
*- Synopsis...: Clears customer range when saletyp modified for rept = "D"
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns: .t.
*------------------------------------------------------------------------------
FUNCTION v_saletyp

  PRIVATE ln_opnsls

  *-- Initialize locals
  ln_opnsls = 0

  *-- If ALL not selected verify that existing customers selected match the
  *-- saletyp specified
  IF LEFT(lc_saletyp,1) <> "A"
    *-- Attempt to open ARCUST file
    ln_opnsls = g_opnfl(gf_soslsmf, "a_soslsm", .f., .f.)

    *-- If Unable to open arcust, blank out field
    IF ln_opnsls = 0
      STORE SPACE(4) TO lc_bpepl
      STORE SPACE(4) TO lc_epepl
    ELSE

      IF NOT EMPTY(lc_bpepl)
        go_SQL.so_CurrentAlias.m_Locate("FOR salesmn == lc_bpepl")

        IF NOT go_SQL.so_CurrentAlias.m_IsFound() OR saletyp <> LEFT(lc_saletyp,1)
          STORE SPACE(4) TO lc_bpepl
        ENDIF

      ENDIF

      IF NOT EMPTY(lc_epepl)
        go_SQL.so_CurrentAlias.m_Locate("FOR salesmn == lc_epepl")

        IF NOT go_SQL.so_CurrentAlias.m_IsFound() OR saletyp <> LEFT(lc_saletyp,1)
          STORE SPACE(4) TO lc_epepl
        ENDIF

      ENDIF

    ENDIF &&file opend successfully

  ENDIF && If lc_saletyp not "A"

  *-- Refresh Gets
  SHOW GET lc_bpepl
  SHOW GET lc_epepl

  *-- Close file if opened here
  IF ln_opnsls = 2
    go_SQL.cmpA_Soslsm.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_include()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_ITEM
*------------------------------------------------------------------------------
*- Description: Validates an item on the option grid for report "9"
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION v_item

  PRIVATE ln_trykey, ;
          ln_opnitm, ;
          lc_brwlst

  *-- Initialize locals
  ln_trykey = 0
  ln_opnitm = 0
  lc_brwlst = SPACE(0)

  *-- Determine value to validate
  lc_brwlst = [item    :H = "Item",]   + ;
              [itmdesc :H = "Item Description"]

  *-- Attempt to open ARCUST file
  ln_opnitm = g_opnfl(gf_icitemf, "a_icitem", .f., .f.)

  *-- If Unable to open arcust, blank out field
  IF ln_opnitm = 0
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
    lc_item = SPACE(LEN(gc_itempic))
  ENDIF

  *-- Empty value for all customers OK
  IF NOT EMPTY(lc_item)
    *-- Attempt to validate the customer entered
    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_ITEM"

      .sc_Key               = lc_item
      .sl_List              = .t.

      .sc_Alias             = "a_icitem"
      .sc_Order             = "item"
      .sc_KeyDescription    = "Item"
      .sc_ValueToReturn     = "item"

      ln_trykey = .m_Run()
      *--Return Value
      lc_item = .rx_ReturnValue

    ENDWITH
  ELSE
    ln_trykey = 1
  ENDIF

  *-- Case trykey result
  DO CASE
    CASE ln_trykey > 0
      SHOW GET lc_item

    OTHERWISE
*\ [1 Line] PTR None 01/23/04 TISM Set length of item dynamically
      STORE SPACE(LEN(gc_itempic)) TO lc_item
      _CUROBJ = _CUROBJ
  ENDCASE

  *-- If ARCUST opened here, close it
  IF ln_opnitm = 2
    go_SQL.cmpA_Icitem.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_item()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_DETPRD
*------------------------------------------------------------------------------
*- Description: Determines default period based upon current date and
*-              commission setup periods
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pd_date,
*------------------------------------------------------------------------------
*- Returns:  Returns current period as character expression
*------------------------------------------------------------------------------
FUNCTION l_detprd

PARAMETERS pd_date

  PRIVATE ln_return, ;
          lc_return

  *-- Initialize locals
  ln_return = 0
  lc_return = SPACE(0)

  *-- Determine month based upon date passed
  ln_month = MONTH(pd_date)

  *-- Detemriine current period based upon number of periods defined for
  *-- sales commission
  IF gc_slstrb = Cc_PrdTierBasis OR gc_slstrb = Cc_YrTierBasis
    ln_return = ln_month
  ELSE

    DO CASE
      CASE BETWEEN(ln_month,1,3)
        ln_return = 1

      CASE BETWEEN(ln_month,4,6)
        ln_return = 2

      CASE BETWEEN(ln_month,7,9)
        ln_return = 3

      CASE BETWEEN(ln_month,10,12)
        ln_return = 4

    ENDCASE

  ENDIF

RETURN ln_return
*------------------------------------------------------------------------------
*- End Function...: l_detprd()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_PERIOD
*------------------------------------------------------------------------------
*- Description: Validates the period entered for commission reports
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns: Returns current period as character expression
*------------------------------------------------------------------------------
FUNCTION v_period

  PRIVATE ll_return

  *-- Initialize locals
  ll_return = .f.

  *-- If validating the beginning period
  IF UPPER(g_curvar()) = "LN_BPERIOD"

    *-- Empty period is valid
    IF EMPTY(ln_bperiod)
      ll_return = .t.
    ELSE

      IF gc_slsqpd = "12"

        IF BETWEEN(ln_bperiod,1,12)
          ll_return = .t.
        ELSE
          ll_return = .f.
          DO g_dspalt WITH "Period value must fall between 01 and 12", 3
        ENDIF

      ELSE

        IF BETWEEN(ln_bperiod,1,4)
          ll_return = .t.
        ELSE
          ll_return = .f.
          DO g_dspalt WITH "Period value must fall between 01 and 04", 3
        ENDIF

      ENDIF

    ENDIF

  ENDIF

  *-- If validating the ending period
  IF UPPER(g_curvar()) = "LN_EPERIOD"

    *-- Empty period is valid
    IF EMPTY(ln_eperiod)
      ll_return = .t.
    ELSE

      IF gc_slsqpd = "12"

        IF BETWEEN(ln_eperiod,1,12)

          IF ln_eperiod < ln_bperiod
            DO g_dspalt WITH "Ending period cannot be less than " + ;
                             "beginning period", 3

            ll_return = .f.
          ELSE
            ll_return = .t.
          ENDIF

        ELSE
          ll_return = .f.
          DO g_dspalt WITH "Period value must fall between 01 and 12", 3
        ENDIF

      ELSE

        IF BETWEEN(ln_eperiod,1,4)

          IF ln_eperiod < ln_bperiod
            DO g_dspalt WITH "Ending period cannot be less than " + ;
                             "beginning period", 3

            ll_return = .f.
          ELSE
            ll_return = .t.
          ENDIF

        ELSE
          ll_return = .f.
          DO g_dspalt WITH "Period value must fall between 01 and 04", 3
        ENDIF

      ENDIF

    ENDIF

  ENDIF

RETURN ll_return
*------------------------------------------------------------------------------
*- End Function...: v_period()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_TRBRNG
*------------------------------------------------------------------------------
*- Synopsis...: Validates tier basis range for sales commission reports:
*-              commission due and commission for items.
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:  Returns current period as character expression
*------------------------------------------------------------------------------
FUNCTION v_trbrng

  PRIVATE ll_return

  *-- Initialize locals
  ll_return = .f.

  *-- If validating the beginning period
  IF UPPER(g_curvar()) = "LN_BPERIOD"

    IF gc_slstrb = Cc_PrdTierBasis OR gc_slstrb = Cc_YrTierBasis

      IF BETWEEN(ln_bperiod,1,12)
        ll_return = .t.
      ELSE
        ll_return = .f.
        DO g_dspalt WITH "Period value must fall between 01 and 12", 3
      ENDIF

    ELSE

      IF BETWEEN(ln_bperiod,1,4)
        ll_return = .t.
      ELSE
        ll_return = .f.
        DO g_dspalt WITH "Period value must fall between 01 and 04", 3
      ENDIF

    ENDIF

  ENDIF

  *-- If validating the ending period
  IF UPPER(g_curvar()) = "LN_EPERIOD"

    IF gc_slstrb = Cc_PrdTierBasis OR gc_slstrb = Cc_YrTierBasis

      IF BETWEEN(ln_eperiod,1,12)

        IF ln_eperiod < ln_bperiod
          DO g_dspalt WITH "Ending period cannot be less than " + ;
                           "beginning period", 3

          ll_return = .f.
        ELSE
          ll_return = .t.
        ENDIF

      ELSE
        ll_return = .f.
        DO g_dspalt WITH "Period value must fall between 01 and 12", 3
      ENDIF

    ELSE

      IF BETWEEN(ln_eperiod,1,4)

        IF ln_eperiod < ln_bperiod
          DO g_dspalt WITH "Ending period cannot be less than " + ;
                           "beginning period", 3

          ll_return = .f.
        ELSE
          ll_return = .t.
        ENDIF

      ELSE
        ll_return = .f.
        DO g_dspalt WITH "Period value must fall between 01 and 04", 3
      ENDIF

    ENDIF

  ENDIF

RETURN ll_return
*------------------------------------------------------------------------------
*- End Function...: V_TRBRNG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: V_RANGE
*------------------------------------------------------------------------------
*- Description: Validates the range selected for commission reports
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:  Returns current period as character expression
*------------------------------------------------------------------------------
FUNCTION v_range

  DO CASE
    CASE TRIM(lc_range) = "Quarter" OR TRIM(lc_range) = "Month"
      lc_bdate = Cc_NullDate
      lc_edate = Cc_NullDate
      *-- Changed current date into system date
      ln_bperiod = l_detprd(gd_sdate)
      ln_eperiod = ln_bperiod
      lc_file    = "Current"

    CASE TRIM(lc_range) = "Range"
      ln_bperiod = 0
      ln_eperiod = 0

    OTHERWISE
      lc_bdate = Cc_NullDate
      lc_edate = Cc_NullDate
      ln_bperiod = 0
      ln_eperiod = 0
  ENDCASE

  SHOW GET lc_bdate
  SHOW GET lc_edate
  SHOW GET ln_bperiod
  SHOW GET ln_eperiod
  SHOW GET lc_file

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_range()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: l_pertodte
*------------------------------------------------------------------------------
*- Description: Returns a date value for a period entered
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pn_prdtyp    - Period type, 1 = start, 2 = end
*-              pn_period    - period or quarter to convert to date
*------------------------------------------------------------------------------
*- Returns:  Returns current period as character expression
*------------------------------------------------------------------------------
FUNCTION l_pertodte

PARAMETERS pn_prdtyp, ;
           pn_period

  PRIVATE lc_date, ;
          ln_month, ;
          lc_tmpdate, ;
          ln_period

  *-- Initialize locals
  lc_date    = SPACE(08)
  ln_month   = 0
  lc_tmpdate = ""
  ln_period  = 0

  *-- If period is 0, assign default value
  IF pn_period = 0

    IF pn_prdtyp = 1
      *-- Start of period or quarter
      ln_period = 1
    ELSE
      *-- End of period or quarter
      ln_period = IIF(gc_slstrb = Cc_PrdTierBasis,4,12)
    ENDIF

  ENDIF && pn_period = 0

  IF gc_slstrb = Cc_PrdTierBasis OR gc_slstrb = Cc_YrTierBasis
    *-- Tiers based on period or year

    IF pn_prdtyp = 1
      *-- Find starting date for
      lc_month =  PADL(ALLTRIM(STR(pn_period,2,0)),2,"0")

      lc_date  = DTOC(g_cnvdt(lc_month + "/01/" + ;
                 ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))
    ELSE
      *-- Find ending date for year or period
      lc_month =  PADL(ALLTRIM(STR(pn_period,2,0)),2,"0")

      *-- Find last day in month
      IF lc_month = "12"
        *-- Special case for December
        lc_date = DTOC(g_cnvdt(lc_month + "/31/" + ;
                  ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))
      ELSE
        *-- All other months
        lc_month = PADL(ALLTRIM(STR(pn_period + 1,2,0)),2,"0")

        *-- Determine first day of next month
        lc_tmpdate = DTOC(g_cnvdt(lc_month + "/01/" + ;
                     ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))

        *-- Substract 1 day from lc_tmpdate to get last day of month
        lc_date = DTOC(g_retdt(CTOD(lc_tmpdate))-1)
      ENDIF

    ENDIF && pn_prdtyp = 1

  ELSE
    *-- Tiers based quarter

    IF pn_prdtyp = 1
      *-- Find starting date for quarter
      lc_month =  PADL(ALLTRIM(STR((pn_period*3)-2,2,0)),2,"0")

      lc_date = DTOC(g_cnvdt(lc_month + "/01/" + ;
                ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))
    ELSE

      *-- Find ending date for quarter
      lc_month =  PADL(ALLTRIM(STR(pn_period * 3,2,0)),2,"0")

      *-- Find last day in month
      IF lc_month = "12"
        *-- Special case for December
        lc_date = DTOC(g_cnvdt(lc_month + "/31/" + ;
                  ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))
      ELSE
        *-- All other months
        lc_month = PADL(ALLTRIM(STR((pn_period*3) + 1,2,0)),2,"0")

        *-- Determine first day of next month
        lc_tmpdate = DTOC(g_cnvdt(lc_month + "/01/" + ;
                     ALLTRIM(RIGHT(STR(YEAR(gd_sdate),4,0),2))))

        *-- Substract 1 day from lc_tmpdate to get last day of month
        lc_date = DTOC(g_retdt(CTOD(lc_tmpdate))-1)
      ENDIF

    ENDIF && pn_prdtyp = 1

  ENDIF && gc_slstrb = Cc_PrdTierBasis...

RETURN(lc_date)
*------------------------------------------------------------------------------
*- End Function...: l_pertodte()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: v_scope
*------------------------------------------------------------------------------
*- Description: CLears grid vars based upon current history both selection
*-             for Report #9
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: None
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION v_scope

  IF lc_file $ "History~Both   "
    lc_range = "Range "
    ln_eperiod = 0
    ln_bperiod = 0
  ENDIF

  SHOW GET lc_range
  SHOW GET ln_bperiod
  SHOW GET ln_eperiod

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: v_scope()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_VALCUST()
*------------------------------------------------------------------------------
*- Synopsis...: Validates the customer number.
*------------------------------------------------------------------------------
*- Calls......: g_trykey()
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_custno
*-
*- Files Open.: a_arcust
*------------------------------------------------------------------------------
*- Returns:
*- Value......:  .t. if variables are valid
*------------------------------------------------------------------------------
FUNCTION l_valcust

  PRIVATE ll_return
  ll_return = .f.


  LOCAL lc_SQLCustno
  lc_SQLCustno = lc_custno

  IF EMPTY(lc_custno)
    ll_return = .t.

  ELSE

    LOCAL ln_trykey

    ln_trykey = 0
    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_CUST"

      .sc_Key               = TRIM(lc_custno)
      .sl_List              = (.t.)

      .sc_Alias             = "a_arcust"
      .sc_Order             = "custno"
      .sc_KeyDescription    = "customer"
      .sc_ValueToReturn     = "custno"

      ln_trykey = .m_Run()
      lc_SQLCustno = .rx_ReturnValue

    ENDWITH

    IF ln_trykey > 0

      IF a_arcust->custno <> TRIM(lc_custno)
        lc_custno = a_arcust->custno
      ENDIF

      ll_return = .t.
    ELSE

      IF LEFT(lc_custno, 1) = "?"
        *-- Clear "?"
        KEYBOARD "{CTRL+Y}" PLAIN
      ELSE
         lc_custno = ""
      ENDIF

    ENDIF

  ENDIF && EMPTY(lc_custno)

RETURN (ll_return)
*------------------------------------------------------------------------------
*- End Function...: l_valcust()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_VALPO()
*------------------------------------------------------------------------------
*- Synopsis...: Validates the PO number. If valid PO number
*-              is not entered alerts the user. If <F2> is pressed pick
*-              list will be displayed
*------------------------------------------------------------------------------
*- Calls......: g_dspalt(), g_selkey()
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_custno, lc_pono, lc_file
*------------------------------------------------------------------------------
*- Returns:
*- Value..: .t. if variables are valid
*------------------------------------------------------------------------------
FUNCTION l_valpo

  PRIVATE ll_return, ;
          lc_prefix, ;
          ll_list, ;
          lc_srchfil, ;
          lc_ordmst, ;
          lc_ordyms, ;
          ll_test, ;
          ln_area, ;
          lc_ftmast, ;
          lc_ftymst

  ll_return  = .f.
  ll_list    = (LEFT(lc_pono, 1) = "?")
  ln_area    = SELECT(0)
  lc_ftmast  = ""
  lc_ftymst  = ""

  IF go_SQL.m_IsUsed("a_somast")
    go_SQL.m_TableChangeCurrent("a_somast")
    go_SQL.so_CurrentAlias.m_SetFilter("")
  ENDIF

  IF go_SQL.m_IsUsed("a_soymst")
    go_SQL.m_TableChangeCurrent("a_soymst")
    go_SQL.so_CurrentAlias.m_SetFilter("")
  ENDIF

  go_SQL.m_TableChangeCurrent(ln_area)

  *-- PO number not entered
  IF EMPTY(lc_pono)
    ll_return = .t.
  ELSE
    *-- Open files
    lc_ordmst = IIF(go_SQL.m_IsUsed("a_somast"), go_SQL.cmpA_Somast.m_GetOrder(), "")
    lc_ordyms = IIF(go_SQL.m_IsUsed("a_soymst"), go_SQL.cmpA_Soymst.m_GetOrder(), "")

    *-- File open based on if condition
    IF go_SQL.m_IsUsed("a_somast")
      go_SQL.m_TableChangeCurrent("a_somast")
    ELSE
      = g_opnfl(gf_somastf, "a_somast", .f., .f.)
    ENDIF

    *-- Clear current filtering of PO's
    go_SQL.so_CurrentAlias.m_SetFilter("")

    IF go_SQL.m_IsUsed("a_soymst")
      go_SQL.m_TableChangeCurrent("a_soymst")
    ELSE
      = g_opnfl(gf_soymstf, "a_soymst", .f., .f.)
    ENDIF

    *-- Clear current filtering of PO's
    go_SQL.so_CurrentAlias.m_SetFilter("")

    *-- Determine sort order and search prefix
    IF NOT EMPTY(lc_custno)
      go_SQL.cmpA_Somast.m_SetOrder("custno2")
      go_SQL.cmpA_Soymst.m_SetOrder("custno2")
      lc_prefix = TRIM(lc_custno)
    ELSE
      go_SQL.cmpA_Somast.m_SetOrder("ponum1")
      go_SQL.cmpA_Soymst.m_SetOrder("ponum1")
      lc_prefix = ""
    ENDIF

    IF NOT ll_list

      *-- Search for PO
      IF lc_file = "Both"
        ll_return = go_SQL.cmpA_Somast.m_Seek(lc_prefix, "") OR go_SQL.cmpA_Soymst.m_Seek(lc_prefix, "")
      ELSE
        ll_return = IIF(lc_file = "History", ;
                                  go_SQL.cmpA_soymst.m_Seek(lc_prefix, ""), ;
                                  go_SQL.cmpA_somast.m_Seek(lc_prefix, ""))
      ENDIF

      *-- If not found
      IF NOT ll_return
        *-- Alert user
        lc_msg = "PO number " + ALLTRIM(lc_pono) + " not found"

        IF NOT EMPTY(lc_custno)
          lc_msg = lc_msg + " for customer " + ALLTRIM(lc_custno)
        ENDIF

        IF lc_file <> "Both"
          lc_msg = lc_msg + gc_oseol + "in " + LOWER(TRIM(lc_file)) + " file."
        ELSE
          lc_msg = lc_msg + "."
        ENDIF

        ll_list = (g_getdlg(lc_msg, 2, 1, "List", "Reenter") = 1)
      ENDIF && NOT SEEK(lc_prefix + lc_pono, "a_somast")

    ENDIF && NOT ll_list

    *-- List po's
    IF ll_list

      *-- Determine search file
      IF lc_file = "Both"
        lc_srchfil = IIF(g_getdlg("Search for PO number in", 0, 1, ;
                     "Current", "History") = 2, ;
                     "History", "Current")
*        lc_srchfil = IIF(g_getdlg("Search for PO number in", 0, 1, "Currhist", "History") = 2, "History", "Currhist")
      ELSE
        lc_srchfil = lc_file
      ENDIF

      IF lc_srchfil = "History"
        go_SQL.m_TableChangeCurrent("a_soymst")
      ELSE
        go_SQL.m_TableChangeCurrent("a_somast")
      ENDIF

      go_SQL.so_CurrentAlias.m_SetFilter("LEFT(custno," + STR(LEN(lc_prefix)) + ") = '" + lc_prefix + "'")
      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
      ll_test = IIF (go_SQL.so_CurrentAlias.m_IsEof(),.f.,.t.)
      go_SQL.so_CurrentAlias.m_SetFilter("")

      IF ll_test

        WITH g_NewObj("SycTryKey", "SYBROWSE")

   		   .sc_DataViewID        = "PL_SOMAST_PONUM"
   		   .sc_FromTableNameFull = IIF(lc_srchfil = "History", go_sql.CmpA_soymst.Sc_TableNameFull, go_sql.CmpA_somast.Sc_TableNameFull)
   		   .sc_FromTableSQLType  = go_Sql.sc_SqlTypeMain
   		   .sc_ValueToReturn     = "ponum"

           .sc_KeyDescription    = "PO Number"

           IF NOT EMPTY(lc_custno)
             .sc_Filter = "custno = '" + lc_custno + "'"
           ENDIF

           .m_PickList()

    	   IF .rn_SelectedRecordID > 0
   			  lc_pono = ALLTRIM(.rx_ReturnValue)
              ll_return = .t.
 		   ELSE
              ll_return = .f.
		   ENDIF

    	ENDWITH

      ELSE
        DO g_dspalt WITH "No PO Exist for the Customer "+ lc_prefix, 2
      ENDIF

    ENDIF && ll_list

    *-- If PO was found, set filters
    IF ll_return
      go_SQL.m_TableChangeCurrent("a_somast")

      *-- Build filter string, so we don't have scope problems with variable
      go_SQL.so_CurrentAlias.m_SetFilter("UPPER(a_somast->ponum) %=% UPPER(ALLTRIM(??lc_pono)) + '%/%' ")

      go_SQL.m_TableChangeCurrent("a_soymst")

      *-- Build filter string, so we don't have scope problems with variable
      go_SQL.so_CurrentAlias.m_SetFilter("UPPER(a_soymst->ponum) %=% UPPER(ALLTRIM(??lc_pono)) + '%/%' ")
    ENDIF

    *-- Reset tags
    go_SQL.cmpA_Somast.m_SetOrder(lc_ordmst)
    go_SQL.cmpA_Soymst.m_SetOrder(lc_ordyms)

    *-- Reselect work area
    go_SQL.m_TableChangeCurrent(ln_area)

  ENDIF && EMPTY(lc_pono)

  IF NOT ll_return AND LEFT(lc_pono, 1) = "?"
    *-- Clear "?"
    KEYBOARD "{CTRL+Y}" PLAIN
  ENDIF

RETURN (ll_return)
*------------------------------------------------------------------------------
*- End Function...: l_valpo()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: l_scttype()
*------------------------------------------------------------------------------
*- Synopsis...: Translates Sales commission document types (one character)
*-              english text
*------------------------------------------------------------------------------
*- Calls......: None
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pc_doctype, Sales commission document type
*-              pl_detail,  Full details?
*-                          .f. to summarize:
*-                              invoices and shipments as "Commission"
*-                              credit memos and returns as "Returns"
*-
*- Objects....: None
*------------------------------------------------------------------------------
*- Returns:
*- Value......: Text translation of Sales commission document type
*------------------------------------------------------------------------------
FUNCTION l_scttype

PARAMETERS pc_doctype, ;
           pl_detail

  PRIVATE lc_return
  lc_return = Cc_NullStr

  DO CASE
    CASE pc_doctype = "I" AND pl_detail
      lc_return = "Invoice"

    CASE pc_doctype = "S" AND pl_detail
      lc_return = "Order"

    CASE INLIST(pc_doctype, "I", "S")
      lc_return = "Commission"

    CASE pc_doctype = "C" AND pl_detail
      lc_return = "Credit Memo"

    CASE pc_doctype = "R" AND pl_detail
      lc_return = "Order Return"

    CASE INLIST(pc_doctype, "C", "R")
      lc_return = "Return"

    CASE pc_doctype = "V"
      lc_return = "Invoice Void"

    CASE pc_doctype = "D"
      lc_return = "Credit Void"

    CASE pc_doctype = "-"
      lc_return = "Payment Reversed"

    CASE pc_doctype = "E"
      lc_return = "Salesperson Change"

    OTHERWISE
      lc_return = "Adjustment"

  ENDCASE

RETURN (lc_return)
*------------------------------------------------------------------------------
*- End Function...: l_scttype()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SUMTRN
*------------------------------------------------------------------------------
*- Description: Summarize temporary transaction file when
*-              using serial numbers
*------------------------------------------------------------------------------
*- Synopsis...: Summarizes and totals multiple SO transaction records into
*-              one record based on a key value. Used to print one line
*-              item per SO where the tran file may have many records
*-              per item (due to serialization and lot tracking).
*-              This procedure is only used when the global switches
*-              for lots or serial numbers are set to .t.
*------------------------------------------------------------------------------
*- Calls......: None
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_xscope - What type of print choice
*-              lc_ndx    - key value expression
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sumtrn

*\ [1 Line] PTR# 78017 10/25/04 TISM Added local variables lc_srchexpr, lc_expr, ll_Found
  LOCAL lc_srchexpr, ;
        lc_expr, ;
        ll_Found

  *-- Select temporary tran file
  go_SQL.m_TableChangeCurrent("a_tmpf1")

  *-- Index expression to differentiate unique line items on order entries
  IF LEFT(lc_order,1) = "I"
    lc_ndx = "sono + item + loctid + descrip + DTOS(rqdate) + " + ;
             "qstore + qbin + lotno + umeasur"

    *-- SSHA + STR(MLEN(intmemo)) - is currently not properly supported
  ELSE
    lc_ndx = "sono + loctid + qstore + qbin + lotno + " + ;
             "item + descrip + DTOS(rqdate) + umeasur"
    *-- SSHA + STR(MLEN(intmemo)) - is currently not properly supported
  ENDIF

  *-- Create structural CDX for temp file
  *-- Key value for line item summarization
  go_SQL.so_CurrentAlias.m_CreateIndex("keyval", lc_ndx, "", .t., .f.)

  *-- Used for lot and serial number printing
  go_SQL.so_CurrentAlias.m_CreateIndex("lot", "lotno", "", .t., .f.)
  *-- SSHA + STR(MLEN(intmemo)) - is currently not properly supported

  *-- Used to set a relation back to a_tmpf4 to find the memo field
  go_SQL.so_CurrentAlias.m_CreateIndex("line", "sono + STR(tranlineno)", "", .t., .f.)

  *-- Set order for totaling
  go_SQL.cmpA_Tmpf1.m_SetOrder("keyval")

  *-- Set relation to inventory file
  go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

  *-- TIW SOC hooks to print all the components for picking tickets only
  IF gl_tiw AND lc_grpitem = "N"
    *-- Print all the detail line items in the order
    go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(3), "")

  ELSE

*\ [1 Line] PTR# 74805 06/26/04 TISP Include internal memo field for grouping
*\ [Begin] PTR# 78017 10/25/04 TISM Removed the call to m_Total, TOTAL ON does not
*\                                  support memo fields. Workaround to create unique
*\                                  records and to total based on the expression

    *-- Added tqtyord
    *-- Total temp tran file to create one record for each unique item
    go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(9, "F"), "FOR .t. = .f.", "F")
    ln_opnitm = g_opnfl(go_SQL.m_getTempTableName(9, "F"), "a_tmpf9", .t., .f., , , "F")

    *-- Add internal memo to the expression to locate the unique record
    lc_srchexpr = "intmemo + " + lc_ndx

    *-- Expression to differentiate unique line items on order entries
    IF LEFT(lc_order,1) = "I"
      lc_expr = "a_tmpf1->intmemo + a_tmpf1->sono + a_tmpf1->item + a_tmpf1->loctid + a_tmpf1->descrip  + " + ;
                " DTOS(a_tmpf1->rqdate) + a_tmpf1->qstore + a_tmpf1->qbin + a_tmpf1->lotno + a_tmpf1->umeasur"

    ELSE
      lc_expr = "a_tmpf1->intmemo + a_tmpf1->sono + a_tmpf1->loctid + a_tmpf1->qstore + a_tmpf1->qbin + a_tmpf1->lotno + " + ;
                "a_tmpf1->item + a_tmpf1->descrip + DTOS(a_tmpf1->rqdate) + a_tmpf1->umeasur"
    ENDIF

    *-- Select temporary tran file
    go_SQL.m_TableChangeCurrent("a_tmpf1")
    
    *-- Scan all the records to get unique records
    go_SQL.cmpA_tmpf1.m_ScanBegin("F", ".t. = .t.")
    DO WHILE go_SQL.cmpA_tmpf1.m_ScanBulk()
      ll_Found = .t.

      *-- Search the temporary table with expression
      IF NOT go_SQL.cmpA_tmpf9.m_Locate("FOR " + lc_srchexpr + " = " + lc_expr)
        *-- Unique record, Add this to the temporary table
        
        go_SQL.cmpA_tmpf9.m_Add()
        SCATTER MEMVAR MEMO
        go_SQL.cmpA_tmpf9.m_Gather("MEMVAR MEMO")
        ll_Found = .f.
      ENDIF
      
      *-- SUM up qtyord, qtyshp, tqtyord, extprice fields, Accumalte totals if 
      *-- the records already exists
      go_SQL.cmpA_tmpf9.m_ReplaceBulk("qtyord   WITH " + IIF(ll_Found, "qtyord", "0.00") + " + a_tmpf1->qtyord, " + ;
                                      "qtyshp   WITH " + IIF(ll_Found, "qtyshp", "0.00")  + " + a_tmpf1->qtyshp, " + ;
                                      "tqtyord  WITH " + IIF(ll_Found, "tqtyord", "0.00") + " + a_tmpf1->tqtyord, " + ;
                                      "extprice WITH " + IIF(ll_Found, "extprice", "0.00") + " + a_tmpf1->extprice")
    
    ENDDO
    go_SQL.cmpA_tmpf1.m_ScanEnd()

    *-- Copy the temporary total table 
    go_SQL.cmpA_Tmpf9.m_CopyTo(go_SQL.m_getTempTableName(3), "", "S")
*\ [End] PTR# 78017 10/25/04 TISM Removed the call to m_Total, TOTAL ON does not
*\                                support memo fields. Workaround create to unique
*\                                records and to total based on the expression

    go_SQL.cmpA_Tmpf9.m_CopyTo(go_SQL.m_getTempTableName(3), "", "S")
    go_SQL.m_CloseTable("a_tmpf9")
    go_SQL.m_TableChangeCurrent("a_tmpf1")
  ENDIF

  go_SQL.cmpA_Tmpf1.m_SetOrder("line")

  *-- Open temporary summary sotran file
  ln_opnitm = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)

  DO CASE
    CASE LEFT(lc_order, 1) = "I"
      go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + item + loctid + qstore + qbin", "", .t., .f.)

    CASE LEFT(lc_order, 1) = "L"
      go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + loctid + qstore + qbin + item", "", .t., .f.)

    CASE LEFT(lc_order, 1) = "O"
      go_SQL.so_CurrentAlias.m_CreateIndex("sono", "sono + transeq + STR(tranlineno, 4) + loctid + qstore + qbin", "", .t., .f.)
  ENDCASE


  go_SQL.cmpA_Iciloc.m_SetOrder("item1")

  *-- Set Relation To Item Location File
  go_SQL.so_CurrentAlias.m_SetRelation("item + loctid", "a_iciloc", .f.)
  go_SQL.so_CurrentAlias.m_SetRelation("sono + STR(tranlineno)", "a_tmpf1", .t.)

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sumtrn
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Description: Check if current picking ticket finished printing
*------------------------------------------------------------------------------
*- Synopsis...: Sets "end_of_group" flag to indicate if finishing current
*-              picking ticket and moving to a new Order or going to the
*-              next page of the current picking ticket. Called from within
*-              the picking ticket FRX
*------------------------------------------------------------------------------
FUNCTION l_mrkprt

  PRIVATE lc_cloc

  *-- Store current alias
  lc_alias = ALIAS()

  go_SQL.m_TableChangeCurrent("a_tmpf3")

  *-- Set "end-of-group" variable to indicate if finishing current SO
  IF NOT go_SQL.so_CurrentAlias.m_IsEof()
    lc_cloc = loctid
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)

    DO CASE
      CASE a_tmpf1->sono <> lc_sono OR go_SQL.so_CurrentAlias.m_IsEof()
        *-- If finishing current picking ticket
        ll_eog = .t.

      CASE lc_lpage = "Yes" AND a_tmpf1->loctid <> lc_cloc OR go_SQL.so_CurrentAlias.m_IsEof()
        *-- If finishing current picking ticket
        ll_eog = .t.

      OTHERWISE
        *-- Moving to next page of current picking ticket
        ll_eog = .f.

    ENDCASE

    *-- Reset record pointer
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_PrevRec)
  ELSE
    ll_eog = .t.
  ENDIF

  *-- Restore original alias
  go_SQL.m_TableChangeCurrent(lc_alias)

  *-- Return to calling FRX
RETURN ""
*------------------------------------------------------------------------------
*- End Function...: l_mrkprt()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_OUTSTK
*------------------------------------------------------------------------------
*- Description: Check if item is in stock
*------------------------------------------------------------------------------
*- Synopsis...: Checks Item record in ICILOC to see that onhand - allocated
*-              is not zero.
*------------------------------------------------------------------------------
*- Example....: l_outstk(item)
*------------------------------------------------------------------------------
FUNCTION l_outstk

PARAMETERS lc_item

  ll_outstk  = .f.
  ll_insfstk = .f.
  ll_NoOnhand = .f.

  IF a_tmpf1->stkcode = "Y" AND a_iciloc->lonhand <= 0
    ll_outstk = .t.
  ELSE

    *-- the summed qtyord alias should be used
    *-- Check order qty against on hand
    IF a_tmpf3->stkcode = "Y" AND a_iciloc->lonhand < ;
       (a_iciloc->lsoaloc - a_iciloc->lwoaloc - a_iciloc->ltmaloc) AND ;
       a_iciloc->lonhand < a_tmpf3->qtyord
      ll_insfstk = .t.
    ENDIF

  ENDIF

  IF gl_lots AND a_icitem->uselots $ "OS" AND EMPTY(a_tmpf1->lotno)
    ll_NoOnhand = .t.
  ENDIF

RETURN lc_item
*------------------------------------------------------------------------------
*- End Function...: l_outstk()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_PRNSN
*------------------------------------------------------------------------------
*- Description: Print lots and/or serial numbers on a picking ticket
*------------------------------------------------------------------------------
*- Synopsis...: Builds an array of text strings for lot and/or serial numbers.
*-              The text strings contain delimiters to force line feeds in
*-              the FRX. Called by a UDF in the SO FRX's which print picking
*-              tickets
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: la_prnsn[4], strings for lot/serial display
*-
*------------------------------------------------------------------------------
FUNCTION l_prnsn

  PRIVATE lc_SQLAlias
  lc_SQLAlias = ""

  PRIVATE lc_lotno, ;
          ln_sncol, ;
          lc_key, ;
          lc_alias, ;
          lc_scan, ;
          lc_lotln, ;
          lc_snln, ;
          lc_qtytag, ;
          ln_tmprec, ;
          ll_dblln, ;
          ln_cnt, ;
          ll_eof

  *-- Initialize variables
  ll_eof   = .t.

  *-- Store current alias
  lc_alias = ALIAS()

  *-- Store current record position
  ln_recno = go_SQL.so_CurrentAlias.m_GetRecno()

  *-- Store key expression for the current record
  lc_key = &lc_ndx

  IF NOT go_SQL.cmpA_Tmpf3.m_IsEof()
    *-- Skip one record and check for last record
    go_SQL.cmpA_Tmpf3.m_MoveRecord(Cn_NextRec)

    *-- Set the end of file flag
    ll_eof = go_SQL.cmpA_Tmpf3.m_IsEof()

    *-- Reset the record pointer
    go_SQL.cmpA_Tmpf3.m_MoveRecord(Cn_PrevRec)
  ENDIF

  *-- Store current tags for the following tables
  lc_qtytag = go_SQL.cmpA_Iciqty.m_GetOrder()

  *-- Set order to Item + Qserial
  go_SQL.cmpA_Iciqty.m_SetOrder("item3")

  *-- Create cursor to hold strings
  go_SQL.m_createTable(go_SQL.m_getTempTableName(8), ;
                      " FREE (prnlot C(10), prnsn C(20), nolot C(1))", ;
                        "", "")

  go_SQL.so_CurrentAlias.m_CloseTable()
  = g_opnfl(go_SQL.m_getTempTableName(8), "a_tmpf8", .t., .f.)

  *-- Reset array string values
  la_prnsn = ""

  *-- Set vars for lot and sn underline
  lc_lotln = REPLICATE("_", 8)
  lc_snln = REPLICATE("_", 18)

  *-- Initialize var to hold tmpf1 record
  ln_tmprec = 0

  *-- Select temp file which contains detail tran records
  go_SQL.m_TableChangeCurrent("a_tmpf1")

  *-- Set order to key value tag
  go_SQL.cmpA_Tmpf1.m_SetOrder("keyval")

  *-- Find first occurance of current line item in detail temp file
  IF go_SQL.so_CurrentAlias.m_Seek(lc_key, "")

    ln_tmprec = go_SQL.so_CurrentAlias.m_GetRecno()

    IF a_icitem->useserl $ "OS" OR a_icitem->uselots $ "OS"
      *-- Set order to lotno tag
      go_SQL.cmpA_Tmpf1.m_SetOrder("lot")

      *-- Begin building text string to be passed back to the FRX
      go_SQL.CmpA_tmpf1.m_ScanBegin("W", "lc_key = " + lc_ndx)
      DO WHILE go_SQL.CmpA_tmpf1.m_Scan()
        lc_lotno = ""

        IF NOT (a_tmpf1->detail = gx_true) AND a_icitem->uselots $ "OS"
          lc_lotno = a_tmpf1->lotno
        ENDIF

        ln_lotcnt = 0

        *-- If print S/N's
        IF a_icitem->useserl $ "OS" OR a_icitem->uselots $ "OS"

          IF a_tmpf1->detail = gx_True
            go_SQL.m_TableChangeCurrent("a_icserl")
            lc_scan = "soline= '" + a_tmpf1->sono + STR(a_tmpf1->tranlineno,4) + ;
                      "' AND item= '" + a_tmpf1->item + "' " + ;
                      " AND status = ' '"
            go_SQL.CmpA_icserl.m_ScanBegin("F", lc_scan)
          ELSE
            lc_scan = "a_tmpf1->lotno = ??lc_lotno AND lc_key = &lc_ndx. AND " + ;
                      "NOT go_SQL.so_CurrentAlias.m_IsEof()"
            go_SQL.so_CurrentAlias.m_ScanBegin("W", lc_scan)
          ENDIF

          lc_SQLAlias = ALIAS()

          DO WHILE go_SQL.so_CurrentAlias.m_ScanBulk()

            IF a_tmpf1->qtyord > 0

              *-- Increment text string
              IF UPPER(ALIAS()) = "A_ICSERL"

                IF NOT EMPTY(a_icserl->qserial) AND go_SQL.cmpA_Iciqty.m_Seek(a_icserl->item + a_icserl->qserial, "")
                  lc_lotno = a_iciqty->lotno
                ENDIF

                go_SQL.cmpA_tmpf8.m_SQLInsert("PRNLOT, PRNSN, NOLOT", ;
                                              "lc_lotno, a_icserl->qserial, " + IIF(EMPTY(lc_lotno), "'X'", "''"), ;
                                              "")

              ELSE

                IF NOT EMPTY(a_tmpf1->serial) AND go_SQL.cmpA_Iciqty.m_Seek(a_tmpf1->item + a_tmpf1->serial, "")
                  lc_lotno = a_iciqty->lotno
                ENDIF

                go_SQL.cmpA_tmpf8.m_SQLInsert("PRNLOT, PRNSN, NOLOT", ;
                                              "lc_lotno, a_icserl->qserial, " + IIF(EMPTY(lc_lotno), "'X'", "''"), ;
                                              "")

              ENDIF

            ENDIF

            go_SQL.m_TableChangeCurrent(lc_SQLAlias)
          ENDDO
          go_SQL.so_CurrentAlias.m_ScanEnd()

          IF UPPER(ALIAS()) = "A_ICSERL"
            go_SQL.m_TableChangeCurrent("a_tmpf1")
          ELSE
            go_SQL.so_CurrentAlias.m_MoveRecord(Cn_BottRec)
          ENDIF

        ENDIF && a_icitem->useserl $ "OS"

      ENDDO
      go_SQL.so_CurrentAlias.m_ScanEnd()

    ENDIF && a_icitem->useserl $ "OS" OR a_icitem->uselots $ "OS")

    *-- Reset record in tmpf1
    IF ln_tmprec > 0
      go_SQL.cmpA_Tmpf1.m_MoveToRecno(ln_tmprec)
    ENDIF

  ENDIF && SEEK(lc_key)

  *-- Build string values from cursor
  go_SQL.m_TableChangeCurrent("A_tmpf8")
  go_SQL.so_CurrentAlias.m_CreateIndex("nolot1", "nolot + prnlot", "", .t., .f.)
  go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

  ln_sncol = 2
  lc_lotno = "X" + prnlot
  ll_dblln = .f.

  go_SQL.CmpA_tmpf8.m_ScanBegin("F", "")
  DO WHILE go_SQL.cmpA_tmpf8.m_ScanBulk()

    IF a_icitem->uselots $ "OS"
      *-- Item uses lots

      IF EMPTY(prnlot)
        *-- If no lot, print entry line

        *-- Add returns to finish off previous line
        IF ln_sncol > 2

          FOR ln_sncol = ln_sncol TO 4
            la_prnsn[ln_sncol] = la_prnsn[ln_sncol] + gc_oseol
          NEXT

        ENDIF

        *-- Give extra line of space
        FOR ln_cnt = 1 TO 4
          la_prnsn[ln_cnt] = la_prnsn[ln_cnt] + gc_oseol
        NEXT

        *-- Note that this is a double line
        ll_dblln = .t.

        la_prnsn[1] = la_prnsn[1] + lc_lotln + gc_oseol

        *-- Set to 1st serial number column
        ln_sncol = 2
      ELSE

        IF lc_lotno <> prnlot
          *-- If lot and lot has changed

          *-- Add returns to finish off previous line
          IF ln_sncol > 2

            FOR ln_sncol = ln_sncol TO 4
              la_prnsn[ln_sncol] = la_prnsn[ln_sncol] + gc_oseol
            NEXT

          ENDIF

          *-- add lot line
          la_prnsn[1] = la_prnsn[1] + prnlot + gc_oseol

          *-- Set to 1st serial number column
          ln_sncol = 2

          *-- Record current lot number
          lc_lotno = prnlot

          *-- Note this is no longer a double line
          ll_dblln = .f.

        ELSE
          *-- Not a new lot

          IF ln_sncol = 2
            *-- New line of serial numbers
            la_prnsn[1] = la_prnsn[1] + gc_oseol
          ENDIF

        ENDIF

      ENDIF

    ENDIF

    IF a_icitem->useserl $ "OS"

      IF EMPTY(prnsn)
        *-- If no serial, print entry line

        IF NOT ll_dblln
          *-- If not already a double height line, make this one

          FOR ln_cnt = 1 TO 4
            la_prnsn[ln_cnt] = la_prnsn[ln_cnt] + gc_oseol
          NEXT

          ll_dblln = .t.
        ENDIF

        la_prnsn[ln_sncol] = la_prnsn[ln_sncol] + lc_snln + gc_oseol
      ELSE
        *-- Print serial number
        la_prnsn[ln_sncol] = la_prnsn[ln_sncol] + prnsn + gc_oseol
      ENDIF

      *-- Item has lot, increment column count

      IF ln_sncol = 4
        ln_sncol = 2
      ELSE
        ln_sncol = ln_sncol + 1
      ENDIF

    ENDIF

  ENDDO
  go_SQL.so_CurrentAlias.m_ScanEnd()

  *-- Set order back to key used in relation
  go_SQL.cmpA_Tmpf1.m_SetOrder("line")

  *-- Set order back in iciqty
  IF NOT EMPTY(lc_qtytag)
    go_SQL.cmpA_Iciqty.m_SetOrder(lc_qtytag)
  ENDIF

  *-- Restore original alias
  go_SQL.m_TableChangeCurrent(lc_alias)

  *-- Insure correct record position
  go_SQL.so_CurrentAlias.m_MoveToRecno(ln_recno)

  *-- Close cursor
  IF go_SQL.m_IsUsed("A_tmpf8")
    go_SQL.cmpA_tmpf8.m_CloseTable()
  ENDIF

RETURN Cc_NullStr
*------------------------------------------------------------------------------
*- End Function...: l_prnsn()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_PRNSB
*------------------------------------------------------------------------------
*- Description: Print line item memos on picking ticket
*------------------------------------------------------------------------------
*- Synopsis...: Builds two text strings of store & bin information for
*-              use in the calling FRX. The two text strings contain
*-              delimiters to force line feeds in the FRX.
*-              Called by a UDF in the SO FRX's which print picking tickets.
*------------------------------------------------------------------------------
FUNCTION l_prnsb

  PRIVATE lc_eoln, ;
          ln_qtyord, ;
          lc_qtytag, ;
          lc_tmp1tag, ;
          lc_key, ;
          lc_scan

  *-- Initialize local variables
  lc_eoln = gc_oseol
  ln_qtyord = 0

  *-- Initialize string vars for stores and bins
  lc_prnsb1 = Cc_NullStr
  lc_prnsb2 = Cc_NullStr

  DO CASE
    CASE a_icitem->useserl $ "OS"
      *-- Tagged and Untagged Serialized items

      *-- Store current tags for the following tables
      lc_qtytag = go_SQL.cmpA_Iciqty.m_GetOrder()
      lc_tmp1tag = go_SQL.cmpA_Tmpf1.m_GetOrder()

      *-- Store key expression for the current record
      lc_key = &lc_ndx.

      *-- Set order to key value tag
      go_SQL.cmpA_Tmpf1.m_SetOrder("keyval")
      *-- Set order to Item + Qserial
      go_SQL.cmpA_Iciqty.m_SetOrder("item3")

      *-- Select temp file which contains detail tran records
      go_SQL.m_TableChangeCurrent("a_tmpf1")

      ln_tmprec = go_SQL.so_CurrentAlias.m_GetRecno()

      *-- Find first occurance of current line item in detail temp file
      IF go_SQL.so_CurrentAlias.m_Seek(lc_key, "")

        *-- Begin building text string to be passed back to the FRX
        go_SQL.CmpA_tmpf1.m_ScanBegin("W", "lc_key = " + lc_ndx)
        DO WHILE go_SQL.CmpA_tmpf1.m_Scan()

          *-- Check if there is serial number in detail file
          IF a_tmpf1->detail = gx_True

            go_SQL.m_TableChangeCurrent("a_icserl")

            lc_scan = "soline= '" + a_tmpf1->sono + STR(a_tmpf1->tranlineno,4) + "' AND item= '" + a_tmpf1->item + "'"

            *-- Look thru the detail line serial # table
            go_SQL.CmpA_icserl.m_ScanBegin("F", lc_scan)
            DO WHILE go_SQL.CmpA_icserl.m_ScanBulk()

              *-- Fetch only open serial number
              IF a_icserl->status = " " AND NOT EMPTY(a_icserl->qserial)

                IF go_SQL.cmpA_Iciqty.m_Seek(a_tmpf1->item + a_icserl->qserial, "")
                  = l_single("a_iciqty")
                  ln_qtyord = ln_qtyord + 1
                ENDIF

              ENDIF && a_icserl->status = " " AND NOT EMPTY(a_icserl->qserial)

            ENDDO
            go_SQL.so_CurrentAlias.m_ScanEnd()

            *-- Reselect the detail temp
            go_SQL.m_TableChangeCurrent("a_tmpf1")

          ELSE
            *-- For converted from Pro 2.5 version, fetch store & bin directly
            = l_single("a_tmpf1")
            ln_qtyord = ln_qtyord + 1
          ENDIF && a_tmpf1->detail

        ENDDO
        go_SQL.so_CurrentAlias.m_ScanEnd()

      ENDIF && SEEK(lc_key)

      IF ln_tmprec > 0
        go_SQL.cmpA_Tmpf1.m_MoveToRecno(ln_tmprec)
      ENDIF

      *-- Set order back to key used in relation
      IF NOT EMPTY(lc_qtytag)
        go_SQL.cmpA_Iciqty.m_SetOrder(lc_qtytag)
      ENDIF

      IF NOT EMPTY(lc_tmp1tag)
        go_SQL.cmpA_Tmpf1.m_SetOrder(lc_tmp1tag)
      ENDIF

      *-- If there are untagged serialized item then print all
      IF ln_qtyord < a_tmpf3->qtyord
        = l_getall()
      ENDIF

    CASE NOT EMPTY(a_tmpf3->lotno)
      *-- Lotted items already include stores and bins

      *-- Fetch Store & Bin from current table
      = l_single("a_tmpf3")

    OTHERWISE
      *-- Select Inventory Quantities file
      = l_getall()

  ENDCASE

  *-- Reselect the temporary file
  go_SQL.m_TableChangeCurrent("a_tmpf3")

  *-- Return to calling FRX
RETURN Cc_NullStr
*------------------------------------------------------------------------------
*- End Function...: l_prnsb()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_SINGLE
*------------------------------------------------------------------------------
*- Description: Fetch single store and bin value from the given table.
*------------------------------------------------------------------------------
*- Synopsis...: Builds two text strings of store & bin information.
*-              The text strings contain delimiters to force
*-              line feeds in the FRX. Called by a UDF in the SO
*-              FRX's which print picking tickets.
*------------------------------------------------------------------------------
*- Example....: = l_single("a_tmpf3")
*------------------------------------------------------------------------------
FUNCTION l_single

PARAMETERS lc_alias

  PRIVATE lc_store, ;
          ll_store, ;
          lc_eoln, ;
          lc_qtyln, ;
          lc_sbln

  lc_store = ""
  lc_eoln = gc_oseol
  lc_qtyln = REPLICATE("_", 8)
  lc_sbln = REPLICATE("_", 11)

  ll_store = .f.

  IF gl_store
    lc_store = &lc_alias.->qstore

    IF NOT (lc_store $ lc_prnsb2)

      lc_prnsb1 = lc_prnsb1 + lc_eoln
      lc_prnsb2 = lc_prnsb2 + ;
                  IIF(lc_store = "_OVERSHIP" OR EMPTY(lc_store), ;
                  lc_sbln, lc_store) + lc_eoln

      ll_store = .t.
    ENDIF

  ENDIF

  *-- Add Bin text
  lc_bintxt = &lc_alias.->qbin

  IF (NOT (lc_bintxt $ lc_prnsb2) OR ll_store) AND gl_bin
    lc_prnsb1 = lc_prnsb1 + lc_qtyln + lc_eoln
    lc_prnsb2 = lc_prnsb2 + ;
                IIF(lc_bintxt = "_OVERSHIP" OR EMPTY(lc_bintxt), ;
                lc_sbln, lc_bintxt) + lc_eoln
  ENDIF

RETURN Cc_NullStr
*------------------------------------------------------------------------------
*- End Function...: l_single()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_GETALL
*------------------------------------------------------------------------------
*- Description: Fetch all available store and bin value from the iciqty table.
*------------------------------------------------------------------------------
*- Synopsis...: Builds two text strings of store & bin information.
*-              The text strings contain delimiters to force
*-              line feeds in the FRX. Called by a UDF in the SO
*-              FRX's which print picking tickets.
*------------------------------------------------------------------------------
*- Example....: = l_getall()
*------------------------------------------------------------------------------
FUNCTION l_getall

  PRIVATE ll_first, ;
          lc_bin, ;
          lc_store, ;
          lc_eoln, ;
          ll_bintxt, ;
          lc_qtyln, ;
          lc_sbln

  lc_bin = ""

  ll_first = .t.
  lc_store = ""
  lc_eoln = gc_oseol
  ll_bintxt = .f.
  lc_qtyln = REPLICATE("_", 8)
  lc_sbln = REPLICATE("_", 11)

  *-- Select Inventory Quantities file
  go_SQL.m_TableChangeCurrent("a_iciqty")

  *-- Get all stores and bins
  go_SQL.CmpA_iciqty.m_ScanBegin("F", "item + loctid = '" + a_tmpf3->item + a_tmpf3->loctid + "'")
  DO WHILE go_SQL.CmpA_iciqty.m_ScanBulk()

    *-- Get stores first line
    IF ll_first AND gl_store
      lc_store = a_iciqty->qstore

      lc_prnsb1 = lc_prnsb1 + lc_eoln
      lc_prnsb2 = lc_prnsb2 + ;
                  IIF(a_iciloc->lonhand <= 0, "_OVERSHIP", ;
                  IIF(lc_store = "_OVERSHIP" OR EMPTY(lc_store), ;
                  lc_sbln, lc_store)) + lc_eoln

      ll_first = .f.
    ENDIF

    *-- Get stores
    IF lc_store <> a_iciqty->qstore AND gl_store
      lc_store = a_iciqty->qstore

      IF lc_store = "_OVERSHIP" OR EMPTY(lc_store)
        lc_prnsb1 = lc_prnsb1 + lc_eoln
        lc_prnsb2 = lc_prnsb2 + lc_eoln
      ELSE
        lc_prnsb1 = lc_prnsb1 + lc_eoln + lc_eoln
        lc_prnsb2 = lc_prnsb2 + lc_eoln + lc_store + lc_eoln
      ENDIF

      ll_bintxt = .t.

    ENDIF

    IF gl_bin
      *-- Get bins

      IF NOT (a_iciqty->qbin = "_OVERSHIP" OR ;
         EMPTY(a_iciqty->qbin) OR (a_iciqty->qonhand <= 0))

        IF lc_bin <> a_iciqty->qbin

          lc_bin = a_iciqty->qbin

          lc_prnsb1 = lc_prnsb1 + lc_qtyln + lc_eoln
          lc_prnsb2 = lc_prnsb2 + a_iciqty->qbin + lc_eoln

          ll_bintxt = .t.

        ENDIF

      ENDIF

    ENDIF

  ENDDO
  go_SQL.so_CurrentAlias.m_ScanEnd()

  *-- Add lines if no bin text
  IF NOT ll_bintxt AND gl_bin
    lc_prnsb1 = lc_prnsb1 + lc_qtyln + lc_eoln
    lc_prnsb2 = lc_prnsb2 + lc_sbln + lc_eoln
  ENDIF

RETURN Cc_NullStr
*------------------------------------------------------------------------------
*- End Function...: l_getall()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_GETTYPE
*------------------------------------------------------------------------------
*- Description: Fetch Return Order from the given table.
*------------------------------------------------------------------------------
*- Synopsis...: Search thru the given alias by order number and
*-              salesperson, look for order returns by adding "R"
*-              as the document type.
*------------------------------------------------------------------------------
*- Example....: = l_gettype("a_soscmt", lc_sono, lc_salesmn)
*------------------------------------------------------------------------------
FUNCTION l_gettype

PARAMETERS pc_alias, ;
           pc_sono, ;
           pc_salesmn

  PRIVATE lc_sono

  lc_sono = Cc_NullStr

  *-- search for return order
  IF go_SQL.cmp&pc_Alias..m_Seek("R" + pc_sono + pc_salesmn, "")
    lc_sono = "R" + ALLTRIM(pc_sono)
  ELSE
    lc_sono = pc_sono
  ENDIF

RETURN lc_sono
*------------------------------------------------------------------------------
*- End Function...: l_gettype()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_RETCXRA
*------------------------------------------------------------------------------
*- Synopsis...: Returns current exchange rate from the specified currency
*-              to the Base currency
*------------------------------------------------------------------------------
*- Calls......: g_retxra()
*------------------------------------------------------------------------------
*- Called By..: SOREPT.PRG
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.:
*-
*- Assumptions: None
*------------------------------------------------------------------------------
FUNCTION l_retcxra

PARAMETERS pc_currid, ;
           pd_rtdate

  PRIVATE ln_currate, ;
          ld_rtdate

  ln_currate = 1.00
  ld_rtdate = IIF(EMPTY(pd_rtdate), gd_sdate, pd_rtdate)

  = g_retxra(pc_currid, gc_basecur, ld_rtdate, @ln_currate, "S")

RETURN ln_currate
*------------------------------------------------------------------------------
*- End Function...: l_retxcra
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_VFPGETSHP
*------------------------------------------------------------------------------
*- Description: Calculate shipment amounts from IC transaction files
*-              in VFP mode
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: A_TMPF1, temporary report file based on SOTRAN with fields
*-                       QTYSHP storing shipped qty, SHIPQTY storing
*-                       shipped price
*------------------------------------------------------------------------------
PROCEDURE l_VFPgetshp

  PRIVATE lc_alias, ;
          lc_decnum

  *-- Setup current alias
  lc_alias = ALIAS()

  *-- Get shipments for ICTRAN
  = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "applid2")

  *-- "EI" and "ER" record should not have been included in the quantity total.
  SET FILTER TO applid='SO' AND LEFT(trantyp, 1) <> 'E'

  go_SQL.m_TableChangeCurrent(lc_alias)

  REPLACE ALL qtyshp  WITH 0, ;
              shipqty WITH 0, ;
              tqtyshp WITH 0, ;
              tshpqty WITH 0

  SET RELATION TO "SO" + sono + STR(tranlineno,4) INTO a_ictran
  SET SKIP TO a_ictran

*\ [Begin] PTR# 76810 08/06/04 TIVN Fix for performance improvement
  DO CASE
    CASE gl_mc AND go_SQL.m_IsUsed("a_tmp18") AND ;
         TYPE("a_tmp18->decnum") <> "U"
      SET RELATION TO currid INTO a_tmp18 ADDITIVE
      lc_decnum = "a_tmp18->decnum"

    CASE gl_mc AND NOT go_SQL.m_IsUsed("a_tmp18")
      lc_decnum = "g_retcdc(a_ictran->currid)"

    OTHERWISE
      lc_decnum = "2"
  ENDCASE
*\ [End] PTR# 76810 08/06/04 TIVN Fix for performance improvement

*\ [2 Lines] PTR# 76810 08/06/04 TIVN Fix for performance improvement
  *-- Added tqtyshp
  *-- Added tshpqty using tqty,trprice
  *-- Calculate bshipqty using tqty,trprice
  *-- Calculate shipqty using tqty,tfprice
  *-- Update shipments summary from ICTRAN, reverse sign since stock quantity
  *-- of issues is stored negative.  ROUND price to avoid error
  REPLACE ALL qtyshp   WITH qtyshp - a_ictran->sqty, ;
              tqtyshp  WITH tqtyshp - a_ictran->tqty, ;
              shipqty  WITH shipqty - g_extnd(&lc_decnum., ;
                            a_ictran->tqty, a_ictran->tfprice, ;
                            a_ictran->disc), ;
              tshpqty  WITH tshpqty - g_extnd(&lc_decnum., ;
                            a_ictran->tqty, a_ictran->tfprice, ;
                            a_ictran->disc), ;
              bshipqty WITH bshipqty - g_extnd(2, a_ictran->tqty, ;
                            a_ictran->trprice, a_ictran->disc)

*\ [Begin] PTR# 76810 08/06/04 TIVN Fix for performance improvement
  IF gl_mc AND go_SQL.m_IsUsed("a_tmp18") AND ;
     TYPE("a_tmp18->decnum") <> "U"
    SET RELATION OFF INTO a_tmp18
  ENDIF
*\ [End] PTR# 76810 08/06/04 TIVN Fix for performance improvement

  SET RELATION TO

  *-- reset the transaction table
  go_SQL.m_TableChangeCurrent("a_ictran")
  SET FILTER TO

  *-- Get shipments for ICTRAN
  = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "applid2")

  *-- "EI" and "ER" record should not have been included in the quantity total.
  SET FILTER TO applid='SO' AND LEFT(trantyp, 1) <> "E"

  go_SQL.m_TableChangeCurrent(lc_alias)
  GOTO TOP

  SET RELATION TO "SO" + sono + STR(tranlineno,4) INTO a_icytrn
  SET SKIP TO a_icytrn

  *-- Update shipments summary from ICYTRN, history shipments against order
  REPLACE ALL qtyshp   WITH qtyshp - a_icytrn->sqty, ;
              tqtyshp  WITH tqtyshp - a_icytrn->tqty, ;
              shipqty  WITH shipqty - g_extnd(2, a_icytrn->tqty, ;
                            a_icytrn->tfprice, a_icytrn->disc), ;
              tshpqty  WITH tshpqty - g_extnd(2, a_icytrn->tqty, ;
                            a_icytrn->tfprice, a_icytrn->disc), ;
              bshipqty WITH bshipqty - g_extnd(2, a_icytrn->tqty, ;
                            a_icytrn->trprice, a_icytrn->disc)


  *-- reset the history transaction table
  go_SQL.m_TableChangeCurrent("a_icytrn")
  SET FILTER TO

  go_SQL.m_TableChangeCurrent(lc_alias)
  SET RELATION TO
RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_VFPgetshp
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SQLGETSHP
*------------------------------------------------------------------------------
*- Description: Calculate shipment amounts from IC transaction files
*-              in SQL mode
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: A_TMPF1, temporary report file based on SOTRAN with fields
*-                       QTYSHP storing shipped qty, SHIPQTY storing
*-                       shipped price
*------------------------------------------------------------------------------
PROCEDURE l_SQLgetshp

  LOCAL lc_SQLAlias, ;
        lc_SQLString, ;
        lc_SQLqtyshp, ;
        lc_SQLtqtyshp, ;
        lc_SQLOthers, ;
        lc_SQLbshpqty

  *--Construct a update string to reset the qtyshp, shipqty, tqtyshp, tshpqty
  lc_SQLString = ""
  *--Construct a update string to reset the qtyshp, shipqty, tqtyshp, tshpqty
  lc_SQLString = " update " + ;
                 go_sql.so_currentalias.sc_tablenamefull + ;
                 " set qtyshp=0, shipqty=0, tqtyshp=0, tshpqty=0"
  go_SQL.m_Execute(lc_SQLString, "")

  *-- Get data from ICTRAN file
  *--Construct a SQL statement to qtyshp, shipqty, tqtyshp, tshpqty from ICYTRN file
  lc_SQLqtyshp = " -ISNULL((select sum(sqty) from " + ;
                 gf_ictranf + ;
                 " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0)"
  *--Get sum of tqty as tqtyshp
  lc_SQLtqtyshp= " -ISNULL((select sum(tqty) from " + ;
                 gf_ictranf + ;
                 " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0)"
  *--Get sum of tqty*tfprice%disc as other fileds
  lc_SQLOthers = " -ISNULL((select sum(g_extnd(g_retcur(currid, 'DECNUM'), tqty, tfprice, disc)) from  " + ;
                 gf_ictranf + ;
                 " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

  *-- Get sum of tqty*trprice%disc as bshpqty
  lc_SQLbshpqty = " -ISNULL((select sum(g_extnd(g_retcur(currid, 'DECNUM'), tqty, trprice, disc)) from  " + ;
                  gf_ictranf + ;
                  " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

  *--Get sum of sqty as qtyshp
  IF go_SQL.sc_SQLType = "SS"
    lc_SQLString = " update " + go_sql.so_currentalias.sc_tablenamefull + " set " + ;
                   " qtyshp   = " + lc_SQLqtyshp + ", " + ;
                   " tqtyshp  = " + lc_SQLtqtyshp + ", " + ;
                   " shipqty  = " + lc_SQLOthers + ", " + ;
                   " tshpqty  = " + lc_SQLOthers + ", " + ;
                   " bshipqty = " + lc_SQLbshpqty + ;
                   " from " + go_sql.so_currentalias.sc_tablenamefull + " AS a_tmpf1 "

    *--Issue the update command
    go_SQL.m_Execute(lc_SQLString, "")
  ELSE
    *-- Change the function to work with DB2
    lc_SQLqtyshp  = STRTRAN(lc_SQLqtyshp, "-ISNULL", "-COALESCE")

    lc_SQLtqtyshp = STRTRAN(lc_SQLtqtyshp, "-ISNULL", "-COALESCE")

    *--Get sum of tqty*tfprice%disc as other fileds
    lc_SQLOthers = " -COALESCE((select sum(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ;
                   ".g_extnd(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ".g_retcur(currid, 'DECNUM', '', 0, '', '', 0, ''), " + ;
                   "tqty, tfprice, disc, 0, 0)) from  " + ;
                   gf_ictranf + ;
                   " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

    *-- Get sum of tqty*trprice%disc as bshpqty
    lc_SQLbshpqty = " -COALESCE((select sum(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ;
                    ".g_extnd(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ".g_retcur(currid, 'DECNUM', '', 0, '', '', 0, ''), " + ;
                    "tqty, trprice, disc, 0, 0)) from  " + ;
                    gf_ictranf + ;
                    " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

    *--Get sum of sqty as qtyshp
    lc_SQLString = " update " + go_sql.so_currentalias.sc_tablenamefull + " a_tmpf1 set " + ;
                   " qtyshp   = " + lc_SQLqtyshp + ", " + ;
                   " tqtyshp  = " + lc_SQLtqtyshp + ", " + ;
                   " shipqty  = " + lc_SQLOthers + ", " + ;
                   " tshpqty  = " + lc_SQLOthers + ", " + ;
                   " bshipqty = " + lc_SQLbshpqty

    *--Issue the update command
    go_SQL.m_Execute(lc_SQLString, "", , .t.)
  ENDIF

  *-- Get data from ICYTRN file


  IF go_SQL.sc_SQLType = "SS"
    *-- Creating table using SELECT..INTO creates a table with user as the
    *-- owner (e.g. AIADMN) instead of "dbo"
    lc_TmpFile = go_SQL.sc_TempDbName + ".dbo.t" + gc_Tmpf9

    *-- Compute the aggregate values and move it into a temporary table
    go_SQL.m_Execute("SELECT a_icytrn.docno AS docno, " + ;
                     "a_icytrn.tranlineno AS tranlineno, " + ;
                     "SUM(sqty) AS sqty, " + ;
                     "SUM(tqty) AS tqty, " + ;
                     "SUM(g_extnd(g_retcur(a_icytrn.currid, 'DECNUM'), a_icytrn.tqty, tfprice, a_icytrn.disc)) AS tqtshp1, " + ;
                     "SUM(g_extnd(g_retcur(a_icytrn.currid, 'DECNUM'), a_icytrn.tqty, trprice, a_icytrn.disc)) AS bqtshp1 " + ;
                     " INTO " + lc_TmpFile + ;
                     " FROM " + ;
                     gf_icytrnf + " a_Icytrn " + ;
                     "INNER JOIN " + go_SQL.so_CurrentAlias.sc_TableNameFull + ;
                     " a_Tmpf1 ON a_tmpf1.sono = a_icytrn.docno AND " + ;
                     " a_tmpf1.tranlineno = a_icytrn.tranlineno " + ;
                     "WHERE a_icytrn.applid = 'SO' GROUP BY a_icytrn.docno, a_icytrn.tranlineno", "")

    *-- Update summed up values
    go_SQL.m_Execute("UPDATE " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                     " SET " + ;
                     "qtyshp = -1 * a_tmpf9.sqty, " + ;
                     "tqtyshp = -1 * a_tmpf9.tqty, " + ;
                     "shipqty = -1 * a_tmpf9.tqtshp1, " + ;
                     "tshpqty = -1 * a_tmpf9.tqtshp1, " + ;
                     "bshipqty = -1 * a_tmpf9.bqtshp1 " + ;
                     "FROM " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + ;
                     " a_Tmpf1 INNER JOIN " + lc_Tmpfile + ;
                     " a_Tmpf9 ON a_tmpf1.sono = a_Tmpf9.docno AND " + ;
                     " a_Tmpf1.tranlineno = a_Tmpf9.Tranlineno ", "")

    go_SQL.m_DropTable(lc_TmpFile)
  ELSE
    *--Construct a SQL statement to qtyshp, shipqty, tqtyshp, tshpqty from ICYTRN file
    lc_SQLqtyshp = " -COALESCE((select sum(sqty) from " + ;
                   gf_icytrnf + ;
                   " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0)"

    *--Get sum of tqty as tqtyshp
    lc_SQLtqtyshp= " -COALESCE((select sum(tqty) from " + ;
                   gf_icytrnf + ;
                   " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0)"

    *--Get sum of tqty*tfprice%disc as other fileds
    lc_SQLOthers = " -COALESCE((select sum(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ".g_extnd(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ;
                   ".g_retcur(currid, 'DECNUM', '', 0, '', '', 0, ''), tqty, tfprice, disc, 0, 0)) from  " + ;
                   gf_icytrnf + ;
                   " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

    *-- Get sum of tqty*trprice%disc as bshpqty
    lc_SQLbshpqty = " -COALESCE((select sum(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ".g_extnd(" + ALLTRIM(go_SQL.sc_FunctionSchemaName) + ;
                    ".g_retcur(currid, 'DECNUM', '', 0, '', '', 0, ''), tqty, trprice, disc, 0, 0)) from  " + ;
                    gf_icytrnf + ;
                    " where applid='SO' AND docno=a_tmpf1.sono and tranlineno=a_tmpf1.tranlineno), 0) "

    *--Get sum of sqty as qtyshp
    lc_SQLString = " update " + go_sql.so_currentalias.sc_tablenamefull + " a_tmpf1 set " + ;
                   " qtyshp   = qtyshp   + " + lc_SQLqtyshp + ", " + ;
                   " tqtyshp  = tqtyshp  + " + lc_SQLtqtyshp + ", " + ;
                   " shipqty  = shipqty  + " + lc_SQLOthers + ", " + ;
                   " tshpqty  = tshpqty  + " + lc_SQLOthers + ", " + ;
                   " bshipqty = bshipqty + " + lc_SQLbshpqty

    *--Issue the update command
    go_SQL.m_Execute(lc_SQLString, "", , .t.)
  ENDIF

  go_SQL.m_TableChangeCurrent("a_tmpf1")

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_SQLgetshp
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function..: l_setfrm
*------------------------------------------------------------------------------
*- Synopsis...: Assigns report form names to lc_frmfile
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*------------------------------------------------------------------------------
*- Parameters.: None
*------------------------------------------------------------------------------
FUNCTION  l_setfrm

  LOCAL ln_opncfrm, ;
        lc_frmfile

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

*!*	  *-- Open Form File
*!*	  ln_opncfrm = g_opnfl(gc_idrvdbf + "sydform", "a_sydfor", .f., .f., "")

  DO CASE
    CASE lc_rept = "T"
      *-- Picking Tickets

*!*	      go_SQL.so_CurrentAlias.m_Locate("FOR a_sydfor->menuitm = .t. AND " + ;
*!*	                                      "'SOPKTK' + ??gc_compid $ a_sydfor->rptcmnd")

*!*	      IF go_SQL.so_CurrentAlias.m_IsFound()
*!*	        *-- Assign customized report form name
*!*	        lc_frmfile = gc_adrvprg + ALLTRIM(a_sydfor->frmfile)
*!*	      ELSE
*!*	        *-- Set form type
*!*	        *# DOCCODE REPORT FORM sopktk
*!*	        lc_frmfile = gc_adrvprg + "sopktk"
*!*	      ENDIF

*\ [1 Line] PTR# 73741 02/11/04 TIVN Qualify the report name with path info
      *-- Launch the report selection dialog if custom reports
      *-- are available
      lc_frmfile = g_selrpt(gc_adrvprg + "SOPKTK")

  ENDCASE

*!*	  IF ln_opncfrm = 2 AND go_SQL.m_IsUsed("a_sydfor")
*!*	    *-- Close form file
*!*	    go_SQL.cmpA_Sydfor.m_CloseTable()
*!*	  ENDIF
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports

RETURN lc_frmfile
*------------------------------------------------------------------------------
*- End Function...: l_setfrm
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SOREP1_VFP
*------------------------------------------------------------------------------
*- Description: Reports - Procedure 1 of 4
*------------------------------------------------------------------------------
*- Synopsis...: Reports 1 - Transaction Reports
*-                      2 - Shipments
*-                      3 - Open Orders
*-                      4 - Orders by Salesperson
*-                      V - Distribution by Value
*-                      P - Customer PO report
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_DSPALT, G_EXTND(), G_CLRTX, G_FRMCLC, SYVALR,
*-              G_OPNFL
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_rept   = single character report identifier
*-              LEFT(lc_file,1)     = file to get records from:
*-                          "C" for current period file
*-                          "H" for history file
*-                          "B" for both files
*-              lc_detail   = level of detail:
*-                          "S" for summary report
*-                          "D" for detail report
*-              lc_type     = type of report:
*-                          "A" for all orders
*-                          "E" for open and returns only
*-                          "S" for open orders only
*-                          "R" for returns only
*-                          "B" for bids only
*-              lc_tax      = include tax Yes or No
*-              lc_show     = view by qty or $ (1,3,4):
*-                          "Q" for qty ordered
*-                          "V" for value ($) ordered
*-              lc_only     = type of order (3 or 4 only):
*-                          "A" for all open orders (3)
*-                          "A" for all orders (4)
*-                          "O" for open orders only (4 only)
*-                          "P" for partially shipped only
*-              lc_bdate    = beginning date
*-              lc_edate    = ending date
*-              lc_order    = "C" to order report by customer number
*-                          "D" to order report by date (req or ship)
*-                          "I" to order report by item number
*-                          "O" to order report by order number
*-                          "S" to order report by salesperson
*-              lc_custno   = customer number or portion to match
*-              lc_item     = item number or portion to match
*-              lc_class    = inventory class or portion to match
*-              lc_code     = inventory code or portion to match
*-              lc_dbvtype, "C" = Customer, "I" = Inventory, "V" = Vendor
*-              ln_minamt, activity below this amount is excluded
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_sorep1_vfp

  PRIVATE lc_sofilt, ;
          ln_icserlf

  lc_sofilt  = ""
  ln_icserlf = 1

  PRIVATE lc_SQLMast, ;
          lc_SQLFilt, ;
          lc_IndDef

  lc_SQLMast = ""
  lc_SQLFilt = ""
  lc_IndDef = ""

  *-- Convert variables to dates
  ld_bdate   = g_retdt(lc_bdate)
  ld_edate   = g_retdt(lc_edate)

  *-- Set up variable to match to sostat field
  IF lc_rept $ "13P"
    *-- 1 - Transactions
    *-- 3 - Open Orders
    *-- P - PO report

    *-- Open ICSERL file
    ln_icserlf = g_opnfl(gf_icserlf, "a_icserl", .f., .f., "sono1")

    DO CASE
      CASE lc_type = "A"
        ms = " ORBD"
      CASE lc_type = "E"
        ms = " ORD"
      CASE lc_type = "O"
        ms = " O"
      CASE lc_type = "R"
        ms = "R"
      CASE lc_type = "B"
        ms = "B"
      CASE lc_type = "D"
        ms = "D"

    ENDCASE

  ELSE
    ms = " ORD"
  ENDIF

  *-- Set to continue
  ll_cont = .t.

  DO WHILE ll_cont
    DO g_dspst WITH "Locating Selected Transactions...", .t., ;
                    gn_msgline, "", "", ""

    DO CASE
      CASE lc_rept = "3"
        *-- Open Orders

        *-- Open Customer file
        = g_opnfl(gf_arcustf, "a_arcust", .f., .f., "")
        SET ORDER TO 0 IN a_arcust

        *-- Open Inventory Master file
        = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")
        SET ORDER TO 0 IN a_icitem

        *-- Open current Master file
        = g_opnfl(gf_somastf, "a_somast", .f., .f., "")
        SET ORDER TO 0 IN a_somast

        *-- Open current Detail file
        = g_opnfl(gf_sotranf, "a_sotran", .f., .f., "")
        SET ORDER TO 0 IN a_sotran

        *-- Setup WHERE condition
        lc_filt = lc_filt + [ EMPTY(a->sostat) AND ]

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + [a->loctid = TRIM(lc_loctid) AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + [a->custno = TRIM(lc_custno) AND ]
        ENDIF

        IF NOT EMPTY(lc_item)

          IF gl_sbtmod

            IF lc_incitm = "I"
              *-- Set item number condition
              lc_filt = lc_filt + [a->item = TRIM(lc_item) AND ]
            ELSE
              *-- Set item number condition to exclude
              lc_filt = lc_filt + [a->item <> TRIM(lc_item) AND ]
            ENDIF

          ELSE
            *-- Set item number condition
            lc_filt = lc_filt + [a->item = TRIM(lc_item) AND ]
          ENDIF

        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [c->itmclss = TRIM(lc_class) AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [c->code = TRIM(lc_code) AND ]
        ENDIF

        *-- Set date conditions
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + [DTOS(a->ordate)] + ;
                    [ >= "] + DTOS(ld_bdate) + [" AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + [DTOS(a->ordate)] + ;
                    [ <= "] + DTOS(ld_edate) + [" AND ]
        ENDIF

        *-- Partially shipped Open Orders
        IF lc_only <> "A"
          lc_filt = lc_filt + [b->shpamt <> 0 AND ]
        ENDIF

        *-- Unshipped Items Only
        IF lc_shipped <> "A"
          lc_filt = lc_filt + [a->qtyord <> 0 AND ]
        ENDIF

        *-- Setup filter based on type
        lc_filt1 = ""

        DO CASE
          CASE lc_type = "A"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O' OR ] + ;
                       [a->sotype = 'R' OR a->sotype = 'B' OR ] + ;
                       [a->sotype = 'D' ]

          CASE lc_type = "E"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O' OR ] + ;
                       [a->sotype = 'R' OR a->sotype = 'D' ]

          CASE lc_type = "O"
            lc_filt1 = [a->sotype = ' ' OR a->sotype = 'O']
          CASE lc_type = "R"
            lc_filt1 = [a->sotype = 'R']
          CASE lc_type = "B"
            lc_filt1 = [a->sotype = 'B']
          CASE lc_type = "D"
            lc_filt1 = [a->sotype = 'D']

        ENDCASE

        IF lc_type $ "AEO"
          lc_filt1 = lc_filt1 + [ OR (a->sotype = "O" AND ] + ;
                     [a->qtyshp = 0.000)]
        ENDIF

        IF NOT EMPTY(lc_filt1)
          lc_filt1 = [(] + lc_filt1 + [) AND ]
        ENDIF

        *-- Setup table list
        IF NOT EMPTY(lc_class) OR NOT EMPTY(lc_code)
          *-- Include item master file
          lc_from = [a_sotran a, a_somast b, a_icitem c]
          lc_filt = lc_filt + [a->item = c->item AND ]
        ELSE
          *-- SO transaction detail and header files only
          lc_from = [a_sotran a, a_somast b, a_icitem c]
          lc_filt = lc_filt + [a->item = c->item AND ]
        ENDIF

        *-- If Summary
        IF lc_detail = "S"
          *-- Include customer file
          lc_from = lc_from + [, a_arcust d]
          lc_filt = lc_filt + [a->custno = d->custno AND ]
        ENDIF

        *-- Add join to master file
        lc_filt = lc_filt + [a->sono = b->sono AND ]

*\ [Begin] PTR# 76810 08/06/04 TIVN Fix for performance improvement
        LOCAL lc_Tmpf18, ;
              lc_PrevAlias, ;
              lc_Eratedef, ;
              lc_Erate

        IF gl_mc
          lc_Tmpf18 = go_SQL.m_GetTempTableName(18)

          lc_PrevAlias = ALIAS()

          *-- The approach here is to bring all the 'currencies used for ORDERS',
          *-- their exchange rates and the corresponding number of decimals
          *-- into a separate table
          go_SQL.m_SQLSelect([DISTINCT currid AS currency, ] + ;
                             [0000000001.000000000 AS erate, ] + ;
                             [1 AS decnum ] + ;
                             [FROM ] + ;
                             go_SQL.cmpA_Somast.sc_TableNameFull, ;
                             "SQL TABLE", ;
                             lc_Tmpf18)

          *-- Close the opened table
          go_SQL.so_CurrentAlias.m_CloseTable()

          *-- Open the temp table
          =g_opnfl(lc_Tmpf18, "a_tmp18", .f., .f.)

          *-- Create index on the temporary table
          go_SQL.cmpA_tmp18.m_CreateIndex("currid", "currency", "", .t., .f.)

          *-- Replace exchange rate and number of decimals
          go_SQL.cmpA_tmp18.m_ReplaceBulk("erate WITH l_retcxra(currency), " + ;
                                          "decnum WITH g_retcdc(currency)", ;
                                          "A")

          *-- Restore previously selected work area
          IF NOT EMPTY(lc_PrevAlias)
            go_SQL.m_TableChangeCurrent(lc_PrevAlias)
          ENDIF

          *-- Include temporary exchange rate file
          lc_from = lc_from + [, a_tmp18 e]
          lc_filt = lc_filt + [a->currid = e->currency AND ]

          *-- Exchange rate field definition
          lc_Eratedef  = [e->erate AS exchrat, ]
          lc_Erate     = [e->erate]
        ELSE
          *-- Exchange rate field definition
          lc_Eratedef  = [1.0000000 AS exchrat, ]
          lc_Erate     = [1.00]
        ENDIF && gl_mc
*\ [End] PTR# 76810 08/06/04 TIVN Fix for performance improvement

*\ [Begin] PTR# 76810 08/06/04 TIVN Fix for performance improvement
        *-- Setup fields list
        IF lc_detail = "S"
          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Added tcost,tbcost
          *-- Summary

*- Note: Exchange rate is replaced after the SQL statement is executed with a Bulk Replace
          lc_fields = [a->sono, a->custno, a->item, d->company AS descrip, ] + ;
                      [a->disc, a->taxrate, a->cost, a->tcost, a->price, a->tprice, a->tbprice, ] + ;
                      [a->qtyord, a->tqtyord, a->qtyshp, a->tqtyshp, a->extprice, a->ordate, ] + ;
                      [a->rqdate, a->shipdate, a->shipqty, a->tshpqty, a->terr, a->salesmn, a->isoclss, ] + ;
                      [a->seq, a->stkcode, a->taxable, a->currhist, a->sostat, a->sotype, a->taxcode, a->loctid, ] + ;
                      [a->tranlineno, b->shpamt, b->currid, $0.00 AS bshipqty, b->bshpamt, ] + ;
                      lc_Eratedef + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->price, 1/] + lc_Erate + [, 0) AS bprice, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->cost, 1/] + lc_Erate + [, 0) AS bcost, ] + ;
                      [a->tbcost, ] + ;
                      [g_extnd(] + + ALLTRIM(STR(gn_basedec)) + [, a->extprice, 1/] + lc_Erate + [, 0) AS bextpri, ] + ;
                      [b->exchfrz ]

        ELSE
          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Added tcost,tbcost
          *-- Detail

*- Note: Exchange rate is replaced after the SQL statement is executed with a Bulk Replace
          lc_fields = [a->sono, a->custno, a->item, a->descrip, a->disc, a->taxrate, ] + ;
                      [a->cost, a->tcost, a->price, a->tprice, a->tbprice, a->qtyord, a->tqtyord, ] + ;
                      [a->qtyshp, a->tqtyshp, a->extprice, a->ordate, a->rqdate, a->shipdate, a->shipqty, ] + ;
                      [a->tshpqty, a->terr, a->salesmn, a->isoclss, a->seq, a->stkcode, a->taxable, ] + ;
                      [a->currhist, a->sostat, a->sotype, a->taxcode, a->loctid, a->tranlineno, b->shpamt, ] + ;
                      [a->rqdate AS tdate, c->stkumid, a->umeasur, a->umfact, b->currid, $0.00 AS bshipqty, ] + ;
                      [b->bshpamt, ] + ;
                      lc_Eratedef + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->price, 1/] + lc_Erate + [, 0) AS bprice, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->cost, 1/] + lc_Erate + [, 0) AS bcost, ] + ;
                      [a->tbcost, ] + ;
                      [g_extnd(] + ALLTRIM(STR(gn_basedec)) + [, a->extprice, 1/] + lc_Erate + [, 0) AS bextpri, ] + ;
                      [b->exchfrz ]

        ENDIF && lc_detail = "S"
*\ [End] PTR# 76810 08/06/04 TIVN Fix for performance improvement

        *-- Setup ORDER BY list
        DO CASE
          CASE lc_detail = "S"
            *-- If summary report
            lc_orderby = ""

          CASE lc_detail = "D" AND lc_order = "S"
            *-- loctid + salesmn + custno + sono
            *-- Changed order from 26, 17, 2, 1, 27 to 32, 23, 2, 1, 33
            lc_orderby = "ORDER BY 32, 23, 2, 1, 33"

          CASE lc_detail = "D" AND lc_order = "T"
            *-- gl_sbtmod by territory
            *-- loctid + terr + custno + sono
            *-- Changed order from 26, 16, 2, 1 to 32, 23, 2, 1
            lc_orderby = "ORDER BY 32, 22, 2, 1"

          CASE lc_detail = "D" AND lc_order = "C"
            *-- loctid + custno + sono
            *-- Changed order from 26, 2, 1, 27 to 32, 2, 1, 33
            lc_orderby = "ORDER BY 32, 2, 1, 33"

          CASE lc_detail = "D" AND lc_order = "D"
            *-- loctid + STR(CTOD(rqdate) - {01/01/01}, 8, 0)
            *-- Changed order from 26, 29, 1, 3 to 32, 35, 1, 3
            lc_orderby = "ORDER BY 32, 35, 1, 3"

          CASE lc_detail = "D" AND lc_order = "I"
            *-- loctid + item + STR(CTOD(rqdate) - {01/01/01},8,0)
            *-- Changed order from 26, 3, 29 to 32, 3, 35
            lc_orderby = "ORDER BY 32, 3, 35"

          CASE lc_detail = "D" AND lc_order = "O"
            *-- loctid + sono + custno
            *-- Changed order from 26, 1, 2, 27 to 32, 1, 2, 33
            *-- Changed order from 26, 1, 2, 23 to 32, 1, 2, 33
            lc_orderby = "ORDER BY 32, 1, 2, 33"

        ENDCASE

        *-- Get subset of records
        go_SQL.m_SQLSelect(lc_fields + ;
                           " FROM " + lc_from + ;
                           " WHERE " + lc_filt + " " + lc_filt1 + ;
                           " a->sostat <> 'V' AND a->sostat <> 'C' AND a->sostat <> 'X' " + ;
                           lc_orderby, "SQL TABLE", go_SQL.m_getTempTableName(1))
        *-- Open Temporary report file
        = go_SQL.so_CurrentAlias.m_CloseTable()
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE gl_locts AND lc_detail = "S"
            *# DOCCODE REPORT FORM sosonl
            lc_frx = gc_adrvprg + "sosonl"
          CASE NOT gl_locts AND lc_detail = "S"
            *# DOCCODE REPORT FORM soson2
            lc_frx = gc_adrvprg + "soson2"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM sooctl
            lc_frx = gc_adrvprg + "sooctl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodtl
            lc_frx = gc_adrvprg + "soodtl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM soootl
            lc_frx = gc_adrvprg + "soootl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soostl
            lc_frx = gc_adrvprg + "soostl"
          CASE gl_locts AND lc_tax = "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM soottl
            lc_frx = gc_adrvprg + "soottl"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM sooct2
            lc_frx = gc_adrvprg + "sooct2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodt2
            lc_frx = gc_adrvprg + "soodt2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooot2
            lc_frx = gc_adrvprg + "sooot2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soost2
            lc_frx = gc_adrvprg + "soost2"
          CASE NOT gl_locts AND lc_tax = "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM soottl
            lc_frx = gc_adrvprg + "soottl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM soocnl
            lc_frx = gc_adrvprg + "soocnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodnl
            lc_frx = gc_adrvprg + "soodnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooonl
            lc_frx = gc_adrvprg + "sooonl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soosnl
            lc_frx = gc_adrvprg + "soosnl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "I"
            *# DOCCODE REPORT FORM sooinl
            lc_frx = gc_adrvprg + "sooinl"
          CASE gl_locts AND lc_tax <> "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM sootnl
            lc_frx = gc_adrvprg + "sootnl"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "C"
            *# DOCCODE REPORT FORM soocn2
            lc_frx = gc_adrvprg + "soocn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "D"
            *# DOCCODE REPORT FORM soodn2
            lc_frx = gc_adrvprg + "soodn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "O"
            *# DOCCODE REPORT FORM sooon2
            lc_frx = gc_adrvprg + "sooon2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "S"
            *# DOCCODE REPORT FORM soosn2
            lc_frx = gc_adrvprg + "soosn2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "I"
            *# DOCCODE REPORT FORM sooin2
            lc_frx = gc_adrvprg + "sooin2"
          CASE NOT gl_locts AND lc_tax <> "Y" AND lc_order = "T"
            *# DOCCODE REPORT FORM sootnl
            lc_frx = gc_adrvprg + "sootnl"
        ENDCASE

*\ [Deleted 15 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                             routine g_cursum for currency summary.
        
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        *-- Check for records in result set
        IF RECCOUNT() = 0
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        IF lc_detail = "D"
          REPLACE ALL a_tmpf1->umfact WITH 1 FOR a_tmpf1->umfact = 0
          GOTO TOP
        ENDIF

        *-- Display processing message
        DO g_dspst WITH "Retrieving shipments...", .t., gn_msgline, "", "", ""

        *-- Get shipments for ICTRAN
        DO l_getshp

        *-- Summary report
        IF lc_detail = "S"
          *-- Display processing message
          DO g_dspst WITH "Summarizing transactions...", .t., ;
                          gn_msgline, "", "", ""

          *-- Setup ORDER BY
          IF LEFT(lc_show,1) = "Q"
            *-- qtyord
            lc_orderby = "ORDER BY 8"
          ELSE
            *-- openval extprice
            lc_orderby = "ORDER BY 13"
          ENDIF

          *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
          *-- Create summarized cursor for report
          go_SQL.m_SQLSelect(" sono, loctid, custno, ordate, rqdate,  " + ;
                             " SUM(ROUND(tprice * (tqtyord + tqtyshp) * (100 - disc) / 100.000, 3)) AS extprice,   " + ;
                             " SUM(qtyshp) AS qtyshp, SUM(qtyord) AS qtyord,   " + ;
                             " SUM(shipqty) AS shipqty, SUM(tshpqty) AS tshpqty,   " + ;
                             " salesmn, descrip,   " + ;
                             " SUM(ROUND(tprice * tqtyord * (100 - disc) / 100.000, 3)) AS openval,   " + ;
                             " tbprice,   " + ;
                             " SUM(ROUND(tbprice * (tqtyord + tqtyshp) * (100 - disc) / 100.000, 3)) AS bextpri,   " + ;
                             " SUM(bshipqty) AS bshipqty,   " + ;
                             " SUM(ROUND(bprice * qtyord * (100 - disc) / 100.000, 3)) AS bopenval,   " + ;
                             " currid, exchfrz, exchrat   " + ;
                             " FROM " + go_SQL.m_getTempTableName(1) + ;
                             " GROUP BY sono, loctid, custno, ordate " + ;
                             lc_orderby, ;
                             "SQL TABLE", go_SQL.m_getTempTableName(6))

          *-- Close the temporary table
          go_SQL.so_CurrentAlias.m_CloseTable()

          *-- Close and erase Temporary file
          go_SQL.cmpA_Tmpf1.m_CloseTable()
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(1), "", "")

          = g_opnfl(go_SQL.m_getTempTableName(6), "a_tmpf6", .t., .f.)

          IF ll_cont AND gl_mc
            *--SSHA  Need to pupulate exchfrz field also
          ENDIF

        ENDIF && lc_detail = "S"

        *-- Move to top of temporary cursor or file
        GOTO TOP

        *-- If including sales tax
        IF lc_tax = "Y"
          DO g_dspst WITH "Calculating sales tax...", .t., gn_msgline, ;
                          "", "", ""

          *-- Initialize variables for report totals
          ln_alltot = 0.000
          ln_alltax = 0.000

          ln_balltot = 0.000
          ln_balltax = 0.000

*\ [1 Line] PTR #74741 05/07/04 TISJ Fix for expansion of customer, vendor, item and state
*\                                   in reports
          *-- Create temporary tax file
          go_SQL.m_createTable(go_SQL.m_getTempTableName(4), ;
                               " FREE (sono C(10), custno C(" + TRIM(STR(LEN(gc_CVNoPic))) + "), "+ ;
                               " taxamt Y, totamt Y, btaxamt Y, btotamt Y, exchfrz L)", "", "")
          go_SQL.so_CurrentAlias.m_CloseTable()
          *-- Open Temporary Tax file
          = g_opnfl(go_SQL.m_getTempTableName(4), "a_tmpf4", .t., .f.)

          *-- Save alias name for temporary report file
          lc_alias = IIF(lc_detail = "D", "a_tmpf1", "a_tmpf2")

          *-- Select temporary report file
          go_SQL.m_TableChangeCurrent(lc_alias)

          *-- Create index for tax calculation
          INDEX ON loctid + custno + sono TAG loctid

          GOTO TOP

          *-- Calculate line item tax and save total tax for each order
          DO WHILE NOT EOF()
            mcust = custno
            msono = sono
            ln_linamt = 0.000
            ln_taxamt = 0.000
            ln_totamt = 0.000
            ln_totopn = lc_alias+"->extprice"
            ln_btaxamt = 0.00
            ln_btotamt = 0.00

            DO g_clrtx  WITH taxrate
            DO g_frmclc WITH "custno = mcust AND sono = msono", ;
                             ln_linamt, ln_taxamt, ln_totamt, ln_totopn

            ln_btaxamt = g_extnd(gn_basedec, ln_taxamt, ;
                         1/&lc_alias.->exchrat, 0)
            ln_btotamt = g_extnd(gn_basedec, ln_totamt, ;
                         1/&lc_alias.->exchrat, 0)

            SCAN WHILE custno = mcust AND sono = msono

              *-- Advance to next order
            ENDSCAN

            *-- Add order totals to report totals
            ln_alltot = ln_alltot + (ln_totamt - ln_taxamt)
            ln_alltax = ln_alltax + ln_taxamt
            ln_balltot = ln_balltot + (ln_btotamt - ln_btaxamt)
            ln_balltax = ln_balltax + ln_btaxamt

            *-- Save total amount and tax for each order
            go_SQL.m_TableChangeCurrent("a_tmpf4")
            go_SQL.cmpA_Tmpf4.m_SQLInsert("sono, custno, taxamt, totamt, btaxamt, btotamt", ;
                                          "msono, mcust, ln_taxamt, ln_totamt, ln_btaxamt, ln_btotamt", "")

            go_SQL.m_TableChangeCurrent(lc_alias)
          ENDDO

          *-- Create index for temporary tax file
          go_SQL.m_TableChangeCurrent("a_tmpf4")
          INDEX ON sono TAG sono

          *-- Set relation into temporary tax file
          go_SQL.m_TableChangeCurrent(lc_alias)
          SET ORDER TO 0 IN (lc_alias)
          GOTO TOP
          SET RELATION TO sono INTO a_tmpf4
        ENDIF && lc_tax = "Y"

        *-- Set report title
        lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                   " Open Orders Report"

        DO CASE
          CASE lc_detail = "S"
            *-- Summary report
          CASE lc_order = "C"
            lc_title = lc_title + " by Customer"
          CASE lc_order = "D"
            lc_title = lc_title + " by Date Required"
          CASE lc_order = "I"
            lc_title = lc_title + " by Item"
          CASE lc_order = "O"
            lc_title = lc_title + " by Order Number"
          CASE lc_order = "S"
            lc_title = lc_title + " by Salesperson"
        ENDCASE

        *-- Set relation into master file
        *- NOTE: Check to see if the alias is changing
        SET ORDER TO TAG custno1 IN a_somast
        SET RELATION TO custno + sono INTO a_somast

        *-- If Include Tax
        IF lc_tax = "Y"
          *-- Relate to table containing tax summarizations
          SET RELATION TO sono INTO a_tmpf4
        ENDIF

        IF ll_cursum

          IF lc_detail = "D"
            DO g_cursum WITH "currid", ;
                             "extprice~shipqty", ;
                             "Open Value~Shipped Value"
          ELSE
            DO g_cursum WITH "currid", ;
                             "openval~shipqty", ;
                             "Open Value~Shipped Value"
          ENDIF

          gl_landscp = .f.
          *# DOCCODE REPORT FORM sycsum
          lc_frx = gc_idrvprg + "sycsum"
          lc_title = ALLTRIM(lc_title) + " - Currency Summary"
        ENDIF

      CASE lc_rept $ "14P"
        *-- 1 - Transactions
        *-- 4 - Orders by Salesperson
        *-- P - Customer PO

        *-- Open IC Serial number table
        ln_icserlf = g_opnfl(gf_icserlf, ;
                     "a_icserl", .f., .f., "sono1")

        *-- Select SO serial number detail file
        go_SQL.m_TableChangeCurrent("a_icserl")
        SET ORDER TO TAG sono1 IN a_icserl

        *-- Select records from transaction files
        IF LEFT(lc_file,1) = "C" OR ;
           (lc_rept $ "P" AND lc_only = "O")

          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")
          SET ORDER TO TAG sono1 IN a_sotran

          SET ORDER TO TAG item IN a_icitem
          SET RELATION TO item INTO a_icitem

          *-- Select Order Entry Master file
          go_SQL.m_TableChangeCurrent("a_somast")
          SET ORDER TO TAG sono IN a_somast
          SET RELATION TO sono INTO a_sotran
          SET SKIP TO a_sotran
          lc_alias = "a_sotran->"
        ELSE
          *-- Open YTD Order Entry Transaction file
          ln_opndhst = g_opnfl(gf_soytrnf, "a_soytrn", .f., .f.)
          SET ORDER TO TAG sono1 IN a_soytrn
          SET RELATION TO item INTO a_icitem

          *-- Select Order Entry Master file
          IF NOT go_SQL.m_IsUsed("a_soymst")
            ln_opnmhst = g_opnfl(gf_soymstf, "a_soymst", .f., .f.)
          ELSE
            go_SQL.m_TableChangeCurrent("a_soymst")
          ENDIF

          SET ORDER TO TAG sono IN a_soymst
          SET RELATION TO sono INTO a_soytrn
          SET SKIP TO a_soytrn
          lc_alias = "a_soytrn->"
        ENDIF

        *-- Set current period condition
        IF LEFT(lc_file,1) = "C"
          lc_current = [currhist <> 'X' AND ]
        ELSE
          lc_current = ""
        ENDIF

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + lc_alias + [loctid = TRIM(lc_loctid) AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + lc_alias + [custno = TRIM(lc_custno) AND ]
        ENDIF

        IF NOT EMPTY(lc_item)

          IF gl_sbtmod

            IF lc_incitm = "I"
              *-- Set item number condition
              lc_filt = lc_filt + lc_alias + [item = TRIM(lc_item) AND ]
            ELSE
              *-- Set item number condition to exclude
              lc_filt = lc_filt + lc_alias + [item <> TRIM(lc_item) AND ]
            ENDIF

          ELSE
            *-- Set item number condition
            lc_filt = lc_filt + lc_alias + [item = TRIM(lc_item) AND ]
          ENDIF

        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [a_icitem->itmclss = TRIM(lc_class) AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [a_icitem->code = TRIM(lc_code) AND ]
        ENDIF

        *-- Set date condition
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + lc_alias + [ordate >= ld_bdate AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + lc_alias + [ordate <= ld_edate AND ]
        ENDIF

        IF NOT EMPTY(lc_filt)
          lc_filt = LEFT(lc_filt, RAT(" AND ", lc_filt) - 1)
        ELSE
          lc_filt = '1=1'
        ENDIF

        *-- Added tprice,tqtyord,tqtyshp,tbprice
        *-- Added tcost,tbcost,tshpqty
        lc_fields = lc_alias + "sono, " + ;
                    lc_alias + "custno, " + ;
                    lc_alias + "item, " + ;
                    lc_alias + "descrip, " + ;
                    lc_alias + "disc, " + ;
                    lc_alias + "taxrate, " + ;
                    lc_alias + "cost, " + ;
                    lc_alias + "tcost, " + ;
                    lc_alias + "price, " + ;
                    lc_alias + "qtyord, " + ;
                    "a_icitem->stkumid, " + ;
                    lc_alias + "qtyshp, " + ;
                    lc_alias + "extprice, " + ;
                    lc_alias + "ordate, " + ;
                    lc_alias + "rqdate, " + ;
                    lc_alias + "shipdate, " + ;
                    lc_alias + "shipqty, " + ;
                    lc_alias + "tshpqty, " + ;
                    lc_alias + "umeasur, " + ;
                    lc_alias + "umfact, " + ;
                    lc_alias + "terr, " + ;
                    lc_alias + "salesmn, " + ;
                    lc_alias + "isoclss, " + ;
                    lc_alias + "seq, " + ;
                    lc_alias + "stkcode, " + ;
                    lc_alias + "taxable, " + ;
                    lc_alias + "currhist, " + ;
                    lc_alias + "sostat, " + ;
                    lc_alias + "sotype, " + ;
                    lc_alias + "taxcode, " + ;
                    lc_alias + "loctid, " + ;
                    lc_alias + "tranlineno, " + ;
                    "shpamt, " + ;
                    "ponum, " + ;
                    "sodate, " + ;
                    lc_alias + "currid, " + ;
                    lc_alias + "bcost,  " + ;
                    lc_alias + "tbcost,  " + ;
                    lc_alias + "bextpri,  " + ;
                    lc_alias + "bprice,  " + ;
                    lc_alias + "exchrat, " + ;
                    lc_alias + "tqtyord,  " + ;
                    lc_alias + "tprice,  " + ;
                    lc_alias + "tqtyshp,  " + ;
                    lc_alias + "tbprice "

        lc_tmpfl = go_SQL.m_getTempTableName(2)

        COPY TO (lc_tmpfl) ;
                FIELDS &lc_fields. ;
                FOR &lc_current. &lc_filt.

        *-- Reset index order
        SET ORDER TO TAG sono1 IN a_sotran

*\ [1 Line] PTR #74741 05/07/04 TISJ Fix for expansion of customer, vendor, item and state
*\                                   in reports
        *-- Added tprice,tqtyord,tqtyshp,tbprice,tshpqty
        *-- Added tcost,tbcost
        *-- Build structure for temporary file
        go_SQL.m_CreateTable(go_SQL.m_getTempTableName(1), ;
                            " FREE (sono C(10), custno C(" + TRIM(STR(LEN(gc_CVNoPic))) + "), "+ ;
                            " item C(" + TRIM(STR(LEN(gc_ItemPic))) + "), descrip C(60), disc N(7,3), taxrate N(7,3), "+ ;
                            " cost N(15,5), tcost N(15,5), price N(15,5), qtyord N(15,6), stkumid C(6), qtyshp N(15,6), "+ ;
                            " extprice Y, ordate D, rqdate D, shipdate D, shipqty Y, umeasur C(10), umfact N(12,3), terr C(2), "+ ;
                            " salesmn C(4), isoclss C(6), seq C(4), stkcode C(1), taxable C(1), currhist C(1), sostat  C(1), "+ ;
                            " sotype C(1), taxcode C(1), loctid C(6), tranlineno N(4,0), shpamt Y, ponum C(20), sodate D, "+ ;
                            " currid C(3), bcost N(15,5), tbcost N(15,5), bextpri Y, bprice N(15,5), exchrat B(9), bshipqty Y, "+ ;
                            " tqtyord N(15,6), tprice N(15,5), tbprice N(15,5), tshpqty Y, tqtyshp N(15, 6))")

        *-- Open Temporary report file
        = go_SQL.so_CurrentAlias.m_CloseTable()
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        DO CASE
          CASE lc_rept $ "1P"
            *-- Transactions
            APPEND FROM (lc_tmpfl) ;
                   FOR sotype $ ms AND NOT sostat $ "VX"

          CASE lc_rept = "4"
            *-- Orders by Salesperson
            mshiplen = LEN(TRIM(gc_shiptyp))

            DO CASE
              CASE lc_only = "O"
                *-- Open orders
                APPEND FROM (lc_tmpfl) FOR ;
                       sotype $ ms AND ;
                       NOT sostat $ "VCX" AND ;
                       IIF(EMPTY(gc_shiptyp), .t., ;
                       item <> TRIM(gc_shiptyp))

              CASE lc_only = "P"
                *-- Partially Shipped
                APPEND FROM (lc_tmpfl) FOR ;
                       sotype $ ms AND ;
                       NOT sostat $ "VCX" AND ;
                       shpamt > 0 AND ;
                       IIF(EMPTY(gc_shiptyp), ;
                       .t., item  <> TRIM(gc_shiptyp))

              CASE lc_only = "A"
                *-- All orders
                APPEND FROM (lc_tmpfl) ;
                       FOR sotype $ ms AND NOT sostat $ "VX" AND ;
                       IIF(EMPTY(gc_shiptyp), .t., item <> TRIM(gc_shiptyp))
            ENDCASE

        ENDCASE

        *-- Erase second temporary file
        go_SQL.m_DropTable(go_SQL.m_getTempTableName(2), "", "")

        IF LEFT(lc_file,1) = "B" AND NOT (lc_rept = "4" AND lc_type = "O")
          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")

          *-- Set filter to current file
          lc_filt = STRTRAN(lc_filt, "a_soytrn", "a_sotran")
          lc_filt = STRTRAN(lc_filt, "a_somast", "a_soymst")

          *-- Set code condition
          IF NOT EMPTY(lc_code)
            SET RELATION TO item INTO a_icitem
          ENDIF

          *-- Select Order Entry Transaction file
          go_SQL.m_TableChangeCurrent("a_sotran")
          SET ORDER TO TAG sono1 IN a_sotran

          SET ORDER TO TAG item IN a_icitem
          SET RELATION TO item INTO a_icitem

          *-- Select Order Entry Master file
          go_SQL.m_TableChangeCurrent("a_somast")

          SET ORDER TO TAG sono IN a_somast
          SET RELATION TO sono INTO a_sotran
          SET SKIP TO a_sotran
          lc_fields = STRTRAN(lc_fields, lc_alias, "a_sotran->")
          lc_fields = STRTRAN(lc_fields, "a_soymst->", "a_somast->")
          lc_alias = "a_sotran->"

          DO CASE
            CASE NOT EMPTY(lc_pono)
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      FOR &lc_filt. AND ;
                      UPPER(a_somast->ponum) = UPPER(ALLTRIM(lc_pono))

            CASE NOT EMPTY(ld_bdate) AND NOT EMPTY(ld_edate)
              SET ORDER TO TAG ordate1 IN a_somast
              SET NEAR ON
              SEEK DTOS(ld_bdate)
              SET NEAR OFF
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      WHILE ordate <= ld_edate ;
                      FOR &lc_filt.

            CASE NOT EMPTY(ld_bdate)
              SET ORDER TO TAG ordate1 IN a_somast
              SET NEAR ON
              SEEK DTOS(ld_bdate)
              SET NEAR OFF
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      REST ;
                      FOR &lc_filt.

            CASE NOT EMPTY(ld_edate)
              SET ORDER TO TAG ordate1 IN a_somast
              GOTO TOP
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      WHILE ordate <= ld_edate ;
                      FOR &lc_filt.

            CASE lc_rept = "4"
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      FOR NOT (sostat $ 'VCX' ) AND &lc_filt.

            OTHERWISE
              SET ORDER TO 0 IN a_somast
              COPY TO (lc_tmpfl) ;
                      FIELDS &lc_fields. ;
                      FOR &lc_filt.
          ENDCASE

          *-- Reset index order
          SET ORDER TO TAG sono IN a_somast

          *-- Select first temporary file
          go_SQL.m_TableChangeCurrent("a_tmpf1")

          DO CASE
            CASE lc_rept $ "1P"
              *-- Transactions
              APPEND FROM (lc_tmpfl) ;
                     FOR currhist = " " AND sotype $ ms AND NOT ;
                     sostat $ "VX"

            CASE lc_rept = "4"
              *-- Orders by Salesperson
              mshiplen = LEN(TRIM(gc_shiptyp))

              APPEND FROM (lc_tmpfl) ;
                     FOR currhist = " " AND sotype $ ms AND NOT ;
                     sostat $ "VX" AND IIF(EMPTY(gc_shiptyp), .t., ;
                     item <> TRIM(gc_shiptyp))
          ENDCASE

          *-- Erase second temporary file
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(2), "", "")
        ENDIF && LEFT(lc_file,1) = "B" AND etc.

        *-- Find first matching record
        GOTO TOP

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE lc_rept = "1"

            DO CASE
              CASE lc_detail = "D"

                IF gl_locts

                  DO CASE
                    CASE lc_order = "C"
                      *# DOCCODE REPORT FORM sotdcl
                      lc_frx = gc_adrvprg + "sotdcl"
                    CASE lc_order = "D"
                      *# DOCCODE REPORT FORM sotddl
                      lc_frx = gc_adrvprg + "sotddl"
                    CASE lc_order = "I"
                      *# DOCCODE REPORT FORM sotdil
                      lc_frx = gc_adrvprg + "sotdil"
                    CASE lc_order = "O"
                      *# DOCCODE REPORT FORM sotdol
                      lc_frx = gc_adrvprg + "sotdol"
                    CASE lc_order = "S"
                      *# DOCCODE REPORT FORM sotdsl
                      lc_frx = gc_adrvprg + "sotdsl"
                  ENDCASE

                ELSE

                  DO CASE
                    CASE lc_order = "C"
                      *# DOCCODE REPORT FORM sotdcx
                      lc_frx = gc_adrvprg + "sotdcx"
                    CASE lc_order = "D"
                      *# DOCCODE REPORT FORM sotddx
                      lc_frx = gc_adrvprg + "sotddx"
                    CASE lc_order = "I"
                      *# DOCCODE REPORT FORM sotdix
                      lc_frx = gc_adrvprg + "sotdix"
                    CASE lc_order = "O"
                      *# DOCCODE REPORT FORM sotdox
                      lc_frx = gc_adrvprg + "sotdox"
                    CASE lc_order = "S"
                      *# DOCCODE REPORT FORM sotdsx
                      lc_frx = gc_adrvprg + "sotdsx"
                  ENDCASE

                ENDIF

              CASE lc_detail = "S"

                IF gl_locts
                  *# DOCCODE REPORT FORM sotrsl
                  lc_frx = gc_adrvprg + "sotrsl"
                ELSE
                  *# DOCCODE REPORT FORM sotrsx
                  lc_frx = gc_adrvprg + "sotrsx"
                ENDIF

            ENDCASE

*\ [Deleted 15 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                             routine g_cursum for currency summary.            

          CASE lc_rept = "P"
            *# DOCCODE REPORT FORM sopotr
            *# DOCCODE REPORT FORM sopots
            lc_frx = gc_adrvprg + IIF(lc_detail = "D", "sopotr", "sopots")

*\ [Deleted 9 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                            routine g_cursum for currency summary.

          CASE lc_rept = "4"

            DO CASE
              CASE lc_detail = "D"

                IF gl_locts
                  *# DOCCODE REPORT FORM sotndl
                  lc_frx = gc_adrvprg + "sotndl"
                ELSE
                  *# DOCCODE REPORT FORM sotndx
                  lc_frx = gc_adrvprg + "sotndx"
                ENDIF

              CASE lc_detail = "S"

                *# DOCCODE REPORT FORM sosyal
                lc_frx = gc_adrvprg + "sosyal"
            ENDCASE

*\ [Deleted 9 lines] PTR# 75004 06/28/04 TISY Removed Duplicate code in calling global
*\                                            routine g_cursum for currency summary.
          ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        IF EOF()
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        REPLACE ALL a_tmpf1->umfact WITH 1 FOR a_tmpf1->umfact = 0
        GOTO TOP

        DO g_dspst WITH "Sorting transactions...", .t., gn_msgline, "", "", ""

        IF lc_detail = "D"
          *-- Detail report

          *-- Calculate discounted price and quantity
          REPLACE ALL  qtyord   WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        qtyord + qtyshp, IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        qtyshp, qtyord)), ;
                       tqtyord  WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        tqtyord + tqtyshp, IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        tqtyshp, tqtyord)), ;
                       extprice WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                         g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyord, tprice, disc), IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                         g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyshp, tprice, disc), extprice)), ;
                       bextpri  WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                         g_extnd(gn_basedec, tqtyord, tbprice, disc), IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                         g_extnd(gn_basedec, tqtyshp, tbprice, disc), bextpri)), ;
                       taxrate  WITH IIF(lc_rept = "4", 0, taxrate)

          *-- Get shipments for ICTRAN
          DO l_getshp

          SET RELATION TO item INTO a_icitem
        ELSE
          *-- Summary report
          go_SQL.m_TableChangeCurrent("a_tmpf1")
          SET RELATION TO custno INTO a_arcust

          *-- Update conditionally based on the item type
          REPLACE ALL qtyord   WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        qtyord + qtyshp, IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        qtyshp, qtyord)), ;
                      tqtyord  WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        tqtyord + tqtyshp, IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        tqtyshp, tqtyord)), ;
                      extprice WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyord, tprice, disc), IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        g_extnd(g_retcur(UPPER(currid), 'DECNUM'), tqtyshp, tprice, disc), extprice)), ;
                      bextpri  WITH IIF(sostat <> 'C' AND LEFT(item, LEN(gc_shiptyp)) <> gc_shiptyp, ;
                                        g_extnd(gn_basedec, tqtyord, tbprice, disc), IIF(sostat = 'C' OR (LEFT(item, LEN(gc_shiptyp)) = gc_shiptyp AND qtyord = 0), ;
                                        g_extnd(gn_basedec, tqtyshp, tbprice, disc), bextpri)), ;
                      taxrate  WITH IIF(lc_rept = "4", 0, taxrate), ;
                      descrip WITH a_arcust->company

          *-- Get shipments for ICTRAN
          DO l_getshp

          go_SQL.m_TableChangeCurrent("a_tmpf1")

          *-- Fetch the records from a_tmpf1 table into a_tmpf2 table by grouping on key values
          go_SQL.m_SQLSelect("sono, " + ;
                             "custno, " + ;
                             "item, " + ;
                             "descrip, " + ;
                             "disc, " + ;
                             "taxrate, " + ;
                             "SUM(cost) AS cost, " + ;
                             "SUM(tcost) AS tcost, " + ;
                             "SUM(price) AS price, " + ;
                             "SUM(qtyord) AS qtyord, " + ;
                             "stkumid, " + ;
                             "SUM(qtyshp) AS qtyshp, " + ;
                             "SUM(extprice) AS extprice, " + ;
                             "ordate, " + ;
                             "rqdate, " + ;
                             "shipdate, " + ;
                             "SUM(shipqty) AS shipqty, " + ;
                             "SUM(tshpqty) AS tshpqty, " + ;
                             "umeasur, " + ;
                             "umfact, " + ;
                             "terr, " + ;
                             "salesmn, " + ;
                             "isoclss, " + ;
                             "seq, " + ;
                             "stkcode, " + ;
                             "taxable, " + ;
                             "currhist, " + ;
                             "sostat, " + ;
                             "sotype, " + ;
                             "taxcode, " + ;
                             "loctid, " + ;
                             "tranlineno, " + ;
                             "SUM(shpamt) AS shpamt, " + ;
                             "ponum, " + ;
                             "sodate, " + ;
                             "currid, " + ;
                             "SUM(bcost) AS bcost,  " + ;
                             "SUM(tbcost) AS tbcost,  " + ;
                             "SUM(bextpri) AS bextpri,  " + ;
                             "SUM(bprice) AS bprice,  " + ;
                             "exchrat, " + ;
                             "SUM(tqtyord) AS tqtyord,  " + ;
                             "SUM(tprice) AS tprice,  " + ;
                             "SUM(tqtyshp) AS tqtyshp,  " + ;
                             "SUM(tbprice) AS tbprice, " + ;
                             "000000.00 AS bshipqty " + ;
                             "FROM " + go_SQL.cmpA_Tmpf1.sc_TableNameFull + " " + ;
                             "GROUP BY loctid, sono, ordate, custno " + ;
                             "ORDER BY loctid, sono, ordate, custno", ;
                             "SQL TABLE", ;
                             go_SQL.m_GetTempTableName(2))

          go_SQL.so_CurrentAlias.m_CloseTable()

          *-- Close and erase Temporary file
          go_SQL.cmpA_Tmpf1.m_CloseTable()
          go_SQL.m_DropTable(go_SQL.m_getTempTableName(1), "", "")

          = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)

          DO CASE
            CASE lc_rept $ "1P"

              IF gl_locts
                INDEX ON loctid + DTOS(ordate) TAG loctid
              ELSE
                INDEX ON ordate TAG ordate
              ENDIF

            OTHERWISE
              INDEX ON salesmn + DTOS(ordate) TAG salesmn
          ENDCASE

        ENDIF && lc_detail = "D"

        *-- Create temporary index
        DO g_dspst WITH "Indexing file...", .t., gn_msgline, "", "", ""

        DO CASE
          CASE lc_detail = "S" AND lc_rept = "1"
            DO CASE
              CASE LEFT(lc_show,1) = "Q"
                go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY loctid, qtyord", ;
                                   "SQL TABLE", go_SQL.m_getTempTableName(3))
              CASE LEFT(lc_show,1) = "V"
                go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY loctid, extprice", ;
                                   "SQL TABLE", go_SQL.m_getTempTableName(3))

            ENDCASE

            *-- Close the temporary table
            go_SQL.so_CurrentAlias.m_CloseTable()

            *-- Open sorted temporary file
            = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)

          CASE lc_rept = "P"
            INDEX ON custno + ponum + sono TAG custno

          CASE lc_detail = "D" AND lc_rept = "1"

            DO CASE
              CASE lc_order = "S"

                IF gl_locts
                  INDEX ON loctid + salesmn + custno + sono TAG loctid
                ELSE
                  INDEX ON salesmn + custno + sono TAG salesmn
                ENDIF

              CASE lc_order = "T"

                *-- gl_sbtmod by territory
                IF gl_locts
                  INDEX ON loctid + terr + custno + sono TAG loctid
                ELSE
                  INDEX ON terr + custno + sono TAG terr
                ENDIF

              CASE lc_order = "C"

                IF gl_locts
                  INDEX ON loctid + custno + sono TAG loctid
                ELSE
                  INDEX ON custno + sono TAG custno
                ENDIF

              CASE lc_order = "D"

                IF gl_locts
                  INDEX ON loctid + DTOS(rqdate) TAG loctid
                ELSE
                  INDEX ON rqdate TAG rqdate
                ENDIF

              CASE lc_order = "I"

                IF gl_locts
                  INDEX ON loctid + item + DTOS(rqdate) TAG loctid
                ELSE
                  INDEX ON item + DTOS(rqdate) TAG item
                ENDIF

              CASE lc_order = "O"

                IF gl_locts
                  INDEX ON loctid + sono + custno TAG loctid
                ELSE
                  INDEX ON sono + custno TAG sono
                ENDIF

                SET ORDER TO TAG custno1 IN a_somast
                SET RELATION TO
                SET RELATION TO custno + sono INTO a_somast ADDITIVE
            ENDCASE

          CASE lc_rept = "4"

            IF LEFT(lc_show,1) = "Q"
              go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY qtyord DESC", ;
                                 "SQL TABLE", go_SQL.m_getTempTableName(3))
            ELSE
              go_SQL.m_SQLSelect(" * FROM " + go_SQL.so_CurrentAlias.sc_TableNameFull + " ORDER BY extprice DESC", ;
                                 "SQL TABLE", go_SQL.m_getTempTableName(3))
            ENDIF

            = go_SQL.so_CurrentAlias.m_CloseTable()

            IF go_SQL.m_IsUsed("a_tmpf2")
              go_SQL.cmpA_Tmpf2.m_CloseTable()
            ENDIF

            = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf2", .t., .f.)

            DO CASE
              CASE gl_locts AND LEFT(lc_show,1) = "Q"
                INDEX ON loctid + salesmn TAG loctid

              CASE gl_locts AND LEFT(lc_show,1) = "V"
                INDEX ON loctid + salesmn TAG loctid

              CASE LEFT(lc_show,1) = "Q"
                INDEX ON salesmn TAG salesmn

              CASE LEFT(lc_show,1) = "V"
                INDEX ON salesmn TAG salesmn
            ENDCASE

        ENDCASE

        *-- Set report title
        DO CASE
          CASE lc_rept $ "1"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Transaction Report by "

            DO CASE
              CASE lc_detail = "S" AND LEFT(lc_show,1) = "Q"
                lc_title = lc_title + "Qty ordered"
              CASE lc_detail = "S" AND LEFT(lc_show,1) = "V"
                lc_title = lc_title + "Value ordered"
              CASE lc_order = "C"
                lc_title = lc_title + "Customer"
              CASE lc_order = "D"
                lc_title = lc_title + "Date Required"
              CASE lc_order = "I"
                lc_title = lc_title + "Item"
              CASE lc_order = "S"
                lc_title = lc_title + "Salesperson"
              CASE lc_order = "O"
                lc_title = lc_title + "Order Number"
            ENDCASE

          CASE lc_rept = "4" AND lc_only = "A"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Orders by Salesperson"

          CASE lc_rept = "4" AND lc_only = "O"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Open Orders by Salesperson"

          CASE lc_rept = "4" AND lc_only = "P"
            lc_title = IIF(lc_detail = "D", "Detail", "Summary") + ;
                       " Partially Shipped Orders by Salesperson"

        ENDCASE

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        *-- Set report form name
        DO CASE
          CASE lc_rept = "1"

            IF ll_cursum

              IF lc_detail = "S" AND gl_locts
                DO g_cursum WITH "currid", ;
                                 "extprice~shipqty", ;
                                 "Order Value~Ship Value"
              ELSE
                DO g_cursum WITH "currid", ;
                                 "extprice~shipqty", ;
                                 "Order Value~Shipped Value"
              ENDIF

              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

          CASE lc_rept = "P"
            *# DOCCODE REPORT FORM sopotr
            *# DOCCODE REPORT FORM sopots
            lc_frx = gc_adrvprg + IIF(lc_detail = "D", "sopotr", "sopots")

            IF ll_cursum
              DO g_cursum WITH "currid", ;
                               "extprice~shipqty", ;
                               "Order Value~Shipped Value"
              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

          CASE lc_rept = "4"

            IF ll_cursum
              DO g_cursum WITH "currid", ;
                               "extprice~shipqty", ;
                               "Order Value~Shipped Value"
              gl_landscp = .f.
              *# DOCCODE REPORT FORM sycsum
              lc_frx = gc_idrvprg + "sycsum"
              lc_title = ALLTRIM(lc_title) + " - Currency Summary"
            ENDIF

        ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

      CASE lc_rept = "2"
        *-- Shipments

        *-- Open Inventory Master file
        = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")
        SET ORDER TO 0 IN a_icitem

        IF LEFT(lc_file,1) $ "BC"
          *-- Open current Master file
          = g_opnfl(gf_somastf, "a_somast", .f., .f., "")
          SET ORDER TO 0 IN a_somast

          *-- Open current Inventory transfers
          = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "")
          SET ORDER TO 0 IN a_ictran
        ENDIF

        IF LEFT(lc_file,1) $ "BH"
          *-- Open YTD Transaction file
          = g_opnfl(gf_soymstf, "a_soymst", .f., .f., "")
          SET ORDER TO 0 IN a_soymst

          *-- Open YTD Inventory Transaction Detail file
          = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "")
          SET ORDER TO 0 IN a_icytrn
        ENDIF

        *-- Set transaction type condition, exclude explosion records
        lc_filt = [LEFT(a->trantyp,1) <> 'E' AND ]

        *-- Set location condition
        IF NOT EMPTY(lc_loctid)
          lc_filt = lc_filt + [a->loctid+a->item = TRIM(lc_loctid) AND ]
        ENDIF

        *-- Set customer number condition
        IF NOT EMPTY(lc_custno)
          lc_filt = lc_filt + [a->orgno+a->docno = TRIM(lc_custno) AND ]
        ENDIF

        *-- Set item number condition
        IF NOT EMPTY(lc_item)
          lc_filt = lc_filt + [a->item = TRIM(lc_item) AND ]
        ENDIF

        *-- Set class condition
        IF NOT EMPTY(lc_class)
          lc_filt = lc_filt + [c->itmclss = TRIM(lc_class) AND ]
        ENDIF

        *-- Set code condition
        IF NOT EMPTY(lc_code)
          lc_filt = lc_filt + [c->code = TRIM(lc_code) AND ]
        ENDIF

        *-- Set date range conditions
        IF NOT EMPTY(ld_bdate)
          lc_filt = lc_filt + [DTOS(a->tdate) >= '] + DTOS(ld_bdate) + [' AND ]
        ENDIF

        IF NOT EMPTY(ld_edate)
          lc_filt = lc_filt + [DTOS(a->tdate) <= '] + DTOS(ld_edate) + [' AND ]
        ENDIF

        *-- Add join and shipment conditions
        lc_filt = [a->applid+a->docno = 'SO'+b->sono AND ] + lc_filt + [a->sqty <> 0 ]

        *-- Setup FROM (table) lists

        lc_hfrom = gf_icytrnf + " AS a, " + gf_soymstf + " AS b"
        lc_cfrom = gf_ictranf + " AS a, " + gf_somastf + " AS b"

        *-- Include item master file

        lc_cfrom = lc_cfrom + ", " + gf_icitemf + " AS c"
        lc_hfrom = lc_hfrom + ", " + gf_icitemf + " AS c"

        *-- Added code for join to a_icitem
        lc_filt = [a->item = c->item AND ] + lc_filt

        *-- Setup fields list list
        IF lc_detail = "S"
          *-- Added tqty,trprice,tfprice
          *-- Added tftcost
          *-- Summary
          lc_fields = [a->loctid, ] + ;
                      [a->tdate, ] + ;
                      [a->docno, ] + ;
                      [a->orgno, ] + ;
                      [1 AS sqty, ] + ;
                      [1 AS tqty, ] + ;
                      [SUM(ROUND(-a->sqty * a->price * ] + ;
                      [(100 - a->disc)/100, 2)) AS price, ] + ;
                      [SUM(ROUND(-a->tqty * a->trprice * ] + ;
                      [(100 - a->disc)/100, 2)) AS trprice, ] + ;
                      [a->disc, ] + ;
                      [a->taxrate, ] + ;
                      [b->salesmn, ] + ;
                      [c->stkumid, ] + ;
                      [a->umeasur, ] + ;
                      [a->umfact, ]  + ;
                      [a->currid, ]  + ;
                      [SUM(ROUND(-a->sqty * a->fprice * ] + ;
                      [(100 - a->disc)/100, 2)) AS fprice, ] + ;
                      [SUM(ROUND(-a->tqty * a->tfprice * ] + ;
                      [(100 - a->disc)/100, 2)) AS tfprice, ] + ;
                      [a->tftcost, ] + ;
                      [a->ftcost   ]

        ELSE
          *-- Added tqty,trprice,tfprice
          *-- Added tftcost
          *-- Detail
          lc_fields = [a->loctid, ] + ;
                      [a->item, ] + ;
                      [a->trantyp, ] + ;
                      [a->tdate, ] + ;
                      [-a->sqty AS sqty, ] + ;
                      [-a->tqty AS tqty, ] + ;
                      [a->tcost, ] + ;
                      [a->applid, ] + ;
                      [a->orgno, ] + ;
                      [a->docno, ] + ;
                      [a->tstore, ] + ;
                      [a->tbin, ] + ;
                      [a->price, ] + ;
                      [a->trprice, ] + ;
                      [a->disc, ] + ;
                      [a->taxrate, ] + ;
                      [b->salesmn, ] + ;
                      [c->stkumid, ] + ;
                      [a->umeasur, ] + ;
                      [a->umfact, ]  + ;
                      [a->currid, ]  + ;
                      [a->fprice, ] + ;
                      [a->tfprice, ] + ;
                      [a->tftcost, ] + ;
                      [a->ftcost   ]

        ENDIF && lc_detail = "S"

        *-- Setup ORDER BY list
        DO CASE
          CASE lc_detail = "S"
            *-- Summary, create temporary total file
            lc_orderby = "ORDER BY 1, 2, 3"

          CASE lc_order = "S"
            *-- loctid + salesmn + orgno + docno + item
            lc_orderby = "ORDER BY 1, 15, 9, 10, 2"
            lc_IndDef = "loctid + salesmn + orgno + docno + item"

          CASE lc_order = "C"
            *-- loctid + orgno + docno + item
            lc_orderby = "ORDER BY 1, 9, 10, 2"
            lc_IndDef = "loctid + orgno + docno + item"

          CASE lc_order = "D"
            *-- loctid + tdate + docno + item
            lc_orderby = "ORDER BY 1, 4, 10, 2"
            lc_IndDef = "loctid + DTOS(tdate) + docno + item"

          CASE lc_order = "I"
            *-- loctid + item + tdate
            lc_orderby = "ORDER BY 1, 2, 4"
            lc_IndDef = "loctid + item + DTOS(tdate)"

          CASE lc_order = "O"
            *-- loctid + docno + orgno + item
            lc_orderby = "ORDER BY 1, 10, 9, 2"
            lc_IndDef = "loctid + docno + orgno + item"

        ENDCASE

        *-- Setup GROUP BY list
        IF lc_detail = "S"
          *-- Summary, create temporary total file
          lc_groupby = "GROUP BY a->loctid, a->tdate, a->docno"
        ELSE
          *-- Detail
          lc_groupby = ""
        ENDIF

        *-- Retrieve records
        DO CASE
          CASE LEFT(lc_file,1) = "C"
            *-- From current file
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_cfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))

          CASE LEFT(lc_file,1) = "H"
            *-- From history file
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_hfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))

          CASE LEFT(lc_file,1) = "B"
            *-- From current and history file

            *--Get data from current table
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_cfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(9))
            go_SQL.so_CurrentAlias.m_CloseTable()

            *--Get data from history table
            go_SQL.m_SQLSelect(lc_fields + ;
                               " FROM " + lc_hfrom + ;
                               " WHERE " + lc_filt + " " + lc_groupby + ;
                               " " + lc_orderby, ;
                               "SQL TABLE", go_SQL.m_getTempTableName(5))
            go_SQL.so_CurrentAlias.m_CloseTable()

            *--Open history table
            = g_opnfl(go_SQL.m_getTempTableName(5), "a_tmpf5", .t., .f.)

            *--Append History data with current data
            lc_tmpfl = go_SQL.m_getTempTableName(9)
            APPEND FROM (lc_tmpfl)

            go_SQL.m_DropTable(go_SQL.m_getTempTableName(9))
        ENDCASE

        *-- Open Temporary report file
        go_SQL.so_CurrentAlias.m_CloseTable()
        = g_opnfl(go_SQL.m_getTempTableName(5), "a_tmpf5", .t., .f.)

        IF lc_detail = "D"
          INDEX ON &lc_IndDef. TAG loctid
        ELSE
          INDEX ON loctid + docno + orgno TAG loctid
        ENDIF

 *\ [Begin] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                  to support printing no matching data
        DO CASE
          CASE lc_detail = "D" AND gl_locts
            *# DOCCODE REPORT FORM soshpl
            lc_frx = gc_adrvprg + "soshpl"
          CASE lc_detail = "D" AND NOT gl_locts
            *# DOCCODE REPORT FORM soshpx
            lc_frx = gc_adrvprg + "soshpx"
          CASE lc_detail = "S" AND gl_locts
            *# DOCCODE REPORT FORM soshsl
            lc_frx = gc_adrvprg + "soshsl"
          CASE lc_detail = "S" AND NOT gl_locts
            *# DOCCODE REPORT FORM soshsx
            lc_frx = gc_adrvprg + "soshsx"
        ENDCASE
 *\ [End] PTR# 73740 01/12/04 TISU Moved the code setting frx name from within condition
 *\                                to support printing no matching data

        *-- Check for records in result set
        IF RECCOUNT() = 0
          *-- Set continuation flag
          ll_cont = .f.
          *-- Exit control loop
          EXIT
        ENDIF

        REPLACE ALL a_tmpf5->umfact WITH 1 FOR a_tmpf5->umfact = 0
        GOTO TOP

        *-- Set report title
        DO CASE
          CASE lc_order = "C"
            lc_title = "Shipments by Customer"
            lc_gpdesc = "** Customer => "
          CASE lc_order = "D"
            lc_title = "Shipments by Ship Date"
            lc_gpdesc = "** Ship Date => "
          CASE lc_order = "I"
            lc_title = "Shipments by Item"
            lc_gpdesc = "** Item => "
          CASE lc_order = "O"
            lc_title = "Shipments by Order Number"
            lc_gpdesc = "** Order => "
          CASE lc_order = "S"
            lc_title = "Shipments by Salesperson"
            lc_gpdesc = "** Salesman => "
        ENDCASE

        IF lc_detail = "D"
          lc_title = "Detail " + lc_title
        ELSE
          lc_title = "Summary " + lc_title
        ENDIF

        *-- Set decimals to the user defined value of price decimals
        ln_decnum = SET("DECIMALS")
        SET DECIMALS TO gn_decprc

      CASE lc_rept = "V"
        *-- Distribution by Value Report

        *-- Create and build Distribution by Value Report file
        *# DOCCODE DO syvalr
        DO (gc_idrvprg + "syvalr")

        *-- Set report title
        lc_title = "Customer Distribution by Value Report"

        *-- Set report form name
        *# DOCCODE REPORT FORM syvalc
        lc_frx = gc_idrvprg + "syvalc"

    ENDCASE

    *-- Exit control loop
    EXIT
  ENDDO && WHILE ll_cont

  *-- close data tables opened here
  IF USED("a_icserl") AND ln_icserlf = Cn_OpenHere
    go_SQL.cmpA_Icserl.m_CloseTable()
  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sorep1_vfp
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: l_UnInvShip
*------------------------------------------------------------------------------
*- Synopsis...: 2 - Uninvoiced SO Shipments report
*------------------------------------------------------------------------------
*- Calls......: G_DSPST, G_DSPALT, G_EXTND(), G_CLRTX, G_FRMCLC, SYVALR,
*-              G_OPNFL
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: lc_bdate    = beginning ship date
*-              lc_edate    = ending ship date
*-              lc_order    = "Customer" to order report by customer number
*-                            "Ship Via" to order report by salesperson
*-                            "FOB" to order report by FOB
*-                            "Salesperson" to order report by Ship Via
*-              lc_custno   = customer number or portion to match
*-              lc_ShipVia  = Ship via
*-              lc_FOB      = FOB
*-              lc_SalesMn  = Salesperson
*-              lc_CurrId   = Currency ID
*-              lc_loctid   = Inventory location
*-           	lc_GrpOrds  = Group orders
*-
*-              lc_Grouping = Report grouping
*-              lc_gpdesc   = Group description
*-              lc_frx      = Report file name
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_UnInvShip

  lc_frx = gc_adrvprg + "soshun"

  LOCAL lc_sql, ;
        lc_OrderBy

  lc_OrderBy = UPPER(ALLTRIM(lc_order))

  *--Open shipping tables
  = g_opnfl(gf_SoHShpf, "a_SoHShp", .f., .f., "ShipNo")
  = g_opnfl(gf_SoDShpf, "a_SoDShp", .f., .f., "ShipNo")

  *-- Setup for summary / detail
  IF lc_detail = "S"
    *-- Summary, create temporary total file
    lc_sql = "a_SoHShp->ShipNo,  a_SoHShp->SoNo, a_SoHShp->ShipDate, " + ;
             "a_SoHShp->ShipVia, a_SoHShp->Fob, a_SoHShp->CurrId, " + ;
             "a_SoHShp->CustNo,  a_SoHShp->SalesMn, a_SoHShp->OrDate, " + ;
             "a_SoHShp->OrdAmt, " + ;
             "a_SoHShp->ShipAmt - a_SoHShp->Tax  AS ShipAmt, " + ;
             "a_SoHShp->bShpAmt - a_SoHShp->bTax AS bShpAmt, " + ;
             "1 AS TranLineNo, 0 AS tQtyShp, " + ;
             "' ' AS LoctId,  ' ' AS Descrip, ' ' AS uMeasur " + ;
             "FROM " + go_Sql.CmpA_SoHShp.sc_TableNameFull + " AS a_SoHShp " + ;
             "WHERE a_SoHShp->Invoiced = .f. "
  ELSE
    *-- Detail
    lc_sql = "a_SoHShp->ShipNo,  a_SoHShp->SoNo, a_SoHShp->ShipDate, " + ;
             "a_SoHShp->ShipVia, a_SoHShp->Fob, a_SoHShp->CurrId, " + ;
             "a_SoHShp->CustNo,  a_SoHShp->SalesMn, a_SoHShp->OrDate, " + ;
             "0 AS OrdAmt, " + ;
             "a_SoDShp->TranLineNo, a_SoDShp->tQtyShp, " + ;
             "a_SoDShp->ExtPrice AS ShipAmt, a_SoDShp->bExtPri as  bShpAmt, " + ;
             "a_SoDShp->LoctId,  a_SoDShp->Item AS Descrip, a_SoDShp->uMeasur " + ;
             "FROM " + go_Sql.CmpA_SoHShp.sc_TableNameFull + " AS a_SoHShp, " + ;
                       go_Sql.CmpA_SoDShp.sc_TableNameFull + " AS a_SoDShp " + ;
             "WHERE a_SoHShp->Invoiced = .f. AND " + ;
                   "a_SoHShp->ShipNo = a_SoDShp->ShipNo "
  ENDIF


  *-- Convert variables to dates
  ld_bdate = g_retdt(lc_bdate)
  ld_edate = g_retdt(lc_edate)

  *-- Set filter conditions
  IF NOT EMPTY(ld_bdate)
    lc_sql = lc_sql + [ AND a_SoHshp->ShipDate >= ??ld_bdate]
  ENDIF

  IF NOT EMPTY(ld_edate)
    lc_sql = lc_sql + [ AND a_SoHshp->ShipDate <= ??ld_edate]
  ENDIF

  IF NOT EMPTY(lc_custno)
    lc_sql = lc_sql + [ AND a_SoHshp->CustNo %=% TRIM(??lc_CustNo) + '%/%']
  ENDIF

  IF NOT EMPTY(lc_ShipVia)
    lc_sql = lc_sql + [ AND a_SoHshp->ShipVia %=% TRIM(??lc_ShipVia) + '%/%']
  ENDIF

  IF NOT EMPTY(lc_LoctID)
    lc_sql = lc_sql + [ AND a_SoDshp->LoctId %=% TRIM(??lc_LoctID) + '%/%']
  ENDIF

  IF NOT EMPTY(lc_FOB)
    lc_sql = lc_sql + [ AND a_SoHshp->FOB %=% TRIM(??lc_FOB) + '%/%']
  ENDIF

  IF NOT EMPTY(lc_SalesMn)
    lc_sql = lc_sql + [ AND a_SoHshp->Salesmn %=% TRIM(??lc_SalesMn) + '%/%']
  ENDIF

  IF gl_mc AND NOT EMPTY(lc_CurrId)
    lc_sql = lc_sql + [ AND a_SoHshp->CurrId %=% TRIM(??lc_CurrId) + '%/%']
  ENDIF

  lc_title  = IIF(gl_detail, "Detail Uninvoiced Shipments ", "Summary Uninvoiced Shipments ")

  DO CASE
    CASE lc_OrderBy = "CUSTOMER"
      lc_Sql = lc_Sql + ;
               IIF(gl_detail, " ORDER BY a_SoHShp->CustNo, a_SoHShp->SoNo", ;
                              " ORDER BY a_SoHShp->CustNo, a_SoHShp->SoNo")
      lc_Grouping = "CustNo"
      lc_gpdesc   = "Customer ID: "
      lc_title    = lc_title + " by Customer "
    CASE lc_OrderBy = "SHIP VIA"
      lc_Sql = lc_Sql + ;
               IIF(gl_detail, " ORDER BY a_SoHShp->ShipVia, a_SoHShp->SoNo", ;
                              " ORDER BY a_SoHShp->ShipVia, a_SoHShp->SoNo")
      lc_Grouping = "ShipVia"
      lc_gpdesc   = "Ship Via: "
      lc_title    = lc_title + " by Ship Via "
    CASE lc_OrderBy = "SALESPERSON"
      lc_Sql = lc_Sql + " ORDER BY a_SoHShp->SalesMn, a_SoHShp->SoNo"
      lc_Grouping = "Salesmn"
      lc_gpdesc   = "Salesperson: "
      lc_title    = lc_title + " by Salesperson "
    CASE lc_OrderBy = "FOB"
      lc_Sql = lc_Sql + " ORDER BY a_SoHShp->FOB, a_SoHShp->SoNo"
      lc_Grouping = "FOB"
      lc_gpdesc   = "FOB: "
      lc_title    = lc_title + " by FOB "
  ENDCASE

  IF lc_detail = "D" AND lc_GrpOrds = "Yes"
    lc_Sql = lc_Sql + ", a_SoDShp->TranLineNo, a_SoDShp->uMeasur"
  ELSE
    lc_Sql = lc_Sql + ", a_SoHShp->ShipNo"
  ENDIF

  *--Get data to local temp table
  = go_SQL.m_SQLSelect(lc_sql, "CURSOR", "ac_temp")

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_UnInvShip
*------------------------------------------------------------------------------

*\[Begin] PTR# 73741 01/31/04 TIVN Support for multiple custom reports
*------------------------------------------------------------------------------
*- Procedure..: l_getfrx
*------------------------------------------------------------------------------
*- Synopsis...: Return the appropriate report file name to be used for
*-              previewing/printing
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: la_custom  - Array in which report form names
*-                           are stored
*-              lc_cusrept - Default report name/User chosen report
*-
*- Parameters.: None
*------------------------------------------------------------------------------
FUNCTION l_getfrx

  LOCAL lc_Frxfile, ;
        lc_Tmpname, ;
        ln_Row

  *-- Strip off the 'Standard' label
  lc_Tmpname = UPPER(ALLTRIM(STRTRAN(lc_Cusrept, "(Standard)", "", 1, -1, 1)))

  *-- If the grid option does not have any selection combo,
  *-- return the name of the standard/stock report.
  IF ll_NoSelrpt

    *-- Check for the user's choice
    IF lc_Tmpname == UPPER(JUSTSTEM(lc_frx))
      *-- Standard/Stock
      lc_Frxfile = lc_frx
    ELSE
      *-- Custom
*\ [1 Line] PTR# 74905 06/18/04 TIGJ To fetch the exact custom report
      ln_Row = ASCAN(la_custom, lc_Cusrept, -1, -1, -1, 14)
      lc_Frxfile = ALLTRIM(la_custom[ln_Row, 2]) + ALLTRIM(lc_Cusrept)
    ENDIF

  ELSE
    *-- Standard/Stock
    lc_Frxfile = lc_frx
  ENDIF && NOT ll_NoSelrpt

RETURN lc_Frxfile
*------------------------------------------------------------------------------
*- End Procedure...: l_getfrx
*------------------------------------------------------------------------------
*\[End] PTR# 73741 01/31/04 TIVN Support for multiple custom reports


*\ [Begin] PTR# 74805 06/26/04 TISP Added function getting correct internal memo
*------------------------------------------------------------------------------
*- Procedure..: l_getmemo
*------------------------------------------------------------------------------
*- Synopsis...: Return the appropriate internal memo of a line item.
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: 
*-
*- Parameters.: None
*------------------------------------------------------------------------------
FUNCTION l_getmemo

  LOCAL lc_return

  *-- Select correct transaction record
  go_SQL.cmpA_Tmpf1.m_Seek(a_tmpf3->sono + STR(a_tmpf3->tranlineno))

  lc_return = A_Tmpf1->intmemo

RETURN lc_return
*------------------------------------------------------------------------------
*- End Procedure...: l_getmemo
*------------------------------------------------------------------------------
*\ [End] PTR# 74805 06/26/04 TISP Added function getting correct internal memo
*------------------------------------------------------------------------------

*- File Name..: $Workfile:   SOREPT.prg  $
*- Total Lines: 13762